/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.batchprocessing;

/**
 * This methods are implemented by the clinical viewer
 * @author Nuno Barros, updated by Johannes Slotboom 11.2018.
 */
public interface BatchProcessingTaskExecutor 
{

    public void openFile( String file );

    public void openReferenceImages( String file1, String file2, String file3 );

    public void saveResults( String file );
    
    public void saveMetaboliteMapsMAT( String file, boolean profileCorrection );

    public void createReport( String outputFile, int outputFileType, 
                              String customReportFile);

    public void quantifySpectra( );
    
    public void quantifyWithTDFDFitInAction( String tdfdfitModelToUse );
    
    public void processingFinished( );

    public void removeWaterHLSVDPro( double lowerLimit, 
                                     double upperLimit, 
                                     int peaks );
    
    public void removeWaterHLSVD64( double lowerLimit, 
                                    double upperLimit, 
                                    int peaks );

    public void removeWaterTDFDFit( String waterModel );
    
    public void removeAmplitudeOffsetTD( double lowerLimitTD, double upperLimitTD );
    
    public void removeAmplitudeOffsetFD( double lowerLimitFD, double upperLimitFD );
    
    public void assessQuality( String RFile );

    public int qualitySelection( double threshold );

    public void baselineCorrection( int nr );

    public void apodizeExponentialSelection( double fact, boolean update );

    public void apodizeGaussianSelection( double fact, boolean update );

    public void calcPPMshiftSelection( double[] minvals, double[] maxvals, 
                                       double[] targets, int[] multiplicities, 
                                       double SNRLimit, double minPPM, 
                                       double maxPPM, double maxLocalShift, 
                                       boolean update);

    public void autoPhaseSelection( float minppm, float maxppm, boolean update );

    public void selectExcitedVoxels( );

    public void selectInnerExcitedVoxels( );

    public void selectAllVoxels( );
    
    public void printTxt( String txt );
    
}
