/*
 * File: $Id: ClinicalSpectroscopyCaseWorklistData.java,v 1.1.1.1 $
 * History
 * Date: 12.12.2016  Authors: Hans Slotboom
 *
 * Changes:
 *
 * Copyright (C) 2016 by
 *
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */
package org.spectrim.clinicalcasehandling;

import org.spectrim.dicom.DicomFileSystemAlterationListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

/**
 * Singleton class that handles the clinical spectroscopy work list data
 * 
 * @author slotboom
 */
public class ClinicalSpectroscopyCaseWorklistData implements ActionListener {
    
    
    
    private ClinicalSpectroscopyCaseWorklistData( ) 
    {

    }
    
    /**
     * Returns the one and only instance of ClinicalSpectroscopyCaseWorklistData
     * @return the one and only instance
     */
    public static ClinicalSpectroscopyCaseWorklistData getInstance( )
    {
        if ( theInstance == null )
        {
            theInstance = new ClinicalSpectroscopyCaseWorklistData( );
        }
        return theInstance;
    }

    @Override
    public void actionPerformed(ActionEvent e) 
    {
        if ( e.getSource( ) instanceof String )
        {
            if ( e.getID( ) == DicomFileSystemAlterationListener.NOTIFY_DICOM_FILE_RENAMED_ID )
            {
                String spectroFileRef = (String)e.getSource();
                ClinicalCase clinCase = new ClinicalCase( spectroFileRef );
            }
        }
    }
    
    
    // Attributes of the class
    private static  ClinicalSpectroscopyCaseWorklistData theInstance = null;
    private Vector<ClinicalSpectroscopyCaseWorklistDataElement> m_workList;
}
