/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.colormap;

import java.awt.Color;

/**
 *
 * @author nunopbarros
 */
public class ColorScale {
//    Colors

    private String name;
    private Color[] colors;

    /**
     *
     * @param name name of the color scale
     * @param colors ordered list of colors from lowest to highest value
     */
    public ColorScale(String name, Color[] colors) {
        this.name = name;
        this.colors = colors;
    }

    /**
     * Returns a color according to the predefined scale
     *
     * @param val value from 0 to 1
     * @param alpha transparency (0-255)
     * @return
     */
    public Color getColor(float val, int alpha) {
        if (val >= 1f) {
            Color c1 = colors[colors.length - 1];
            return new Color(c1.getRed(), c1.getGreen(), c1.getBlue(), alpha);
        }
        if (val <= 0f) {
            Color c1 = colors[0];
            return new Color(c1.getRed(), c1.getGreen(), c1.getBlue(), alpha);
        }
        int n = (int) (val * (float) (colors.length - 1));
        float rest = (val * (float) (colors.length - 1)) - n;
        Color c1 = colors[n];
        Color c2 = colors[n + 1];

        int r = Math.round(c1.getRed() * (1f - rest) + c2.getRed() * rest);
        int g = Math.round(c1.getGreen() * (1f - rest) + c2.getGreen() * rest);
        int b = Math.round(c1.getBlue() * (1f - rest) + c2.getBlue() * rest);

        return new Color(r, g, b, alpha);
    }

    public String getName() {
        return name;
    }
}
