/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.curvefitting;

/**
 *
 * @author Nuno
 */
public class DoubleGaussian {
    
    private double miu1;
    private double miu2;
    private double sigma1;
    private double sigma2;
    private double ratio;

    public DoubleGaussian(double miu1, double sigma1, double miu2, double sigma2, double ratio) {
        this.miu1 = miu1;
        this.miu2 = miu2;
        this.sigma1 = sigma1;
        this.sigma2 = sigma2;
        this.ratio = ratio;
    }
    
    public void setParameters(double miu1, double sigma1, double miu2, double sigma2,  double ratio) {
        this.miu1 = miu1;
        this.miu2 = miu2;
        this.sigma1 = sigma1;
        this.sigma2 = sigma2;
        this.ratio = ratio;
    }
    
    public double getY(double x) {        
        return (float) ((ratio/Math.sqrt(2*Math.PI*Math.pow(sigma1, 2)))*Math.exp(-Math.pow(x-miu1,2)/(2*Math.pow(sigma1,2)))+
                ((1-ratio)/Math.sqrt(2*Math.PI*Math.pow(sigma2, 2)))*Math.exp(-Math.pow(x-miu2,2)/(2*Math.pow(sigma2,2))));
    }

    public double[] getY(double x[]) {
        double res[] = new double[x.length];
        for (int i = 0; i < x.length; i++) {
            res[i] = getY(x[i]);
        }
        return res;
    }
    
}

