/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.decisionforest.structure;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.mongodb.BasicDBList;
import com.mongodb.BasicDBObject;
import com.mongodb.DBObject;
import com.mongodb.util.JSON;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.spectrim.decisionforest.data.DataSet;
import org.spectrim.decisionforest.multithreading.ForestTrainingControler;
import org.spectrim.decisionforest.multithreading.ResultsListener;
import org.spectrim.decisionforest.results.ResultSet;

/**
 *
 * @author user
 */
public class Forest implements java.io.Serializable {

    private int ntree;
    private int counter;
    private int maxdepth;
    private int nrvarnode;
    private int nriter;
    private int nrsamples;
    private int baggingsize;
    private int nrvardata;
    private int nchilds;
    private int minsize;
    private DataSet traindata;
    private DataSet testdata;
    private ArrayList<ResultSet> resultsOOB;
    private LinkedList<Tree> trees;
    private ForestTrainingControler controler;
    private final int treesPerGroup = 24;
    private int lastTree;
    private int maxSplits;
    private ResultSet globalResults;
    private double minreliab;
    private String resultsOutput;
    private ResultsListener resultsListener;
    private ArrayList<Double> varMin;
    private ArrayList<Double> varMax;
    private int weaklearner;
    private boolean optimizeWeights;

    public Forest(int ntree, int maxdepth, int nchilds, int nrvarnode, int nrvardata, int minsize, int maxSplits) {
        this.ntree = ntree;
        this.maxdepth = maxdepth;
        this.nrvarnode = nrvarnode;
        this.nrvardata = nrvardata;
        this.nchilds = nchilds;
        this.trees = new LinkedList<>();
        this.minsize = minsize;
        this.maxSplits = maxSplits;
    }

    public Forest() {
    }

    private void addtree() {
//        DataSet auxdataset = new DataSet();
//        auxdataset.addAll(this.dataset);
        this.trees.add(new Tree(this, maxdepth, nchilds, nrvarnode, nrvardata, minsize, maxSplits));
    }

    public void setTestData(DataSet testdata) {
        this.testdata = testdata;
    }

    public void train(DataSet traindata, int nriter, int nrsamples, int baggingsize, boolean normalize, int weaklearner, boolean optimizeWeights) {

        if (normalize) {
            this.varMax = (ArrayList<Double>) traindata.getVarMax().clone();
            this.varMin = (ArrayList<Double>) traindata.getVarMin().clone();
            traindata.normalize();
        }
        this.traindata = traindata;
        this.nriter = nriter;
        this.baggingsize = baggingsize;
        this.nrsamples = nrsamples;
        this.weaklearner = weaklearner;
        this.optimizeWeights = optimizeWeights;

        for (int i = 1; i <= ntree; i++) {
            this.addtree();
            if (i % 10 == 0) {
//                System.out.println("Planting trees... (" + i + "/" + this.ntree + ")");
            }
        }

        resultsOOB = new ArrayList<>();
        for (int n = 0; n <= this.nrvardata; n++) {
            resultsOOB.add(new ResultSet());
        }
        trainTreeGroup(0, treesPerGroup - 1);
    }

    public void trainTreeGroup(int firstIndex, int lastIndex) {
        for (int i = firstIndex; i <= lastIndex; i++) {
            if (i < trees.size()) {
//                System.out.println("Starting to train tree nr: " + i);
                this.trees.get(i).startTrainingThread(traindata, nriter, nrsamples, baggingsize, resultsOOB, weaklearner, optimizeWeights);
                lastTree = i;
            }
        }
    }

    public void trainTree(int i) {
        if (i < trees.size()) {
//            System.out.println("Starting to train tree nr: " + i);
            this.trees.get(i).startTrainingThread(traindata, nriter, nrsamples, baggingsize, resultsOOB, weaklearner, optimizeWeights);
            lastTree = i;
        }
    }

    public void testTreeGroup(int firstIndex, int lastIndex) {
        for (int i = firstIndex; i <= lastIndex; i++) {
            if (i < trees.size()) {
                this.trees.get(i).startTestingThread(testdata, minreliab);
                lastTree = i;
            }
        }
    }

    public void testTree(int i) {
        if (i < trees.size()) {
            this.trees.get(i).startTestingThread(testdata, minreliab);
            lastTree = i;
        }
    }

    public synchronized void informTrainedTree() {
        counter++;
//        System.out.println("Training... (" + nrTrainedTrees + "/" + this.ntree + ")");
        if (counter < ntree) {
            trainTree(lastTree + 1);
        } else if (counter == ntree) {
//            DecimalFormat formatter = new DecimalFormat("#.#####");
//            double OOBerr = resultsOOB.get(0).getErrorRate(traindata);
//            double OOBMSE = resultsOOB.get(0).getMSE(traindata);
//            String txt1 = "OOBerr";
//            String txt2 = formatter.format(OOBerr);
//
//            for (int n = 1; n <= this.nrvardata; n++) {
//                txt2 = txt2 + "\t" + formatter.format(resultsOOB.get(n).getErrorRate(traindata));
//                txt1 = txt1 + "\t" + "var" + n;
//            }
//            System.out.println(txt1);
//            System.out.println(txt2);
//            txt1 = "OOBMSE";
//            txt2 = formatter.format(OOBMSE);
//            for (int n = 0; n < this.nrvardata; n++) {
//                txt2 = txt2 + "\t" + formatter.format(resultsOOB.get(n).getMSE(traindata));
//                txt1 = txt1 + "\t" + "var" + n;
//            }
//            System.out.println(txt1);
//            System.out.println(txt2);
//            this.save("C:\\Users\\user\\Desktop\\label backup\\forest_dataset"+ntree+"_"+maxdepth+"_"+nchilds+"_"+nrvarnode+"_"+minsize+"_"+String.valueOf(System.currentTimeMillis())+".data");
            if (controler != null) {
                controler.testAndSaveForest(this);
                controler.trainNextForest();
            }
        }
    }

    public synchronized void reportResults(ResultSet results) {
        counter++;
        if (counter == 1) {
            globalResults = results;
        } else {
            globalResults.mergeWith(results);
        }

        if (counter < ntree) {
            testTree(lastTree + 1);
        } else if (counter == ntree) {
            if (resultsListener != null) {
                resultsListener.resultsReady(globalResults);
            }
            if (!this.resultsOutput.matches("")) {
                try {
                    globalResults.writeResults(resultsOutput);
                } catch (FileNotFoundException ex) {
                    Logger.getLogger(Forest.class.getName()).log(Level.SEVERE, null, ex);
                } catch (UnsupportedEncodingException ex) {
                    Logger.getLogger(Forest.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }

    public void test(DataSet testdata, double minreliab, String resultsOutput, ResultsListener listener, boolean multithreading) {
        if (this.varMax != null) {
            testdata.normalize(varMin, varMax);
        }
        if (!multithreading) {
            ListIterator iter = this.trees.listIterator(0);
            Tree treeaux;
            DataSet dataaux;
            ArrayList<Integer> dataelemaux = new ArrayList<>();
            ResultSet results = new ResultSet();
            int j = 1;

            for (int i = 0; i < testdata.size(); i++) {
                dataelemaux.add(i);
            }
            while (iter.hasNext()) {
                treeaux = (Tree) iter.next();
                dataaux = (DataSet) testdata.clone();
                treeaux.test(dataelemaux, testdata, results, minreliab);
                dataaux.clear();
                if (j % 10 == 0) {
//                System.out.println("Testing... (" + j + "/" + this.ntree + ")");
                }
                j++;
            }
            try {
                if (!resultsOutput.matches("")) {
                    results.writeResults(resultsOutput);
                }
            } catch (FileNotFoundException | UnsupportedEncodingException ex) {
                Logger.getLogger(Forest.class.getName()).log(Level.SEVERE, null, ex);
            }
        } else {
            counter = 0;
            this.resultsListener = listener;
            this.globalResults = new ResultSet();
            this.testdata = testdata;
            this.minreliab = minreliab;
            this.resultsOutput = resultsOutput;
            testTreeGroup(0, treesPerGroup - 1);
        }
    }

    public void setControler(ForestTrainingControler controler) {
        this.controler = controler;
    }

    public void save(String file) {

        BasicDBObject dbVarMax = new BasicDBObject();
        for (int i = 0; i < this.varMax.size(); i++) {
            dbVarMax.append(String.valueOf(i), this.varMax.get(i));
        }
        BasicDBObject dbVarMin = new BasicDBObject();
        for (int i = 0; i < this.varMin.size(); i++) {
            dbVarMin.append(String.valueOf(i), this.varMin.get(i));
        }

        BasicDBObject forest = new BasicDBObject().
                append("ntree", this.ntree).
                append("maxdepth", this.maxdepth).
                append("nrvarnode", this.nrvarnode).
                append("nrvardata", this.nrvardata).
                append("nchilds", this.nchilds).
                append("varmax", dbVarMax).
                append("varmin", dbVarMin);

        List<BasicDBObject> listTree = new ArrayList<>();
        for (Tree tree : trees) {
            listTree.add(tree.save());
        }

        forest.append("forest", listTree);

        StringWriter sw = new StringWriter();
        try {
            Writer writer = new FileWriter(file);
            Gson gson = new GsonBuilder().setPrettyPrinting().create();
            writer.write(gson.toJson(forest));
            writer.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    public void load(String file) {
        String input = "";

        BufferedReader br;
        try {
            br = new BufferedReader(new FileReader(file));
            StringBuilder sb = new StringBuilder();
            String line = br.readLine();

            while (line != null) {
                sb.append(line);
                sb.append('\n');
                line = br.readLine();
            }
            input = sb.toString();
            br.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        DBObject obj = (DBObject) JSON.parse(input);

        this.ntree = Integer.valueOf(obj.get("ntree").toString());
        this.maxdepth = Integer.valueOf(obj.get("maxdepth").toString());
        this.nrvarnode = Integer.valueOf(obj.get("nrvarnode").toString());
        this.nrvardata = Integer.valueOf(obj.get("nrvardata").toString());
        this.nchilds = Integer.valueOf(obj.get("nchilds").toString());
        this.trees = new LinkedList<>();

        this.varMax = new ArrayList<>();
        this.varMin = new ArrayList<>();

        BasicDBObject dbVarMax = (BasicDBObject) obj.get("varmax");
        for (int i = 0; i < dbVarMax.keySet().size(); i++) {
            this.varMax.add(new Double(dbVarMax.getDouble("" + i)));
        }
        BasicDBObject dbVarMin = (BasicDBObject) obj.get("varmin");
        for (int i = 0; i < dbVarMin.keySet().size(); i++) {
            this.varMin.add(new Double(dbVarMin.getDouble("" + i)));
        }

        List<BasicDBObject> dbForest = (List<BasicDBObject>) obj.get("forest");

        for (BasicDBObject dbTree : dbForest) {
            Tree tree = new Tree();

            tree.maxdepth = Integer.valueOf(dbTree.get("maxdepth").toString());
            tree.nchilds = Integer.valueOf(dbTree.get("nchilds").toString());
            tree.nodenum = Integer.valueOf(dbTree.get("nodenum").toString());
            tree.root = loadNode((BasicDBObject) dbTree.get("tree"));
            tree.parent = this;
            this.trees.add(tree);
        }
    }

    public static Node loadNode(BasicDBObject dbNode) {

        Node node = new Node();
        node.id = dbNode.getInt("id");
        node.level = dbNode.getInt("level");
        node.infgain = (double) dbNode.getDouble("infgain");
        node.childList = new ArrayList<>();
        node.varnode = new ArrayList<>();
        BasicDBObject dbVarnode = (BasicDBObject) dbNode.get("varnode");
        for (int i = 0; i < dbVarnode.keySet().size(); i++) {
            node.varnode.add(dbVarnode.getInt("" + i));
        }
        BasicDBObject dbCentroidWeights = (BasicDBObject) dbNode.get("centroidWeights");
        node.centroidWeights = new double[node.childList.size()];
        if (dbCentroidWeights == null) {
            for (int i = 0; i < node.childList.size(); i++) {
                node.centroidWeights[i] = 1;
            }
        } else {
            for (int i = 0; i < dbCentroidWeights.keySet().size(); i++) {
                node.centroidWeights[i] = dbCentroidWeights.getDouble("" + i);
            }
        }
        node.dataelem = new ArrayList<>();
        node.paramnode = new ArrayList<>();
        BasicDBObject dbParamnode = (BasicDBObject) dbNode.get("paramnode");
        for (int i = 0; i < dbParamnode.keySet().size(); i++) {
            node.paramnode.add(dbParamnode.getDouble("" + i));
        }
        node.endnodeclass = dbNode.getString("endnodeclass");
        BasicDBList dbTrainPop = (BasicDBList) dbNode.get("trainingPopulation");
        for (int i = 0; i < dbTrainPop.keySet().size(); i++) {
            String entry = ((BasicDBObject) dbTrainPop.get(i)).getString("" + i);
            String[] parts = entry.split("%%%");
            node.trainingPopulation.put(parts[0], Integer.valueOf(parts[1]));
        }
        node.nrElementsTraining = dbNode.getInt("nrElements");
        List<BasicDBObject> listNodeChildren = (List<BasicDBObject>) dbNode.get("children");
        for (BasicDBObject dbChild : listNodeChildren) {
            node.childList.add(loadNode(dbChild));
        }

        return node;
    }
}
