/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * DicomFileCreatorOptionsFrame.java
 *
 * Created on 07-Jun-2009, 18:47:41
 */

package org.spectrim.dicom;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.JFileChooser;
import javax.swing.JFrame;

/**
 * DicomFileCreatorOptionsFrame enables the setting of Dicom related file 
 * creation options.
 * @author slotboom
 */
public class DicomFileCreatorOptionsFrame extends javax.swing.JFrame implements ActionListener
{



    /** 
     * Constructor: creates new form DicomFileCreatorOptionsFrame. 
     * @param frameTitle
     * @param parent
     * @param fInfo
     */
    public DicomFileCreatorOptionsFrame( String frameTitle, JFrame parent, FileInfo fInfo )
    {
        initComponents( );
        
        setTitle( frameTitle );

        m_parent = parent;

        // provide user with information  of selected patient
        m_patientNameLabel.setText( fInfo.getPatientName( ) );
        m_DOBLabel.setText( fInfo.getPatientBirthDate( ) );
        m_patientNumberLabel.setText( fInfo.getPatientID( ) );
        m_examinationDateLabel.setText( fInfo.getAcquisitionDate( ) );
        m_examinationTimeLabel.setText( "" + fInfo.getAcquisitionTime( ) );
        m_accessionNumberLabel.setText( "" + fInfo.getAccessionNumber( ) );

        // provide user with information of currently selected remote dicom node
        DicomNetworkNodeDefaults dnwnd = DicomNetworkNodeDefaults.getInstance( );
        DicomNetworkNodes  dnwns = DicomNetworkNodes.getInstance( );
        DicomNetworkNode dnwn = dnwns.getRemoteDicomNetworkNode( dnwns.getSelectedRemoteDicomNodeNumber( ) );

        m_selectedDicomNodeName.setText( dnwn.getNodeName( ) );
        m_selectedDicomNodeIPAddress.setText( dnwn.getIPaddressr( ) );
        m_selectedDicomNodePortNumber.setText( "" + dnwn.getDicomReceivePortNumber( ) );
        m_selectedDicomNodeAetitle.setText( dnwn.getReceiveAEtitle( ) );

        m_seriesDescriptionTextField.setText( "Secondary capture DIN Bildlabor" );
        m_seriesNumbertextField.setText( "1000" );

        m_currentIntermediateStorageForCreationDicomFilesDirectory.setText( DicomNetworkNodeDefaults.getInstance( ).getProperty( DicomNetworkNodeDefaults.CURRENT_INTERMEDIATE_DICOM_CREATION_DIRECTORY ) );

        
        pack( );
        // Put the Dialog nicely in the middle of its parent
        Point centerParent = new Point( m_parent.getX( ) + ( m_parent.getWidth( ) - getWidth( ) ) / 2,
                                        m_parent.getY( ) + ( m_parent.getHeight( ) - getHeight( ) ) / 2 );

        setLocation( centerParent );
        setVisible( true );

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        m_patientNameLabel = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        m_patientNumberLabel = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        m_examinationDateLabel = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        m_examinationTimeLabel = new javax.swing.JLabel();
        m_accessionNumberLabel = new javax.swing.JLabel();
        jLabel111 = new javax.swing.JLabel();
        jLabel112 = new javax.swing.JLabel();
        m_DOBLabel = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        m_includeGeometryTags = new javax.swing.JCheckBox();
        jLabel2 = new javax.swing.JLabel();
        m_seriesDescriptionTextField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        m_seriesNumbertextField = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        m_currentIntermediateStorageForCreationDicomFilesDirectory = new javax.swing.JLabel();
        m_setLocalDicomDirectory = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        m_selectedDicomNodeName = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        m_selectedDicomNodeIPAddress = new javax.swing.JLabel();
        m_selectedDicomNodePortNumber = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        m_selectedDicomNodeAetitle = new javax.swing.JLabel();
        m_changeSelectedDicomNode = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        m_createOnlyButton = new javax.swing.JButton();
        m_createAndSendDicomFilesButton = new javax.swing.JButton();
        m_cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Patient & examination details"));

        jLabel1.setText("Patient name         :");

        m_patientNameLabel.setFont(new java.awt.Font("DejaVu Sans", 1, 13)); // NOI18N
        m_patientNameLabel.setForeground(new java.awt.Color(251, 0, 0));
        m_patientNameLabel.setText(">> patient name <<");

        jLabel3.setText("Date of birth          :");

        m_patientNumberLabel.setFont(new java.awt.Font("DejaVu Sans", 1, 13)); // NOI18N
        m_patientNumberLabel.setText(">> patient number <<");

        jLabel5.setText("Examination date   :");

        m_examinationDateLabel.setText(">> examination date  <<");

        jLabel7.setText("Examination time   :");

        m_examinationTimeLabel.setText(">> examination time  <<");

        m_accessionNumberLabel.setText(">> accession number  <<");

        jLabel111.setText("Accession number :");

        jLabel112.setText("Patient number     :");

        m_DOBLabel.setFont(new java.awt.Font("DejaVu Sans", 1, 13)); // NOI18N
        m_DOBLabel.setText(">> date of birth <<");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel7)
                            .addComponent(jLabel111))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_accessionNumberLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_examinationTimeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addGap(18, 18, 18)
                        .addComponent(m_DOBLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(18, 18, 18)
                        .addComponent(m_patientNameLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel5)
                        .addGap(18, 18, 18)
                        .addComponent(m_examinationDateLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel112)
                        .addGap(18, 18, 18)
                        .addComponent(m_patientNumberLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(781, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(m_patientNameLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(m_DOBLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel112)
                    .addComponent(m_patientNumberLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(m_examinationDateLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_examinationTimeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_accessionNumberLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel111)))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Dicom creation options"));

        m_includeGeometryTags.setSelected(true);
        m_includeGeometryTags.setText("Copy spatial information from associated dicom file");

        jLabel2.setText("Series description");

        jLabel6.setText("Series number");

        jLabel10.setText("Local dicom directory");

        m_currentIntermediateStorageForCreationDicomFilesDirectory.setText(">>Local directory to store intermediate dicom files <<");

        m_setLocalDicomDirectory.setText("Set local Dicom directory");
        m_setLocalDicomDirectory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_setLocalDicomDirectoryActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_includeGeometryTags)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel10)
                            .addComponent(jLabel2)
                            .addComponent(jLabel6))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_seriesNumbertextField, javax.swing.GroupLayout.DEFAULT_SIZE, 740, Short.MAX_VALUE)
                            .addComponent(m_seriesDescriptionTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 740, Short.MAX_VALUE)
                            .addComponent(m_currentIntermediateStorageForCreationDicomFilesDirectory))))
                .addGap(4, 4, 4)
                .addComponent(m_setLocalDicomDirectory)
                .addGap(27, 27, 27))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(m_includeGeometryTags)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(m_seriesDescriptionTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_seriesNumbertextField, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 14, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel10)
                    .addComponent(m_currentIntermediateStorageForCreationDicomFilesDirectory)
                    .addComponent(m_setLocalDicomDirectory))
                .addGap(22, 22, 22))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Selected Dicom node to send images to"));

        jLabel8.setText("Dicom node name :");

        m_selectedDicomNodeName.setText(">>selected dicom node<<");

        jLabel11.setText("IP-address              :");

        m_selectedDicomNodeIPAddress.setText(">>ip-addresss of dicom node<<");

        m_selectedDicomNodePortNumber.setText(">>port number of dicom node<<");

        jLabel14.setText("Port number          :");

        jLabel15.setText("AE-title                   :");

        m_selectedDicomNodeAetitle.setText(">>port number of dicom node<<");

        m_changeSelectedDicomNode.setText("Change selected Dicom node .. ");
        m_changeSelectedDicomNode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_changeSelectedDicomNodeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel8)
                        .addGap(18, 18, 18)
                        .addComponent(m_selectedDicomNodeName))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel11)
                        .addGap(18, 18, 18)
                        .addComponent(m_selectedDicomNodeIPAddress))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel14)
                        .addGap(18, 18, 18)
                        .addComponent(m_selectedDicomNodePortNumber))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel15)
                        .addGap(18, 18, 18)
                        .addComponent(m_selectedDicomNodeAetitle)))
                .addContainerGap(715, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(360, Short.MAX_VALUE)
                .addComponent(m_changeSelectedDicomNode)
                .addGap(537, 537, 537))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(m_selectedDicomNodeName))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(m_selectedDicomNodeIPAddress))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(m_selectedDicomNodePortNumber))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel15)
                    .addComponent(m_selectedDicomNodeAetitle))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 16, Short.MAX_VALUE)
                .addComponent(m_changeSelectedDicomNode)
                .addContainerGap())
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        m_createOnlyButton.setText("Only Create Dicom File(s)");
        m_createOnlyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_createOnlyButtonActionPerformed(evt);
            }
        });

        m_createAndSendDicomFilesButton.setText("Create & Send Dicom File(s)");
        m_createAndSendDicomFilesButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_createAndSendDicomFilesButtonActionPerformed(evt);
            }
        });

        m_cancelButton.setText("Cancel");
        m_cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_cancelButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addGap(27, 27, 27)
                .addComponent(m_cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 214, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 243, Short.MAX_VALUE)
                .addComponent(m_createAndSendDicomFilesButton, javax.swing.GroupLayout.PREFERRED_SIZE, 214, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(206, 206, 206)
                .addComponent(m_createOnlyButton, javax.swing.GroupLayout.PREFERRED_SIZE, 214, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(37, 37, 37))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_createOnlyButton)
                    .addComponent(m_cancelButton)
                    .addComponent(m_createAndSendDicomFilesButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
    /**
     * Called after pressing the cancel button.
     * @param evt 
     */
    private void m_cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_cancelButtonActionPerformed
        // TODO add your handling code here:
        notifyActionListeners( NOTIFY_CANCEL_BUTTON_PRESSED_EVENT, null );
    }//GEN-LAST:event_m_cancelButtonActionPerformed

    /**
     * Called after pressing rge create and sent Dicom files button.
     * @param evt 
     */
    private void m_createAndSendDicomFilesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_createAndSendDicomFilesButtonActionPerformed
        if ( m_includeGeometryTags.isSelected( ) == true )
        {
            notifyActionListeners( NOTIFY_DICOMIZE_AND_SEND_BUTTON_PRESSED, ALSO_INCLUDE_SPATIAL_TAGS );
        }
        else
        {
            notifyActionListeners( NOTIFY_DICOMIZE_AND_SEND_BUTTON_PRESSED, DO_NOT_INCLUDE_SPATIAL_TAGS );
        }
    }//GEN-LAST:event_m_createAndSendDicomFilesButtonActionPerformed
    
    /**
     * Called after the button create only Dicom file button is pressed.
     * @param evt 
    */
    private void m_createOnlyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_createOnlyButtonActionPerformed

        if ( m_includeGeometryTags.isSelected( ) == true )
        {
            notifyActionListeners( NOTIFY_DICOMIZE_ONLY_BUTTON_PRESSED, ALSO_INCLUDE_SPATIAL_TAGS );
        }
        else
        {
            notifyActionListeners( NOTIFY_DICOMIZE_ONLY_BUTTON_PRESSED, DO_NOT_INCLUDE_SPATIAL_TAGS );
        }
    }//GEN-LAST:event_m_createOnlyButtonActionPerformed

    /**
     * Called after a selected dicom node action performed is detected.  
     * @param evt 
     */
    private void m_changeSelectedDicomNodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_changeSelectedDicomNodeActionPerformed
        m_dicomNodesFrame = new DicomNetworkNodeDefinerAndSelectionFrame( this );
        m_dicomNodesFrame.addActionListener( this );
}//GEN-LAST:event_m_changeSelectedDicomNodeActionPerformed
    /**
     * Allows the user to define a Dicom path on the local machine in which 
     * the data is stored.
     * @param evt
    */
    private void m_setLocalDicomDirectoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_setLocalDicomDirectoryActionPerformed
        // TODO add your handling code here:

       setLocalDicomDirectory( );

    }//GEN-LAST:event_m_setLocalDicomDirectoryActionPerformed

    /**
     * Returns the Dicom directory selected by the user.
     */
    private File setLocalDicomDirectory( )
    {
        DicomNetworkNodeDefaults fdef = DicomNetworkNodeDefaults.getInstance( );

        JFileChooser fileChooser = new JFileChooser( fdef.getProperty( DicomNetworkNodeDefaults.CURRENT_INTERMEDIATE_DICOM_CREATION_DIRECTORY ) + System.getProperty( "file.separator" ) );

        fileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );

        int result = fileChooser.showOpenDialog( this );

        File selected_dir = new File( "" );

        switch ( result )
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                                                selected_dir = fileChooser.getSelectedFile( );
                                                DicomNetworkNodeDefaults def = DicomNetworkNodeDefaults.getInstance( );
                                                def.setProperty( DicomNetworkNodeDefaults.CURRENT_INTERMEDIATE_DICOM_CREATION_DIRECTORY, selected_dir.getPath( ) );
                                                def.save( );
                                                this.m_currentIntermediateStorageForCreationDicomFilesDirectory.setText( selected_dir.getPath( ) );
                                                break;
           case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                                                break;
           case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                                                break;
        }

        return selected_dir;
    }

    /**
     * Notify listeners that something in this object has changed.
     * @param eventType
     * @param cmnd
     */
    protected void notifyActionListeners( int eventType, String cmnd )
    {

        Iterator it = m_actionListeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, eventType, cmnd ) );
        }

    }


    /**
     * Adds an action listener to the list of action listeners who are notified
     * when something happens in this component.
     * @param e
     */
    public void addActionListener( ActionListener e )
    {
        m_actionListeners.add( e );
    }

    /**
     * Is called whenever a registered object raises an ActionEvent.
     * @param ae
     */
    @Override
    public void actionPerformed( ActionEvent ae ) 
    {
        
        Object sender = ae.getSource( );
        
        if ( sender == m_dicomNodesFrame )
        {
            if ( ae.getID( ) == DicomNetworkNodeDefinerAndSelectionFrame.OK_BUTTON_PRESSED )
            {
                // provide user with information of currently selected remote dicom node
                DicomNetworkNodeDefaults dnwnd = DicomNetworkNodeDefaults.getInstance( );
                DicomNetworkNodes  dnwns = DicomNetworkNodes.getInstance( );
                DicomNetworkNode dnwn = dnwns.getRemoteDicomNetworkNode( dnwns.getSelectedRemoteDicomNodeNumber( ) );
            
                // refresh the text of the selected node
                m_selectedDicomNodeName.setText( dnwn.getNodeName( ) );
                m_selectedDicomNodeIPAddress.setText( dnwn.getIPaddressr( ) );
                m_selectedDicomNodePortNumber.setText( "" + dnwn.getDicomReceivePortNumber( ) );
                m_selectedDicomNodeAetitle.setText( dnwn.getReceiveAEtitle( ) );


            }
        }
    }
    
    /**
     * Returns the user defined series number.
     * @return
     */
    public int getUserSelectedSeriesNumberForDicomization( )
    {
        return (new Integer( m_seriesNumbertextField.getText( ) ) );
    }


    /**
     * Returns the user defined series number.
     * @return
     */
    public String getUserSelectedSeriesDescriptionForDicomization( )
    {
        return m_seriesDescriptionTextField.getText( );
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel111;
    private javax.swing.JLabel jLabel112;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JLabel m_DOBLabel;
    private javax.swing.JLabel m_accessionNumberLabel;
    private javax.swing.JButton m_cancelButton;
    private javax.swing.JButton m_changeSelectedDicomNode;
    private javax.swing.JButton m_createAndSendDicomFilesButton;
    private javax.swing.JButton m_createOnlyButton;
    private javax.swing.JLabel m_currentIntermediateStorageForCreationDicomFilesDirectory;
    private javax.swing.JLabel m_examinationDateLabel;
    private javax.swing.JLabel m_examinationTimeLabel;
    private javax.swing.JCheckBox m_includeGeometryTags;
    private javax.swing.JLabel m_patientNameLabel;
    private javax.swing.JLabel m_patientNumberLabel;
    private javax.swing.JLabel m_selectedDicomNodeAetitle;
    private javax.swing.JLabel m_selectedDicomNodeIPAddress;
    private javax.swing.JLabel m_selectedDicomNodeName;
    private javax.swing.JLabel m_selectedDicomNodePortNumber;
    private javax.swing.JTextField m_seriesDescriptionTextField;
    private javax.swing.JTextField m_seriesNumbertextField;
    private javax.swing.JButton m_setLocalDicomDirectory;
    // End of variables declaration//GEN-END:variables


    private final LinkedList<ActionListener> m_actionListeners = new LinkedList<>( );
    private DicomNetworkNodeDefinerAndSelectionFrame m_dicomNodesFrame;
    public final static int NOTIFY_CANCEL_BUTTON_PRESSED_EVENT = 0;
    public final static int NOTIFY_DICOMIZE_AND_SEND_BUTTON_PRESSED = 1;
    public final static int NOTIFY_DICOMIZE_ONLY_BUTTON_PRESSED = 2;

    public final static String ALSO_INCLUDE_SPATIAL_TAGS = "ALSO_INCLUDE_SPATIAL_TAGS";
    public final static String DO_NOT_INCLUDE_SPATIAL_TAGS = "DO_NOT_INCLUDE_SPATIAL_TAGS";
    private final JFrame m_parent;
}
