/*
 * File: $Id: DicomNetworkListenerPropertiesFrame.java,v 1.6 2009/15/06 13:28:39 hans Exp $
 * History
 * Date: 15.06.2009  Authors: Hans Slotboom
 *
 * Changes:
 *
 * Copyright (C) 2009 by
 *
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */
  
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.spectrim.dicom;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.JFrame;

/**
 * 
 * Frame allowing the user to set Network listing properties
 * 
 * @author slotboom
 */
public class DicomNetworkListenerPropertiesFrame extends JFrame implements ActionListener
{
    /**
     * Constructor of the DicomNetworkListening properties
     */
    public DicomNetworkListenerPropertiesFrame( JFrame parent )
    {
        m_parent = parent;
        
        m_dicomNetworkListenerPropertiesPanel = new DicomNetworkListenerPropertiesPanel( this );
        m_dicomNetworkListenerPropertiesPanel.addActionListener( this );

        setContentPane( m_dicomNetworkListenerPropertiesPanel );

        this.setTitle( "Dicom Network Listener Properties Definition Control" );
        
        pack( );
        // Put the Dialog nicely in the middle of its parent
        Point centerParent = new Point( m_parent.getX( ) + ( m_parent.getWidth( ) - getWidth( ) ) / 2,
                                        m_parent.getY( ) + ( m_parent.getHeight( ) - getHeight( ) ) / 2 );

        setLocation( centerParent );
        setVisible( true );

    }
    
     
    /**
     * Implements actionListener 
     * @param arg0
     */
    public void actionPerformed( ActionEvent e )
    {

        Object sender = e.getSource( );

        if ( sender == m_dicomNetworkListenerPropertiesPanel )
        {
            if ( e.getID( ) == DicomNetworkListenerPropertiesPanel.HIDE_FRAME_ID )
            {
                this.setVisible( false );
            }
        }

        if ( sender instanceof File )
        {
            
            if ( e.getID( ) == DicomNetworkListenerPropertiesPanel.NOTIFY_DICOM_FILE_UNEXPECTED_EOF_ID  )
            {
                System.out.println( "DicomNetworkListenerPropertiesFrame::actionPerformed::NOTIFY_DICOM_FILE_UNEXPECTED_EOF_ID" );
            }
            
        }
//TO DO Handling code once a CSI dataset is detected.
//        if ( e.getSource( ) instanceof SiemensSVSLoader )
//        {
//            if ( e.getActionCommand( ).compareTo( SiemensSpectroscopyLoadingHandler.SIEMENS_SVS_DATASERIES_COMPLETE_COMMAND ) == 0 )
//            {
//                if ( e.getID( ) == SiemensSpectroscopyLoadingHandler.SIEMENS_SVS_DATASERIES_COMPLETE_ID )
//                {
//                    System.out.println( ">>>>>> All data is available" );
//                    notifyActionListeners( e.getSource( ), e.getID( ), e.getActionCommand( ) );
//                }
//            }
//        }
    }

    /**
     * Adds an actionlistener to the list of ActionListeners
     * @param aThis
     */
    public void addActionListener( ActionListener listener  )
    {
        m_actionListeners.add( listener );
    }

    /**
     * Notifies actionEvent to all registered listeners
     */
    private void notifyActionListeners( Object obj, int eventType, String eventString )
    {
        Iterator it = m_actionListeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( obj, eventType, eventString ) );
        }
    }


    // Panel to control 
    private JFrame m_parent;
    private DicomNetworkListenerPropertiesPanel m_dicomNetworkListenerPropertiesPanel;
    private LinkedList<ActionListener> m_actionListeners = new LinkedList<ActionListener>( );
   
    static final public String  NOTIFY_DICOM_FILE_RENAMED       = "DICOM_IMAGE_FILE_RENAMED";
    public static final int     NOTIFY_DICOM_FILE_RENAMED_ID    = 1;
   
}