/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * DicomRegridImageSeriesPropertiesFrame.java
 *
 * Created on 30-Aug-2010, 13:21:15
 */

package org.spectrim.dicom;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.JFrame;

/**
 * Frame to enable re-gridding of Dicom image data.
 * @author slotboom
 */
public class DicomRegridImageSeriesPropertiesFrame extends javax.swing.JFrame {

    /** 
     * Creates new form DicomRegridImageSeriesPropertiesFrame.
     * @param parent
     * @param initialXMatrixSize
     * @param initialYMatrixSize
     * @param seriesDescription
     */
    public DicomRegridImageSeriesPropertiesFrame( JFrame parent, 
                                                  int initialXMatrixSize, 
                                                  int initialYMatrixSize,
                                                  String seriesDescription )
    {
        initComponents( );

        pack( );
        
        m_currentImageMatrixSizeXLabel.setText( "" + initialXMatrixSize );
        m_currentImageMatrixSizeYLabel.setText( "" + initialYMatrixSize );
        m_newSeriesDescriptionTextField.setText( eliminateIllegalFileSystemCharacters( seriesDescription ).trim( ) + "_regridded_" );
        if ( parent != null )
        {
            Point centerParent = new Point( parent.getX( ) + ( parent.getWidth( ) - getWidth( ) ) / 2,
                                            parent.getY( ) + ( parent.getHeight( ) - getHeight( ) ) / 2 );

            setLocation( centerParent );

        }

        if ( initialXMatrixSize == 64 )
        {
            m_selectNewNumberOfPixelsInXDirection.setSelectedIndex( 5 );
            m_selectNewNumberOfPixelsInYDirection.setSelectedIndex( 5 );
        }
        else if ( initialXMatrixSize == 128 )
        {
            m_selectNewNumberOfPixelsInXDirection.setSelectedIndex( 6 );
            m_selectNewNumberOfPixelsInYDirection.setSelectedIndex( 6 );
        }
        else if ( initialXMatrixSize == 256 )
        {
            m_selectNewNumberOfPixelsInXDirection.setSelectedIndex( 7 );
            m_selectNewNumberOfPixelsInYDirection.setSelectedIndex( 7 );
        }
        else if ( initialXMatrixSize == 512 )
        {
            m_selectNewNumberOfPixelsInXDirection.setSelectedIndex( 8 );
            m_selectNewNumberOfPixelsInYDirection.setSelectedIndex( 8 );
        }
        else if ( initialXMatrixSize == 1024 )
        {
            m_selectNewNumberOfPixelsInXDirection.setSelectedIndex( 9 );
            m_selectNewNumberOfPixelsInYDirection.setSelectedIndex( 9 );
        }

        setVisible( true );
        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_informationPanel = new javax.swing.JPanel();
        m_selectNewNumberOfPixelsInXDirection = new javax.swing.JComboBox();
        m_newNumberOfPixelsInXDirection = new javax.swing.JLabel();
        m_selectNewNumberOfPixelsInYDirection = new javax.swing.JComboBox();
        m_newNumberOfPixelsInXDirection1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        m_newSeriesNumberTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        m_newSeriesDescriptionTextField = new javax.swing.JTextField();
        m_propertiesPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        m_currentImageMatrixSizeXLabel = new javax.swing.JLabel();
        m_currentImageMatrixSizeYLabel = new javax.swing.JLabel();
        m_showDicomInformationButton = new javax.swing.JButton();
        m_choicePanel = new javax.swing.JPanel();
        m_performRegriddingButton = new javax.swing.JButton();
        m_cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        m_informationPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Set new DICOM image grid dimensions"));

        m_selectNewNumberOfPixelsInXDirection.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "4", "8", "16", "32", "64", "128", "256", "512", "1024", "2048" }));

        m_newNumberOfPixelsInXDirection.setText("New # pixels X-direction");

        m_selectNewNumberOfPixelsInYDirection.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "4", "8", "16", "32", "64", "128", "256", "512", "1024", "2048" }));

        m_newNumberOfPixelsInXDirection1.setText("New # pixels X-direction");

        jLabel3.setText("New series number");

        m_newSeriesNumberTextField.setText("1000");
        m_newSeriesNumberTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_newSeriesNumberTextFieldActionPerformed(evt);
            }
        });

        jLabel4.setText("New series description");

        m_newSeriesDescriptionTextField.setText("_regridded_256_256");

        javax.swing.GroupLayout m_informationPanelLayout = new javax.swing.GroupLayout(m_informationPanel);
        m_informationPanel.setLayout(m_informationPanelLayout);
        m_informationPanelLayout.setHorizontalGroup(
            m_informationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_informationPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_informationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(m_informationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(m_informationPanelLayout.createSequentialGroup()
                            .addComponent(m_newNumberOfPixelsInXDirection)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(m_selectNewNumberOfPixelsInXDirection, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGroup(m_informationPanelLayout.createSequentialGroup()
                            .addGroup(m_informationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(m_newNumberOfPixelsInXDirection1)
                                .addComponent(jLabel3))
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addGroup(m_informationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(m_selectNewNumberOfPixelsInYDirection, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(m_newSeriesNumberTextField)
                                .addComponent(m_newSeriesDescriptionTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE))))
                    .addComponent(jLabel4))
                .addContainerGap(44, Short.MAX_VALUE))
        );
        m_informationPanelLayout.setVerticalGroup(
            m_informationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_informationPanelLayout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addGroup(m_informationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_newNumberOfPixelsInXDirection)
                    .addComponent(m_selectNewNumberOfPixelsInXDirection, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_informationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_newNumberOfPixelsInXDirection1)
                    .addComponent(m_selectNewNumberOfPixelsInYDirection, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(m_informationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(m_newSeriesNumberTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(m_informationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(m_newSeriesDescriptionTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(22, Short.MAX_VALUE))
        );

        m_propertiesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Current image matrix"));

        jLabel1.setText("Current # pixels X-direction :");

        jLabel2.setText("Current # pixels Y-direction :");

        m_currentImageMatrixSizeXLabel.setText("256");

        m_currentImageMatrixSizeYLabel.setText("256");

        m_showDicomInformationButton.setText("DICOM info..");
        m_showDicomInformationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_showDicomInformationButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout m_propertiesPanelLayout = new javax.swing.GroupLayout(m_propertiesPanel);
        m_propertiesPanel.setLayout(m_propertiesPanelLayout);
        m_propertiesPanelLayout.setHorizontalGroup(
            m_propertiesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_propertiesPanelLayout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addGroup(m_propertiesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(m_propertiesPanelLayout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_currentImageMatrixSizeYLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 50, Short.MAX_VALUE)
                        .addComponent(m_showDicomInformationButton)
                        .addGap(32, 32, 32))
                    .addGroup(m_propertiesPanelLayout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_currentImageMatrixSizeXLabel)
                        .addContainerGap(190, Short.MAX_VALUE))))
        );
        m_propertiesPanelLayout.setVerticalGroup(
            m_propertiesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_propertiesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_propertiesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(m_currentImageMatrixSizeXLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_propertiesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(m_currentImageMatrixSizeYLabel)
                    .addComponent(m_showDicomInformationButton))
                .addContainerGap(17, Short.MAX_VALUE))
        );

        m_performRegriddingButton.setText("Regrid and Write..");
        m_performRegriddingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_performRegriddingButtonActionPerformed(evt);
            }
        });

        m_cancelButton.setText("Cancel");
        m_cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_cancelButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout m_choicePanelLayout = new javax.swing.GroupLayout(m_choicePanel);
        m_choicePanel.setLayout(m_choicePanelLayout);
        m_choicePanelLayout.setHorizontalGroup(
            m_choicePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, m_choicePanelLayout.createSequentialGroup()
                .addGap(42, 42, 42)
                .addComponent(m_cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 186, Short.MAX_VALUE)
                .addComponent(m_performRegriddingButton)
                .addGap(30, 30, 30))
        );
        m_choicePanelLayout.setVerticalGroup(
            m_choicePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, m_choicePanelLayout.createSequentialGroup()
                .addContainerGap(20, Short.MAX_VALUE)
                .addGroup(m_choicePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_performRegriddingButton)
                    .addComponent(m_cancelButton)))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(m_informationPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(m_propertiesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(m_choicePanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_propertiesPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(4, 4, 4)
                .addComponent(m_informationPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_choicePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_cancelButtonActionPerformed
        notifyActionListeners( CANCEL_REGRIDDING_EVENT, CANCEL_REGRIDDING_CMD );
        this.dispose( );
}//GEN-LAST:event_m_cancelButtonActionPerformed

    private void m_performRegriddingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_performRegriddingButtonActionPerformed
       notifyActionListeners( APPLY_REGRIDDING_EVENT, APPLY_REGRIDDING_CMD );
       this.dispose( );
}//GEN-LAST:event_m_performRegriddingButtonActionPerformed

    private void m_newSeriesNumberTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_newSeriesNumberTextFieldActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_m_newSeriesNumberTextFieldActionPerformed

    private void m_showDicomInformationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_showDicomInformationButtonActionPerformed
        notifyActionListeners( SHOW_DICOM_INFORMATION_EVENT, SHOW_DICOM_INFORMATION_CMD );
}//GEN-LAST:event_m_showDicomInformationButtonActionPerformed

    /**
     * Returns the new series number.
     * @return
     */
    public int getNewSeriesNumber( )
    {
        return ( new Integer( (String)m_newSeriesNumberTextField.getText( ) ) ).intValue( );
    }


    /**
     * Returns the new series number.
     * @return
     */
    public String getNewSeriesDescription( )
    {
        return m_newSeriesDescriptionTextField.getText( );
    }



    /**
     * Returns the new series description.
     * @return
     */
    public int getNewHorizontalGridSize( )
    {
        return ( new Integer( (String)m_selectNewNumberOfPixelsInXDirection.getSelectedObjects( )[ 0 ] ) ).intValue( );
    }

    /**
     * Returns the new horizontal grid size.
     * @return
     */
    public int getNewVerticalGridSize( )
    {
        return ( new Integer( (String)m_selectNewNumberOfPixelsInYDirection.getSelectedObjects( )[ 0 ] ) ).intValue( );
    }


   /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new DicomRegridImageSeriesPropertiesFrame( null, 256, 256, "_regrided_" ).setVisible( true );
            }
        });
    }

    /**
     * Adds an action listener to the list of action listeners who are notified
     * when something happens in this component.
     */
    public void addActionListener( ActionListener e )
    {
        m_actionListeners.add( e );
    }

    /**
     * Notify listeners that something in the object has changed.
     * @param eventType
     * @param cmd
     */
    protected void notifyActionListeners( int eventType, String cmd )
    {
        Iterator it = m_actionListeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, eventType, cmd ) );
        }
    }

    /**
     * Replaces all blanks by "\  " in order to be interpreted
     * correctly by the Windows operating system
     * @param cmd
     * @return
     */
    private String eliminateIllegalFileSystemCharacters( String cmd )
    {

        // first get rid ofm blancs
        cmd = cmd.trim( );

        cmd = cmd.replace( ' ', '_' );
        cmd = cmd.replace( ',', '_' );
        cmd = cmd.replace( ':', '_' );
        cmd = cmd.replace( ';', '_' );
        cmd = cmd.replace( '%', '_' );
        //cmd.replace( '*', '_' );

        cmd = cmd.replace( 'é', 'e' ); // problematic on some linux systems
        cmd = cmd.replace( 'è', 'e' ); // problematic on some linux systems
        cmd = cmd.replace( 'ö', 'o' ); // problematic on some linux systems
        cmd = cmd.replace( 'ü', 'u' ); // problematic on some linux systems
        cmd = cmd.replace( 'à', 'a' ); // problematic on some linux systems
        cmd = cmd.replace( 'ä', 'a' ); // problematic on some linux systems
        cmd = cmd.replace( 'Ö', 'O' ); // problematic on some linux systems
        cmd = cmd.replace( 'Ü', 'U' ); // problematic on some linux systems

        cmd = cmd.replace( '@', '_' ); // problematic on some linux systems
        cmd = cmd.replace( '#', '_' ); // problematic on some linux systems

        cmd = cmd.replace( '?', '_' );  // problematic on some linux systems

        cmd = cmd.replace( '¢', 'c' ); // problematic on some linux systems
        cmd = cmd.replace( '!', '_' );  // problematic on some linux systems
        cmd = cmd.replace( '§', '_' );  // problematic on some linux systems
        cmd = cmd.replace( '¦', '_' );  // problematic on some linux systems

        cmd = cmd.replace( '$', '_' );  // problematic on some linux systems
        cmd = cmd.replace( '[', '_' );  // problematic on some linux systems
        cmd = cmd.replace( ']', '_' );  // problematic on some linux systems

        cmd = cmd.replace( '^', '_' );  // problematic on some linux systems
        cmd = cmd.replace( '~', '_' );  // problematic on some linux systems

        cmd = cmd.replace( 'ç', 'c' );  // problematic on some linux systems
        cmd = cmd.replace( '~', '_' );  // problematic on some linux systems
        cmd = cmd.replace( '"', '_' );  // problematic on some linux systems

        cmd = cmd.replace(">", "_" );
        cmd = cmd.replace("<", "_" );

        cmd = cmd.replace("____", "_" );
        cmd = cmd.replace("___", "_" );
        cmd = cmd.replace("__", "_" );

        return cmd;
    }



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JButton m_cancelButton;
    private javax.swing.JPanel m_choicePanel;
    private javax.swing.JLabel m_currentImageMatrixSizeXLabel;
    private javax.swing.JLabel m_currentImageMatrixSizeYLabel;
    private javax.swing.JPanel m_informationPanel;
    private javax.swing.JLabel m_newNumberOfPixelsInXDirection;
    private javax.swing.JLabel m_newNumberOfPixelsInXDirection1;
    private javax.swing.JTextField m_newSeriesDescriptionTextField;
    private javax.swing.JTextField m_newSeriesNumberTextField;
    private javax.swing.JButton m_performRegriddingButton;
    private javax.swing.JPanel m_propertiesPanel;
    private javax.swing.JComboBox m_selectNewNumberOfPixelsInXDirection;
    private javax.swing.JComboBox m_selectNewNumberOfPixelsInYDirection;
    private javax.swing.JButton m_showDicomInformationButton;
    // End of variables declaration//GEN-END:variables

    LinkedList<ActionListener> m_actionListeners = new LinkedList<>( );

    public final static int CANCEL_REGRIDDING_EVENT         = 0;
    public final static int APPLY_REGRIDDING_EVENT          = 1;
    public final static int SHOW_DICOM_INFORMATION_EVENT    = 2;

    public final static String CANCEL_REGRIDDING_CMD = "CANCEL_REGRIDDING_CMD";
    public final static String APPLY_REGRIDDING_CMD  = "APPLY_REGRIDDING_CMD";
    public final static String SHOW_DICOM_INFORMATION_CMD = "SHOW_DICOM_INFORMATION_CMD";

}
