/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.hlsvd;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JFrame;
import javax.swing.KeyStroke;
import static org.spectrim.hlsvd.HLSVDControlPanel.RETURN_HLSVD_FILTERED_SIGNAL_CMD;
import static org.spectrim.hlsvd.HLSVDControlPanel.RETURN_HLSVD_FILTERED_SIGNAL_ID;
import org.spectrim.tdfdfit.SingleVoxelMeasuredSpectralData;

/**
 * This frame enables the user to interactively influence the water
 * removal and broad baseline components.
 * @author johan
 */
public class HLSVDControlFrame extends javax.swing.JFrame implements ActionListener
{

    /**
     * Creates new form HLSVDControlFrame.
     * This frame enables the user to interactively influence the water
     * removal and broad baseline components.
     */
    public HLSVDControlFrame( SingleVoxelMeasuredSpectralData  signalToProcess, boolean complexConjugate ) 
    {
        initComponents( );
        
        if ( complexConjugate == true )
        {
            signalToProcess.doComplexConjugation( );
        }
        
        m_HLSVDControlPanel.setSVSResponseToFilter( signalToProcess );
        
        
        setVisible( true );
        setDefaultCloseOperation( JFrame.HIDE_ON_CLOSE );
        setTitle( "HLSVD signal analysis and processing" );
        m_HLSVDControlPanel.setParentFrame( this );  
        
        //setDefaultButton( m_ApplyButton );
                  
        Action applyAndExit = new AbstractAction( ) 
        {
            @Override
            public void actionPerformed( ActionEvent e ) 
            {
                notifyActionListeners( this, RETURN_HLSVD_FILTERED_SIGNAL_ID, RETURN_HLSVD_FILTERED_SIGNAL_CMD );
                dispose( );
            }
        };

        Action exitWithoutChange = new AbstractAction( ) 
        {
            @Override
            public void actionPerformed( ActionEvent e )
            {
               dispose( );
            }
        };


        this.getRootPane( ).getInputMap( ).put( KeyStroke.getKeyStroke( "ENTER" ),
                                                                        "applyAndExit" );
        
        this.getRootPane( ).getActionMap( ).put( "applyAndExit",
                                                 applyAndExit  );

        this.getRootPane( ).getInputMap( ).put( KeyStroke.getKeyStroke( "ESCAPE" ),
                                                "Exit without change" );
        
        this.getRootPane( ).getActionMap( ).put( "Exit without change",
                                                 exitWithoutChange );
        
    }   
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_HLSVDControlPanel = new org.spectrim.hlsvd.HLSVDControlPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(m_HLSVDControlPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(m_HLSVDControlPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
    /**
     * Adds an ActionListener to the list of listeners.
     * @param listener
    */
    public void addActionListener( ActionListener listener )
    {
        m_HLSVDControlPanel.addActionListener( this );
        m_actionListeners.add( listener );
    }
    
    /**
     * Notifies actionEvent to all registered listeners.
     */
    private void notifyActionListeners( Object obj, int eventType, String actionCommand ) 
    {
        Iterator it = m_actionListeners.iterator( );
        while ( it.hasNext( ) ) 
        {
            ( (ActionListener) it.next( ) ).actionPerformed( new ActionEvent( this, eventType, actionCommand ) );
        }
    }
    
    @Override
    public void actionPerformed( ActionEvent e ) 
    {
        if ( e.getSource( ) == m_HLSVDControlPanel )
        {

            notifyActionListeners( m_HLSVDControlPanel,  
                                   HLSVDControlPanel.RETURN_HLSVD_FILTERED_SIGNAL_ID,
                                   HLSVDControlPanel.RETURN_HLSVD_FILTERED_SIGNAL_CMD );
            
        }
    }
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.spectrim.hlsvd.HLSVDControlPanel m_HLSVDControlPanel;
    // End of variables declaration//GEN-END:variables

    private final LinkedList<ActionListener> m_actionListeners = new LinkedList<>( );

    /**
     * Returns the resulting signal after user defined HLSVD-filtering process.
     * @return 
     */
    public LinkedList<SingleVoxelMeasuredSpectralData> getHLSVDFilteredSignalList( ) 
    {
        return m_HLSVDControlPanel.getHLSVDFilteredSignal( );
    }
    
}
