!
module double
integer, parameter :: dp = kind(0.0d0)
end module double
!
module doubli
integer, parameter :: di = selected_int_kind(15)
end module doubli
!
      subroutine callfortran(signal_name, name_len, &
        ndp, step, larmor, &
        istr1_len, istr2_len, istr3_len, &
        istr4_len, istr5_len, istr6_len, &
        str_nat1, str_nat2, str_nat3, &
        str_nat4, str_nat5, str_nat6, &
        int_len, idbl_len, int_nat, dbl_nat)
!              
use double
use doubli
!
      character*(istr1_len) str_nat1
      character*(istr2_len) str_nat2
      character*(istr3_len) str_nat3
      character*(istr4_len) str_nat4
      character*(istr5_len) str_nat5
      character*(istr6_len) str_nat6, dir_cur, dir_new
      
      character*100            signal_name
      character*(istr1_len+22) log_name
      
      integer n, nrow, ncol, ncom, kfit, nback
      integer name_len, ndp, ndphlsvd
      integer istr1_len, istr2_len, istr3_len, &
              istr4_len, istr5_len, istr6_len
      integer int_len, idbl_len
      integer int_nat(int_len)
            
      real(dp)  :: step
      real(dp)  :: larmor      
      real(dp)  :: temp1 
      real(dp)  :: temp2

      real*8    :: ampl(int_nat(4))
      real*8    :: freq(int_nat(4))
      real*8    :: damp(int_nat(4))  
      real*8    :: phas(int_nat(4))

      real*8    :: hz     
      real*8    :: ppm
      real*8    :: pi
      real*8    :: fmin
      real*8    :: fmax
      
      real*4    :: expon,test
        
      real(dp)  :: dbl_nat(idbl_len)
                       
      complex(dp),  allocatable :: signal(:)
      complex(dp),  allocatable :: signal_f(:)
      complex(dp),  allocatable :: recon(:)
      complex(dp),  allocatable :: residu(:)
      real(dp),     allocatable :: sinvals(:)
                       
      call getcwd(dir_cur)
      dir_new = str_nat6
      call chdir(dir_new)
      
      log_name = 'callfortran_hlsvd_'//str_nat1//'.log'
      
      open (6, file = log_name, status = 'unknown')
      
      write(6,'(''Hello in subroutine callfortran'')')
      write(6,'(''signal_name = '', A)') trim(signal_name(1:name_len))
      write(6,'(''name_len = '', I5)') name_len
      write(6,'(''ndp = '', I5)') ndp
      write(6,'(''step (in ms) = '', f6.2)') step
      write(6,'(''larmor (in MHz) = '', f6.2)') larmor

      write(6,'(''str_nat1 = '', A)') str_nat1(1:istr1_len)
      write(6,'(''str_nat2 = '', A)') str_nat2(1:istr2_len)
      write(6,'(''str_nat3 = '', A)') str_nat3(1:istr3_len)
      write(6,'(''str_nat4 = '', A)') str_nat4(1:istr4_len)
      write(6,'(''str_nat5 = '', A)') str_nat5(1:istr5_len)
      write(6,'(''str_nat6 = '', A)') str_nat6

      do n = 1, int_len
        write(6,'(''int_nat(n) = '', I5)') int_nat(n)
      enddo

      do n = 1, idbl_len
        write(6,'(''dbl_nat(n) = '', d25.16)') dbl_nat(n)
      enddo
      
      ndphlsvd = int_nat(2)
      write(6,'(''ndphlsvd = '', I5)') ndphlsvd
      nrow    = int_nat(3)
      write(6,'(''nrow = '', I5)') nrow   
      ncom    = int_nat(4)
      write(6,'(''ncom = '', I5)') ncom       
      nback   = int_nat(5)
      write(6,'(''nback = '', I5)') nback
      fmin = dbl_nat(1)
      write(6,'(''fmin (PPM) = '', d25.16)') fmin  
      fmax = dbl_nat(2)
      write(6,'(''fmax (PPM) = '', d25.16)') fmax  
            
!     BEGIN ARRAY-ALLOCATION
      allocate(signal(ndp))
      allocate(signal_f(ndp))
      allocate(recon(ndp+nback))
      allocate(residu(ndp))
      allocate(sinvals(nrow))
!     END ARRAY-ALLOCATION      

      write(6,'(''Begin reading signal.txt'')')
      open (8, file = "signal.txt", status = 'unknown')
      do n = 1, ndp
        read (8,*) temp1, temp2
        signal(n) = dcmplx(temp1, temp2)
      enddo
      close (8)
      write(6,'(''End reading signal.txt'')')
      
      write(6,'(''The first 5 points of signal.txt'')')
      do n = 1, 5     
        write(6,'(2f25.16)') signal(n)
      enddo
      
      expon=log(real(ndphlsvd))/log(2.)
      test=mod(100.*expon,100.)
      write (6,'("test for check = ",f6.3)') test
      if (test .ne. 0.) then
        call check(ndphlsvd)
        write (6,'("ndphlsvd after calling check = ",i5)') ndphlsvd
      endif
      
      ncol = ndphlsvd + 1 - nrow                   
      call hlsvd(signal,ndphlsvd,nrow,ncol,ncom,kfit,sinvals, &
                 ampl,phas,damp,freq)              

      pi = 4.0d0*datan2(1.0d0,1.0d0)
      hz = 1000.0d0/step
      ppm = hz/larmor
      
      call sortfreq(kfit,ampl,phas,damp,freq)

      write(6, '("             ampl            freq              damp            phas")')
      write(6, '("             a.u.            PPM               Hz              degr.")')
      do i = 1, kfit
         write (6, '(i5, 3f17.12,1x,f17.12)') i,&
         ampl(i), freq(i)*ppm, damp(i)*hz, phas(i)*180.0d0/pi
      enddo
      
      write(6,'(''Begin writing hlsvd_signal.txt'')')      
      open (10,file = "hlsvd_signal.txt", status = 'unknown')        
        do n = 1, ndphlsvd
          temp1 = dble(signal(n))
          temp2 = imag(signal(n))
          write (10,*) temp1, temp2
        enddo       
      close (10)
      write(6,'(''End writing hlsvd_signal.txt'')')

      call sigrecon(recon, &
        ndphlsvd, step, larmor, kfit, ampl, freq, damp, phas, nback)

      write(6,'(''The first 5 points of recon'')')
      do n = 1, 5     
        write(6,'(2f25.16)') recon(n)
      enddo
 
      write(6,'(''Begin writing hlsvd_recon.txt'')')      
      open (11,file = "hlsvd_recon.txt", status = 'unknown')        
        do n = 1, ndphlsvd+nback
          temp1 = dble(recon(n))
          temp2 = imag(recon(n))
          write (11,*) temp1, temp2
        enddo       
      close (11)
      write(6,'(''End writing hlsvd_recon.txt'')') 

      do n = 1, ndphlsvd     
        residu(n) = signal(n) - recon(n+nback)
      enddo

      write(6,'(''Begin writing hlsvd_residu.txt'')')      
      open (12,file = "hlsvd_residu.txt", status = 'unknown')        
        do n = 1, ndphlsvd
          temp1 = dble(residu(n))
          temp2 = imag(residu(n))
          write (12,*) temp1, temp2
        enddo       
      close (12)
      write(6,'(''End writing hlsvd_residu.txt'')') 

      write(6,'(''Begin writing hlsvd_sinvals.txt'')')      
      open (13,file = "hlsvd_sinvals.txt", status = 'unknown')        
        do n = 1, kfit
          temp1 = dlog(dble(sinvals(n)))
          temp2 = 0.0d0
          write (13,*) temp1, temp2          
        enddo
        do n = kfit+1, ndp
          temp1 = 0.0d0
          temp2 = 0.0d0
          write (13,*) temp1, temp2
        enddo               
      close (13)
      write(6,'(''End writing hlsvd_sinvals.txt'')')
      
      call signal_filtered(signal, signal_f, &
        ndphlsvd, step, larmor, kfit, ampl, freq, damp, phas, &
        fmin, fmax)
        
      write(6,'(''The first 5 points of signal_f'')')
      do n = 1, 5     
        write(6,'(2f25.16)') signal_f(n)
      enddo
      
      write(6,'(''Begin writing hlsvd_signal_filtered.txt'')')      
      open (14,file = "hlsvd_signal_filtered.txt", status = 'unknown')        
        do n = 1, ndphlsvd
          temp1 = dble(signal_f(n))
          temp2 = imag(signal_f(n))
          write (14,*) temp1, temp2
        enddo       
      close (14)
      write(6,'(''End writing hlsvd_signal_filtered.txt'')')   
      
      call chdir(dir_cur)

!     BEGIN ARRAY-DEALLOCATION
      deallocate(signal)
      deallocate(signal_f)
      deallocate(recon)
      deallocate(residu)
      deallocate(sinvals)
!     END ARRAY-DEALLOCATION

      close (6) 

      end subroutine callfortran

      subroutine sigrecon(recon, &
        ndp, step, larmor, ncom, ampl, freq, damp, phas, nback)

      integer n, m, ndp, ncom, nback

      real*8     :: step
      real*8     :: larmor    
      real*8     :: pi

      real*8     :: ampl(ncom)
      real*8     :: freq(ncom)
      real*8     :: damp(ncom)  
      real*8     :: phas(ncom)

      complex*16 :: ctemp

      complex*16 :: recon(ndp+nback)
      complex*16 :: root(ncom)
      complex*16 :: campl(ncom)

      pi = 4.0d0*datan2(1.0d0,1.0d0)
            
      do m = 1, ncom
        campl(m) = ampl(m)*cdexp(dcmplx(0.0d0, phas(m)))
        root(m)  = cdexp(dcmplx(damp(m),2*pi*freq(m)))        
      enddo

      do n = 1, ndp
        recon(n) =  dcmplx(0.0d0,0.0d0)
      enddo
      
      write (6,'("nback in sigrecon = ",i5)') nback

      do n = 1, ndp+nback
        ctemp = (0.0d0,0.0d0)
        do m = 1, ncom
          ctemp = ctemp + campl(m) * (root(m))**(n-nback-1)
        enddo
        recon(n) = ctemp
      enddo

      return
      end subroutine sigrecon    

      subroutine signal_filtered(signal, signal_f, &
        ndp, step, larmor, ncom, ampl, freq, damp, phas, &
        fmin, fmax)

      integer n, m, ndp, ncom

      real*8     :: step
      real*8     :: larmor    
      real*8     :: hz
      real*8     :: ppm
      real*8     :: pi
      real*8     :: fmin
      real*8     :: fmax

      real*8     :: ampl(ncom)
      real*8     :: freq(ncom)
      real*8     :: damp(ncom)  
      real*8     :: phas(ncom)

      complex*16 :: ctemp

      complex*16 :: signal(ndp)
      complex*16 :: recon(ndp)
      complex*16 :: signal_f(ndp)
      complex*16 :: root(ncom)
      complex*16 :: campl(ncom)

      pi = 4.0d0*datan2(1.0d0,1.0d0)
      
      hz = 1000.0d0/step
      ppm = hz/larmor
      fmin = fmin/ppm
      fmax = fmax/ppm
      
      do m = 1, ncom
        campl(m) = ampl(m)*cdexp(dcmplx(0.0d0, phas(m)))
        root(m)  = cdexp(dcmplx(damp(m),2*pi*freq(m)))        
      enddo

      do n = 1, ndp
        recon(n) =  dcmplx(0.0d0,0.0d0)
      enddo

      do n = 1, ndp
        ctemp = (0.0d0,0.0d0)
        do m = 1, ncom
          if ((freq(m).LT.fmin).OR.(freq(m).GT.fmax)) then
            ctemp = ctemp + campl(m) * (root(m))**(n-1)
          end if
        enddo
        recon(n) = ctemp
        signal_f(n) = signal(n) - recon(n)
      enddo

      return
      end subroutine signal_filtered
      
      subroutine bar2gnuplot()

      integer :: ret        

! create gnuplot command file
      OPEN(10,ACCESS='SEQUENTIAL',FILE='gp.txt')
      write(10,*) 'set size 1,1'
      write(10,*) 'set terminal wxt size 50,600 position 800,0'
      write(10,*) 'set title "Progress\nLanczos"'
      write(10,*) 'unset key'
      write(10,*) 'unset xtics'
      write(10,*) 'unset ytics'
      write(10,*) 'set border linewidth 5.0'
      write(10,*) 'set xrange [0.999:1.001]'
      write(10,*) 'set yrange [0.0:100.0]'
      write(10,*) 'plot "hlsvd_bar_data.txt" using 1:2 with lines linecolor rgb "blue" linewidth 5.0'
      write(10,*) 'pause 0.2'     
      write(10,*) 'reread'      
      CLOSE(10,STATUS='KEEP')

! plot curve with gnuplot and cleanup file
      ret=SYSTEM('START /B C:\"Program Files"\gnuplot\bin\gnuplot gp.txt')
!rdb      ret=SYSTEM('rm gp.txt')
	 
      end subroutine bar2gnuplot
      
      
      
