/*
 * File: $Id: PolygonParameterDisplayer.java,v 1.1.1.1 2006/04/19 09:38:47 hans Exp $
 * History
 * Date: 15. November 2002, 10:34  Authors: Martin Buerki / Hans Slotboom  
 *
 * Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

package org.spectrim.imagegraphicobjects;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 *
 * Most simple dialog to visualize the main properties of a given RegioPolygon.
 *
 * @author  slotboom
 */
public class PolygonParameterDisplayer extends JFrame implements ActionListener 
{
    
    /** 
     * Creates a new instance of PolygonParameterDisplaye.
     * @param parent
     * @param roiSize
     * @param av
     * @param stdev
     */
    public PolygonParameterDisplayer( JPanel parent, int roiSize, float av, float stdev  )
    {
        setTitle( "ROI properties" );
        // set the layout of the main panel
        m_contentPanel = new JPanel( );
        
        m_contentPanel.setLayout( new BorderLayout( ) );
        
        m_informationPanel = new JPanel( );
        m_informationPanel.setLayout( new BoxLayout( m_informationPanel, BoxLayout.Y_AXIS ) );
        
        m_roiSizeLabel = new JLabel( "Size : " + roiSize + " pixels" );
        m_roiAverageLabel = new JLabel( "Mean Pixel Value : " + av );
        m_roiStandardDeviationLabel = new JLabel( "Standard Deviation : " + stdev );
        m_informationPanel.add( m_roiSizeLabel );
        m_informationPanel.add( m_roiAverageLabel );
        m_informationPanel.add( m_roiStandardDeviationLabel );
        m_okButton = new JButton( "OK" );
        
        m_okButtonPanel = new JPanel( );
        
        m_okButtonPanel.setLayout( new FlowLayout( ) );
        m_okButton.addActionListener( this );
        m_okButtonPanel.add( m_okButton );
        
        m_contentPanel.add( m_informationPanel, BorderLayout.CENTER );
        m_contentPanel.add( m_okButtonPanel, BorderLayout.SOUTH );

        getContentPane( ).setPreferredSize( new Dimension( 250, 100 ) );

        getContentPane( ).add( m_contentPanel );
        
        // Put the Dialog nicely in the middle of its parent
        Point parentLoc = parent.getLocation( );
        Point centerParent = new Point( parent.getX( ) + parent.getWidth( ) / 2,
                                        parent.getY( ) + parent.getHeight( ) / 2 );
        setLocation( centerParent );
        pack( );
        setVisible( true );
    }
    
    /**
     * Is called in response to an ActionEvent. 
     * @param actionEvent 
     */
    @Override
    public void actionPerformed( ActionEvent actionEvent ) 
    {
        Object sender = actionEvent.getSource( );
        
	if ( sender == m_okButton ) 
        {
            setVisible( false );
        }
    }
    
    // Declarations
    private final JPanel m_contentPanel;
    private final JPanel m_informationPanel;
    private final JLabel m_roiSizeLabel;
    private final JLabel m_roiAverageLabel;
    private final JLabel m_roiStandardDeviationLabel;
    private final JPanel m_okButtonPanel;
    private final JButton m_okButton;
    
    // For proper serialization
    private static final long serialVersionUID = 1221295898889393L;
    
}
