/*
 * File: $Id: ImageSegmentProperties.java,v 1.1.1.1 2008/10/10 09:38:47 hans Exp $
 * History
 * Date: 10.10.2008 Hans Slotboom  Changes:
 *
 * Copyright (C) 2008 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

package org.spectrim.imageprocessing;

/**
 * Container class handling the properties of the image segments.
 * @author  hans
 */
public class ImageSegmentProperties 
{
    
    /** 
     * Creates a new instance of ImageSegmentProperties. 
     */
    public ImageSegmentProperties( ) 
    {
        
    }
    
    /**
     * Sets the name of the ROI to which this belongs.
     * @param name
     */
    public void setImageSegmentName( String name )
    {
        m_nameOfImageSegment = name;
    }

    /**
     * Returns the name of the ROI to which this belongs.
     * @return 
     */
    public String getImageSegmentName( )
    {
        return m_nameOfImageSegment;
    }

    /**
     * Sets the  number of pixels within ROI. 
     * @param number
     */
    public void setNumberOfPixels( int number )
    {
        m_numberOfPixelsWithinROI = number;
    }

    /**
     * Returns the  number of pixels within ROI.
     * @return 
     */
    public int getNumberOfPixels( )
    {
        return m_numberOfPixelsWithinROI;
    }

    /**
     * Sets the volume of the ROI. 
     * @param volume
     */
    public void setImageSegmentVolume( double volume )
    {
        m_imageSegmentVolume = volume;
    }

    /**
     * Returns the volume of the ROI.
     * @return 
     */
    public double getImageSegmentVolume( )
    {
        return m_imageSegmentVolume;
    }    
    
    /**
     * Sets the mean pixel value of the ROI. 
     * @param mean
     */
    public void setMeanPixelValue( float mean )
    {
        m_meanOfPixelValues = mean;
    }

    /**
     * Returns the mean pixel value of the ROI. 
     * @return 
     */
    public float getMeanPixelValue( )
    {
        return m_meanOfPixelValues;
    }    
    
    /**
     * Sets the standard deviation pixel value of the ROI. 
     * @param stdev
     */
    public void setStandardDeviationOfPixelValues( float stdev )
    {
        m_standardDeviationOfPixelValues = stdev;
    }

    /**
     * Returns the standard deviation pixel value of the ROI. 
     * @return 
     */
    public float getStandardDeviationOfPixelValues( )
    {
        return m_standardDeviationOfPixelValues;
    }
    
    // Attributes
    private String m_nameOfImageSegment;
    private int m_numberOfPixelsWithinROI;
    private double m_imageSegmentVolume;
    
    private float m_meanOfPixelValues;
    private float m_standardDeviationOfPixelValues;
}
