/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.spectrim.imageprocessing;

/**
 *
 * @author slotboom
 */
public class MomentsAboutTheMeanOfVOICalculator
{
    private int m_maximumValue;
    private int m_minimumValue;
/**
     *
     * Constructor
     *
     * @param voiOverlay
     * @param image
     * @param imageWidth
     * @param imageHeight
     * @param zoom
     */
    public MomentsAboutTheMeanOfVOICalculator( boolean[][] voiOverlay, int[] image, int imageWidth, int imageHeight, float zoom )
    {
        m_voiOverlay    = voiOverlay;
        m_zoom          = zoom;
        m_image         = image;
        m_imageWidth    = imageWidth;
        m_imageHeight   = imageHeight;
    }

    /**
     * Does the actual computation of the moments about the mean.
     * @return 
     */
    public MomentsAboutTheMean computeStatistics( )
    {
        m_roiSize = 0;

        if ( m_voiOverlay != null )
        {

            // Calculate the average of the ROI
            for ( int i = 0; i < m_imageWidth; i++ )
            {
                for ( int j = 0; j < m_imageHeight ; j++ )
                {
                    if ( m_voiOverlay[i][j] == true )
                    {
                        m_roiSize++;
                    }
                }
            }

            int[] signalOfRegion = new int[m_roiSize];
            int cntr = 0;


            // now we can fill the signal array
            for ( int y = 0; y < m_imageHeight; y++ )
            {
                for ( int x = 0; x < m_imageWidth ; x++ )
                {
                    if ( m_voiOverlay[x][y] == true )
                    {
                        signalOfRegion[cntr] = m_image[ x + m_imageWidth * y ];
                        cntr++;
                    }
                }
            }

            // 1. compute first moment: sample mean
            for ( int i = 0; i < signalOfRegion.length; i++ )
            {
                m_average += signalOfRegion[i];
            }

            m_average = m_average / signalOfRegion.length;

            // 2. compute sample variance of the
            for ( int i = 0; i < signalOfRegion.length; i++ )
            {
                m_variance += ( signalOfRegion[i] - m_average ) * ( signalOfRegion[i] - m_average );
            }

            m_variance = m_variance / ( signalOfRegion.length - 1 );

            // 3. variance of sample variance
            double mhu_2 = 0.0f;
            for ( int i = 0; i < signalOfRegion.length; i++ )
            {
                mhu_2 += signalOfRegion[i] * signalOfRegion[i];
            }
            mhu_2 = mhu_2 / signalOfRegion.length;

            double mhu_4 = 0.0f;
            for ( int i = 0; i < signalOfRegion.length; i++ )
            {
                mhu_4 += signalOfRegion[i] * signalOfRegion[i] * signalOfRegion[i] * signalOfRegion[i];
            }
            mhu_4 = mhu_4 / signalOfRegion.length;

            double M = (double)signalOfRegion.length;
            double n = (double)( signalOfRegion.length - 1 );

            double a1 = M * ( M - n ) * ( M * n - M - n - 1 ) / ( ( M - 3 ) * ( M - 2 ) * ( M - 1 ) * ( n - 1 ) * n );
            double a2 = M * ( M - n ) * ( M * M * n - 3 * n - 3 * M * M + 6 * M - 3 ) / ( ( M - 3 ) * ( M - 2 ) * ( M - 1 ) * ( n - 1 ) * n );

            m_varianceOfVariance = Math.log( a1 * mhu_4 + a2 * mhu_2 );

            // 4. Sample skewness
            double numerator = 0.0;
            for ( int i = 0; i < signalOfRegion.length; i++ )
            {
                numerator += ( signalOfRegion[i] - m_average ) * ( signalOfRegion[i] - m_average ) * ( signalOfRegion[i] - m_average );
            }
            double dominator = 0.0;
            for ( int i = 0; i < signalOfRegion.length; i++ )
            {
                dominator += ( signalOfRegion[i] - m_average ) * ( signalOfRegion[i] - m_average );
            }
            double factor = Math.sqrt( M * ( M - 1 ) )/( M - 2 );

            m_skewness = factor * Math.sqrt( M ) * dominator / ( dominator * Math.sqrt( dominator ) );

            // 5. variance of sample skewness (assume Gaussian distribution)
            m_varianceOfSkewness = 6 * M / ( ( M + 1 ) * ( M + 3 ) );

            // 6. Sample kurtosis
            double numerator_kur = 0.0;
            for ( int i = 0; i < signalOfRegion.length; i++ )
            {
                double factor_kur = ( signalOfRegion[i] - m_average );
                numerator_kur += factor_kur * factor_kur * factor_kur * factor_kur;
            }

            double G = ( M + 1 ) * M / ( ( M - 1 ) * ( M - 2 ) * ( M - 3 ) );
            double H = ( M - 1 ) * ( M - 1 ) / ( ( M - 2 ) * ( M - 3 ) );

            m_kurtosis = ( G * numerator_kur/ ( m_variance * m_variance ) ) - 3 * H;

            // 7. variance of sample kurtosis
            m_varianceOfKurtosis = 24 * M * ( M - 2 ) * ( M - 3 ) / ( ( M + 1 ) * ( M + 1 ) * (M + 3) * ( M + 5 ) );

            
            // 8. compute minimum and maximum
    
            for ( int kk = 0; kk < signalOfRegion.length; kk++ )
            {
                if ( signalOfRegion[kk] > m_maximumValue )
                {
                    m_maximumValue = signalOfRegion[kk];
                }
                    
                if ( signalOfRegion[kk] < m_minimumValue )
                {
                    m_minimumValue = signalOfRegion[kk];
                }   
            }
            
            
            System.out.println( "m_average               : " + m_average );
            System.out.println( "m_variance              : " + m_variance );
            System.out.println( "m_stdev                 : " + Math.sqrt( m_variance ) );
            System.out.println( "m_varianceOfVariance    : " + m_varianceOfVariance );
            System.out.println( "m_skewness              : " + m_skewness );
            System.out.println( "m_varianceOfSkewness    : " + m_varianceOfSkewness );
            System.out.println( "m_kurtosis              : " + m_kurtosis );
            System.out.println( "m_varianceOfKurtosis    : " + m_varianceOfKurtosis );
            System.out.println( "m_minimumValue          : " + m_minimumValue );
            System.out.println( "m_maximumValue          : " + m_maximumValue );
            
        }

        MomentsAboutTheMean momentAboutTheMean = new MomentsAboutTheMean( );

        momentAboutTheMean.setNumberOfPixels( m_roiSize );
        momentAboutTheMean.setMean( m_average );
        momentAboutTheMean.setStDev( Math.sqrt( m_variance ) );
        momentAboutTheMean.setVariance( m_variance );
        momentAboutTheMean.setVarianceOfVariance( m_varianceOfVariance );
        momentAboutTheMean.setSkewness( m_skewness );
        momentAboutTheMean.setVarianceOfSkewness( m_varianceOfSkewness );
        momentAboutTheMean.setKurtosis( m_kurtosis );
        momentAboutTheMean.setVarianceOfKurtosis( m_varianceOfKurtosis );
        momentAboutTheMean.setMinimum( m_minimumValue );
        momentAboutTheMean.setMaximum( m_maximumValue );
        
        return momentAboutTheMean;
        
    }


    // Attributes
    private final boolean[][]  m_voiOverlay;
    private int                m_roiSize;
    private final int[]        m_image;
    private final int          m_imageWidth;
    private final int          m_imageHeight;
    private final float        m_zoom;

    // attributes than contain the numeric values of the computation
    private double        m_average              = 0.0;
    private double        m_variance             = 0.0;
    private double        m_varianceOfVariance   = 0.0;
    private double        m_skewness             = 0.0;
    private double        m_varianceOfSkewness   = 0.0;
    private double        m_kurtosis             = 0.0;
    private double        m_varianceOfKurtosis   = 0.0;

}
