/*
 * File: $Id: ProbingRegionPropertiesPanel.java,v 1.1.1.1 2008/04/18 09:38:48 hans Exp $
 * History
 * Date: 17.04.2008  Authors: Hans Slotboom  
 *
 * Changes:
 *
 * Copyright (C) 2008 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */ 
        
/*
 * ProbingRegionPropertiesPanel.java
 *
 * Created on April 17, 2008, 11:01 AM
 */

package org.spectrim.imageprocessing;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author  hans
 */
public class ProbingRegionPropertiesPanel extends javax.swing.JPanel implements ActionListener, ChangeListener
{
    
    /** 
     * Creates new form ProbingRegionPropertiesPanel. 
     * @param minPixVal
     * @param maxPixVal
     */
    public ProbingRegionPropertiesPanel( float minPixVal, float maxPixVal ) 
    {
        initComponents( );
        m_minimumThresholdSlider.addChangeListener( this );
        m_maximumThresholdSlider.addChangeListener( this );
        m_minPixVal = minPixVal;
        m_maxPixVal = maxPixVal;
        m_maximumThresholdSliderLabel.setText(  "" + (int)( m_maximumThresholdSlider.getValue( ) * this.m_maxPixVal / 1000f ) );
        
        m_pixelRangeDeterminationType = PIXEL_RANGE_DEFINED_BY_STANDARD_DEVIATION;
    
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_permutationNumber = new javax.swing.ButtonGroup();
        m_segmentationRegionButtonGroup = new javax.swing.ButtonGroup();
        jLabel10 = new javax.swing.JLabel();
        m_rangeDeterminatedByButtonGroup = new javax.swing.ButtonGroup();
        m_segmentationScopeButtonGroup = new javax.swing.ButtonGroup();
        m_subSegmentationButtonGroup = new javax.swing.ButtonGroup();
        m_SegmentationPropertiesTabbedPane = new javax.swing.JTabbedPane();
        m_regionToSegmentTab = new javax.swing.JPanel();
        m_segmentWholeImageRadioButton = new javax.swing.JRadioButton();
        m_segmentWholeImageAfterThresholdingRadioButton = new javax.swing.JRadioButton();
        m_minimumThresshold = new javax.swing.JTextField();
        m_maximumThresshold = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        m_defineRegionToSegmentRadioButton = new javax.swing.JRadioButton();
        m_defineAreaForSegmentationButton = new javax.swing.JButton();
        m_deleteAreaForSegmentation = new javax.swing.JButton();
        m_segmentationAmplitudeThressholds = new javax.swing.JPanel();
        m_minimumSliderPanel = new javax.swing.JPanel();
        m_minimumThresholdSlider = new javax.swing.JSlider();
        m_minimumThresholdSliderLabel = new javax.swing.JLabel();
        m_minimumLabel = new javax.swing.JLabel();
        m_maximumSliderPanel = new javax.swing.JPanel();
        m_maximumThresholdSlider = new javax.swing.JSlider();
        m_maxiimumLabel = new javax.swing.JLabel();
        m_applyThresholdingBeforeSegmentation = new javax.swing.JCheckBox();
        m_advancedSegmentation = new javax.swing.JCheckBox();
        m_maximumThresholdSliderLabel = new javax.swing.JLabel();
        m_autoApplyButton = new javax.swing.JCheckBox();
        m_segmentAmplitudeBoundsAndSegmentationScoopTab = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        m_rangeDefinedByStandardDeviation = new javax.swing.JRadioButton();
        m_rangeDefinedByMinMaxPixelRange = new javax.swing.JRadioButton();
        m_segmentationAmplitudeRangeMultiplyer = new javax.swing.JComboBox();
        jLabel11 = new javax.swing.JLabel();
        m_segmentationScopePannel = new javax.swing.JPanel();
        m_applySegmentationToAllSlices = new javax.swing.JRadioButton();
        m_applySegmentationToCurrentSliceOnly = new javax.swing.JRadioButton();
        m_subSegmentationPanel = new javax.swing.JPanel();
        m_applySubSegmentationToAllImages = new javax.swing.JRadioButton();
        m_applySubSegmentationToCurrentlyDisplayedImageOnly = new javax.swing.JRadioButton();
        m_probingRegionPropertiesTab = new javax.swing.JPanel();
        m_probingRegionPropertiesPanel = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        m_defineProbeSizeX = new javax.swing.JComboBox();
        m_defineProbeSizeY = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        m_numberOfProbingPixels = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        m_allPermutationsCheckbox = new javax.swing.JRadioButton();
        m_restrictedNumberOfPermutationsCheckbox = new javax.swing.JRadioButton();
        m_numberOfPermutations = new javax.swing.JTextField();
        m_probingCriteriaPropertiesTab = new javax.swing.JPanel();
        m_probingCriteriaTabbedPane = new javax.swing.JTabbedPane();
        m_histogramCriteriaPanel = new javax.swing.JPanel();
        m_meanCheckBox = new javax.swing.JCheckBox();
        m_varianceCheckBox = new javax.swing.JCheckBox();
        m_skewnessCheckBox = new javax.swing.JCheckBox();
        m_kurtosisCheckBox = new javax.swing.JCheckBox();
        m_meanLogicCombo = new javax.swing.JComboBox();
        m_varianceLogicCombo = new javax.swing.JComboBox();
        m_skewnessLogicCombo = new javax.swing.JComboBox();
        m_absoluteGradientCriteriaPanel = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        m_runlengthMatrixCriteriaPanel = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        m_probingCriteriaTab = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        m_segmentationProgressBar = new javax.swing.JProgressBar();
        m_segmentationPerformAndStopbuttonPanel = new javax.swing.JPanel();
        m_performSimpleSegmentationButton = new javax.swing.JButton();
        m_performAdvancedSegmentationButton = new javax.swing.JButton();

        jLabel10.setText("jLabel10");

        setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));

        m_segmentationRegionButtonGroup.add(m_segmentWholeImageRadioButton);
        m_segmentWholeImageRadioButton.setSelected(true);
        m_segmentWholeImageRadioButton.setText("whole image");
        m_segmentWholeImageRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        m_segmentWholeImageRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                segmentWholeImageRadioButtonSelected(evt);
            }
        });

        m_segmentationRegionButtonGroup.add(m_segmentWholeImageAfterThresholdingRadioButton);
        m_segmentWholeImageAfterThresholdingRadioButton.setText("image after thressholding");
        m_segmentWholeImageAfterThresholdingRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        m_segmentWholeImageAfterThresholdingRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                segmentImageAfterThressholdingButtonPressed(evt);
            }
        });

        m_minimumThresshold.setEditable(false);

        m_maximumThresshold.setEditable(false);

        jLabel8.setText("minimum");

        jLabel9.setText("maximum");

        m_segmentationRegionButtonGroup.add(m_defineRegionToSegmentRadioButton);
        m_defineRegionToSegmentRadioButton.setText("define area for segmentation");
        m_defineRegionToSegmentRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        m_defineRegionToSegmentRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                segmentGraphicelDefinedRegionButtonPressed(evt);
            }
        });

        m_defineAreaForSegmentationButton.setText("Define Area");
        m_defineAreaForSegmentationButton.setEnabled(false);
        m_defineAreaForSegmentationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                defineAreaForSegmentationButtonPressed(evt);
            }
        });

        m_deleteAreaForSegmentation.setText("Delete Area");
        m_deleteAreaForSegmentation.setEnabled(false);
        m_deleteAreaForSegmentation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteAreaForSegmentationButtonPressed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_regionToSegmentTabLayout = new org.jdesktop.layout.GroupLayout(m_regionToSegmentTab);
        m_regionToSegmentTab.setLayout(m_regionToSegmentTabLayout);
        m_regionToSegmentTabLayout.setHorizontalGroup(
            m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_regionToSegmentTabLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_segmentWholeImageRadioButton)
                    .add(m_regionToSegmentTabLayout.createSequentialGroup()
                        .add(m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(m_segmentWholeImageAfterThresholdingRadioButton)
                            .add(m_defineRegionToSegmentRadioButton))
                        .add(16, 16, 16)
                        .add(m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(m_regionToSegmentTabLayout.createSequentialGroup()
                                .add(jLabel8)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(m_minimumThresshold, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 55, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(m_defineAreaForSegmentationButton))
                        .add(12, 12, 12)
                        .add(m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(m_regionToSegmentTabLayout.createSequentialGroup()
                                .add(jLabel9)
                                .add(4, 4, 4)
                                .add(m_maximumThresshold, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 53, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(m_deleteAreaForSegmentation))))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        m_regionToSegmentTabLayout.setVerticalGroup(
            m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_regionToSegmentTabLayout.createSequentialGroup()
                .add(22, 22, 22)
                .add(m_segmentWholeImageRadioButton)
                .add(30, 30, 30)
                .add(m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_segmentWholeImageAfterThresholdingRadioButton)
                    .add(jLabel8)
                    .add(jLabel9)
                    .add(m_maximumThresshold, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_minimumThresshold, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(31, 31, 31)
                .add(m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_defineRegionToSegmentRadioButton)
                    .add(m_defineAreaForSegmentationButton)
                    .add(m_deleteAreaForSegmentation))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_SegmentationPropertiesTabbedPane.addTab("Region to segment", m_regionToSegmentTab);

        m_minimumThresholdSlider.setMajorTickSpacing(2000);
        m_minimumThresholdSlider.setMaximum(10000);
        m_minimumThresholdSlider.setMinorTickSpacing(1000);
        m_minimumThresholdSlider.setPaintTicks(true);
        m_minimumThresholdSlider.setValue(0);

        m_minimumThresholdSliderLabel.setText("0");

        m_minimumLabel.setText("Minimum [0.1‰]");

        m_maximumThresholdSlider.setMajorTickSpacing(2000);
        m_maximumThresholdSlider.setMaximum(10000);
        m_maximumThresholdSlider.setMinorTickSpacing(1000);
        m_maximumThresholdSlider.setPaintTicks(true);
        m_maximumThresholdSlider.setValue(10000);

        m_maxiimumLabel.setText("Maximum [0.1‰]");

        org.jdesktop.layout.GroupLayout m_maximumSliderPanelLayout = new org.jdesktop.layout.GroupLayout(m_maximumSliderPanel);
        m_maximumSliderPanel.setLayout(m_maximumSliderPanelLayout);
        m_maximumSliderPanelLayout.setHorizontalGroup(
            m_maximumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_maximumSliderPanelLayout.createSequentialGroup()
                .add(m_maximumThresholdSlider, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 350, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_maxiimumLabel)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        m_maximumSliderPanelLayout.setVerticalGroup(
            m_maximumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_maximumSliderPanelLayout.createSequentialGroup()
                .add(m_maximumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_maximumThresholdSlider, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_maximumSliderPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(m_maxiimumLabel)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_applyThresholdingBeforeSegmentation.setSelected(true);
        m_applyThresholdingBeforeSegmentation.setText("Thressh. before segm.");
        m_applyThresholdingBeforeSegmentation.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        m_advancedSegmentation.setText("Advanced segm.");
        m_advancedSegmentation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_advancedSegmentationActionPerformed(evt);
            }
        });

        m_maximumThresholdSliderLabel.setText("1000");

        m_autoApplyButton.setSelected(true);
        m_autoApplyButton.setText("auto-apply");
        m_autoApplyButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout m_minimumSliderPanelLayout = new org.jdesktop.layout.GroupLayout(m_minimumSliderPanel);
        m_minimumSliderPanel.setLayout(m_minimumSliderPanelLayout);
        m_minimumSliderPanelLayout.setHorizontalGroup(
            m_minimumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_minimumSliderPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_minimumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_minimumSliderPanelLayout.createSequentialGroup()
                        .add(m_minimumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(m_minimumThresholdSliderLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(m_maximumThresholdSliderLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(m_minimumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(m_minimumSliderPanelLayout.createSequentialGroup()
                                .add(m_minimumThresholdSlider, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 348, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(m_minimumLabel))
                            .add(m_maximumSliderPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(m_minimumSliderPanelLayout.createSequentialGroup()
                        .add(m_applyThresholdingBeforeSegmentation)
                        .add(18, 18, 18)
                        .add(m_autoApplyButton)
                        .add(18, 18, 18)
                        .add(m_advancedSegmentation)))
                .addContainerGap())
        );
        m_minimumSliderPanelLayout.setVerticalGroup(
            m_minimumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_minimumSliderPanelLayout.createSequentialGroup()
                .add(m_minimumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_minimumThresholdSliderLabel)
                    .add(m_minimumThresholdSlider, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_minimumSliderPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(m_minimumLabel)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_minimumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_maximumThresholdSliderLabel)
                    .add(m_maximumSliderPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(m_minimumSliderPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_applyThresholdingBeforeSegmentation)
                    .add(m_autoApplyButton)
                    .add(m_advancedSegmentation))
                .add(9, 9, 9))
        );

        org.jdesktop.layout.GroupLayout m_segmentationAmplitudeThressholdsLayout = new org.jdesktop.layout.GroupLayout(m_segmentationAmplitudeThressholds);
        m_segmentationAmplitudeThressholds.setLayout(m_segmentationAmplitudeThressholdsLayout);
        m_segmentationAmplitudeThressholdsLayout.setHorizontalGroup(
            m_segmentationAmplitudeThressholdsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_minimumSliderPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        m_segmentationAmplitudeThressholdsLayout.setVerticalGroup(
            m_segmentationAmplitudeThressholdsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_segmentationAmplitudeThressholdsLayout.createSequentialGroup()
                .add(m_minimumSliderPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(0, 0, Short.MAX_VALUE))
        );

        m_SegmentationPropertiesTabbedPane.addTab("Thresholds", m_segmentationAmplitudeThressholds);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Segmentation Range Criterium"));

        m_rangeDeterminatedByButtonGroup.add(m_rangeDefinedByStandardDeviation);
        m_rangeDefinedByStandardDeviation.setSelected(true);
        m_rangeDefinedByStandardDeviation.setText("standard deviation");
        m_rangeDefinedByStandardDeviation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_rangeDefinedByStandardDeviationActionPerformed(evt);
            }
        });

        m_rangeDeterminatedByButtonGroup.add(m_rangeDefinedByMinMaxPixelRange);
        m_rangeDefinedByMinMaxPixelRange.setText("min-max pixel range");
        m_rangeDefinedByMinMaxPixelRange.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_rangeDefinedByMinMaxPixelRangeActionPerformed(evt);
            }
        });

        m_segmentationAmplitudeRangeMultiplyer.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0.1", "0.2", "0.3", "0.4", "0.5", "0.6", "0.7", "0.8", "0.9", "1.0", "1.1", "1.2", "1.3", "1.4", "1.5", "1.6", "1.7", "1.8", "1.9", "2.0", "2.1", "2.2", "2.3", "2.4", "2.5", "2.6", "2.7", "2.8", "2.9", "3.0", "3.1", "3.2", "3.3", "3.4", "3.5", "3.6", "3.7", "3.8", "3.9", "4.0", "4.1", "4.2", "4.3", "4.4", "4.5", "4.6", "4.7", "4.8", "4.9", "5.0", "5.1", "5.2", "5.3", "5.4", "5.5", "5.6", "5.7", "5.8", "5.9", "6.0", "6.1", "6.2", "6.3", "6.4", "6.5", "6.6", "6.7", "6.8", "6.9", "7.0", "7.1", "7.2", "7.3", "7.4", "7.5", "7.6", "7.7", "7.8", "7.9", "8.0" }));
        m_segmentationAmplitudeRangeMultiplyer.setSelectedIndex(19);

        jLabel11.setText("Faktor");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(m_rangeDefinedByStandardDeviation)
                .add(18, 18, 18)
                .add(m_rangeDefinedByMinMaxPixelRange)
                .add(18, 18, 18)
                .add(jLabel11)
                .add(10, 10, 10)
                .add(m_segmentationAmplitudeRangeMultiplyer, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(m_rangeDefinedByStandardDeviation)
                        .add(m_rangeDefinedByMinMaxPixelRange))
                    .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(m_segmentationAmplitudeRangeMultiplyer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(jLabel11)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_segmentationScopePannel.setBorder(javax.swing.BorderFactory.createTitledBorder("Segmentation Scope"));

        m_segmentationScopeButtonGroup.add(m_applySegmentationToAllSlices);
        m_applySegmentationToAllSlices.setSelected(true);
        m_applySegmentationToAllSlices.setText("Apply to all images");

        m_segmentationScopeButtonGroup.add(m_applySegmentationToCurrentSliceOnly);
        m_applySegmentationToCurrentSliceOnly.setText("Apply to displayed image only");

        org.jdesktop.layout.GroupLayout m_segmentationScopePannelLayout = new org.jdesktop.layout.GroupLayout(m_segmentationScopePannel);
        m_segmentationScopePannel.setLayout(m_segmentationScopePannelLayout);
        m_segmentationScopePannelLayout.setHorizontalGroup(
            m_segmentationScopePannelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_segmentationScopePannelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_applySegmentationToAllSlices)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(m_applySegmentationToCurrentSliceOnly)
                .addContainerGap())
        );
        m_segmentationScopePannelLayout.setVerticalGroup(
            m_segmentationScopePannelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_segmentationScopePannelLayout.createSequentialGroup()
                .add(m_segmentationScopePannelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_applySegmentationToAllSlices, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_applySegmentationToCurrentSliceOnly, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_subSegmentationPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Sub Segmentation Scope"));

        m_subSegmentationButtonGroup.add(m_applySubSegmentationToAllImages);
        m_applySubSegmentationToAllImages.setText("Apply to all images");
        m_applySubSegmentationToAllImages.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applySubSegmentationToAllImagesActionPerformed(evt);
            }
        });

        m_subSegmentationButtonGroup.add(m_applySubSegmentationToCurrentlyDisplayedImageOnly);
        m_applySubSegmentationToCurrentlyDisplayedImageOnly.setSelected(true);
        m_applySubSegmentationToCurrentlyDisplayedImageOnly.setText("Apply to displayed image only");
        m_applySubSegmentationToCurrentlyDisplayedImageOnly.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applySubSegmentationToCurrentlyDisplayedImageOnlyActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_subSegmentationPanelLayout = new org.jdesktop.layout.GroupLayout(m_subSegmentationPanel);
        m_subSegmentationPanel.setLayout(m_subSegmentationPanelLayout);
        m_subSegmentationPanelLayout.setHorizontalGroup(
            m_subSegmentationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_subSegmentationPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_applySubSegmentationToAllImages)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(m_applySubSegmentationToCurrentlyDisplayedImageOnly)
                .addContainerGap())
        );
        m_subSegmentationPanelLayout.setVerticalGroup(
            m_subSegmentationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_applySubSegmentationToCurrentlyDisplayedImageOnly, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(m_applySubSegmentationToAllImages, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout m_segmentAmplitudeBoundsAndSegmentationScoopTabLayout = new org.jdesktop.layout.GroupLayout(m_segmentAmplitudeBoundsAndSegmentationScoopTab);
        m_segmentAmplitudeBoundsAndSegmentationScoopTab.setLayout(m_segmentAmplitudeBoundsAndSegmentationScoopTabLayout);
        m_segmentAmplitudeBoundsAndSegmentationScoopTabLayout.setHorizontalGroup(
            m_segmentAmplitudeBoundsAndSegmentationScoopTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(m_segmentationScopePannel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(m_subSegmentationPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        m_segmentAmplitudeBoundsAndSegmentationScoopTabLayout.setVerticalGroup(
            m_segmentAmplitudeBoundsAndSegmentationScoopTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_segmentAmplitudeBoundsAndSegmentationScoopTabLayout.createSequentialGroup()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 60, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(1, 1, 1)
                .add(m_segmentationScopePannel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 42, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_subSegmentationPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_SegmentationPropertiesTabbedPane.addTab("Segment Bounds & Scope", m_segmentAmplitudeBoundsAndSegmentationScoopTab);

        m_probingRegionPropertiesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Properties of probing region"));

        jLabel2.setText("Size y");

        jLabel1.setText("Size x");

        m_defineProbeSizeX.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
        m_defineProbeSizeX.setSelectedIndex(2);

        m_defineProbeSizeY.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
        m_defineProbeSizeY.setSelectedIndex(2);

        jLabel3.setText("#of probe  pixels");

        m_numberOfProbingPixels.setText("5");

        jLabel4.setText("# of permutations");

        m_permutationNumber.add(m_allPermutationsCheckbox);
        m_allPermutationsCheckbox.setText("all");
        m_allPermutationsCheckbox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        m_permutationNumber.add(m_restrictedNumberOfPermutationsCheckbox);
        m_restrictedNumberOfPermutationsCheckbox.setSelected(true);
        m_restrictedNumberOfPermutationsCheckbox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        m_numberOfPermutations.setText("5");

        org.jdesktop.layout.GroupLayout m_probingRegionPropertiesPanelLayout = new org.jdesktop.layout.GroupLayout(m_probingRegionPropertiesPanel);
        m_probingRegionPropertiesPanel.setLayout(m_probingRegionPropertiesPanelLayout);
        m_probingRegionPropertiesPanelLayout.setHorizontalGroup(
            m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_probingRegionPropertiesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_probingRegionPropertiesPanelLayout.createSequentialGroup()
                        .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(m_probingRegionPropertiesPanelLayout.createSequentialGroup()
                                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel1)
                                    .add(jLabel2))
                                .add(68, 68, 68)
                                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(m_defineProbeSizeX, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .add(m_defineProbeSizeY, 0, 56, Short.MAX_VALUE)))
                            .add(m_probingRegionPropertiesPanelLayout.createSequentialGroup()
                                .add(jLabel3)
                                .add(14, 14, 14)
                                .add(m_numberOfProbingPixels, 0, 1, Short.MAX_VALUE)))
                        .add(20, 20, 20))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, m_probingRegionPropertiesPanelLayout.createSequentialGroup()
                        .add(jLabel4)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(m_allPermutationsCheckbox)
                        .add(18, 18, 18)
                        .add(m_restrictedNumberOfPermutationsCheckbox)))
                .add(18, 18, 18)
                .add(m_numberOfPermutations, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 57, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(191, Short.MAX_VALUE))
        );
        m_probingRegionPropertiesPanelLayout.setVerticalGroup(
            m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_probingRegionPropertiesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(m_defineProbeSizeX, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(m_defineProbeSizeY, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(m_numberOfProbingPixels, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(m_numberOfPermutations, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_restrictedNumberOfPermutationsCheckbox)
                    .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(m_allPermutationsCheckbox)
                        .add(jLabel4)))
                .add(23, 23, 23))
        );

        org.jdesktop.layout.GroupLayout m_probingRegionPropertiesTabLayout = new org.jdesktop.layout.GroupLayout(m_probingRegionPropertiesTab);
        m_probingRegionPropertiesTab.setLayout(m_probingRegionPropertiesTabLayout);
        m_probingRegionPropertiesTabLayout.setHorizontalGroup(
            m_probingRegionPropertiesTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_probingRegionPropertiesPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        m_probingRegionPropertiesTabLayout.setVerticalGroup(
            m_probingRegionPropertiesTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_probingRegionPropertiesPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        m_SegmentationPropertiesTabbedPane.addTab("Probing region", m_probingRegionPropertiesTab);

        m_probingCriteriaTabbedPane.setTabPlacement(javax.swing.JTabbedPane.BOTTOM);
        m_probingCriteriaTabbedPane.setMinimumSize(new java.awt.Dimension(0, 0));

        m_meanCheckBox.setSelected(true);
        m_meanCheckBox.setText("mean");
        m_meanCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        m_varianceCheckBox.setText("variance");
        m_varianceCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        m_skewnessCheckBox.setText("skewness");
        m_skewnessCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        m_kurtosisCheckBox.setText("kurtosis");
        m_kurtosisCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        m_meanLogicCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "AND", "OR" }));
        m_meanLogicCombo.setEnabled(false);

        m_varianceLogicCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "AND", "OR" }));
        m_varianceLogicCombo.setEnabled(false);

        m_skewnessLogicCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "AND", "OR" }));
        m_skewnessLogicCombo.setEnabled(false);

        org.jdesktop.layout.GroupLayout m_histogramCriteriaPanelLayout = new org.jdesktop.layout.GroupLayout(m_histogramCriteriaPanel);
        m_histogramCriteriaPanel.setLayout(m_histogramCriteriaPanelLayout);
        m_histogramCriteriaPanelLayout.setHorizontalGroup(
            m_histogramCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_histogramCriteriaPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_histogramCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_meanCheckBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 61, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_varianceCheckBox)
                    .add(m_skewnessCheckBox)
                    .add(m_kurtosisCheckBox))
                .add(24, 24, 24)
                .add(m_histogramCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(m_varianceLogicCombo, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(m_skewnessLogicCombo, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(m_meanLogicCombo, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(299, Short.MAX_VALUE))
        );
        m_histogramCriteriaPanelLayout.setVerticalGroup(
            m_histogramCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_histogramCriteriaPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_histogramCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_meanCheckBox)
                    .add(m_meanLogicCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_histogramCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_varianceCheckBox)
                    .add(m_varianceLogicCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_histogramCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_skewnessCheckBox)
                    .add(m_skewnessLogicCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_kurtosisCheckBox)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_probingCriteriaTabbedPane.addTab("Histogram", m_histogramCriteriaPanel);

        jLabel5.setText("to be implemented soon!");

        org.jdesktop.layout.GroupLayout m_absoluteGradientCriteriaPanelLayout = new org.jdesktop.layout.GroupLayout(m_absoluteGradientCriteriaPanel);
        m_absoluteGradientCriteriaPanel.setLayout(m_absoluteGradientCriteriaPanelLayout);
        m_absoluteGradientCriteriaPanelLayout.setHorizontalGroup(
            m_absoluteGradientCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_absoluteGradientCriteriaPanelLayout.createSequentialGroup()
                .add(108, 108, 108)
                .add(jLabel5)
                .addContainerGap(216, Short.MAX_VALUE))
        );
        m_absoluteGradientCriteriaPanelLayout.setVerticalGroup(
            m_absoluteGradientCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_absoluteGradientCriteriaPanelLayout.createSequentialGroup()
                .add(60, 60, 60)
                .add(jLabel5)
                .addContainerGap(49, Short.MAX_VALUE))
        );

        m_probingCriteriaTabbedPane.addTab("Absolute gradient", m_absoluteGradientCriteriaPanel);

        jLabel6.setText("to be implemented soon!");

        org.jdesktop.layout.GroupLayout m_runlengthMatrixCriteriaPanelLayout = new org.jdesktop.layout.GroupLayout(m_runlengthMatrixCriteriaPanel);
        m_runlengthMatrixCriteriaPanel.setLayout(m_runlengthMatrixCriteriaPanelLayout);
        m_runlengthMatrixCriteriaPanelLayout.setHorizontalGroup(
            m_runlengthMatrixCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_runlengthMatrixCriteriaPanelLayout.createSequentialGroup()
                .add(100, 100, 100)
                .add(jLabel6)
                .addContainerGap(224, Short.MAX_VALUE))
        );
        m_runlengthMatrixCriteriaPanelLayout.setVerticalGroup(
            m_runlengthMatrixCriteriaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_runlengthMatrixCriteriaPanelLayout.createSequentialGroup()
                .addContainerGap(49, Short.MAX_VALUE)
                .add(jLabel6)
                .add(60, 60, 60))
        );

        m_probingCriteriaTabbedPane.addTab("Runlength matrix", m_runlengthMatrixCriteriaPanel);

        jLabel7.setText("to be implemented soon!");

        org.jdesktop.layout.GroupLayout m_probingCriteriaTabLayout = new org.jdesktop.layout.GroupLayout(m_probingCriteriaTab);
        m_probingCriteriaTab.setLayout(m_probingCriteriaTabLayout);
        m_probingCriteriaTabLayout.setHorizontalGroup(
            m_probingCriteriaTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_probingCriteriaTabLayout.createSequentialGroup()
                .add(112, 112, 112)
                .add(jLabel7)
                .addContainerGap(212, Short.MAX_VALUE))
        );
        m_probingCriteriaTabLayout.setVerticalGroup(
            m_probingCriteriaTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_probingCriteriaTabLayout.createSequentialGroup()
                .add(57, 57, 57)
                .add(jLabel7)
                .addContainerGap(52, Short.MAX_VALUE))
        );

        m_probingCriteriaTabbedPane.addTab("Co-ocurrence matrix", m_probingCriteriaTab);

        org.jdesktop.layout.GroupLayout m_probingCriteriaPropertiesTabLayout = new org.jdesktop.layout.GroupLayout(m_probingCriteriaPropertiesTab);
        m_probingCriteriaPropertiesTab.setLayout(m_probingCriteriaPropertiesTabLayout);
        m_probingCriteriaPropertiesTabLayout.setHorizontalGroup(
            m_probingCriteriaPropertiesTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_probingCriteriaTabbedPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        m_probingCriteriaPropertiesTabLayout.setVerticalGroup(
            m_probingCriteriaPropertiesTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_probingCriteriaTabbedPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 165, Short.MAX_VALUE)
        );

        m_SegmentationPropertiesTabbedPane.addTab("Probing criteria", m_probingCriteriaPropertiesTab);

        m_performSimpleSegmentationButton.setText("Perform segmentation");
        m_performSimpleSegmentationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                performSegmentationButtonPressed(evt);
            }
        });

        m_performAdvancedSegmentationButton.setText("Stop segmentation");

        org.jdesktop.layout.GroupLayout m_segmentationPerformAndStopbuttonPanelLayout = new org.jdesktop.layout.GroupLayout(m_segmentationPerformAndStopbuttonPanel);
        m_segmentationPerformAndStopbuttonPanel.setLayout(m_segmentationPerformAndStopbuttonPanelLayout);
        m_segmentationPerformAndStopbuttonPanelLayout.setHorizontalGroup(
            m_segmentationPerformAndStopbuttonPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_segmentationPerformAndStopbuttonPanelLayout.createSequentialGroup()
                .add(37, 37, 37)
                .add(m_performSimpleSegmentationButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 217, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 33, Short.MAX_VALUE)
                .add(m_performAdvancedSegmentationButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 178, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(48, 48, 48))
        );
        m_segmentationPerformAndStopbuttonPanelLayout.setVerticalGroup(
            m_segmentationPerformAndStopbuttonPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_segmentationPerformAndStopbuttonPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                .add(m_performAdvancedSegmentationButton)
                .add(m_performSimpleSegmentationButton))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_segmentationPerformAndStopbuttonPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(m_SegmentationPropertiesTabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_segmentationProgressBar, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(m_SegmentationPropertiesTabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 231, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_segmentationProgressBar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_segmentationPerformAndStopbuttonPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void performSegmentationButtonPressed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_performSegmentationButtonPressed
        notifyActionListeners( START_SEGMENTATION );
    }//GEN-LAST:event_performSegmentationButtonPressed

    private void deleteAreaForSegmentationButtonPressed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteAreaForSegmentationButtonPressed
        notifyActionListeners( REMOVE_GRAPHIC_SEGMENTATION_REGION_REQUIRED );
        m_segmentWholeImageRadioButton.setSelected( true );
        m_defineAreaForSegmentationButton.setEnabled( false );
        m_deleteAreaForSegmentation.setEnabled( false );
    }//GEN-LAST:event_deleteAreaForSegmentationButtonPressed

    private void defineAreaForSegmentationButtonPressed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_defineAreaForSegmentationButtonPressed
        notifyActionListeners( GRAPHIC_SEGMENTATION_REGION_DEFINITION_REQUIRED );
    }//GEN-LAST:event_defineAreaForSegmentationButtonPressed

    /**
     * User selects the radio button indicating that he wants
     * to define a region in the image for segmentation
     */
    private void segmentGraphicelDefinedRegionButtonPressed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_segmentGraphicelDefinedRegionButtonPressed
        m_minimumThresshold.setEditable( false );
        m_maximumThresshold.setEditable( false );
        m_defineAreaForSegmentationButton.setEnabled( true );
        m_deleteAreaForSegmentation.setEnabled( true );
    }//GEN-LAST:event_segmentGraphicelDefinedRegionButtonPressed

    private void segmentImageAfterThressholdingButtonPressed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_segmentImageAfterThressholdingButtonPressed
        m_minimumThresshold.setEditable( true );
        m_maximumThresshold.setEditable( true );
        m_defineAreaForSegmentationButton.setEnabled( false );
        m_deleteAreaForSegmentation.setEnabled( false );
    }//GEN-LAST:event_segmentImageAfterThressholdingButtonPressed

    private void segmentWholeImageRadioButtonSelected(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_segmentWholeImageRadioButtonSelected
       m_minimumThresshold.setEditable( false );
       m_maximumThresshold.setEditable( false );
       m_defineAreaForSegmentationButton.setEnabled( false );
       m_deleteAreaForSegmentation.setEnabled( false );
    }//GEN-LAST:event_segmentWholeImageRadioButtonSelected

    private void m_advancedSegmentationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_advancedSegmentationActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_advancedSegmentationActionPerformed

private void m_applySubSegmentationToAllImagesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applySubSegmentationToAllImagesActionPerformed
// TODO add your handling code here:
        notifyActionListeners( SUBSEGMENT_IN_ALL_SLICES );
}//GEN-LAST:event_m_applySubSegmentationToAllImagesActionPerformed

private void m_applySubSegmentationToCurrentlyDisplayedImageOnlyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applySubSegmentationToCurrentlyDisplayedImageOnlyActionPerformed
        notifyActionListeners( SUBSEGMENT_IN_CURRENTLY_SELECTED_SLICE_ONLY );
}//GEN-LAST:event_m_applySubSegmentationToCurrentlyDisplayedImageOnlyActionPerformed

private void m_rangeDefinedByStandardDeviationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_rangeDefinedByStandardDeviationActionPerformed
        m_pixelRangeDeterminationType = PIXEL_RANGE_DEFINED_BY_STANDARD_DEVIATION;
}//GEN-LAST:event_m_rangeDefinedByStandardDeviationActionPerformed

private void m_rangeDefinedByMinMaxPixelRangeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_rangeDefinedByMinMaxPixelRangeActionPerformed
        m_pixelRangeDeterminationType = PIXEL_RANGE_DEFINED_BY_PIXEL_INTENSITY_RANGE;
}//GEN-LAST:event_m_rangeDefinedByMinMaxPixelRangeActionPerformed
    
    /**
     * Adds an action listener to the list of action listeners who are notified
     * when something happens with the spinbox.
     * @param e
     */
    public void addActionListener( ActionListener e )
    {
	m_listeners.add( e );
    }
    
    /**
     * Notify all actionListeners
     */
    private void notifyActionListeners( int eventType )
    {
        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, eventType, "" ) );
        }
    }

    /**
     * Is called when ever a registered class raises an action event.
     * @param e
     */
    @Override
    public void actionPerformed( ActionEvent e ) 
    {
        
        Object sender = e.getSource( );
        
        if ( sender instanceof ProbabilityBasedSegmentationCalculator  )
        {
            if ( e.getID( ) == ProbabilityBasedSegmentationCalculator.NOTIFY_PROGRESS_EVENT )
            {
                m_segmentationProgressBar.setValue( ( (ProbabilityBasedSegmentationCalculator)e.getSource( ) ).getProgress( ) );
            }
            if ( e.getID( ) == ProbabilityBasedSegmentationCalculator.PROBABILISTIC_SEGMENTATION_PERFORMED_EVENT )
            {
                m_segmentationProgressBar.setValue( 0 );
            }
        }   
    }
    
    /**
     * Is called whenever a registered component raises a change event.
     */
    @Override
    public void stateChanged( ChangeEvent e ) 
    {
        Object sender = e.getSource( );
        
        if ( sender == m_minimumThresholdSlider ) 
        {
            if ( !m_minimumThresholdSlider.getValueIsAdjusting( ) )
            {
                notifyActionListeners( MINIMUM_VALUE_CHANGE_EVENT );
                
                if ( this.m_autoApplyButton.isSelected( ) )
                {
                    notifyActionListeners( START_SEGMENTATION );
                }
            }
            m_minimumThresholdSliderLabel.setText( "" + (int)( m_minimumThresholdSlider.getValue( ) * this.m_maxPixVal / 10000f ) );
        }
        
        if ( sender == m_maximumThresholdSlider ) 
        {
            if ( !m_maximumThresholdSlider.getValueIsAdjusting( ) )
            {
                notifyActionListeners( MAXIMUM_VALUE_CHANGE_EVENT );
                
                if ( this.m_autoApplyButton.isSelected( ) )
                {
                    notifyActionListeners( START_SEGMENTATION );
                }
            }
            m_maximumThresholdSliderLabel.setText( "" + (int)( m_maximumThresholdSlider.getValue( ) * this.m_maxPixVal / 10000f ) );
        }
    }
    
    /**
     * Returns the user defined value of the minimum threshold slider.
     * @return 
     */
    public float getValueOfMinimumThresholdSlider( )
    {
        return (float)( m_minimumThresholdSlider.getValue( ) * this.m_maxPixVal / 10000f );
        //return m_minimumThresholdSlider.getValue( );
    }
    
    /**
     * Returns the user defined value of the maximum threshold slider.
     * @return 
     */
    public float getValueOfMaximumThresholdSlider( )
    {
        return (float)( m_maximumThresholdSlider.getValue( ) * this.m_maxPixVal / 10000f );
        //return m_maximumThresholdSlider.getValue( );
    }
    
    /**
     * Returns whether the user wants the segmentation calculator to perform
     * a simple thresholding (based on user defined values before the 
     * true segmentation.
     * @return 
     */ 
    public boolean performThresholdingBeforeSegmentation( )
    {
        return m_applyThresholdingBeforeSegmentation.isSelected( );
    }
    
    /**
     * Returns whether the user wants the segmentation calculator to perform
     * after the simple thresholding, simple segmentation a time consuming 
     * probabilistic segmentation to find out whether user wants a more accurate 
     * segmentation. 
     * @return 
     */ 
    public boolean performAdvancedSegmentation( )
    {
        return m_advancedSegmentation.isSelected( );
    }
    
    
    
    /**
     * Returns the value of probe size X.
     * @return 
     */
    public int getProbeSizeX( )
    {
        return m_defineProbeSizeX.getSelectedIndex( ) + 1;
    }
    
    /**
     * Returns the value of probe size Y.
     * @return 
     */
    public int getProbeSizeY( )
    {
        return m_defineProbeSizeY.getSelectedIndex( ) + 1;
    }
    
    /**
     * Returns the number of permutations.
     * @return 
     */
    public int getNumberOfPermutations( )
    {
        return ( new Integer( m_numberOfPermutations.getText( ) ) ).intValue( );
    }
    
    /**
     * Returns the number of permutations.
     */
    public int getNumberOfProbingPixels( )
    {
        return ( new Integer( m_numberOfProbingPixels.getText( ) ) ).intValue( );
    }
    
    
    /**
     * Method that determines the scope of the sub segment selection by 
     * double clicking; Apply it either to all or to selected image only.
     * @return int value SUBSEGMENT_IN_ALL_SLICES or 
     * SUBSEGMENT_IN_CURRENTLY_SELECTED_SLICE_ONLY
     */
    public int getSubSegmentScope( )
    {
        if ( m_applySubSegmentationToAllImages.isSelected( ) == true )
        {
            return SUBSEGMENT_IN_ALL_SLICES;
        }
        else
        {
            return SUBSEGMENT_IN_CURRENTLY_SELECTED_SLICE_ONLY;
        }
    }
    
    /**
     * Determines the way the pixel range is taken which is used in the
     * segmentation. 
     * @return
     */
    public int getPixelRangeComputationType( )
    {
        return m_pixelRangeDeterminationType;
    }
    
    /**
     * Returns the value with which the range must be mulitplied
     * @return
     */
    public float getRangeMultiplier( )
    {
        String value = (String)m_segmentationAmplitudeRangeMultiplyer.getModel( ).getSelectedItem( );
        return new Float( value ).floatValue( );
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTabbedPane m_SegmentationPropertiesTabbedPane;
    private javax.swing.JPanel m_absoluteGradientCriteriaPanel;
    private javax.swing.JCheckBox m_advancedSegmentation;
    private javax.swing.JRadioButton m_allPermutationsCheckbox;
    private javax.swing.JRadioButton m_applySegmentationToAllSlices;
    private javax.swing.JRadioButton m_applySegmentationToCurrentSliceOnly;
    private javax.swing.JRadioButton m_applySubSegmentationToAllImages;
    private javax.swing.JRadioButton m_applySubSegmentationToCurrentlyDisplayedImageOnly;
    private javax.swing.JCheckBox m_applyThresholdingBeforeSegmentation;
    private javax.swing.JCheckBox m_autoApplyButton;
    private javax.swing.JButton m_defineAreaForSegmentationButton;
    private javax.swing.JComboBox m_defineProbeSizeX;
    private javax.swing.JComboBox m_defineProbeSizeY;
    private javax.swing.JRadioButton m_defineRegionToSegmentRadioButton;
    private javax.swing.JButton m_deleteAreaForSegmentation;
    private javax.swing.JPanel m_histogramCriteriaPanel;
    private javax.swing.JCheckBox m_kurtosisCheckBox;
    private javax.swing.JLabel m_maxiimumLabel;
    private javax.swing.JPanel m_maximumSliderPanel;
    private javax.swing.JSlider m_maximumThresholdSlider;
    private javax.swing.JLabel m_maximumThresholdSliderLabel;
    private javax.swing.JTextField m_maximumThresshold;
    private javax.swing.JCheckBox m_meanCheckBox;
    private javax.swing.JComboBox m_meanLogicCombo;
    private javax.swing.JLabel m_minimumLabel;
    private javax.swing.JPanel m_minimumSliderPanel;
    private javax.swing.JSlider m_minimumThresholdSlider;
    private javax.swing.JLabel m_minimumThresholdSliderLabel;
    private javax.swing.JTextField m_minimumThresshold;
    private javax.swing.JTextField m_numberOfPermutations;
    private javax.swing.JTextField m_numberOfProbingPixels;
    private javax.swing.JButton m_performAdvancedSegmentationButton;
    private javax.swing.JButton m_performSimpleSegmentationButton;
    private javax.swing.ButtonGroup m_permutationNumber;
    private javax.swing.JPanel m_probingCriteriaPropertiesTab;
    private javax.swing.JPanel m_probingCriteriaTab;
    private javax.swing.JTabbedPane m_probingCriteriaTabbedPane;
    private javax.swing.JPanel m_probingRegionPropertiesPanel;
    private javax.swing.JPanel m_probingRegionPropertiesTab;
    private javax.swing.JRadioButton m_rangeDefinedByMinMaxPixelRange;
    private javax.swing.JRadioButton m_rangeDefinedByStandardDeviation;
    private javax.swing.ButtonGroup m_rangeDeterminatedByButtonGroup;
    private javax.swing.JPanel m_regionToSegmentTab;
    private javax.swing.JRadioButton m_restrictedNumberOfPermutationsCheckbox;
    private javax.swing.JPanel m_runlengthMatrixCriteriaPanel;
    private javax.swing.JPanel m_segmentAmplitudeBoundsAndSegmentationScoopTab;
    private javax.swing.JRadioButton m_segmentWholeImageAfterThresholdingRadioButton;
    private javax.swing.JRadioButton m_segmentWholeImageRadioButton;
    private javax.swing.JComboBox m_segmentationAmplitudeRangeMultiplyer;
    private javax.swing.JPanel m_segmentationAmplitudeThressholds;
    private javax.swing.JPanel m_segmentationPerformAndStopbuttonPanel;
    private javax.swing.JProgressBar m_segmentationProgressBar;
    private javax.swing.ButtonGroup m_segmentationRegionButtonGroup;
    private javax.swing.ButtonGroup m_segmentationScopeButtonGroup;
    private javax.swing.JPanel m_segmentationScopePannel;
    private javax.swing.JCheckBox m_skewnessCheckBox;
    private javax.swing.JComboBox m_skewnessLogicCombo;
    private javax.swing.ButtonGroup m_subSegmentationButtonGroup;
    private javax.swing.JPanel m_subSegmentationPanel;
    private javax.swing.JCheckBox m_varianceCheckBox;
    private javax.swing.JComboBox m_varianceLogicCombo;
    // End of variables declaration//GEN-END:variables
    
    // Listeners to changes in the segmentation gui control
    private LinkedList<ActionListener> m_listeners = new LinkedList<ActionListener>( );
    
    
    // For proper serialization
    private static final long serialVersionUID = 1412325898865493L;
    
    public final static int GRAPHIC_SEGMENTATION_REGION_DEFINITION_REQUIRED = 0;
    public final static int REMOVE_GRAPHIC_SEGMENTATION_REGION_REQUIRED = 1;
    public final static int START_SEGMENTATION = 2;
    public final static int STOP_SEGMENTATION = 3;
    
    public final static int MINIMUM_VALUE_CHANGE_EVENT = 4;
    public final static int MAXIMUM_VALUE_CHANGE_EVENT = 5;
    
    public final static int SUBSEGMENT_IN_CURRENTLY_SELECTED_SLICE_ONLY = 100;
    public final static int SUBSEGMENT_IN_ALL_SLICES = 101;
    
    public final static int PIXEL_RANGE_DEFINED_BY_STANDARD_DEVIATION = 200;
    public final static int PIXEL_RANGE_DEFINED_BY_PIXEL_INTENSITY_RANGE = 201;
    
    
    private final float m_maxPixVal;
    private final float m_minPixVal;
    private int   m_pixelRangeDeterminationType;
    
}
