/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.io.dicom;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import java.util.Iterator;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.table.DefaultTableModel;
import org.dcm4che2.data.DicomObject;

/**
 *
 * @author user
 */
public class DicomTagReaderGUI extends javax.swing.JFrame {

    private DicomHeader header = new DicomHeader();
    private DefaultTableModel tablemodel;
    private File currentFile;

    /**
     * Creates new form DicomTagReaderGUI
     */
    public DicomTagReaderGUI() {
        initComponents();
        tablemodel = (DefaultTableModel) jTable.getModel();
        jTable.setAutoCreateRowSorter(true);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable = new javax.swing.JTable();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenuFile = new javax.swing.JMenu();
        jMenuItemOpen = new javax.swing.JMenuItem();
        jMenuItemSave = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("DICOM Tag Reader");

        jTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Tag", "Description", "VM", "VR", "Value"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable.setColumnSelectionAllowed(true);
        jTable.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTableMousePressed(evt);
            }
        });
        jScrollPane1.setViewportView(jTable);
        jTable.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        if (jTable.getColumnModel().getColumnCount() > 0) {
            jTable.getColumnModel().getColumn(2).setMinWidth(10);
            jTable.getColumnModel().getColumn(2).setPreferredWidth(30);
            jTable.getColumnModel().getColumn(2).setMaxWidth(40);
            jTable.getColumnModel().getColumn(3).setMinWidth(10);
            jTable.getColumnModel().getColumn(3).setPreferredWidth(30);
            jTable.getColumnModel().getColumn(3).setMaxWidth(40);
        }

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jMenuFile.setText("File");

        jMenuItemOpen.setText("Open");
        jMenuItemOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemOpenActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemOpen);

        jMenuItemSave.setText("Save to file");
        jMenuItemSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSaveActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemSave);

        jMenuBar1.add(jMenuFile);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItemOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemOpenActionPerformed
        JFileChooser fileChooser = new JFileChooser(currentFile);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        DicomObject object;
        header.clear();
        int rows = tablemodel.getRowCount();
        if (rows > 0) {
            for (int i = 0; i < rows; i++) {
                tablemodel.removeRow(0);
            }
        }
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                currentFile = fileChooser.getSelectedFile();
                selected_file = currentFile;
                if (selected_file != null) {
                    object = DicomHandler.getDicomObject(selected_file.toString());
                    header = DicomHandler.getHeader(object);
                    DicomHeaderLine line;
                    line = (DicomHeaderLine) header.get("(0008,0016)"); // Check if Siemens Format
                    if (line.Value.contentEquals("1.3.12.2.1107.5.9.1")) {
                        try {
                            DicomHandler.readSiemensData(object, header);
                        } catch (Exception ex) {
                            Logger.getLogger(DicomTagReaderGUI.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                    Set keys = header.keySet();
                    Iterator iter = keys.iterator();

                    String tag;
                    while (iter.hasNext()) {
                        tag = (String) iter.next();
                        line = header.get(tag);
                        if (line.ValueByte == null) {
                            tablemodel.addRow(new Object[]{tag, line.Name, line.VM, line.VR, line.Value});
                        } else {
                            tablemodel.addRow(new Object[]{tag, line.Name, line.VM, line.VR, "###Data###"});
                        }
                    }
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jMenuItemOpenActionPerformed

    private void jMenuItemSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSaveActionPerformed
        if (header.size() > 0) {
            JFileChooser fileChooser = new JFileChooser();
            int result = fileChooser.showSaveDialog(this);
            File selected_file;
            switch (result) {
                case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed

                    selected_file = fileChooser.getSelectedFile();
                    if (selected_file != null) {
                        try {
                            header.write2file(selected_file.toString(), false);
                        } catch (FileNotFoundException ex) {
                            Logger.getLogger(DicomTagReaderGUI.class.getName()).log(Level.SEVERE, null, ex);
                        } catch (UnsupportedEncodingException ex) {
                            Logger.getLogger(DicomTagReaderGUI.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                    break;
                case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                    break;
                case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                    break;
            }
        }
    }//GEN-LAST:event_jMenuItemSaveActionPerformed

    private void jTableMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableMousePressed
    }//GEN-LAST:event_jTableMousePressed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(DicomTagReaderGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(DicomTagReaderGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(DicomTagReaderGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(DicomTagReaderGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new DicomTagReaderGUI().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenu jMenuFile;
    private javax.swing.JMenuItem jMenuItemOpen;
    private javax.swing.JMenuItem jMenuItemSave;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable;
    // End of variables declaration//GEN-END:variables
}
