/*
 * File: $Id: Dialogs.java,v 1.1.1.1 2006/04/19 09:38:48 hans Exp $
 * History
 * Date: 30.11.2002 Authors: Martin Buerki  Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

package org.spectrim.lib;

import java.awt.Dimension;
import javax.swing.*;

/**
 * Helper class to make message dialogs more easy to handle
 * (obsolete now). All references should be replaced 
 * by framework equivalents
 */

public final class Dialogs
{
    public static int messageBox( JFrame owner, String text ) 
    {
        MessageBox mBox = new MessageBox( owner );
        mBox.setMinimumSize( new Dimension( 400, 80 ) );
        return mBox.showModal( text, "Message", MessageBox.MB_OK );
    }

    public static int messageBox( JFrame owner, String text, int buttons )
    {
        MessageBox mBox = new MessageBox( owner );
        mBox.setMinimumSize( new Dimension( 400, 80 ) );
        return mBox.showModal( text, "Message", buttons );
    }

    public static int messageBox( JFrame owner, String text, String title )
    {
        MessageBox mBox = new MessageBox( owner );
        mBox.setMinimumSize( new Dimension( 400, 80 ) );
        return mBox.showModal( text, title, MessageBox.MB_OK );
    }

    public static int messageBox( JFrame owner, String text, String title, int buttons ) 
    {
        MessageBox mBox = new MessageBox( owner );
        mBox.setMinimumSize( new Dimension( 400, 80 ) );
        return mBox.showModal( text, title, buttons );
    }
}
