/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.lib;

import java.util.regex.Pattern;

/**
 * Utility class that brings the strings of DICOM tags in a more appropriate
 * format.
 * @author Johannes Slotboom <johannes.slotboom at insel.ch>
 */
public class DicomStringReformatter 
{
    /**
     * Default constructor of a class that perform formatting of strings read
     * from DICOM tags.
     */
    public DicomStringReformatter( )
    {
        
    }
    
    /**
     * Reformat the patient data string.
     * @param name
     * @return 
     */
    public String reformatPatientName( String name )
    {
        int firstSeparatorSymbol = name.indexOf( '^' );
        String outString = name.replaceFirst( Pattern.quote( "^" ), ", " );
        String outString2;
        
        outString2 = outString.replace( '^', ' ' );
        
        return outString2.trim( );
    }
    
    /**
     * Reformats the ISO formatted date string (YYYYMMDD into a
     * DD.MM.YYYY format.
     * @param dicomDate
     * @return 
     */
    public String getDateMonthYear( String dicomDate )
    {
        String output;
        
        if ( dicomDate.length( ) == 8 )
        {
            output = dicomDate.substring( 6, 8 ) + "." + 
                     dicomDate.substring( 4, 6 ) + "." +
                     dicomDate.substring( 0, 4 );
        }
        else
        {
            output = dicomDate;
            
        }
        return output;
    }
}
