/*
 * ImagesTableModel.java
 *
 * Created on October 18, 2006, 4:05 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.spectrim.patientdatabase;

import java.sql.ResultSet;
import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author hans
 */
public class InstancesTableModel extends AbstractTableModel
{
    
    // blob is not in the list since it cannot be displayed
    private int m_colnum = 6;
    private int m_rownum;
    private String[] m_colNames = {
        "Number", "Dimension", "Position", "Thickness", "TE", "TR"
    };
    
    private  ArrayList<String[]> ResultSets;
    
    private Object[][] m_data;
       
    /** 
     * Creates a new instance of ImagesTableModel 
     */
    public InstancesTableModel( ResultSet rs )
    {
        ResultSets = new ArrayList<String[]>();  
    
        try
        {
            while( rs.next( ) )
            {
      
                String[] row =
                {
                    rs.getString( "instance_number" ),
                    rs.getString( "image_width" ) + "x" + rs.getString( "image_height" ),
                    rs.getString( "slice_location" ),
                    rs.getString( "slice_thickness" ),
                    rs.getString( "TE" ),
                    rs.getString( "TR" )
                };
                
                ResultSets.add( row );
            }   
        }
        catch( Exception e )
        {
            System.out.println( "Exception in InstancesTableModel" );
        }
    }

   public int getRowCount( )
    {
        return ResultSets.size( );
    }

    public int getColumnCount( )
    {
        return m_colnum;
    }

    /**
     * Returns a value from the table
     */
    public Object getValueAt( int rowIndex, int columnIndex )
    { 
        String[] row=ResultSets.get(rowIndex);
        return row[columnIndex];
    }
    
    /**
     * Returns the column name of the
     */ 
    public String getColumnName( int param ) 
    {
       return m_colNames[param];
    }
    
     /**
      * Returns the column names
      */
     public String[] getColumnNames( )
     {
         return m_colNames;
     }
     
     /**
      * Get table data
      */
     public Object[][] getTableData( )
     {
         
         m_data = new Object[ResultSets.size( )][m_colnum];
         
         for ( int i = 0 ; i < m_colnum ; i++ )
         {
             for ( int j = 0 ; j < ResultSets.size( ); j++ )
             {
                 m_data[j][i] = getValueAt( j, i );
             }
         }
         
         return m_data;
     }
    
    // For proper serialization
    private static final long serialVersionUID = 6482325912121223L;
}