/*
 * SeriesTableModel.java
 *
 * Created on October 18, 2006, 3:48 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.spectrim.patientdatabase;

import java.sql.ResultSet;
import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author hans
 */
public class SeriesTableModel extends AbstractTableModel
{
    private int m_colnum = 4;
    private int m_rownum;
    private String[] m_colNames = {
        "Number", "Description", "Instances", "Type"
    };
    
    private  ArrayList<String[]> ResultSets;
    private Object[][] m_data;
    
    /** 
     * Creates a new instance of SeriesTableModel 
     */
    public SeriesTableModel( ResultSet rs )
    {
        ResultSets = new ArrayList<String[]>();  
    
        try
        {
            while( rs.next( ) )
            {
      
                String[] row=
                {
                    rs.getString( "pacs_series_number" ),
                    rs.getString( "series_description" ),
                    rs.getString( "number_of_instances" ),
                    rs.getString( "is_spectrum" )
                };
                
                ResultSets.add( row );
            }   
        }
        catch( Exception e )
        {
            System.out.println( "Exception in SeriesTableModel" );
        }
    }

    public int getRowCount( )
    {
        return ResultSets.size( );
    }

    public int getColumnCount( )
    {
        return m_colnum;
    }

    /**
     * Returns a value from the table
     */
    public Object getValueAt( int rowIndex, int columnIndex )
    { 
        String[] row=ResultSets.get(rowIndex);
        return row[columnIndex];
    }
    
    /**
     * Returns the column name of the
     */ 
    public String getColumnName( int param ) 
    {
       return m_colNames[param];
    }
    
     /**
      * Returns the column names
      */
     public String[] getColumnNames( )
     {
         return m_colNames;
     }
     
     /**
      * Get table data
      */
     public Object[][] getTableData( )
     {
         
         m_data = new Object[ResultSets.size( )][m_colnum];
         
         for ( int i = 0 ; i < m_colnum ; i++ )
         {
             for ( int j = 0 ; j < ResultSets.size( ); j++ )
             {
                 m_data[j][i] = getValueAt( j, i );
             }
         }
         
         return m_data;
     }
     
    // For proper serialization
    private static final long serialVersionUID = 6482325992221223L;
}
