/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.popups;

import java.awt.Dimension;
import java.awt.event.WindowEvent;
import java.awt.event.WindowFocusListener;
import java.io.File;
import java.util.ArrayList;
import javax.swing.DefaultListModel;
import org.spectrim.selectionprofile.SelectionProfileCorrection;

/**
 *
 * @author user
 */
public class PopupjMRUIResultsMap extends javax.swing.JFrame implements WindowFocusListener 
{

    private static PopupjMRUIResultsMap instance;
    private jMRUIResultsMapListener parent;
    private final DefaultListModel listModelAvailable = new DefaultListModel( );
    private final DefaultListModel listModelNumerator = new DefaultListModel( );
    private final DefaultListModel listModelDenominator = new DefaultListModel( );
    private final ArrayList<Integer> numerator = new ArrayList<>();
    private final ArrayList<Integer> denominator = new ArrayList<>();
    
    private boolean m_computeTemperatures = false;
    
    /**
     * Creates new form jMRUIResultsMapListener.
     */
    private PopupjMRUIResultsMap( ) 
    {
        initComponents( );
        this.setVisible( true );
        this.pack( );
        jListAvailableMetabs.setModel( listModelAvailable );
        jListNumerator.setModel( listModelNumerator );
        jListDenominator.setModel( listModelDenominator );
        this.addWindowFocusListener( this );
    }

    
    /**
     * 
     * Sub optimally defined Singleton-class. 
     * 
     * @param parent
     * @param metabs
     * @param features
     * @param computeTemperatures
     * @return 
     */
    public static PopupjMRUIResultsMap getInstance( jMRUIResultsMapListener parent, 
                                                    String[] metabs, 
                                                    String[] features,
                                                    boolean computeTemperatures ) 
    {
         
        if ( instance == null ) 
        {
            instance = new PopupjMRUIResultsMap( );
        }
        
        instance.setComputeTemperatures( computeTemperatures );
        instance.setParent( parent );
        instance.setMetabolites( parent.getMetabolitesNames( ) );
        instance.setFeatures( parent.getFeatureNames( ) );
        instance.setColorScales( );
        instance.pack( );
        instance.setVisible( true );
        return instance;
    }

    private void updateMetabolitesAndFeatures( ) 
    {
        if ( parent != null ) 
        {
            instance.setMetabolites( parent.getMetabolitesNames( ) );
            instance.setFeatures( parent.getFeatureNames( ) );
        }
    }

    private void setParent(jMRUIResultsMapListener parent) {
        this.parent = parent;
    }

    public static void closeWindow() {
        if (instance != null) {
            instance.dispose();
        }
    }

    private void setMetabolites(String[] metabs) 
    {
        this.jComboBoxMetab1.removeAllItems();
        this.jComboBoxMetab2.removeAllItems();
        this.jComboBoxMetabR1.removeAllItems();
        this.jComboBoxMetabR2.removeAllItems();
        this.jComboBoxMetabG1.removeAllItems();
        this.jComboBoxMetabG2.removeAllItems();
        this.jComboBoxMetabB1.removeAllItems();
        this.jComboBoxMetabB2.removeAllItems();
        this.listModelAvailable.removeAllElements();
        this.listModelNumerator.removeAllElements();
        this.listModelDenominator.removeAllElements();
    
        numerator.clear();
        denominator.clear();
        
        for (int i = 0; i < metabs.length; i++) 
        {
            this.jComboBoxMetab1.addItem(metabs[i]);
            this.jComboBoxMetab2.addItem(metabs[i]);
            this.jComboBoxMetabR1.addItem(metabs[i]);
            this.jComboBoxMetabR2.addItem(metabs[i]);
            this.jComboBoxMetabG1.addItem(metabs[i]);
            this.jComboBoxMetabG2.addItem(metabs[i]);
            this.jComboBoxMetabB1.addItem(metabs[i]);
            this.jComboBoxMetabB2.addItem(metabs[i]);
            this.listModelAvailable.addElement(metabs[i]);
        }
    }

    private void setFeatures(String[] features) {
        this.jComboBoxFeature1.removeAllItems();
        this.jComboBoxFeature2.removeAllItems();
        this.jComboBoxFeatureR1.removeAllItems();
        this.jComboBoxFeatureR2.removeAllItems();
        this.jComboBoxFeatureG1.removeAllItems();
        this.jComboBoxFeatureG2.removeAllItems();
        this.jComboBoxFeatureB1.removeAllItems();
        this.jComboBoxFeatureB2.removeAllItems();
        this.jComboBoxFeatureFormula.removeAllItems();
        for (int i = 0; i < features.length; i++) {
            this.jComboBoxFeature1.addItem(features[i]);
            this.jComboBoxFeature2.addItem(features[i]);
            this.jComboBoxFeatureR1.addItem(features[i]);
            this.jComboBoxFeatureR2.addItem(features[i]);
            this.jComboBoxFeatureG1.addItem(features[i]);
            this.jComboBoxFeatureG2.addItem(features[i]);
            this.jComboBoxFeatureB1.addItem(features[i]);
            this.jComboBoxFeatureB2.addItem(features[i]);
            this.jComboBoxFeatureFormula.addItem(features[i]);
        }
    }

    public int getSelectedMetabolite1( )
    {
        return jComboBoxMetab1.getSelectedIndex( );
    } 
    
    public int getSelectedFeature1( )
    {
        return jComboBoxFeature1.getSelectedIndex( );
    } 
    
    public void setSelectedMetabolite1( int metabNumber )
    {
        jComboBoxMetab1.setSelectedIndex( metabNumber );
    } 
    
    public void setSelectedFeature1(  int featureNumber )
    {
        jComboBoxFeature1.setSelectedIndex( featureNumber );
    } 
    
    private void setColorScales() {
        ArrayList<String> scales = parent.getColorMap().getColorScalesNames();
        for (int i = 0; i < scales.size(); i++) {
            this.jComboBoxColorScale.addItem(scales.get(i));
        }
    }

    private void updateTextScaleRange() {
        this.jFormattedTextFieldMinScale.setText("" + parent.getColorMap().getMin());
        this.jFormattedTextFieldMaxScale.setText("" + parent.getColorMap().getMax());
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel7 = new javax.swing.JPanel();
        jFormattedTextFieldMaxScale = new javax.swing.JFormattedTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jFormattedTextFieldMinScale = new javax.swing.JFormattedTextField();
        jComboBoxColorScale = new javax.swing.JComboBox();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jComboBoxFeature1 = new javax.swing.JComboBox();
        jComboBoxMetab1 = new javax.swing.JComboBox();
        jToggleButton1 = new javax.swing.JToggleButton();
        jMapAllButton = new javax.swing.JButton();
        jMapSelectedButton = new javax.swing.JButton();
        jComboBoxMetab2 = new javax.swing.JComboBox();
        jComboBoxFeature2 = new javax.swing.JComboBox();
        jButtonPrintResults = new javax.swing.JButton();
        jButtonCorrectSelectionProfile = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jComboBoxFeatureR1 = new javax.swing.JComboBox();
        jComboBoxMetabR1 = new javax.swing.JComboBox();
        jToggleButtonR = new javax.swing.JToggleButton();
        jLabel1 = new javax.swing.JLabel();
        jComboBoxMetabR2 = new javax.swing.JComboBox();
        jComboBoxFeatureR2 = new javax.swing.JComboBox();
        jPanel10 = new javax.swing.JPanel();
        jComboBoxFeatureG1 = new javax.swing.JComboBox();
        jComboBoxMetabG1 = new javax.swing.JComboBox();
        jToggleButtonG = new javax.swing.JToggleButton();
        jLabel2 = new javax.swing.JLabel();
        jComboBoxMetabG2 = new javax.swing.JComboBox();
        jComboBoxFeatureG2 = new javax.swing.JComboBox();
        jPanel12 = new javax.swing.JPanel();
        jComboBoxFeatureB1 = new javax.swing.JComboBox();
        jComboBoxMetabB1 = new javax.swing.JComboBox();
        jToggleButtonB = new javax.swing.JToggleButton();
        jLabel3 = new javax.swing.JLabel();
        jComboBoxMetabB2 = new javax.swing.JComboBox();
        jComboBoxFeatureB2 = new javax.swing.JComboBox();
        jPanel5 = new javax.swing.JPanel();
        jMapAllButtonTriChannel = new javax.swing.JButton();
        jMapSelectedButtonTriChannel = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jListDenominator = new javax.swing.JList();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jListAvailableMetabs = new javax.swing.JList();
        jScrollPane3 = new javax.swing.JScrollPane();
        jListNumerator = new javax.swing.JList();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jButtonAdd2Denominator = new javax.swing.JButton();
        jButtonRemoveDenominator = new javax.swing.JButton();
        jButtonAdd2Numerator = new javax.swing.JButton();
        jButtonRemoveNumerator = new javax.swing.JButton();
        jComboBoxFeatureFormula = new javax.swing.JComboBox();
        jLabel7 = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jButtonMapAllFormula = new javax.swing.JButton();
        jButtonMapSelectedFormula = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("SpectrIm - Map Quantification Results");
        setAlwaysOnTop(true);

        jPanel7.setLayout(new java.awt.GridBagLayout());

        jFormattedTextFieldMaxScale.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldMaxScale.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMaxScaleActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 86;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
        jPanel7.add(jFormattedTextFieldMaxScale, gridBagConstraints);

        jLabel9.setText("Scale Range:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel7.add(jLabel9, gridBagConstraints);

        jLabel8.setText("Color Scale:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel7.add(jLabel8, gridBagConstraints);

        jFormattedTextFieldMinScale.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldMinScaleActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 86;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
        jPanel7.add(jFormattedTextFieldMinScale, gridBagConstraints);

        jComboBoxColorScale.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxColorScaleActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 165;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        jPanel7.add(jComboBoxColorScale, gridBagConstraints);

        getContentPane().add(jPanel7, java.awt.BorderLayout.PAGE_START);

        jTabbedPane1.setMinimumSize(new java.awt.Dimension(100, 100));
        jTabbedPane1.setPreferredSize(new java.awt.Dimension(300, 200));
        jTabbedPane1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jTabbedPane1StateChanged(evt);
            }
        });

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jComboBoxFeature1.setMinimumSize(new java.awt.Dimension(10, 20));
        jComboBoxFeature1.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jComboBoxFeature1, gridBagConstraints);

        jComboBoxMetab1.setMinimumSize(new java.awt.Dimension(10, 20));
        jComboBoxMetab1.setPreferredSize(new java.awt.Dimension(200, 20));
        jComboBoxMetab1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxMetab1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jComboBoxMetab1, gridBagConstraints);

        jToggleButton1.setText("Show Ratio with:");
        jToggleButton1.setMinimumSize(new java.awt.Dimension(10, 23));
        jToggleButton1.setPreferredSize(new java.awt.Dimension(100, 23));
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHEAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanel2.add(jToggleButton1, gridBagConstraints);

        jMapAllButton.setText("Map All Values");
        jMapAllButton.setActionCommand("jCloseButton");
        jMapAllButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMapAllButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHEAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        jPanel2.add(jMapAllButton, gridBagConstraints);

        jMapSelectedButton.setText("Map in Selected Region");
        jMapSelectedButton.setActionCommand("jCloseButton");
        jMapSelectedButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMapSelectedButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHEAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        jPanel2.add(jMapSelectedButton, gridBagConstraints);

        jComboBoxMetab2.setEnabled(false);
        jComboBoxMetab2.setMinimumSize(new java.awt.Dimension(10, 20));
        jComboBoxMetab2.setPreferredSize(new java.awt.Dimension(200, 20));
        jComboBoxMetab2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxMetab2ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jComboBoxMetab2, gridBagConstraints);

        jComboBoxFeature2.setEnabled(false);
        jComboBoxFeature2.setMinimumSize(new java.awt.Dimension(10, 20));
        jComboBoxFeature2.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jComboBoxFeature2, gridBagConstraints);

        jButtonPrintResults.setText("Print Results");
        jButtonPrintResults.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonPrintResultsActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHEAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        jPanel2.add(jButtonPrintResults, gridBagConstraints);

        jButtonCorrectSelectionProfile.setText("Correct Sel. Profile");
        jButtonCorrectSelectionProfile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCorrectSelectionProfileActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        jPanel2.add(jButtonCorrectSelectionProfile, gridBagConstraints);

        jTabbedPane1.addTab("Standard", jPanel2);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel4.setMinimumSize(new java.awt.Dimension(180, 117));
        jPanel4.setPreferredSize(new java.awt.Dimension(180, 117));
        jPanel4.setLayout(new java.awt.GridBagLayout());

        jComboBoxFeatureR1.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxFeatureR1.setOpaque(false);
        jComboBoxFeatureR1.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel4.add(jComboBoxFeatureR1, gridBagConstraints);

        jComboBoxMetabR1.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxMetabR1.setOpaque(false);
        jComboBoxMetabR1.setPreferredSize(new java.awt.Dimension(200, 20));
        jComboBoxMetabR1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxMetabR1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel4.add(jComboBoxMetabR1, gridBagConstraints);

        jToggleButtonR.setText("Show Ratio with:");
        jToggleButtonR.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonRActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanel4.add(jToggleButtonR, gridBagConstraints);

        jLabel1.setForeground(new java.awt.Color(204, 0, 0));
        jLabel1.setText("Red");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        jPanel4.add(jLabel1, gridBagConstraints);

        jComboBoxMetabR2.setToolTipText("");
        jComboBoxMetabR2.setEnabled(false);
        jComboBoxMetabR2.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxMetabR2.setOpaque(false);
        jComboBoxMetabR2.setPreferredSize(new java.awt.Dimension(200, 20));
        jComboBoxMetabR2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxMetabR2ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel4.add(jComboBoxMetabR2, gridBagConstraints);

        jComboBoxFeatureR2.setToolTipText("");
        jComboBoxFeatureR2.setEnabled(false);
        jComboBoxFeatureR2.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxFeatureR2.setOpaque(false);
        jComboBoxFeatureR2.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel4.add(jComboBoxFeatureR2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 1, 0, 1);
        jPanel3.add(jPanel4, gridBagConstraints);

        jPanel10.setPreferredSize(new java.awt.Dimension(180, 117));
        jPanel10.setLayout(new java.awt.GridBagLayout());

        jComboBoxFeatureG1.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxFeatureG1.setOpaque(false);
        jComboBoxFeatureG1.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel10.add(jComboBoxFeatureG1, gridBagConstraints);

        jComboBoxMetabG1.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxMetabG1.setOpaque(false);
        jComboBoxMetabG1.setPreferredSize(new java.awt.Dimension(200, 20));
        jComboBoxMetabG1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxMetabG1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel10.add(jComboBoxMetabG1, gridBagConstraints);

        jToggleButtonG.setText("Show Ratio with:");
        jToggleButtonG.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonGActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanel10.add(jToggleButtonG, gridBagConstraints);

        jLabel2.setForeground(new java.awt.Color(0, 153, 51));
        jLabel2.setText("Green");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.weightx = 1.0;
        jPanel10.add(jLabel2, gridBagConstraints);

        jComboBoxMetabG2.setToolTipText("");
        jComboBoxMetabG2.setEnabled(false);
        jComboBoxMetabG2.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxMetabG2.setOpaque(false);
        jComboBoxMetabG2.setPreferredSize(new java.awt.Dimension(200, 20));
        jComboBoxMetabG2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxMetabG2ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel10.add(jComboBoxMetabG2, gridBagConstraints);

        jComboBoxFeatureG2.setToolTipText("");
        jComboBoxFeatureG2.setEnabled(false);
        jComboBoxFeatureG2.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxFeatureG2.setOpaque(false);
        jComboBoxFeatureG2.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel10.add(jComboBoxFeatureG2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 1, 0, 1);
        jPanel3.add(jPanel10, gridBagConstraints);

        jPanel12.setPreferredSize(new java.awt.Dimension(180, 117));
        jPanel12.setLayout(new java.awt.GridBagLayout());

        jComboBoxFeatureB1.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxFeatureB1.setOpaque(false);
        jComboBoxFeatureB1.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel12.add(jComboBoxFeatureB1, gridBagConstraints);

        jComboBoxMetabB1.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxMetabB1.setOpaque(false);
        jComboBoxMetabB1.setPreferredSize(new java.awt.Dimension(200, 20));
        jComboBoxMetabB1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxMetabB1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel12.add(jComboBoxMetabB1, gridBagConstraints);

        jToggleButtonB.setText("Show Ratio with:");
        jToggleButtonB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 0, 0);
        jPanel12.add(jToggleButtonB, gridBagConstraints);

        jLabel3.setForeground(new java.awt.Color(0, 0, 204));
        jLabel3.setText("Blue");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.weightx = 1.0;
        jPanel12.add(jLabel3, gridBagConstraints);

        jComboBoxMetabB2.setToolTipText("");
        jComboBoxMetabB2.setEnabled(false);
        jComboBoxMetabB2.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxMetabB2.setOpaque(false);
        jComboBoxMetabB2.setPreferredSize(new java.awt.Dimension(200, 20));
        jComboBoxMetabB2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxMetabB2ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel12.add(jComboBoxMetabB2, gridBagConstraints);

        jComboBoxFeatureB2.setToolTipText("");
        jComboBoxFeatureB2.setEnabled(false);
        jComboBoxFeatureB2.setMinimumSize(new java.awt.Dimension(20, 20));
        jComboBoxFeatureB2.setOpaque(false);
        jComboBoxFeatureB2.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel12.add(jComboBoxFeatureB2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 1, 0, 1);
        jPanel3.add(jPanel12, gridBagConstraints);

        jPanel5.setLayout(new java.awt.BorderLayout());

        jMapAllButtonTriChannel.setText("Map All Values");
        jMapAllButtonTriChannel.setActionCommand("jCloseButton");
        jMapAllButtonTriChannel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMapAllButtonTriChannelActionPerformed(evt);
            }
        });
        jPanel5.add(jMapAllButtonTriChannel, java.awt.BorderLayout.WEST);

        jMapSelectedButtonTriChannel.setText("Map in Selected Region");
        jMapSelectedButtonTriChannel.setActionCommand("jCloseButton");
        jMapSelectedButtonTriChannel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMapSelectedButtonTriChannelActionPerformed(evt);
            }
        });
        jPanel5.add(jMapSelectedButtonTriChannel, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LAST_LINE_END;
        jPanel3.add(jPanel5, gridBagConstraints);

        jTabbedPane1.addTab("Tri-Channel", jPanel3);

        jPanel1.setMinimumSize(new java.awt.Dimension(450, 300));
        jPanel1.setPreferredSize(new java.awt.Dimension(450, 300));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        jScrollPane1.setViewportView(jListDenominator);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(jScrollPane1, gridBagConstraints);

        jLabel4.setText("Metabolites:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        jPanel1.add(jLabel4, gridBagConstraints);

        jScrollPane2.setViewportView(jListAvailableMetabs);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridheight = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(jScrollPane2, gridBagConstraints);

        jScrollPane3.setViewportView(jListNumerator);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(jScrollPane3, gridBagConstraints);

        jLabel5.setText("Numerator:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        jPanel1.add(jLabel5, gridBagConstraints);

        jLabel6.setText("Denominator:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        jPanel1.add(jLabel6, gridBagConstraints);

        jButtonAdd2Denominator.setText("Add -->");
        jButtonAdd2Denominator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAdd2DenominatorActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel1.add(jButtonAdd2Denominator, gridBagConstraints);

        jButtonRemoveDenominator.setText("<-- Remove");
        jButtonRemoveDenominator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRemoveDenominatorActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel1.add(jButtonRemoveDenominator, gridBagConstraints);

        jButtonAdd2Numerator.setText("Add -->");
        jButtonAdd2Numerator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAdd2NumeratorActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel1.add(jButtonAdd2Numerator, gridBagConstraints);

        jButtonRemoveNumerator.setText("<-- Remove");
        jButtonRemoveNumerator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRemoveNumeratorActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel1.add(jButtonRemoveNumerator, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jComboBoxFeatureFormula, gridBagConstraints);

        jLabel7.setText("Feature:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        jPanel1.add(jLabel7, gridBagConstraints);

        jButtonMapAllFormula.setText("Map All");
        jButtonMapAllFormula.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMapAllFormulaActionPerformed(evt);
            }
        });
        jPanel6.add(jButtonMapAllFormula);

        jButtonMapSelectedFormula.setText("Map Selected");
        jButtonMapSelectedFormula.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMapSelectedFormulaActionPerformed(evt);
            }
        });
        jPanel6.add(jButtonMapSelectedFormula);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_END;
        jPanel1.add(jPanel6, gridBagConstraints);

        jTabbedPane1.addTab("Formula", jPanel1);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jComboBoxMetab1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxMetab1ActionPerformed
    }//GEN-LAST:event_jComboBoxMetab1ActionPerformed

    private void jMapAllButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMapAllButtonActionPerformed
        if (this.jToggleButton1.isSelected()) {
            String name = (String) this.jComboBoxFeature1.getSelectedItem() + "-" + (String) this.jComboBoxMetab1.getSelectedItem() + " / "
                    + (String) this.jComboBoxFeature2.getSelectedItem() + "-" + (String) this.jComboBoxMetab2.getSelectedItem();
            parent.setColorMapfromjMRUIResultsRatio(this.jComboBoxMetab1.getSelectedIndex(), this.jComboBoxFeature1.getSelectedIndex(),
                    this.jComboBoxMetab2.getSelectedIndex(), this.jComboBoxFeature2.getSelectedIndex(), false, name);
        } else {
            String name = (String) this.jComboBoxFeature1.getSelectedItem() + "-" + (String) this.jComboBoxMetab1.getSelectedItem();
            parent.setColorMapfromjMRUIResults(this.jComboBoxMetab1.getSelectedIndex(), this.jComboBoxFeature1.getSelectedIndex(), false, name);
        }
        updateTextScaleRange();
    }//GEN-LAST:event_jMapAllButtonActionPerformed

    private void jComboBoxMetab2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxMetab2ActionPerformed
    }//GEN-LAST:event_jComboBoxMetab2ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        this.jComboBoxFeature2.setEnabled(this.jToggleButton1.isSelected());
        this.jComboBoxMetab2.setEnabled(this.jToggleButton1.isSelected());
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void jMapSelectedButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMapSelectedButtonActionPerformed
        if (this.jToggleButton1.isSelected()) {
            String name = (String) this.jComboBoxFeature1.getSelectedItem() + "-" + (String) this.jComboBoxMetab1.getSelectedItem() + " / "
                    + (String) this.jComboBoxFeature2.getSelectedItem() + "-" + (String) this.jComboBoxMetab2.getSelectedItem();
            parent.setColorMapfromjMRUIResultsRatio(this.jComboBoxMetab1.getSelectedIndex(), this.jComboBoxFeature1.getSelectedIndex(),
                    this.jComboBoxMetab2.getSelectedIndex(), this.jComboBoxFeature2.getSelectedIndex(), true, name);
        } else {
            String name = (String) this.jComboBoxFeature1.getSelectedItem() + "-" + (String) this.jComboBoxMetab1.getSelectedItem();
            parent.setColorMapfromjMRUIResults(this.jComboBoxMetab1.getSelectedIndex(), this.jComboBoxFeature1.getSelectedIndex(), true, name);
        }
        updateTextScaleRange();
    }//GEN-LAST:event_jMapSelectedButtonActionPerformed

    
    /**
     * This method forces an update of the GUI.
     * It should only be called after filtering is attempted (previewed)
     * or performed.
     */
    public void refreshDisplayedMap( ) 
    {                                                   
        if ( this.jToggleButton1.isSelected( ) ) 
        {
            String name = (String) this.jComboBoxFeature1.getSelectedItem() + "-" + (String) this.jComboBoxMetab1.getSelectedItem() + " / "
                    + (String) this.jComboBoxFeature2.getSelectedItem() + "-" + (String) this.jComboBoxMetab2.getSelectedItem();
            parent.setColorMapfromjMRUIResultsRatio(this.jComboBoxMetab1.getSelectedIndex(), this.jComboBoxFeature1.getSelectedIndex(),
                    this.jComboBoxMetab2.getSelectedIndex(), this.jComboBoxFeature2.getSelectedIndex(), true, name);
        } 
        else 
        {
            String name = (String) this.jComboBoxFeature1.getSelectedItem() + "-" + (String) this.jComboBoxMetab1.getSelectedItem();
            parent.setColorMapfromjMRUIResults(this.jComboBoxMetab1.getSelectedIndex(), this.jComboBoxFeature1.getSelectedIndex(), true, name);
        }
        updateTextScaleRange( );
    }  
    
    
    private void jComboBoxMetabR2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxMetabR2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxMetabR2ActionPerformed

    private void jComboBoxMetabR1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxMetabR1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxMetabR1ActionPerformed

    private void jToggleButtonRActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonRActionPerformed
        this.jComboBoxFeatureR2.setEnabled(this.jToggleButtonR.isSelected());
        this.jComboBoxMetabR2.setEnabled(this.jToggleButtonR.isSelected());
    }//GEN-LAST:event_jToggleButtonRActionPerformed

    private void jMapAllButtonTriChannelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMapAllButtonTriChannelActionPerformed
        int[] metabsR = new int[]{this.jComboBoxMetabR1.getSelectedIndex(), -1};
        int[] propsR = new int[]{this.jComboBoxFeatureR1.getSelectedIndex(), -1};
        int[] metabsG = new int[]{this.jComboBoxMetabG1.getSelectedIndex(), -1};
        int[] propsG = new int[]{this.jComboBoxFeatureG1.getSelectedIndex(), -1};
        int[] metabsB = new int[]{this.jComboBoxMetabB1.getSelectedIndex(), -1};
        int[] propsB = new int[]{this.jComboBoxFeatureB1.getSelectedIndex(), -1};

        if (this.jToggleButtonR.isSelected()) {
            metabsR[1] = this.jComboBoxMetabR2.getSelectedIndex();
            propsR[1] = this.jComboBoxFeatureR2.getSelectedIndex();
        };
        if (this.jToggleButtonG.isSelected()) {
            metabsG[1] = this.jComboBoxMetabG2.getSelectedIndex();
            propsG[1] = this.jComboBoxFeatureG2.getSelectedIndex();
        };
        if (this.jToggleButtonB.isSelected()) {
            metabsB[1] = this.jComboBoxMetabB2.getSelectedIndex();
            propsB[1] = this.jComboBoxFeatureB2.getSelectedIndex();
        };
        parent.setColorMapfromjMRUIResultsTriChannel(metabsR, propsR, metabsG, propsG, metabsB, propsB, false);
    }//GEN-LAST:event_jMapAllButtonTriChannelActionPerformed

    private void jMapSelectedButtonTriChannelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMapSelectedButtonTriChannelActionPerformed
        int[] metabsR = new int[]{this.jComboBoxMetabR1.getSelectedIndex(), -1};
        int[] propsR = new int[]{this.jComboBoxFeatureR1.getSelectedIndex(), -1};
        int[] metabsG = new int[]{this.jComboBoxMetabG1.getSelectedIndex(), -1};
        int[] propsG = new int[]{this.jComboBoxFeatureG1.getSelectedIndex(), -1};
        int[] metabsB = new int[]{this.jComboBoxMetabB1.getSelectedIndex(), -1};
        int[] propsB = new int[]{this.jComboBoxFeatureB1.getSelectedIndex(), -1};

        if (this.jToggleButtonR.isSelected()) {
            metabsR[1] = this.jComboBoxMetabR2.getSelectedIndex();
            propsR[1] = this.jComboBoxFeatureR2.getSelectedIndex();
        };
        if (this.jToggleButtonG.isSelected()) {
            metabsG[1] = this.jComboBoxMetabG2.getSelectedIndex();
            propsG[1] = this.jComboBoxFeatureG2.getSelectedIndex();
        };
        if (this.jToggleButtonB.isSelected()) {
            metabsB[1] = this.jComboBoxMetabB2.getSelectedIndex();
            propsB[1] = this.jComboBoxFeatureB2.getSelectedIndex();
        };
        parent.setColorMapfromjMRUIResultsTriChannel(metabsR, propsR, metabsG, propsG, metabsB, propsB, true);
    }//GEN-LAST:event_jMapSelectedButtonTriChannelActionPerformed

    private void jComboBoxMetabG2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxMetabG2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxMetabG2ActionPerformed

    private void jComboBoxMetabG1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxMetabG1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxMetabG1ActionPerformed

    private void jToggleButtonGActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonGActionPerformed
        this.jComboBoxFeatureG2.setEnabled(this.jToggleButtonG.isSelected());
        this.jComboBoxMetabG2.setEnabled(this.jToggleButtonG.isSelected());
    }//GEN-LAST:event_jToggleButtonGActionPerformed

    private void jComboBoxMetabB2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxMetabB2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxMetabB2ActionPerformed

    private void jComboBoxMetabB1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxMetabB1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxMetabB1ActionPerformed

    private void jToggleButtonBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonBActionPerformed
        this.jComboBoxFeatureB2.setEnabled(this.jToggleButtonB.isSelected());
        this.jComboBoxMetabB2.setEnabled(this.jToggleButtonB.isSelected());
    }//GEN-LAST:event_jToggleButtonBActionPerformed

    private void jTabbedPane1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jTabbedPane1StateChanged
        switch (this.jTabbedPane1.getSelectedIndex()) {
            case 0:
                this.setPreferredSize(new Dimension(300, 300));
                this.setMinimumSize(new Dimension(300, 300));
                this.jTabbedPane1.setPreferredSize(new Dimension(300, 300));
                this.jTabbedPane1.setMinimumSize(new Dimension(300, 300));
                this.jComboBoxColorScale.setEnabled(true);
                this.jFormattedTextFieldMinScale.setText("");
                this.jFormattedTextFieldMinScale.setEnabled(true);
                this.jFormattedTextFieldMaxScale.setText("");
                this.jFormattedTextFieldMaxScale.setEnabled(true);
                break;
            case 1:
                this.setPreferredSize(new Dimension(750, 300));
                this.setMinimumSize(new Dimension(750, 300));
                this.jTabbedPane1.setPreferredSize(new Dimension(750, 300));
                this.jTabbedPane1.setMinimumSize(new Dimension(750, 300));
                this.jComboBoxColorScale.setEnabled(false);
                this.jFormattedTextFieldMinScale.setText("");
                this.jFormattedTextFieldMinScale.setEnabled(false);
                this.jFormattedTextFieldMaxScale.setText("");
                this.jFormattedTextFieldMaxScale.setEnabled(false);
                break;
            case 2:
                this.setPreferredSize(new Dimension(450, 350));
                this.setMinimumSize(new Dimension(450, 350));
                this.jTabbedPane1.setPreferredSize(new Dimension(450, 350));
                this.jTabbedPane1.setMinimumSize(new Dimension(450, 350));
                this.jComboBoxColorScale.setEnabled(true);
                this.jFormattedTextFieldMinScale.setText("");
                this.jFormattedTextFieldMinScale.setEnabled(true);
                this.jFormattedTextFieldMaxScale.setText("");
                this.jFormattedTextFieldMaxScale.setEnabled(true);
                break;
        }
        pack();
    }//GEN-LAST:event_jTabbedPane1StateChanged

    private void jButtonPrintResultsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonPrintResultsActionPerformed
        parent.printJMRUIResults();
    }//GEN-LAST:event_jButtonPrintResultsActionPerformed

    private void jButtonMapAllFormulaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMapAllFormulaActionPerformed
        parent.setColorMapfromjMRUIResultsFormula(numerator, denominator, this.jComboBoxFeatureFormula.getSelectedIndex(), false);
        updateTextScaleRange();
    }//GEN-LAST:event_jButtonMapAllFormulaActionPerformed

    private void jButtonMapSelectedFormulaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMapSelectedFormulaActionPerformed
        parent.setColorMapfromjMRUIResultsFormula(numerator, denominator, this.jComboBoxFeatureFormula.getSelectedIndex(), true);
        updateTextScaleRange();
    }//GEN-LAST:event_jButtonMapSelectedFormulaActionPerformed

    private void jButtonAdd2NumeratorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAdd2NumeratorActionPerformed
        if (!jListAvailableMetabs.isSelectionEmpty()) {
            listModelNumerator.addElement(listModelAvailable.getElementAt(jListAvailableMetabs.getSelectedIndex()));
            numerator.add((Integer) jListAvailableMetabs.getSelectedIndex());
        }
    }//GEN-LAST:event_jButtonAdd2NumeratorActionPerformed

    private void jButtonAdd2DenominatorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAdd2DenominatorActionPerformed
        if (!jListAvailableMetabs.isSelectionEmpty()) {
            listModelDenominator.addElement(listModelAvailable.getElementAt(jListAvailableMetabs.getSelectedIndex()));
            denominator.add((Integer) jListAvailableMetabs.getSelectedIndex());
        }
    }//GEN-LAST:event_jButtonAdd2DenominatorActionPerformed

    private void jButtonRemoveNumeratorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRemoveNumeratorActionPerformed
        if (!jListNumerator.isSelectionEmpty()) {
            numerator.remove((int) jListNumerator.getSelectedIndex());
            listModelNumerator.removeElementAt(jListNumerator.getSelectedIndex());
        }
    }//GEN-LAST:event_jButtonRemoveNumeratorActionPerformed

    private void jButtonRemoveDenominatorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRemoveDenominatorActionPerformed
        if (!jListDenominator.isSelectionEmpty()) {
            denominator.remove((int) jListDenominator.getSelectedIndex());
            listModelDenominator.removeElementAt(jListDenominator.getSelectedIndex());
        }
    }//GEN-LAST:event_jButtonRemoveDenominatorActionPerformed

    private void jFormattedTextFieldMinScaleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMinScaleActionPerformed
        parent.getColorMap().setMin(Float.valueOf(this.jFormattedTextFieldMinScale.getText().toString()));
    }//GEN-LAST:event_jFormattedTextFieldMinScaleActionPerformed

    private void jFormattedTextFieldMaxScaleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldMaxScaleActionPerformed
        parent.getColorMap().setMax(Float.valueOf(this.jFormattedTextFieldMaxScale.getText().toString()));
    }//GEN-LAST:event_jFormattedTextFieldMaxScaleActionPerformed

    private void jComboBoxColorScaleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxColorScaleActionPerformed
        parent.getColorMap().setCurrentScale(this.jComboBoxColorScale.getSelectedIndex());
    }//GEN-LAST:event_jComboBoxColorScaleActionPerformed

    private void jButtonCorrectSelectionProfileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCorrectSelectionProfileActionPerformed
        try {
            SelectionProfileCorrection selProfCorrection = new SelectionProfileCorrection(this.parent.getModel().getTE(), this.parent.getModel().getCSIGrid().getDimsExcitedVolume());
            String metab1 = (String) this.jComboBoxMetab1.getSelectedItem();
            if (this.jToggleButton1.isSelected()) {
                String metab2 = (String) this.jComboBoxMetab2.getSelectedItem();
                if (selProfCorrection.checkMetaboliteName(metab1) && selProfCorrection.checkMetaboliteName(metab2)) {
                    this.parent.getModel().getColorMap().correctSelectionProfileRatio(selProfCorrection, metab1, metab2);
                } else {
                    if (!selProfCorrection.checkMetaboliteName(metab1) && !selProfCorrection.checkMetaboliteName(metab2)) {
                        this.parent.getModel().printTxt("Selection profile correction not performed. Metabolite names (" + metab1 + ", " + metab2 + ") not recognized.");
                    } else if (!selProfCorrection.checkMetaboliteName(metab1)) {
                        this.parent.getModel().printTxt("Selection profile correction not performed. Metabolite name (" + metab1 + ") not recognized.");
                    } else {
                        this.parent.getModel().printTxt("Selection profile correction not performed. Metabolite name (" + metab2 + ") not recognized.");
                    }
                }
            } else {
                if (selProfCorrection.checkMetaboliteName(metab1)) {
                    this.parent.getModel().getColorMap().correctSelectionProfile(selProfCorrection, metab1);
                } else {
                    this.parent.getModel().printTxt("Selection profile correction not performed. Metabolite name (" + metab1 + ") not recognized.");
                }
            }
        } catch (NoSuchFieldException ex) {
            this.parent.getModel().printTxt("Selection profile correction not available for TE=" + this.parent.getModel().getTE()
                    + " and Excited Volume with dimensions " + this.parent.getModel().getCSIGrid().getDimsExcitedVolume()[0] + "x" + this.parent.getModel().getCSIGrid().getDimsExcitedVolume()[1]);
        }
    }//GEN-LAST:event_jButtonCorrectSelectionProfileActionPerformed
    /**
     * @param args the command line arguments
     */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAdd2Denominator;
    private javax.swing.JButton jButtonAdd2Numerator;
    private javax.swing.JButton jButtonCorrectSelectionProfile;
    private javax.swing.JButton jButtonMapAllFormula;
    private javax.swing.JButton jButtonMapSelectedFormula;
    private javax.swing.JButton jButtonPrintResults;
    private javax.swing.JButton jButtonRemoveDenominator;
    private javax.swing.JButton jButtonRemoveNumerator;
    private javax.swing.JComboBox jComboBoxColorScale;
    private javax.swing.JComboBox jComboBoxFeature1;
    private javax.swing.JComboBox jComboBoxFeature2;
    private javax.swing.JComboBox jComboBoxFeatureB1;
    private javax.swing.JComboBox jComboBoxFeatureB2;
    private javax.swing.JComboBox jComboBoxFeatureFormula;
    private javax.swing.JComboBox jComboBoxFeatureG1;
    private javax.swing.JComboBox jComboBoxFeatureG2;
    private javax.swing.JComboBox jComboBoxFeatureR1;
    private javax.swing.JComboBox jComboBoxFeatureR2;
    private javax.swing.JComboBox jComboBoxMetab1;
    private javax.swing.JComboBox jComboBoxMetab2;
    private javax.swing.JComboBox jComboBoxMetabB1;
    private javax.swing.JComboBox jComboBoxMetabB2;
    private javax.swing.JComboBox jComboBoxMetabG1;
    private javax.swing.JComboBox jComboBoxMetabG2;
    private javax.swing.JComboBox jComboBoxMetabR1;
    private javax.swing.JComboBox jComboBoxMetabR2;
    private javax.swing.JFormattedTextField jFormattedTextFieldMaxScale;
    private javax.swing.JFormattedTextField jFormattedTextFieldMinScale;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JList jListAvailableMetabs;
    private javax.swing.JList jListDenominator;
    private javax.swing.JList jListNumerator;
    private javax.swing.JButton jMapAllButton;
    private javax.swing.JButton jMapAllButtonTriChannel;
    private javax.swing.JButton jMapSelectedButton;
    private javax.swing.JButton jMapSelectedButtonTriChannel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButtonB;
    private javax.swing.JToggleButton jToggleButtonG;
    private javax.swing.JToggleButton jToggleButtonR;
    // End of variables declaration//GEN-END:variables

    @Override
    public void windowGainedFocus(WindowEvent we) {
        /* updateMetabolitesAndFeatures(); */
    }

    @Override
    public void windowLostFocus(WindowEvent we) {
    }

    public void setComputeTemperatures( boolean computeTemperatures ) 
    {
        m_computeTemperatures = computeTemperatures;
    }
    
    public boolean getComputeTemperatures( )
    {
        return m_computeTemperatures;
    }
    
}
