/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.popups;

import java.awt.Component;
import javax.swing.AbstractCellEditor;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableModel;

/**
 *
 * @author nuno
 */
public class TableCellMATLABMapReaderEditor extends AbstractCellEditor implements TableCellEditor {

    private JComboBox editor;
    private JTable table;
    private String[] values = {"No Function", "Coords", "RGB"};
    public static final int MONOCHANNEL = 0;
    public static final int TRICHANNEL = 1;

    public TableCellMATLABMapReaderEditor(JTable table) {
        // Create a new Combobox with the array of values.
        this.table = table;
        editor = new JComboBox(values);
        addListeners();
    }
    
    private void addListeners(){
        editor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxActionPerformed(evt);
            }
        });
        editor.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jComboBoxFocusLost(evt);
            }
        });
    }
    
    private void jComboBoxActionPerformed(java.awt.event.ActionEvent evt) {
        String selected = (String) this.editor.getSelectedItem();
        int rows = table.getModel().getRowCount();
        if (rows > 0) {
            for (int i = 0; i < rows; i++) {
                if (selected.matches((String) table.getModel().getValueAt(i, 2))) {
                    table.getModel().setValueAt("No Function", i, 2);
                }
            }
        }
        table.getModel().setValueAt(selected, table.getSelectedRow(), table.getSelectedColumn());
        this.fireEditingStopped();
    }

    private void jComboBoxFocusLost(java.awt.event.FocusEvent evt) {
        String selected = (String) this.editor.getSelectedItem();
        int rows = table.getModel().getRowCount();
        if (rows > 0) {
            for (int i = 0; i < rows; i++) {
                if (selected.matches((String) table.getModel().getValueAt(i, 2))) {
                    table.getModel().setValueAt("No Function", i, 2);
                }
            }
        }
        table.getModel().setValueAt(selected, table.getSelectedRow(), table.getSelectedColumn());
        this.fireEditingStopped();
    }

    public void setMode(int mode) {
        this.fireEditingStopped();
        if (mode == MONOCHANNEL) {
            values = new String[]{"No Function", "Coords", "RGB"};
            editor = new JComboBox(values);
        } else if (mode == TRICHANNEL) {
            values = new String[]{"No Function", "Coords", "R", "G", "B"};
            editor = new JComboBox(values);
        }
        addListeners();
    }

    @Override
    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int rowIndex, int colIndex) {

        // Set the model data of the table
//        if (isSelected) {
//            editor.setSelectedItem(value);
//            TableModel model = table.getModel();
//            model.setValueAt(value, rowIndex, colIndex);
//        }
        editor = new JComboBox(values);
        addListeners();
        return editor;
    }

    @Override
    public Object getCellEditorValue() {
        return editor.getSelectedItem();
    }
}
