/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.popups;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.dcm4che2.data.DicomObject;
import org.spectrim.grid.CSIGrid;
import org.spectrim.io.dicom.DicomHandler;
import org.spectrim.model.GlobalModel;
import org.spectrim.patientbrowser.ModalityIdentifier;
import org.spectrim.selectionprofile.SelectionProfileCorrection;

/**
 *
 * @author nunopbarros
 */
public class TumourRegionSelectionAssistant extends javax.swing.JFrame {

    public static final int NECRO = 0; // Necrosis
    public static final int E_TUMOUR = 1; // Enhancing Tumour
    public static final int NE_TUMOUR = 2; // Non-enhancing Tumour
    public static final int EDEMA = 3; // Edema
    public static final int NAWM = 4; // Contralateral Normal Appearing White Matter
    public static final int NABT = 5; // Contralateral Normal Appearing Brain Tissue
    private ArrayList<String> selectionNecrotic = new ArrayList<>();
    private ArrayList<String> selectionETumour = new ArrayList<>();
    private ArrayList<String> selectionNonETumour = new ArrayList<>();
    private ArrayList<String> selectionEdema = new ArrayList<>();
    private ArrayList<String> selectionNAWM = new ArrayList<>();
    private ArrayList<String> selectionNABT = new ArrayList<>();
    private HashMap<String, double[]> featuresADC = new HashMap<>();
    private HashMap<String, double[]> featuresFLAIR = new HashMap<>();
    private HashMap<String, double[]> featuresT2 = new HashMap<>();
    private HashMap<String, double[]> featuresT1 = new HashMap<>();
    private HashMap<String, double[]> featuresT1C = new HashMap<>();
    private HashMap<String, double[]> featuresSWI = new HashMap<>();
    private File currentFile;
    private int nrOverlap;
    private static TumourRegionSelectionAssistant instance = null;
    ModelProviderInterface parent;
    protected int totalVoxelsFinished = 0;
    private jMRUIResultsInterface resultsInterface;

    /**
     * Creates new form TumourRegionSelectionAssistant
     */
    protected TumourRegionSelectionAssistant(ModelProviderInterface parent, jMRUIResultsInterface resultsInterface) {
        this.parent = parent;
        this.resultsInterface = resultsInterface;
        this.setVisible(true);
        initComponents();
        this.setDefaultCloseOperation(javax.swing.JFrame.DISPOSE_ON_CLOSE);
    }

    public static TumourRegionSelectionAssistant getInstance(ModelProviderInterface parent, jMRUIResultsInterface resultsInterface) {
        if (instance == null) {
            instance = new TumourRegionSelectionAssistant(parent, resultsInterface);
        } else {
            instance.setVisible(true);
        }
        return instance;
    }

    public static void clearSelection() {
        if (instance != null) {
            instance.clear();
        }
    }

    public void clear() {
        selectionNecrotic.clear();
        selectionETumour.clear();
        selectionEdema.clear();
        selectionNonETumour.clear();
        selectionNAWM.clear();
        selectionNABT.clear();
        featuresADC.clear();
        featuresT1C.clear();
        featuresT1.clear();
        featuresFLAIR.clear();
        featuresT2.clear();
        featuresSWI.clear();
        checkboxStateADC.setState(false);
        checkboxStateT1C.setState(false);
        checkboxStateT1.setState(false);
        checkboxStateFLAIR.setState(false);
        checkboxStateT2.setState(false);
        checkboxStateSWI.setState(false);
        updateGUI();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabelNrOverlapping = new javax.swing.JLabel();
        jButtonSave = new javax.swing.JButton();
        jButtonLoad = new javax.swing.JButton();
        jButtonMap = new javax.swing.JButton();
        jCheckBoxAutoUpdateMap = new javax.swing.JCheckBox();
        jSeparator1 = new javax.swing.JSeparator();
        jPanel1 = new javax.swing.JPanel();
        jButtonEdema = new javax.swing.JButton();
        jButtonNonETumour = new javax.swing.JButton();
        jLabelEdema = new javax.swing.JLabel();
        jLabelNonETumour = new javax.swing.JLabel();
        jLabelETumour = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jButtonNecrotic = new javax.swing.JButton();
        jButtonETumour = new javax.swing.JButton();
        jLabelNecrotic = new javax.swing.JLabel();
        jButtonETumourLoad = new javax.swing.JButton();
        jButtonNonETumourLoad = new javax.swing.JButton();
        jButtonEdemaLoad = new javax.swing.JButton();
        jButtonNecroticLoad = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jButtonNAWM = new javax.swing.JButton();
        jLabelNAWM = new javax.swing.JLabel();
        jButtonNAWMLoad = new javax.swing.JButton();
        jButtonClear = new javax.swing.JButton();
        jButtonNABT = new javax.swing.JButton();
        jLabelNABT = new javax.swing.JLabel();
        jButtonNABTLoad = new javax.swing.JButton();
        jButtonImageFeatures = new javax.swing.JButton();
        jButtonMapFeatures = new javax.swing.JButton();
        jButtonSpectraFeatures = new javax.swing.JButton();
        jButtonT1cFeatures = new javax.swing.JButton();
        jButtonADCFeatures = new javax.swing.JButton();
        jButtonT2Features = new javax.swing.JButton();
        jButtonFLAIRFeatures = new javax.swing.JButton();
        jButtonT1Features = new javax.swing.JButton();
        jButtonSWIFeatures = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JSeparator();
        checkboxStateADC = new java.awt.Checkbox();
        checkboxStateT1 = new java.awt.Checkbox();
        checkboxStateT1C = new java.awt.Checkbox();
        checkboxStateT2 = new java.awt.Checkbox();
        checkboxStateFLAIR = new java.awt.Checkbox();
        checkboxStateSWI = new java.awt.Checkbox();
        jButtonQuantificationFeatures = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("SpectrIm - Tumour Region Selection Assistant");
        setAlwaysOnTop(true);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        jLabelNrOverlapping.setText("Number of overlapping voxels: 0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabelNrOverlapping, gridBagConstraints);

        jButtonSave.setText("Save");
        jButtonSave.setEnabled(false);
        jButtonSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 8;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 31;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(22, 5, 0, 0);
        getContentPane().add(jButtonSave, gridBagConstraints);

        jButtonLoad.setText("Load");
        jButtonLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLoadActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 30;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(22, 0, 0, 5);
        getContentPane().add(jButtonLoad, gridBagConstraints);

        jButtonMap.setText("Map!");
        jButtonMap.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMapActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 122;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        getContentPane().add(jButtonMap, gridBagConstraints);

        jCheckBoxAutoUpdateMap.setText("update Map automaticaly");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.ipadx = 32;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 25, 0);
        getContentPane().add(jCheckBoxAutoUpdateMap, gridBagConstraints);

        jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridheight = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        getContentPane().add(jSeparator1, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jButtonEdema.setText("Edema");
        jButtonEdema.setHideActionText(true);
        jButtonEdema.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonEdema.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonEdema.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonEdema.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonEdemaActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonEdema, gridBagConstraints);

        jButtonNonETumour.setText("Non-Enhancing Tumour");
        jButtonNonETumour.setHideActionText(true);
        jButtonNonETumour.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonNonETumour.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonNonETumour.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonNonETumour.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNonETumourActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonNonETumour, gridBagConstraints);

        jLabelEdema.setText("0 voxels selected");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(9, 0, 4, 10);
        jPanel1.add(jLabelEdema, gridBagConstraints);

        jLabelNonETumour.setText("0 voxels selected");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(9, 0, 4, 10);
        jPanel1.add(jLabelNonETumour, gridBagConstraints);

        jLabelETumour.setText("0 voxels selected");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(9, 0, 4, 10);
        jPanel1.add(jLabelETumour, gridBagConstraints);

        jLabel1.setText("Save current selection as:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel1.add(jLabel1, gridBagConstraints);

        jButtonNecrotic.setText("Necrotic tissue");
        jButtonNecrotic.setHideActionText(true);
        jButtonNecrotic.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonNecrotic.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonNecrotic.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonNecrotic.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNecroticActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonNecrotic, gridBagConstraints);

        jButtonETumour.setText("Enhanching Tumour");
        jButtonETumour.setHideActionText(true);
        jButtonETumour.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonETumour.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonETumour.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonETumour.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonETumourActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonETumour, gridBagConstraints);

        jLabelNecrotic.setText("0 voxels selected");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(9, 0, 4, 10);
        jPanel1.add(jLabelNecrotic, gridBagConstraints);

        jButtonETumourLoad.setText("Enhanching Tumour");
        jButtonETumourLoad.setEnabled(false);
        jButtonETumourLoad.setHideActionText(true);
        jButtonETumourLoad.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonETumourLoad.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonETumourLoad.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonETumourLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonETumourLoadActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonETumourLoad, gridBagConstraints);

        jButtonNonETumourLoad.setText("Non-Enhancing Tumour");
        jButtonNonETumourLoad.setEnabled(false);
        jButtonNonETumourLoad.setHideActionText(true);
        jButtonNonETumourLoad.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonNonETumourLoad.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonNonETumourLoad.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonNonETumourLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNonETumourLoadActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonNonETumourLoad, gridBagConstraints);

        jButtonEdemaLoad.setText("Edema");
        jButtonEdemaLoad.setEnabled(false);
        jButtonEdemaLoad.setHideActionText(true);
        jButtonEdemaLoad.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonEdemaLoad.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonEdemaLoad.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonEdemaLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonEdemaLoadActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonEdemaLoad, gridBagConstraints);

        jButtonNecroticLoad.setText("Necrotic tissue");
        jButtonNecroticLoad.setEnabled(false);
        jButtonNecroticLoad.setHideActionText(true);
        jButtonNecroticLoad.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonNecroticLoad.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonNecroticLoad.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonNecroticLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNecroticLoadActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonNecroticLoad, gridBagConstraints);

        jLabel2.setText("Load following selection:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel1.add(jLabel2, gridBagConstraints);

        jButtonNAWM.setText("NAWM");
        jButtonNAWM.setToolTipText("Save as Normal Appearing White Matter");
        jButtonNAWM.setHideActionText(true);
        jButtonNAWM.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonNAWM.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonNAWM.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonNAWM.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNAWMActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonNAWM, gridBagConstraints);

        jLabelNAWM.setText("0 voxels selected");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(9, 0, 4, 10);
        jPanel1.add(jLabelNAWM, gridBagConstraints);

        jButtonNAWMLoad.setText("NAWM");
        jButtonNAWMLoad.setToolTipText("Load Normal Appearing White Matter");
        jButtonNAWMLoad.setEnabled(false);
        jButtonNAWMLoad.setHideActionText(true);
        jButtonNAWMLoad.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonNAWMLoad.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonNAWMLoad.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonNAWMLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNAWMLoadActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonNAWMLoad, gridBagConstraints);

        jButtonClear.setText("Clear All Selections");
        jButtonClear.setEnabled(false);
        jButtonClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonClearActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(12, 0, 0, 0);
        jPanel1.add(jButtonClear, gridBagConstraints);

        jButtonNABT.setText("Contralateral NABT");
        jButtonNABT.setToolTipText("Save as Contralateral Normal Appearing Brain Tissue");
        jButtonNABT.setHideActionText(true);
        jButtonNABT.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonNABT.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonNABT.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonNABT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNABTActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonNABT, gridBagConstraints);

        jLabelNABT.setText("0 voxels selected");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(9, 0, 4, 10);
        jPanel1.add(jLabelNABT, gridBagConstraints);

        jButtonNABTLoad.setText("Contralateral NABT");
        jButtonNABTLoad.setToolTipText("Load Contralateral Normal Appearing Brain Tissue");
        jButtonNABTLoad.setEnabled(false);
        jButtonNABTLoad.setHideActionText(true);
        jButtonNABTLoad.setMaximumSize(new java.awt.Dimension(105, 23));
        jButtonNABTLoad.setMinimumSize(new java.awt.Dimension(105, 23));
        jButtonNABTLoad.setPreferredSize(new java.awt.Dimension(105, 23));
        jButtonNABTLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNABTLoadActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(jButtonNABTLoad, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.gridheight = 9;
        getContentPane().add(jPanel1, gridBagConstraints);

        jButtonImageFeatures.setText("Extract Image Features");
        jButtonImageFeatures.setEnabled(false);
        jButtonImageFeatures.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonImageFeaturesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonImageFeatures, gridBagConstraints);

        jButtonMapFeatures.setText("Extract Map features");
        jButtonMapFeatures.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMapFeaturesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonMapFeatures, gridBagConstraints);

        jButtonSpectraFeatures.setText("Save Spectra+Img features");
        jButtonSpectraFeatures.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSpectraFeaturesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonSpectraFeatures, gridBagConstraints);

        jButtonT1cFeatures.setText("Collect T1c feats.");
        jButtonT1cFeatures.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonT1cFeaturesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonT1cFeatures, gridBagConstraints);

        jButtonADCFeatures.setText("Collect ADC feats.");
        jButtonADCFeatures.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonADCFeaturesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonADCFeatures, gridBagConstraints);

        jButtonT2Features.setText("Collect T2 feats.");
        jButtonT2Features.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonT2FeaturesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonT2Features, gridBagConstraints);

        jButtonFLAIRFeatures.setText("Collect FLAIR feats.");
        jButtonFLAIRFeatures.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonFLAIRFeaturesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonFLAIRFeatures, gridBagConstraints);

        jButtonT1Features.setText("Collect T1 feats.");
        jButtonT1Features.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonT1FeaturesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonT1Features, gridBagConstraints);

        jButtonSWIFeatures.setText("Collect SWI feats.");
        jButtonSWIFeatures.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSWIFeaturesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonSWIFeatures, gridBagConstraints);

        jSeparator2.setOrientation(javax.swing.SwingConstants.VERTICAL);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridheight = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        getContentPane().add(jSeparator2, gridBagConstraints);

        checkboxStateADC.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 2;
        getContentPane().add(checkboxStateADC, gridBagConstraints);

        checkboxStateT1.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 3;
        getContentPane().add(checkboxStateT1, gridBagConstraints);

        checkboxStateT1C.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 4;
        getContentPane().add(checkboxStateT1C, gridBagConstraints);

        checkboxStateT2.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 5;
        getContentPane().add(checkboxStateT2, gridBagConstraints);

        checkboxStateFLAIR.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 6;
        getContentPane().add(checkboxStateFLAIR, gridBagConstraints);

        checkboxStateSWI.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 7;
        getContentPane().add(checkboxStateSWI, gridBagConstraints);

        jButtonQuantificationFeatures.setText("Extract Quantification features");
        jButtonQuantificationFeatures.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonQuantificationFeaturesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jButtonQuantificationFeatures, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Save segmentation");
        fileChooser.setSelectedFile(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("text", "txt");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = selected_file;
//                this.listener.saveFileLocation(currentFile);
                if (selected_file != null) {
                    if (!selected_file.toString().endsWith(".txt")) {
                        selected_file = new File(selected_file.toString() + ".txt");
                    }
                    int option = 0;
                    if (selected_file.exists()) {
                        option = JOptionPane.showConfirmDialog(this, "The file already exists. Do you wish to overwrite it?", "Confirmation", JOptionPane.OK_CANCEL_OPTION);
                        System.out.println(option);
                    }
                    if (option == 0) {
                        try {
                            selected_file.delete();
                            GlobalModel model = parent.getModel();
                            BufferedWriter output = new BufferedWriter(new FileWriter(selected_file, true));
                            SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy - HH:mm:ss.SSS");
                            Date now = new Date();
                            String strDate = sdf.format(now);
                            output.append("###" + "\t" + model.getPatientName() + "\t" + model.getStudyDate() + "\t" + model.getSeriesNumber()
                                    + "\t" + model.getSeriesDescription() + "\t" + strDate);
                            output.newLine();
                            for (int i = 0; i < selectionNecrotic.size(); i++) {
                                output.append(selectionNecrotic.get(i) + "\t" + TumourRegionSelectionAssistant.NECRO);
                                output.newLine();
                            }
                            for (int i = 0; i < selectionETumour.size(); i++) {
                                output.append(selectionETumour.get(i) + "\t" + TumourRegionSelectionAssistant.E_TUMOUR);
                                output.newLine();
                            }
                            for (int i = 0; i < selectionNonETumour.size(); i++) {
                                output.append(selectionNonETumour.get(i) + "\t" + TumourRegionSelectionAssistant.NE_TUMOUR);
                                output.newLine();
                            }
                            for (int i = 0; i < selectionEdema.size(); i++) {
                                output.append(selectionEdema.get(i) + "\t" + TumourRegionSelectionAssistant.EDEMA);
                                output.newLine();
                            }
                            for (int i = 0; i < selectionNAWM.size(); i++) {
                                output.append(selectionNAWM.get(i) + "\t" + TumourRegionSelectionAssistant.NAWM);
                                output.newLine();
                            }
                            for (int i = 0; i < selectionNABT.size(); i++) {
                                output.append(selectionNABT.get(i) + "\t" + TumourRegionSelectionAssistant.NABT);
                                output.newLine();
                            }
                            output.close();
                        } catch (IOException ex) {
                            Logger.getLogger(TumourRegionSelectionAssistant.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jButtonSaveActionPerformed

    private void jButtonNecroticActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNecroticActionPerformed
        saveCurrentSelection(NECRO);
    }//GEN-LAST:event_jButtonNecroticActionPerformed

    private void jButtonNecroticLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNecroticLoadActionPerformed
        parent.getModel().setSelectedVoxels(selectionNecrotic);
    }//GEN-LAST:event_jButtonNecroticLoadActionPerformed

    private void jButtonEdemaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonEdemaActionPerformed
        saveCurrentSelection(EDEMA);
    }//GEN-LAST:event_jButtonEdemaActionPerformed

    private void jButtonEdemaLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonEdemaLoadActionPerformed
        parent.getModel().setSelectedVoxels(selectionEdema);
    }//GEN-LAST:event_jButtonEdemaLoadActionPerformed

    private void jButtonLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLoadActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Load segmentation");
        fileChooser.setSelectedFile(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("text", "txt");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = selected_file;
//                this.listener.saveFileLocation(currentFile);
                if (selected_file != null) {
                    BufferedReader reader;
                    String line;
                    boolean fileMatches = false;
                    int linesize;
                    try {
                        reader = new BufferedReader(new FileReader(selected_file));
                        while ((line = reader.readLine()) != null) {
                            String[] parts = line.split("\\t");
                            if (parts[0].startsWith("###")) {
                                String patient = parts[1].replace("^", " ").trim();
                                String studyDate = parts[2];
                                String seriesNr = parts[3];
                                String seriesDescr = parts[4];
                                fileMatches = true;
                                GlobalModel model = parent.getModel();

                                if (!model.getPatientName().replace("^", " ").trim().matches(patient)) {
                                    fileMatches = false;
                                    JOptionPane.showMessageDialog(this, "The selected file belongs to a different patient!\n"
                                            + "Patient in file: "
                                            + patient
                                            + "\n"
                                            + "Current patient: " + model.getPatientName(), "Warning", JOptionPane.NO_OPTION);
                                }
                                if (!model.getStudyDate().matches(studyDate) && fileMatches) {
                                    fileMatches = false;
                                    JOptionPane.showMessageDialog(this, "The selected file belongs to a different study!\n"
                                            + "Study date in file: "
                                            + studyDate
                                            + "\n"
                                            + "Current study date: " + model.getStudyDate(), "Warning", JOptionPane.NO_OPTION);
                                }
//                                if (!model.getSeriesNumber().matches(seriesNr) && fileMatches) {
//                                    fileMatches = false;
//                                    JOptionPane.showMessageDialog(this, "The selected file belongs to a different series!\n"
//                                            + "Series number in file: "
//                                            + seriesNr
//                                            + "\n"
//                                            + "Current series number: " + model.getSeriesNumber(), "Warning", JOptionPane.NO_OPTION);
//                                }
//                                if (!model.getSeriesDescription().matches(seriesDescr) && fileMatches) {
//                                    fileMatches = false;
//                                    JOptionPane.showMessageDialog(this, "The selected file belongs to a different series!\n"
//                                            + "Series description in file: "
//                                            + seriesDescr
//                                            + "\n"
//                                            + "Current series description: " + model.getSeriesDescription(), "Warning", JOptionPane.NO_OPTION);
//                                }
                                if (fileMatches) {
                                    this.clear();
                                }
                            }
                            linesize = parts.length;
                            if (linesize == 2 && fileMatches) {
                                int region = Integer.valueOf(parts[1]);
                                switch (region) {
                                    case TumourRegionSelectionAssistant.NECRO:
                                        this.selectionNecrotic.add(parts[0]);
                                        break;
                                    case TumourRegionSelectionAssistant.E_TUMOUR:
                                        this.selectionETumour.add(parts[0]);
                                        break;
                                    case TumourRegionSelectionAssistant.NE_TUMOUR:
                                        this.selectionNonETumour.add(parts[0]);
                                        break;
                                    case TumourRegionSelectionAssistant.EDEMA:
                                        this.selectionEdema.add(parts[0]);
                                        break;
                                    case TumourRegionSelectionAssistant.NAWM:
                                        this.selectionNAWM.add(parts[0]);
                                        break;
                                    case TumourRegionSelectionAssistant.NABT:
                                        this.selectionNABT.add(parts[0]);
                                        break;
                                }
                            }
                        }
                        reader.close();
                        this.updateGUI();
                    } catch (FileNotFoundException ex) {
                        ex.printStackTrace();
                    } catch (IOException ex) {
                        ex.printStackTrace();
                    }
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jButtonLoadActionPerformed

    private void jButtonMapActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMapActionPerformed
        map();
    }//GEN-LAST:event_jButtonMapActionPerformed

    private void jButtonClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonClearActionPerformed
        this.clear();
        this.parent.getModel().clearColorMap();
    }//GEN-LAST:event_jButtonClearActionPerformed

    private void jButtonMapFeaturesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMapFeaturesActionPerformed
        if (selectionNAWM.size() == 0) {
            JOptionPane.showMessageDialog(this, "Please select a region with Normal Appearing White Matter (NAWM)!",
                    "Warning", JOptionPane.NO_OPTION);
        } else {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setDialogTitle("Save Map features per region");
            fileChooser.setSelectedFile(currentFile);
            FileNameExtensionFilter filter = new FileNameExtensionFilter("text", "txt");
            fileChooser.setFileFilter(filter);
            int result = fileChooser.showOpenDialog(this);
            File selected_file;
            switch (result) {
                case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                    selected_file = fileChooser.getSelectedFile();
                    this.currentFile = selected_file;
//                this.listener.saveFileLocation(currentFile);
                    if (selected_file != null) {
                        if (!selected_file.toString().endsWith(".txt")) {
                            selected_file = new File(selected_file.toString() + ".txt");
                        }
                        try {
                            BufferedWriter output = new BufferedWriter(new FileWriter(selected_file, true));

                            parent.getModel().setSelectedVoxels(selectionNAWM);
                            double[] resNAWM = parent.getModel().getColorMap().getValueMapSelectionStatistics();

                            parent.getModel().setSelectedVoxels(selectionNABT);
                            double[] resNABT = parent.getModel().getColorMap().getValueMapSelectionStatistics();

                            parent.getModel().setSelectedVoxels(selectionNecrotic);
                            double[] resNecrotic = parent.getModel().getColorMap().getValueMapSelectionStatistics();

                            parent.getModel().setSelectedVoxels(selectionETumour);
                            double[] resETumour = parent.getModel().getColorMap().getValueMapSelectionStatistics();

                            parent.getModel().setSelectedVoxels(selectionNonETumour);
                            double[] resNonETumour = parent.getModel().getColorMap().getValueMapSelectionStatistics();

                            parent.getModel().setSelectedVoxels(selectionEdema);
                            double[] resEdema = parent.getModel().getColorMap().getValueMapSelectionStatistics();

                            ArrayList<String> selectionActiveTumour = (ArrayList<String>) selectionETumour.clone();
                            for (int i = 0; i < selectionNonETumour.size(); i++) {
                                String aux = selectionNonETumour.get(i);
                                if (!selectionActiveTumour.contains(aux)) {
                                    selectionActiveTumour.add(aux);
                                }
                            }

                            parent.getModel().setSelectedVoxels(selectionActiveTumour);
                            double[] resActiveTum = parent.getModel().getColorMap().getValueMapSelectionStatistics();

                            String file = parent.getModel().getImageStack().getFiles().get(0);
                            DicomObject object = DicomHandler.getDicomObject(file);
                            String nameMap = parent.getModel().getColorMap().getName();
                            String date = DicomHandler.getStudyDate(object);
                            date = date.substring(6, 8) + "/" + date.substring(4, 6) + "/" + date.substring(0, 4);
                            String values = DicomHandler.getPatientName(object) + "\t" + date + "\t" + DicomHandler.getSeriesNumber(object) + "-" + DicomHandler.getSeriesDescription(object) + "\t";
                            values += results2String(resNecrotic) + "\t" + results2String(resETumour) + "\t" + results2String(resNonETumour) + "\t"
                                    + results2String(resEdema) + "\t" + results2String(resActiveTum) + "\t" + results2String(resNAWM) + "\t" + results2String(resNABT) + "\t";
                            values += selectionNecrotic.size() + "\t" + resNecrotic[0] + "\t";
                            values += selectionETumour.size() + "\t" + resETumour[0] + "\t";
                            values += selectionNonETumour.size() + "\t" + resNonETumour[0] + "\t";
                            values += selectionEdema.size() + "\t" + resEdema[0] + "\t";
                            values += selectionNAWM.size() + "\t" + resNAWM[0] + "\t";
                            values += selectionNABT.size() + "\t" + resNABT[0];

                            String header = "PatientName\t";
                            header += "StudyDate\t";
                            header += "Series\t";

                            header += nameMap + "-Mean-Necro\t";
                            header += nameMap + "-Std-Necro\t";

                            header += nameMap + "-Mean-ETum\t";
                            header += nameMap + "-Std-ETum\t";

                            header += nameMap + "-Mean-NETum\t";
                            header += nameMap + "-Std-NETum\t";

                            header += nameMap + "-Mean-Edema\t";
                            header += nameMap + "-Std-Edema\t";

                            header += nameMap + "-Mean-ActiveTum\t";
                            header += nameMap + "-Std-ActiveTum\t";

                            header += nameMap + "-Mean-NAWM\t";
                            header += nameMap + "-Std-NAWM\t";

                            header += nameMap + "-Mean-NABT\t";
                            header += nameMap + "-Std-NABT\t";

                            header += nameMap + "-Necro voxels\t";
                            header += nameMap + "-Necro good\t";
                            header += nameMap + "-ETum voxels\t";
                            header += nameMap + "-ETum good\t";
                            header += nameMap + "-NonETum voxels\t";
                            header += nameMap + "-NonETum good\t";
                            header += nameMap + "-Edema voxels\t";
                            header += nameMap + "-Edema good\t";
                            header += nameMap + "-NAWM voxels\t";
                            header += nameMap + "-NAWM good\t";
                            header += nameMap + "-NABT voxels\t";
                            header += nameMap + "-NABT good\t";
                            output.append(header);
                            output.newLine();
                            output.append(values);
                            output.newLine();
                            output.close();
                        } catch (IOException ex) {
                            Logger.getLogger(TumourRegionSelectionAssistant.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                    break;
                case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                    break;
                case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                    break;
            }
        }
    }//GEN-LAST:event_jButtonMapFeaturesActionPerformed

    private void jButtonImageFeaturesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonImageFeaturesActionPerformed

        if (selectionNAWM.size() == 0) {
            JOptionPane.showMessageDialog(this, "Please select a region with Normal Appearing White Matter (NAWM)!",
                    "Warning", JOptionPane.NO_OPTION);
        } else {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setDialogTitle("Save image features per region");
            fileChooser.setSelectedFile(currentFile);
            FileNameExtensionFilter filter = new FileNameExtensionFilter("text", "txt");
            fileChooser.setFileFilter(filter);
            int result = fileChooser.showOpenDialog(this);
            File selected_file;
            switch (result) {
                case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                    selected_file = fileChooser.getSelectedFile();
                    this.currentFile = selected_file;
//                this.listener.saveFileLocation(currentFile);
                    if (selected_file != null) {
                        if (!selected_file.toString().endsWith(".txt")) {
                            selected_file = new File(selected_file.toString() + ".txt");
                        }
                        try {
                            BufferedWriter output = new BufferedWriter(new FileWriter(selected_file, true));

                            parent.getModel().setSelectedVoxels(selectionNAWM);
                            double meanNAWM = parent.getModel().analyseSelectedVoxelsSubImage()[3];

                            parent.getModel().setSelectedVoxels(selectionNecrotic);
                            double[] resNecrotic = parent.getModel().analyseSelectedVoxelsSubImage(meanNAWM);

                            parent.getModel().setSelectedVoxels(selectionETumour);
                            double[] resETumour = parent.getModel().analyseSelectedVoxelsSubImage(meanNAWM);

                            parent.getModel().setSelectedVoxels(selectionNonETumour);
                            double[] resNonETumour = parent.getModel().analyseSelectedVoxelsSubImage(meanNAWM);

                            parent.getModel().setSelectedVoxels(selectionEdema);
                            double[] resEdema = parent.getModel().analyseSelectedVoxelsSubImage(meanNAWM);

                            ArrayList<String> selectionAll = (ArrayList<String>) selectionNecrotic.clone();
                            for (int i = 0; i < selectionETumour.size(); i++) {
                                String aux = selectionETumour.get(i);
                                if (!selectionAll.contains(aux)) {
                                    selectionAll.add(aux);
                                }
                            }
                            for (int i = 0; i < selectionNonETumour.size(); i++) {
                                String aux = selectionNonETumour.get(i);
                                if (!selectionAll.contains(aux)) {
                                    selectionAll.add(aux);
                                }
                            }
                            for (int i = 0; i < selectionEdema.size(); i++) {
                                String aux = selectionEdema.get(i);
                                if (!selectionAll.contains(aux)) {
                                    selectionAll.add(aux);
                                }
                            }

                            parent.getModel().setSelectedVoxels(selectionAll);
                            double[] resAll = parent.getModel().analyseSelectedVoxelsSubImage(meanNAWM);

                            String file = parent.getModel().getImageStack().getFiles().get(0);
                            DicomObject object = DicomHandler.getDicomObject(file);
                            String modality = ModalityIdentifier.getModalityName(object);
                            String date = DicomHandler.getStudyDate(object);
                            date = date.substring(6, 8) + "/" + date.substring(4, 6) + "/" + date.substring(0, 4);
                            String values = DicomHandler.getPatientName(object) + "\t" + date + "\t" + DicomHandler.getSeriesNumber(object) + "-" + DicomHandler.getSeriesDescription(object) + "\t";
                            values += results2String(resNecrotic) + "\t" + results2String(resETumour) + "\t" + results2String(resNonETumour) + "\t" + results2String(resEdema) + "\t" + results2String(resAll);
                            String header = "PatientName\t";
                            header += "StudyDate\t";
                            header += "Series\t";
                            header += modality + "-Mean-Necro\t";
                            header += modality + "-Std-Necro\t";
                            header += modality + "-Skew-Necro\t";
                            header += modality + "-Kurt-Necro\t";
                            header += modality + "-Mean-ETum\t";
                            header += modality + "-Std-ETum\t";
                            header += modality + "-Skew-ETum\t";
                            header += modality + "-Kurt-ETum\t";
                            header += modality + "-Mean-NETum\t";
                            header += modality + "-Std-NETum\t";
                            header += modality + "-Skew-NETum\t";
                            header += modality + "-Kurt-NETum\t";
                            header += modality + "-Mean-Edema\t";
                            header += modality + "-Std-Edema\t";
                            header += modality + "-Skew-Edema\t";
                            header += modality + "-Kurt-Edema\t";
                            header += modality + "-Mean-All\t";
                            header += modality + "-Std-All\t";
                            header += modality + "-Skew-All\t";
                            header += modality + "-Kurt-All\t";
                            output.append(header);
                            output.newLine();
                            output.append(values);
                            output.newLine();
                            output.close();
                        } catch (IOException ex) {
                            Logger.getLogger(TumourRegionSelectionAssistant.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                    break;
                case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                    break;
                case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                    break;
            }
        }
    }//GEN-LAST:event_jButtonImageFeaturesActionPerformed

    private void jButtonNABTActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNABTActionPerformed
        saveCurrentSelection(NABT);
    }//GEN-LAST:event_jButtonNABTActionPerformed

    private void jButtonNABTLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNABTLoadActionPerformed
        parent.getModel().setSelectedVoxels(selectionNABT);
    }//GEN-LAST:event_jButtonNABTLoadActionPerformed

    private void jButtonSpectraFeaturesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSpectraFeaturesActionPerformed

        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Save spectra and image features per voxel");
        fileChooser.setSelectedFile(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("text", "txt");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = selected_file;
//                this.listener.saveFileLocation(currentFile);
                if (selected_file != null) {
                    if (!selected_file.toString().endsWith(".txt")) {
                        selected_file = new File(selected_file.toString() + ".txt");
                    }
                    try {
                        BufferedWriter output = new BufferedWriter(new FileWriter(selected_file, true));
                        boolean allReady = true;
                        for (int i = 0; i < selectionNAWM.size(); i++) {
                            String aux = selectionNAWM.get(i);
                            allReady = checkImageFeaturesCollected(aux);
                        }
                        for (int i = 0; i < selectionEdema.size(); i++) {
                            String aux = selectionEdema.get(i);
                            allReady = checkImageFeaturesCollected(aux);
                        }
                        for (int i = 0; i < selectionNonETumour.size(); i++) {
                            String aux = selectionNonETumour.get(i);
                            allReady = checkImageFeaturesCollected(aux);
                        }
                        for (int i = 0; i < selectionETumour.size(); i++) {
                            String aux = selectionETumour.get(i);
                            allReady = checkImageFeaturesCollected(aux);
                        }
                        for (int i = 0; i < selectionNecrotic.size(); i++) {
                            String aux = selectionNecrotic.get(i);
                            allReady = checkImageFeaturesCollected(aux);
                        }

                        if (allReady) {
                            String file = parent.getModel().getImageStack().getFiles().get(0);
                            DicomObject object = DicomHandler.getDicomObject(file);
                            String date = DicomHandler.getStudyDate(object);
                            date = date.substring(6, 8) + "/" + date.substring(4, 6) + "/" + date.substring(0, 4);
                            String identifier = DicomHandler.getPatientName(object) + "\t" + date + "\t" + DicomHandler.getSeriesNumber(object) + "-" + DicomHandler.getSeriesDescription(object);
                            for (int i = 0; i < selectionNAWM.size(); i++) {
                                String aux = selectionNAWM.get(i);
                                output.append(identifier + "\t" + aux + "\tNAWM\t" + getFeaturesVoxel(aux));
                                output.newLine();
                            }
                            for (int i = 0; i < selectionEdema.size(); i++) {
                                String aux = selectionEdema.get(i);
                                output.append(identifier + "\t" + aux + "\tEdema\t" + getFeaturesVoxel(aux));
                                output.newLine();
                            }
                            for (int i = 0; i < selectionNonETumour.size(); i++) {
                                String aux = selectionNonETumour.get(i);
                                output.append(identifier + "\t" + aux + "\tNETum\t" + getFeaturesVoxel(aux));
                                output.newLine();
                            }
                            for (int i = 0; i < selectionETumour.size(); i++) {
                                String aux = selectionETumour.get(i);
                                output.append(identifier + "\t" + aux + "\tETum\t" + getFeaturesVoxel(aux));
                                output.newLine();
                            }
                            for (int i = 0; i < selectionNecrotic.size(); i++) {
                                String aux = selectionNecrotic.get(i);
                                output.append(identifier + "\t" + aux + "\tNecr\t" + getFeaturesVoxel(aux));
                                output.newLine();
                            }
                        }
                        output.close();
                    } catch (IOException ex) {
                        Logger.getLogger(TumourRegionSelectionAssistant.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jButtonSpectraFeaturesActionPerformed
    private boolean checkImageFeaturesCollected(String coord) {
        boolean bool = true;
        if (!featuresT1C.containsKey(coord)) {
            bool = false;
            System.out.println("T1c features missing");
        }
        if (!featuresT1.containsKey(coord)) {
            bool = false;
            System.out.println("T1 features missing");
        }
        if (!featuresT2.containsKey(coord)) {
            bool = false;
            System.out.println("T2 features missing");
        }
        if (!featuresFLAIR.containsKey(coord)) {
            bool = false;
            System.out.println("FLAIR features missing");
        }
        if (!featuresADC.containsKey(coord)) {
            bool = false;
            System.out.println("ADC features missing");
        }
        if (!featuresSWI.containsKey(coord)) {
            bool = false;
            System.out.println("SWI features missing");
        }
        if (!featuresT1C.containsKey(coord + "norm")) {
            bool = false;
            System.out.println("T1c normalized features missing");
        }
        if (!featuresT1.containsKey(coord + "norm")) {
            bool = false;
            System.out.println("T1 normalized features missing");
        }
        if (!featuresT2.containsKey(coord + "norm")) {
            bool = false;
            System.out.println("T2 normalized features missing");
        }
        if (!featuresFLAIR.containsKey(coord + "norm")) {
            bool = false;
            System.out.println("FLAIR normalized features missing");
        }
        if (!featuresADC.containsKey(coord + "norm")) {
            bool = false;
            System.out.println("ADC normalized features missing");
        }
        if (!featuresSWI.containsKey(coord + "norm")) {
            bool = false;
            System.out.println("SWI normalized features missing");
        }
        return bool;
    }

    private void calculateFeaturesModality(int modality) {
        switch (modality) {
            case ModalityIdentifier.ADC:
                featuresADC.clear();
                break;
            case ModalityIdentifier.T1C:
                featuresT1C.clear();
                break;
            case ModalityIdentifier.T1:
                featuresT1.clear();
                break;
            case ModalityIdentifier.T2:
                featuresT2.clear();
                break;
            case ModalityIdentifier.FLAIR:
                featuresFLAIR.clear();
                break;
            case ModalityIdentifier.SWI:
                featuresSWI.clear();
                break;
        }
        totalVoxelsFinished = 0;
        parent.getModel().setSelectedVoxels(selectionNAWM);
        double meanNAWM = parent.getModel().analyseSelectedVoxelsSubImage()[3];

        for (int i = 0; i < selectionNAWM.size(); i++) {
            String aux = selectionNAWM.get(i);
            ImageFeaturesCalculator calculator = new ImageFeaturesCalculator(this, parent.getModel().getCSIGrid(), aux, modality, meanNAWM);
            calculator.run();
        }
        for (int i = 0; i < selectionEdema.size(); i++) {
            String aux = selectionEdema.get(i);
            ImageFeaturesCalculator calculator = new ImageFeaturesCalculator(this, parent.getModel().getCSIGrid(), aux, modality, meanNAWM);
            calculator.run();
        }
        for (int i = 0; i < selectionNonETumour.size(); i++) {
            String aux = selectionNonETumour.get(i);
            ImageFeaturesCalculator calculator = new ImageFeaturesCalculator(this, parent.getModel().getCSIGrid(), aux, modality, meanNAWM);
            calculator.run();
        }
        for (int i = 0; i < selectionETumour.size(); i++) {
            String aux = selectionETumour.get(i);
            ImageFeaturesCalculator calculator = new ImageFeaturesCalculator(this, parent.getModel().getCSIGrid(), aux, modality, meanNAWM);
            calculator.run();
        }
        for (int i = 0; i < selectionNecrotic.size(); i++) {
            String aux = selectionNecrotic.get(i);
            ImageFeaturesCalculator calculator = new ImageFeaturesCalculator(this, parent.getModel().getCSIGrid(), aux, modality, meanNAWM);
            calculator.run();
        }
    }


    private void jButtonT1cFeaturesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonT1cFeaturesActionPerformed
        if (checkModality(ModalityIdentifier.T1C)) {
            calculateFeaturesModality(ModalityIdentifier.T1C);
        }
    }//GEN-LAST:event_jButtonT1cFeaturesActionPerformed

    private void jButtonADCFeaturesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonADCFeaturesActionPerformed
        if (checkModality(ModalityIdentifier.ADC)) {
            calculateFeaturesModality(ModalityIdentifier.ADC);
        }
    }//GEN-LAST:event_jButtonADCFeaturesActionPerformed

    private void jButtonT2FeaturesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonT2FeaturesActionPerformed
        if (checkModality(ModalityIdentifier.T2)) {
            calculateFeaturesModality(ModalityIdentifier.T2);
        }
    }//GEN-LAST:event_jButtonT2FeaturesActionPerformed

    private void jButtonFLAIRFeaturesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonFLAIRFeaturesActionPerformed
        if (checkModality(ModalityIdentifier.FLAIR)) {
            calculateFeaturesModality(ModalityIdentifier.FLAIR);
        }
    }//GEN-LAST:event_jButtonFLAIRFeaturesActionPerformed

    private void jButtonT1FeaturesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonT1FeaturesActionPerformed
        if (checkModality(ModalityIdentifier.T1)) {
            calculateFeaturesModality(ModalityIdentifier.T1);
        }
    }//GEN-LAST:event_jButtonT1FeaturesActionPerformed

    private void jButtonSWIFeaturesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSWIFeaturesActionPerformed
        if (checkModality(ModalityIdentifier.SWI)) {
            calculateFeaturesModality(ModalityIdentifier.SWI);
        }
    }//GEN-LAST:event_jButtonSWIFeaturesActionPerformed

    private void jButtonQuantificationFeaturesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonQuantificationFeaturesActionPerformed

        TreeMap<String, HashMap<String, ArrayList<Double>>> results = resultsInterface.getQuantificationResults();
        if (results != null && !results.isEmpty()) {
            double[] fov = parent.getModel().getCSIGrid().getDimsExcitedVolume();
            double TE = parent.getModel().getTE();

            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setDialogTitle("Save quantification features per region");
            fileChooser.setSelectedFile(currentFile);
            FileNameExtensionFilter filter = new FileNameExtensionFilter("text", "txt");
            fileChooser.setFileFilter(filter);
            int result = fileChooser.showOpenDialog(this);
            File selected_file;
            switch (result) {
                case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                    selected_file = fileChooser.getSelectedFile();
                    this.currentFile = selected_file;
//                this.listener.saveFileLocation(currentFile);
                    if (selected_file != null) {
                        if (!selected_file.toString().endsWith(".txt")) {
                            selected_file = new File(selected_file.toString() + ".txt");
                        }
                        try {
                            BufferedWriter output = new BufferedWriter(new FileWriter(selected_file, true));

                            String file = parent.getModel().getImageStack().getFiles().get(0);
                            DicomObject object = DicomHandler.getDicomObject(file);
                            String date = DicomHandler.getStudyDate(object);
                            date = date.substring(6, 8) + "/" + date.substring(4, 6) + "/" + date.substring(0, 4);
                            String tabbedRes = DicomHandler.getPatientName(object) + "\t" + date + "\t" + DicomHandler.getSeriesNumber(object) + "-" + DicomHandler.getSeriesDescription(object) + "\t";
                            tabbedRes += parent.getModel().getTE() + "\t" + selectionNecrotic.size() + "\t" + selectionEdema.size() + "\t" + selectionNABT.size() + "\t";

                            double meanQScoreNecro = 0;
                            double meanQScoreEdema = 0;
                            double meanQScoreNABT = 0;
                            int necroWithQuant = 0;
                            int edemaWithQuant = 0;
                            int nabtWithQuant = 0;
                            for (String coord : results.firstEntry().getValue().keySet()) {

                                if (selectionNecrotic.contains(coord)) {
                                    necroWithQuant++;
                                    meanQScoreNecro += parent.getModel().getSpectra().getQualityScore(coord);
                                }
                                if (selectionEdema.contains(coord)) {
                                    edemaWithQuant++;
                                    meanQScoreEdema += parent.getModel().getSpectra().getQualityScore(coord);
                                }
                                if (selectionNABT.contains(coord)) {
                                    nabtWithQuant++;
                                    meanQScoreNABT += parent.getModel().getSpectra().getQualityScore(coord);
                                }

                            }
                            meanQScoreNecro /= necroWithQuant;
                            meanQScoreEdema /= edemaWithQuant;
                            meanQScoreNABT /= nabtWithQuant;

                            tabbedRes += necroWithQuant + "\t" + edemaWithQuant + "\t" + nabtWithQuant + "\t" + meanQScoreNecro + "\t" + meanQScoreEdema + "\t" + meanQScoreNABT + "\t";

                            String metabFirst = results.firstKey();
                            double meanErrorNecro = 0;
                            double meanErrorEdema = 0;
                            double meanErrorNABT = 0;

                            for (String coord : results.get(metabFirst).keySet()) {
                                if (selectionNecrotic.contains(coord)) {
                                    meanErrorNecro += results.get(metabFirst).get(coord).get(1);
                                }
                                if (selectionEdema.contains(coord)) {
                                    meanErrorEdema += results.get(metabFirst).get(coord).get(1);
                                }
                                if (selectionNABT.contains(coord)) {
                                    meanErrorNABT += results.get(metabFirst).get(coord).get(1);
                                }
                            }
                            meanErrorNecro /= necroWithQuant;
                            meanErrorEdema /= edemaWithQuant;
                            meanErrorNABT /= nabtWithQuant;

                            tabbedRes += meanErrorNecro + "\t" + meanErrorEdema + "\t" + meanErrorNABT + "\t";

                            for (String metab : results.keySet()) {
                                double meanAmpNecro = 0;
                                double meanAmpEdema = 0;
                                double meanAmpNABT = 0;

                                for (String coord : results.get(metab).keySet()) {
                                    if (selectionNecrotic.contains(coord)) {
                                        meanAmpNecro += results.get(metab).get(coord).get(0);
                                    }
                                    if (selectionEdema.contains(coord)) {
                                        meanAmpEdema += results.get(metab).get(coord).get(0);
                                    }
                                    if (selectionNABT.contains(coord)) {
                                        meanAmpNABT += results.get(metab).get(coord).get(0);
                                    }
                                }
                                meanAmpNecro /= necroWithQuant;
                                meanAmpEdema /= edemaWithQuant;
                                meanAmpNABT /= nabtWithQuant;

                                tabbedRes += metab + "\t" + meanAmpNecro + "\t" + meanAmpEdema + "\t" + meanAmpNABT + "\t";
                            }

                            try {
                                SelectionProfileCorrection selProfCorrection = new SelectionProfileCorrection(TE, fov);
                                for (String metab : results.keySet()) {

                                    double meanAmpNecro = 0;
                                    double meanAmpEdema = 0;
                                    double meanAmpNABT = 0;

                                    boolean allFactors = true;
                                    for (String coord : results.get(metab).keySet()) {
                                        double fact = selProfCorrection.getCorrectionFactor(coord, metab);
                                        if (!Double.isNaN(fact)) {
                                            if (selectionNecrotic.contains(coord)) {
                                                meanAmpNecro += results.get(metab).get(coord).get(0) / fact;
                                            }
                                            if (selectionEdema.contains(coord)) {
                                                meanAmpEdema += results.get(metab).get(coord).get(0) / fact;
                                            }
                                            if (selectionNABT.contains(coord)) {
                                                meanAmpNABT += results.get(metab).get(coord).get(0) / fact;
                                            }
                                        } else {
                                            allFactors = false;
                                            break;
                                        }
                                    }
                                    if (allFactors) {
                                        meanAmpNecro /= necroWithQuant;
                                        meanAmpEdema /= edemaWithQuant;
                                        meanAmpNABT /= nabtWithQuant;
                                        tabbedRes += metab + "Corrected\t" + meanAmpNecro + "\t" + meanAmpEdema + "\t" + meanAmpNABT + "\t";
                                    }
                                }

                            } catch (NoSuchFieldException ex) {
                                tabbedRes += "No_correction_available";
                                output.append(tabbedRes);
                                output.newLine();
                                output.close();
                                Logger.getLogger(TumourRegionSelectionAssistant.class.getName()).log(Level.SEVERE, null, ex);
                            }

                            output.append(tabbedRes);
                            output.newLine();
                            output.close();
                        } catch (IOException ex) {
                            Logger.getLogger(TumourRegionSelectionAssistant.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                    break;
                case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                    break;
                case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                    break;
            }
        } else {
            parent.getModel().printTxt("No quantification data available!");
        }
    }//GEN-LAST:event_jButtonQuantificationFeaturesActionPerformed

    private void jButtonNAWMLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNAWMLoadActionPerformed
        parent.getModel().setSelectedVoxels(selectionNAWM);
    }//GEN-LAST:event_jButtonNAWMLoadActionPerformed

    private void jButtonNAWMActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNAWMActionPerformed
        saveCurrentSelection(NAWM);
    }//GEN-LAST:event_jButtonNAWMActionPerformed

    private void jButtonNonETumourLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNonETumourLoadActionPerformed
        parent.getModel().setSelectedVoxels(selectionNonETumour);
    }//GEN-LAST:event_jButtonNonETumourLoadActionPerformed

    private void jButtonNonETumourActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNonETumourActionPerformed
        saveCurrentSelection(NE_TUMOUR);
    }//GEN-LAST:event_jButtonNonETumourActionPerformed

    private void jButtonETumourLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonETumourLoadActionPerformed
        parent.getModel().setSelectedVoxels(selectionETumour);
    }//GEN-LAST:event_jButtonETumourLoadActionPerformed

    private void jButtonETumourActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonETumourActionPerformed
        saveCurrentSelection(E_TUMOUR);
    }//GEN-LAST:event_jButtonETumourActionPerformed

    private void saveCurrentSelection(int type) {
        switch (type) {
            case NECRO:
                selectionNecrotic.clear();
                break;
            case E_TUMOUR:
                selectionETumour.clear();
                break;
            case NE_TUMOUR:
                selectionNonETumour.clear();
                break;
            case EDEMA:
                selectionEdema.clear();
                break;
            case NAWM:
                selectionNAWM.clear();
                break;
            case NABT:
                selectionNABT.clear();
                break;
        }
        ArrayList<String> newSelection = (ArrayList<String>) parent.getModel().getSelectedVoxels().clone();
        removeOverlap(newSelection, selectionNecrotic);
        removeOverlap(newSelection, selectionETumour);
        removeOverlap(newSelection, selectionNonETumour);
        removeOverlap(newSelection, selectionEdema);
        removeOverlap(newSelection, selectionNAWM);
        removeOverlap(newSelection, selectionNABT);
        switch (type) {
            case NECRO:
                selectionNecrotic = newSelection;
                break;
            case E_TUMOUR:
                selectionETumour = newSelection;
                break;
            case NE_TUMOUR:
                selectionNonETumour = newSelection;
                break;
            case EDEMA:
                selectionEdema = newSelection;
                break;
            case NAWM:
                selectionNAWM = newSelection;
                break;
            case NABT:
                selectionNABT = newSelection;
                break;
        }
        updateGUI();
    }

    private void removeOverlap(ArrayList<String> changing, ArrayList<String> reference) {
        for (String str : reference) {
            if (changing.contains(str)) {
                changing.remove(str);
            }
        }
    }

    private boolean checkModality(int modalnr) {
        String file = parent.getModel().getImageStack().getFiles().get(0);
        DicomObject object = DicomHandler.getDicomObject(file);
        return modalnr == ModalityIdentifier.getModality(object);
    }

    private String results2String(double[] res) {
        String output = "0\t0";
        if (res.length > 6) {
            output = res[3] + "\t" + res[4];
        }
        return output;
    }

    private String doubleArray2String(double[] array) {
        String output = "";
        for (int i = 0; i < array.length; i++) {
            if (i == (array.length - 1)) {
                output += array[i];
            } else {
                output += array[i] + "\t";
            }
        }
        return output;
    }

    private String doubleArrayList2String(ArrayList<Double> array) {
        String output = "";
        for (int i = 0; i < array.size(); i++) {
            if (i == (array.size() - 1)) {
                output += array.get(i);
            } else {
                output += array.get(i) + "\t";
            }
        }
        return output;
    }

    private String getFeaturesVoxel(String voxel) {
        String output = "";
        output += parent.getModel().getSpectra().getQualityScore(voxel) + "\t";
        output += doubleArrayList2String(parent.getModel().getSpectra().getMetabolicFeatures(voxel)) + "\t";
        output += doubleArray2String(featuresT1.get(voxel)) + "\t";
        output += doubleArray2String(featuresT1C.get(voxel)) + "\t";
        output += doubleArray2String(featuresT2.get(voxel)) + "\t";
        output += doubleArray2String(featuresFLAIR.get(voxel)) + "\t";
        output += doubleArray2String(featuresADC.get(voxel)) + "\t";
        output += doubleArray2String(featuresSWI.get(voxel)) + "\t";
        output += doubleArray2String(featuresT1.get(voxel + "norm")) + "\t";
        output += doubleArray2String(featuresT1C.get(voxel + "norm")) + "\t";
        output += doubleArray2String(featuresT2.get(voxel + "norm")) + "\t";
        output += doubleArray2String(featuresFLAIR.get(voxel + "norm")) + "\t";
        output += doubleArray2String(featuresADC.get(voxel + "norm")) + "\t";
        output += doubleArray2String(featuresSWI.get(voxel + "norm"));
        return output;
    }

    private void map() {
        HashMap<String, Double> map = new HashMap<>();
        for (int i = 0; i < selectionNecrotic.size(); i++) {
            map.put(selectionNecrotic.get(i), 0d);
        }
        for (int i = 0; i < selectionETumour.size(); i++) {
            String aux = selectionETumour.get(i);
            if (map.containsKey(aux)) {
                map.put(selectionETumour.get(i), 10d);
            } else {
                map.put(selectionETumour.get(i), 1.5d);
            }
        }
        for (int i = 0; i < selectionNonETumour.size(); i++) {
            String aux = selectionNonETumour.get(i);
            if (map.containsKey(aux)) {
                map.put(selectionNonETumour.get(i), 10d);
            } else {
                map.put(selectionNonETumour.get(i), 3d);
            }
        }
        for (int i = 0; i < selectionEdema.size(); i++) {
            String aux = selectionEdema.get(i);
            if (map.containsKey(aux)) {
                map.put(selectionEdema.get(i), 10d);
            } else {
                map.put(selectionEdema.get(i), 4.5d);
            }
        }
        for (int i = 0; i < selectionNAWM.size(); i++) {
            String aux = selectionNAWM.get(i);
            if (map.containsKey(aux)) {
                map.put(selectionNAWM.get(i), 10d);
            } else {
                map.put(selectionNAWM.get(i), 6d);
            }
        }
        for (int i = 0; i < selectionNABT.size(); i++) {
            String aux = selectionNABT.get(i);
            if (map.containsKey(aux)) {
                map.put(selectionNABT.get(i), 10d);
            } else {
                map.put(selectionNABT.get(i), 7.5d);
            }
        }
        parent.getModel().getColorMap().setColorMapValues(map, false);
        parent.getModel().getColorMap().setLimits(0f, 10f);
    }

    private void updateGUI() {
        this.jLabelNecrotic.setText(this.selectionNecrotic.size() + " voxels selected");
        this.jLabelETumour.setText(this.selectionETumour.size() + " voxels selected");
        this.jLabelNonETumour.setText(this.selectionNonETumour.size() + " voxels selected");
        this.jLabelEdema.setText(this.selectionEdema.size() + " voxels selected");
        this.jLabelNAWM.setText(this.selectionNAWM.size() + " voxels selected");
        this.jLabelNABT.setText(this.selectionNABT.size() + " voxels selected");
        int nrSelected = this.selectionNecrotic.size() + this.selectionETumour.size()
                + this.selectionNonETumour.size() + this.selectionEdema.size()
                + this.selectionNAWM.size() + this.selectionNABT.size();
        HashMap<String, Integer> countNrSelections = new HashMap<>();
        for (int i = 0; i < selectionNecrotic.size(); i++) {
            countNrSelections.put(selectionNecrotic.get(i), 1);
        }
        for (int i = 0; i < selectionETumour.size(); i++) {
            String aux = selectionETumour.get(i);
            if (countNrSelections.containsKey(aux)) {
                countNrSelections.put(selectionETumour.get(i), 1 + countNrSelections.get(aux));
            } else {
                countNrSelections.put(selectionETumour.get(i), 1);
            }
        }
        for (int i = 0; i < selectionNonETumour.size(); i++) {
            String aux = selectionNonETumour.get(i);
            if (countNrSelections.containsKey(aux)) {
                countNrSelections.put(selectionNonETumour.get(i), 1 + countNrSelections.get(aux));
            } else {
                countNrSelections.put(selectionNonETumour.get(i), 1);
            }
        }
        for (int i = 0; i < selectionEdema.size(); i++) {
            String aux = selectionEdema.get(i);
            if (countNrSelections.containsKey(aux)) {
                countNrSelections.put(selectionEdema.get(i), 1 + countNrSelections.get(aux));
            } else {
                countNrSelections.put(selectionEdema.get(i), 1);
            }
        }
        for (int i = 0; i < selectionNAWM.size(); i++) {
            String aux = selectionNAWM.get(i);
            if (countNrSelections.containsKey(aux)) {
                countNrSelections.put(selectionNAWM.get(i), 1 + countNrSelections.get(aux));
            } else {
                countNrSelections.put(selectionNAWM.get(i), 1);
            }
        }

        if (selectionEdema.size() > 0) {
            this.jButtonEdemaLoad.setEnabled(true);
        } else {
            this.jButtonEdemaLoad.setEnabled(false);
        }
        if (selectionETumour.size() > 0) {
            this.jButtonETumourLoad.setEnabled(true);
        } else {
            this.jButtonETumourLoad.setEnabled(false);
        }
        if (selectionNonETumour.size() > 0) {
            this.jButtonNonETumourLoad.setEnabled(true);
        } else {
            this.jButtonNonETumourLoad.setEnabled(false);
        }
        if (selectionNecrotic.size() > 0) {
            this.jButtonNecroticLoad.setEnabled(true);
        } else {
            this.jButtonNecroticLoad.setEnabled(false);
        }
        if (selectionNAWM.size() > 0) {
            this.jButtonNAWMLoad.setEnabled(true);
        } else {
            this.jButtonNAWMLoad.setEnabled(false);
        }
        if (selectionNABT.size() > 0) {
            this.jButtonNABTLoad.setEnabled(true);
        } else {
            this.jButtonNABTLoad.setEnabled(false);
        }

        Iterator<String> iter = countNrSelections.keySet().iterator();
        nrOverlap = 0;
        while (iter.hasNext()) {
            String aux = iter.next();
            if (countNrSelections.get(aux) > 1) {
                nrOverlap++;
            }
        }
        this.jLabelNrOverlapping.setText("Number of overlapping voxels: " + nrOverlap);
        if (nrSelected > 0) {
            this.jButtonClear.setEnabled(true);
        } else {
            this.jButtonClear.setEnabled(false);
        }
        if (nrOverlap == 0 && nrSelected > 0) {
            this.jButtonSave.setEnabled(true);
        } else {
            this.jButtonSave.setEnabled(false);
        }
        if (this.jCheckBoxAutoUpdateMap.isSelected()) {
            map();
        }
    }

    public synchronized void imageCalculationThreadFinished(double[] vals, double[] valsNorm, String voxel, int type) {
        totalVoxelsFinished++;
        HashMap<String, double[]> currentMap;
        switch (type) {
            case ModalityIdentifier.ADC:
                currentMap = featuresADC;
                checkboxStateADC.setState(true);
                break;
            case ModalityIdentifier.T1C:
                currentMap = featuresT1C;
                checkboxStateT1C.setState(true);
                break;
            case ModalityIdentifier.T1:
                currentMap = featuresT1;
                checkboxStateT1.setState(true);
                break;
            case ModalityIdentifier.T2:
                currentMap = featuresT2;
                checkboxStateT2.setState(true);
                break;
            case ModalityIdentifier.SWI:
                currentMap = featuresSWI;
                checkboxStateSWI.setState(true);
                break;
            default:
                currentMap = featuresFLAIR;
                checkboxStateFLAIR.setState(true);
                break;
        }
        int nrVoxels = selectionNecrotic.size() + selectionNAWM.size() + selectionNonETumour.size() + selectionETumour.size() + selectionEdema.size();
        currentMap.put(voxel, vals);
        currentMap.put(voxel + "norm", valsNorm);
        if (totalVoxelsFinished == nrVoxels) {
            System.out.println("Finished!");
        } else {
            if (totalVoxelsFinished % (nrVoxels / 10) == 0) {
                System.out.println("Calculating image features: " + totalVoxelsFinished + " out of " + nrVoxels);
            }
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Checkbox checkboxStateADC;
    private java.awt.Checkbox checkboxStateFLAIR;
    private java.awt.Checkbox checkboxStateSWI;
    private java.awt.Checkbox checkboxStateT1;
    private java.awt.Checkbox checkboxStateT1C;
    private java.awt.Checkbox checkboxStateT2;
    private javax.swing.JButton jButtonADCFeatures;
    private javax.swing.JButton jButtonClear;
    private javax.swing.JButton jButtonETumour;
    private javax.swing.JButton jButtonETumourLoad;
    private javax.swing.JButton jButtonEdema;
    private javax.swing.JButton jButtonEdemaLoad;
    private javax.swing.JButton jButtonFLAIRFeatures;
    private javax.swing.JButton jButtonImageFeatures;
    private javax.swing.JButton jButtonLoad;
    private javax.swing.JButton jButtonMap;
    private javax.swing.JButton jButtonMapFeatures;
    private javax.swing.JButton jButtonNABT;
    private javax.swing.JButton jButtonNABTLoad;
    private javax.swing.JButton jButtonNAWM;
    private javax.swing.JButton jButtonNAWMLoad;
    private javax.swing.JButton jButtonNecrotic;
    private javax.swing.JButton jButtonNecroticLoad;
    private javax.swing.JButton jButtonNonETumour;
    private javax.swing.JButton jButtonNonETumourLoad;
    private javax.swing.JButton jButtonQuantificationFeatures;
    private javax.swing.JButton jButtonSWIFeatures;
    private javax.swing.JButton jButtonSave;
    private javax.swing.JButton jButtonSpectraFeatures;
    private javax.swing.JButton jButtonT1Features;
    private javax.swing.JButton jButtonT1cFeatures;
    private javax.swing.JButton jButtonT2Features;
    private javax.swing.JCheckBox jCheckBoxAutoUpdateMap;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabelETumour;
    private javax.swing.JLabel jLabelEdema;
    private javax.swing.JLabel jLabelNABT;
    private javax.swing.JLabel jLabelNAWM;
    private javax.swing.JLabel jLabelNecrotic;
    private javax.swing.JLabel jLabelNonETumour;
    private javax.swing.JLabel jLabelNrOverlapping;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    // End of variables declaration//GEN-END:variables
}

class ImageFeaturesCalculator implements Runnable {

    private final TumourRegionSelectionAssistant parent;
    private final CSIGrid grid;
    private final String voxel;
    private final int modality;
    private final double meanNAWM;

    public ImageFeaturesCalculator(TumourRegionSelectionAssistant parent, CSIGrid grid, String voxel, int modality, double meanNAWM) {
        this.parent = parent;
        this.grid = grid;
        this.voxel = voxel;
        this.modality = modality;
        this.meanNAWM = meanNAWM;
    }

    @Override
    public void run() {
        double[] valsNorm = grid.analyseVoxelSubImage(voxel, false, meanNAWM / 100);
        double[] vals = grid.analyseVoxelSubImage(voxel, false);
        parent.imageCalculationThreadFinished(vals, valsNorm, voxel, modality);
    }
}
