/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.randomforestregression;

import java.util.Iterator;
import java.util.LinkedList;
import org.spectrim.tdfdfit.MRFittingParameters;
import org.spectrim.tdfdfit.MRLineModelParameters;
import org.spectrim.tdfdfit.MRLineModelSpectralResponse;
import org.spectrim.tdfdfit.MRParametricPattern;
import org.spectrim.tdfdfit.MRSignalProperties;

/**
 *
 * @author Brigitte
 */
public class SimulatedSpectralResponse extends MRLineModelSpectralResponse {
//  in class: MRMetaboliteModel 
    
    private MRLineModelSpectralResponse m_lineModelSpectralResponse;
    private LinkedList<MRLineModelParameters> m_simpleLineList = new LinkedList<MRLineModelParameters>( );
    private LinkedList<MRParametricPattern> m_parametricPatternList = new LinkedList<MRParametricPattern>( );
    private MRFittingParameters m_fittingParameters;
    
    /**
     * Default constructor.
     */
    public SimulatedSpectralResponse( )
    {
        
    }
    
    public MRLineModelSpectralResponse getSpectralResponse( MRSignalProperties mrSignalProperties )
    {
        
        // Create a model spectral response per default constructor
        MRLineModelSpectralResponse resp = new MRLineModelSpectralResponse( );
        
        
        
        m_lineModelSpectralResponse = null;
        m_lineModelSpectralResponse = new MRLineModelSpectralResponse( mrSignalProperties.getNumberOfSamplePoints( ) );
        m_lineModelSpectralResponse.setMRSignalProperties( mrSignalProperties );
        
        // Iterate over the m_simpleLineList containing the simple lines
        Iterator iter = m_simpleLineList.iterator( );
        while ( iter.hasNext( ) )
        {
            MRLineModelParameters simpleLine = (MRLineModelParameters)iter.next( );
            
            // calculate the corresponding resonance line
            resp = new MRLineModelSpectralResponse( (MRFittingParameters)simpleLine, mrSignalProperties );
            m_lineModelSpectralResponse.addTimeDomainResponse( resp.getAbsorptionChannelTD( ), resp.getDispersionChannelTD( ) );
        }
        
        // Calculate the sum of all ParametricPattern - MRLineModelSpectralResponse
        // objects - if any
        Iterator parPatIter = m_parametricPatternList.iterator( );
        while ( parPatIter.hasNext( ) )
        {
            MRParametricPattern parPat = (MRParametricPattern)parPatIter.next( );
            resp = parPat.getSpectralResponse( mrSignalProperties );
            m_lineModelSpectralResponse.addTimeDomainResponse( resp.getAbsorptionChannelTD( ), resp.getDispersionChannelTD( ) );
        }
        
        m_lineModelSpectralResponse.applyMRLineModelSpectralResponse( m_fittingParameters );
        
        return m_lineModelSpectralResponse;
    }
    
}
