/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.registration;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.SwingWorker;
import org.spectrim.process.StreamBoozer;
import org.spectrim.settings.RegistrationSettings;

/**
 *
 * @author nuno
 */
public class RegistrationWorker extends SwingWorker<Integer, String> implements OutputListener {

    public String fileRef;
    public String fileFloating;
    public String fileRes;
    public String fileAff;
    public String fileCpp;
    public String fileDef;
    public String fileDisp;
    private RegistrationWorkerListener listener;
    public Mode mode;
    public Date start;
//    OPTIONS ALADIN
    public boolean optAladinSym = false;
    public boolean optAladinRigOnly = false;
    public boolean optAladinAffDirect = false;
    public boolean optAladinAffFromFile = false;
    public String optAladinAffInputFile;
    public int optAladinNrIterations = 5;
    public double optAladinSigmaRef = 0.0f;
    public double optAladinSigmaFloating = 0.0f;
    public int optAladinNrLevels = 3;
    public int optAladinFirstLevels = 3;
    public boolean optAladinInitTranslWithNiftiHeader = false;
    public int optAladinPercentBlock = 50;
    public int optAladinPercentInlierLTS = 50;
//    OPTIONS F3D
    public boolean optF3DCPGFromFile = false;
    public String optF3DCPGInputFile;
    public boolean optF3DAffFromFile = false;
    public String optF3DAffInputFile;
    public double optF3DSigmaRef = 0;
    public double optF3DSigmaFloating = 0;
    public int optF3DNrBinsRef = 64;
    public int optF3DNrBinsFloating = 64;
    public boolean optF3DApplyThresholdRefLow = false;
    public double optF3DThresholdRefLow;
    public boolean optF3DApplyThresholdRefHigh = false;
    public double optF3DThresholdRefHigh;
    public boolean optF3DApplyThresholdFloatingLow = false;
    public double optF3DThresholdFloatingLow;
    public boolean optF3DApplyThresholdFloatingHigh = false;
    public double optF3DThresholdFloatingHigh;
    public double optF3DFinalGridSpacingX = 5f;
    public double optF3DFinalGridSpacingY = 5f;
    public double optF3DFinalGridSpacingZ = 5f;
    public double optF3DBendingEnergyPenalty = 0.005f;
    public double optF3DLinearElasticityPenalty1 = 0.0f;
    public double optF3DLinearElasticityPenalty2 = 0.0f;
    public double optF3DL2NormDisplacementPenalty = 0.0f;
    public double optF3DLogJacobDeterminantPenalty = 0.0f;
    public boolean optF3DApproxJLOnlyAtControlPoint = true;
    public boolean optF3DUseConjugateGradOptim = true;

    public enum optF3DSimilarityMeasureTypes {

        NMI, SSD, KLDiv, ADD_NMI
    };
    public optF3DSimilarityMeasureTypes optF3DSimilarityMeasure = optF3DSimilarityMeasureTypes.NMI;
    public int optF3DMaxIterLevel = 300;
    public int optF3DNrLevels = 3;
    public int optF3DFirstLevels = 3;
    public boolean optF3DPyramidal = true;
    public boolean optF3DSym = false;
    public double optF3DSymInvConsistPenalty = 0.01f;
    public boolean optF3DVel = false;
    public int optF3DVelNrComposStep = 6;
    public double optF3DSmoothGrad = 0f;
    public double optF3DPaddingVal = Float.NaN;
    private String status;

    public enum Mode {

        RIGID, NONRIGID, BOTH
    };

    public RegistrationWorker(String fileRef, String fileFloating, String fileRes, String fileAff, String fileCpp, String fileDef, String fileDisp, RegistrationWorkerListener listener, Mode mode) {
        this.fileRef = fileRef;
        this.fileFloating = fileFloating;
        this.fileRes = fileRes;
        this.fileAff = fileAff;
        this.fileCpp = fileCpp;
        this.fileDef = fileDef;
        this.fileDisp = fileDisp;
        this.listener = listener;
        this.mode = mode;
        this.start = new Date();
    }

//***************************************************************************
//  SETTING OPTIONS ALADIN  
    public void setAladinSym(boolean val) {
        optAladinSym = val;
    }

    public void setAladinRigOnly(boolean val) {
        optAladinRigOnly = val;
    }

    public void setAladinAffDirect(boolean val) {
        optAladinAffDirect = val;
    }

    public void setAladinAffFromFile(boolean val, String file) {
        optAladinAffFromFile = val;
        optAladinAffInputFile = file;
    }

    public void setAladinNrIterations(int val) {
        optAladinNrIterations = val;
    }

    public void setAladinSigmaRef(double val) {
        optAladinSigmaRef = val;
    }

    public void setAladinSigmaFloating(double val) {
        optAladinSigmaFloating = val;
    }

    public void setAladinNrLevels(int val) {
        optAladinNrLevels = val;
    }

    public void setAladinFirstLevels(int val) {
        optAladinFirstLevels = val;
    }

    public void setAladinInitTranslWithNiftiHeader(boolean val) {
        optAladinInitTranslWithNiftiHeader = val;
    }

    public void setAladinPercentBlock(int val) {
        optAladinPercentBlock = val;
    }

    public void setAladinPercentInlierLTS(int val) {
        optAladinPercentInlierLTS = val;
    }

//*******************************************************************************
//  SETTING OPTIONS F3D     
    public void setF3DCPGFromFile(boolean val, String file) {
        optF3DCPGFromFile = val;
        optF3DCPGInputFile = file;
    }

    public void setF3DAffFromFile(boolean val, String file) {
        optF3DAffFromFile = val;
        optF3DAffInputFile = file;
    }

    public void setF3DSigmaRef(double val) {
        optF3DSigmaRef = val;
    }

    public void setF3DSigmaFloating(double val) {
        optF3DSigmaFloating = val;
    }

    public void setF3DNrBinsRef(int val) {
        optF3DNrBinsRef = val;
    }

    public void setF3DNrBinsFloating(int val) {
        optF3DNrBinsFloating = val;
    }

    public void setF3DThresholdRefLow(boolean bool, double val) {
        optF3DApplyThresholdRefLow = bool;
        optF3DThresholdRefLow = val;
    }

    public void setF3DThresholdRefHigh(boolean bool, double val) {
        optF3DApplyThresholdRefHigh = bool;
        optF3DThresholdRefHigh = val;
    }

    public void setF3DThresholdFloatingLow(boolean bool, double val) {
        optF3DApplyThresholdFloatingLow = bool;
        optF3DThresholdFloatingLow = val;
    }

    public void setF3DThresholdFloatingHigh(boolean bool, double val) {
        optF3DApplyThresholdFloatingHigh = bool;
        optF3DThresholdFloatingHigh = val;
    }

    public void setF3DFinalGridSpacingX(double val) {
        optF3DFinalGridSpacingX = val;
    }

    public void setF3DFinalGridSpacingY(double val) {
        optF3DFinalGridSpacingY = val;
    }

    public void setF3DFinalGridSpacingZ(double val) {
        optF3DFinalGridSpacingZ = val;
    }

    public void setF3DBendingEnergyPenalty(double val) {
        optF3DBendingEnergyPenalty = val;
    }

    public void setF3DLinearElasticityPenalty(double val1, double val2) {
        optF3DLinearElasticityPenalty1 = val1;
        optF3DLinearElasticityPenalty2 = val2;
    }

    public void setF3DL2NormDisplacementPenalty(double val) {
        optF3DL2NormDisplacementPenalty = val;
    }

    public void setF3DLogJacobDeterminantPenalty(double val) {
        optF3DLogJacobDeterminantPenalty = val;
    }

    public void setF3DApproxJLOnlyAtControlPoint(boolean val) {
        optF3DApproxJLOnlyAtControlPoint = val;
    }

    public void setF3DUseConjugateGradOptim(boolean val) {
        optF3DUseConjugateGradOptim = val;
    }

    public void setF3DSimilarityMeasure(optF3DSimilarityMeasureTypes val) {
        optF3DSimilarityMeasure = val;
    }

    public void setF3DMaxIterLevel(int val) {
        optF3DMaxIterLevel = val;
    }

    public void setF3DNrLevels(int val) {
        optF3DNrLevels = val;
    }

    public void setF3DFirstLevels(int val) {
        optF3DFirstLevels = val;
    }

    public void setF3DPyramidal(boolean val) {
        optF3DPyramidal = val;
    }

    public void setF3DSym(boolean val) {
        optF3DSym = val;
    }

    public void setF3DSymInvConsistPenalty(double val) {
        optF3DSymInvConsistPenalty = val;
    }

    public void setF3DVel(boolean val) {
        optF3DVel = val;
    }

    public void setF3DVelNrComposStep(int val) {
        optF3DVelNrComposStep = val;
    }

    public void setF3DSmoothGrad(double val) {
        optF3DSmoothGrad = val;
    }

    public void setF3DPaddingVal(double val) {
        optF3DPaddingVal = val;
    }

//***************************************************************************    
//    TRANSLATE OPTION VARIABLES TO COMMAND SYNTAX
    protected void includeOptionsAladin(List<String> command) {
        if (optAladinSym) {
            command.add("-sym");
        }
        if (optAladinRigOnly) {
            command.add("-rigOnly");
        }
        if (optAladinAffDirect) {
            command.add("-affDirect");
        }
        if (optAladinAffFromFile) {
            command.add("-inaff");
            command.add("" + optAladinAffInputFile);
        }
        if (optAladinInitTranslWithNiftiHeader) {
            command.add("-nac");
        }
        command.add("-maxit");
        command.add("" + optAladinNrIterations);
        command.add("-smooR");
        command.add("" + optAladinSigmaRef);
        command.add("-smooF");
        command.add("" + optAladinSigmaFloating);
        command.add("-ln");
        command.add("" + optAladinNrLevels);
        command.add("-lp");
        command.add("" + optAladinFirstLevels);
        command.add("-%v");
        command.add("" + optAladinPercentBlock);
        command.add("-%i");
        command.add("" + optAladinPercentInlierLTS);

        for (int i = 0; i < command.size(); i++) {
            System.out.println(command.get(i));
        }
    }

    protected void includeOptionsF3D(List<String> command) {
        if (optF3DCPGFromFile) {
            command.add("-incpp");
            command.add("" + optF3DCPGInputFile);
        }
        if (optF3DAffFromFile) {
            command.add("-aff");
            command.add("" + optF3DAffInputFile);
        }
        command.add("-smooR");
        command.add("" + optF3DSigmaRef);
        command.add("-smooF");
        command.add("" + optF3DSigmaFloating);
        command.add("--rbn");
        command.add("" + optF3DNrBinsRef);
        command.add("--fbn");
        command.add("" + optF3DNrBinsFloating);
        if (optF3DApplyThresholdRefLow) {
            command.add("--rLwTh");
            command.add("" + optF3DThresholdRefLow);
        }
        if (optF3DApplyThresholdRefHigh) {
            command.add("--rUpTh");
            command.add("" + optF3DThresholdRefHigh);
        }
        if (optF3DApplyThresholdFloatingLow) {
            command.add("--fLwTh");
            command.add("--fLwTh" + optF3DThresholdFloatingLow);
        }
        if (optF3DApplyThresholdFloatingHigh) {
            command.add("--fUpTh");
            command.add("" + optF3DThresholdFloatingHigh);
        }
        command.add("-sx");
        command.add("" + optF3DFinalGridSpacingX);
        command.add("-sy");
        command.add("" + optF3DFinalGridSpacingY);
        command.add("-sz");
        command.add("" + optF3DFinalGridSpacingZ);
        command.add("-be");
        command.add("" + optF3DBendingEnergyPenalty);
        command.add("-le");
        command.add("" + optF3DLinearElasticityPenalty1);
        command.add("" + optF3DLinearElasticityPenalty2);
        command.add("-l2");
        command.add("" + optF3DL2NormDisplacementPenalty);
        command.add("-jl");
        command.add("" + optF3DLogJacobDeterminantPenalty);
        if (!optF3DApproxJLOnlyAtControlPoint) {
            command.add("-noAppJL");
        }
        if (!optF3DUseConjugateGradOptim) {
            command.add("-noConj");
        }
        if (optF3DSimilarityMeasure == optF3DSimilarityMeasureTypes.SSD) {
            command.add("-ssd");
        } else if (optF3DSimilarityMeasure == optF3DSimilarityMeasureTypes.KLDiv) {
            command.add("-kld");
        } else if (optF3DSimilarityMeasure == optF3DSimilarityMeasureTypes.ADD_NMI) {
            command.add("-amc");
        }
        if (!optF3DPyramidal) {
            command.add("-nopy");
        }
        if (optF3DSym) {
            command.add("-sym");
            command.add("-ic");
            command.add("" + optF3DSymInvConsistPenalty);
        }
        if (optF3DVel) {
            command.add("-vel");
            command.add("-step");
            command.add("" + optF3DVelNrComposStep);
        }
        command.add("-maxit");
        command.add("" + optF3DMaxIterLevel);
        command.add("-ln");
        command.add("" + optF3DNrLevels);
        command.add("-lp");
        command.add("" + optF3DFirstLevels);
        command.add("-smoothGrad");
        command.add("" + optF3DSmoothGrad);
        if (optF3DPaddingVal != Float.NaN) {
            command.add("-pad");
            command.add("" + optF3DPaddingVal);
        }
        for (int i = 0; i < command.size(); i++) {
            System.out.println(command.get(i));
        }
    }

    public Mode getMode() {
        return this.mode;
    }

    @Override
    protected Integer doInBackground() {
        this.listener.publish(">>>>>>>>>>>> Registration Started!");
        this.listener.publish("processing... this action might take several minutes...");

        ArrayList<List<String>> commandList = new ArrayList<>();
        List<String> command;
        switch (mode) {
            case RIGID:
                command = new ArrayList<String>();
                command.add(RegistrationSettings.getInstance().getAladinInstallPath());
                command.add("-ref");
                command.add(fileRef);
                command.add("-flo");
                command.add(fileFloating);
                command.add("-res");
                command.add(fileRes);
                command.add("-aff");
                command.add(fileAff);
                includeOptionsAladin(command);
                commandList.add(command);
                commandList = addInvAffCommands(commandList);
                buildProcess(commandList);
                break;
            case NONRIGID:
                command = new ArrayList<String>();
                command.add(RegistrationSettings.getInstance().getF3dInstallPath());
                command.add("-ref");
                command.add(fileRef);
                command.add("-flo");
                command.add(fileFloating);
                command.add("-res");
                command.add(fileRes);
                command.add("-cpp");
                command.add(fileCpp);
                includeOptionsF3D(command);
                commandList.add(command);
                commandList = addDispFileCommands(commandList);
                buildProcess(commandList);
                break;
            case BOTH:
                command = new ArrayList<String>();
                command.add(RegistrationSettings.getInstance().getAladinInstallPath());
                command.add("-ref");
                command.add(fileRef);
                command.add("-flo");
                command.add(fileFloating);
                command.add("-res");
                command.add(fileRes.replace(".nii", "_rig.nii"));
                command.add("-aff");
                command.add(fileAff);
                includeOptionsAladin(command);
                commandList.add(command);
                commandList = addInvAffCommands(commandList);

                command = new ArrayList<String>();
                command.add(RegistrationSettings.getInstance().getF3dInstallPath());
                command.add("-ref");
                command.add(fileRef);
                command.add("-flo");
                command.add(fileRes.replace(".nii", "_rig.nii"));
                command.add("-res");
                command.add(fileRes);
                command.add("-cpp");
                command.add(fileCpp);
                includeOptionsF3D(command);
                commandList.add(command);
                commandList = addDispFileCommands(commandList);
                buildProcess(commandList);
                break;
        }
        return 1;
    }

    private ArrayList<List<String>> addDispFileCommands(ArrayList<List<String>> cmdList) {
        List<String> command = new ArrayList<String>();
        command.add(RegistrationSettings.getInstance().getRegTransformInstallPath());
        command.add("-ref");
        command.add(fileRef);
        command.add("-cpp2def");
        command.add(fileCpp);
        command.add(fileDef);
        cmdList.add(command);

        command = new ArrayList<String>();
        command.add(RegistrationSettings.getInstance().getRegTransformInstallPath());
        command.add("-ref");
        command.add(fileRef);
        command.add("-def2disp");
        command.add(fileDef);
        command.add(fileDisp);
        cmdList.add(command);
        return cmdList;
    }

    private ArrayList<List<String>> addInvAffCommands(ArrayList<List<String>> cmdList) {
        List<String> command = new ArrayList<String>();
        command.add(RegistrationSettings.getInstance().getRegTransformInstallPath());
        command.add("-ref");
        command.add(fileRef);
        command.add("-invAffine");
        command.add(fileAff);
        command.add(fileAff);
        cmdList.add(command);
        return cmdList;
    }

    private void buildProcess(ArrayList<List<String>> commandList) {
        StringWriter infos = new StringWriter();
        StringWriter errors = new StringWriter();
        if (!commandList.isEmpty()) {
            List<String> command = commandList.get(0);
            commandList.remove(0);

            ProcessBuilder pb = new ProcessBuilder(command);
//        if (directory != null) {
//            pb.directory(directory);
//        }
            pb.redirectErrorStream(true);
            Process process;
            try {
                process = pb.start();
                PrintWriter writer = new PrintWriter(new OutputStreamWriter(new BufferedOutputStream(process.getOutputStream())), true);
                writer.flush();
                StreamBoozer seInfo = new StreamBoozer(process.getInputStream(), new PrintWriter(infos, true), this);
                StreamBoozer seError = new StreamBoozer(process.getErrorStream(), new PrintWriter(errors, true), this);
                seError.start();
                seInfo.start();
                int status = process.waitFor();
                seInfo.join();
                seError.join();
                buildProcess(commandList);

            } catch (IOException ex) {
                Logger.getLogger(RegistrationWorker.class
                        .getName()).log(Level.SEVERE, null, ex);
            } catch (InterruptedException ex) {
                Logger.getLogger(RegistrationWorker.class
                        .getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    @Override
    protected void process(List<String> chunks) {
        for (int i = 0; i < chunks.size(); i++) {
            this.listener.publish(chunks.get(i));
        }
    }

    @Override
    public void print(String txt) {
        publish(txt);
    }

    @Override
    public void done() {
        this.listener.publish(">>>>>>>>>>>> Registration Finished!!");
        listener.registrationFinished(this);
    }
}
