/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.report;

import java.awt.Component;
import java.awt.Container;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.SwingUtilities;
import org.spectrim.model.GlobalModel;
import org.spectrim.popups.jMRUIResultsMapListener;

/**
 *
 * @author Giezi adapted by JSlotboom
 */
public class CstmReportPanel extends javax.swing.JPanel implements MouseListener 
{

    private GlobalModel             csimodel;
    private jMRUIResultsMapListener mapListener;
    private javax.swing.JMenuItem[] jMenuItemMetabolites;
    private JMenuItem[]             jMenuItemMetabRatio;
    private String                  level;
    private String                  panelType;
    private String                  metaboliteMapName;

    public final static String EMPTY        = "00";
    public final static String HORIZONTAL   = "01";
    public final static String VERTICAL     = "02";
    public final static String SPECRED      = "03";
    public final static String SPECBLU      = "04";
    public final static String SPECBOT      = "05";
    public final static String LOCH         = "06";
    public final static String LOCV         = "07";
    public final static String OVER         = "08";
    public final static String TABLE        = "09";
    public final static String MAP          = "10";
    public final static String RATIO        = "11";

    public final static int REDSPCPNL       = 0;
    public final static int BLUSPCPNL       = 1;
    public final static int BOTSPCPNL       = 2;

    /**
     * Creates new form CstmReportPanel
     */
    public CstmReportPanel( GlobalModel csimodel, 
                            jMRUIResultsMapListener mapListener, 
                            String level, String panelType ) 
    {
        initComponents( );
        this.panelType = panelType;
        this.level = level;
        this.csimodel = csimodel;
        this.mapListener = mapListener;
        this.addMouseListener(this);
        metaboliteMapName = "";
        addMetaboliteMenuItems( );
    }

    private void addMetaboliteMenuItems( ) 
    {
        String[] names = mapListener.getMetabolitesNames( );
        jMenuItemMetabolites = new javax.swing.JMenuItem[names.length];
        jMenuItemMetabRatio = new JMenuItem[names.length * (names.length - 1)];
        
        for ( int i = 0; i < names.length; i++ ) 
        {
            // Metabolite Map
            jMenuItemMetabolites[i] = new javax.swing.JMenuItem( );
            jMenuItemMetabolites[i].setText( names[i] );
            jMenuItemMetabolites[i].addActionListener( new java.awt.event.ActionListener( ) 
            {
                public void actionPerformed( java.awt.event.ActionEvent evt ) 
                {
                    jMenuItemMetabMapActionPerformed( evt );
                }
            });
            jMenuAddMap.add(jMenuItemMetabolites[i] );

            // Metabolite ratio map
            int c = 0;
            for (int j = 0; j < names.length; j++) 
            {
                if ( i != j ) 
                {
                    jMenuItemMetabRatio[i * (names.length - 1) + c] = new JMenuItem( );
                    jMenuItemMetabRatio[i * (names.length - 1) + c].setText( names[i] + "\t-\t" + names[j] );
                    jMenuItemMetabRatio[i * (names.length - 1) + c].addActionListener(new java.awt.event.ActionListener() 
                    {
                        public void actionPerformed( java.awt.event.ActionEvent evt ) 
                        {
                            jMenuItemMetabRatioActionPerformed( evt );
                        }
                    });
                    jMenuAddRatioMap.add( jMenuItemMetabRatio[i * (names.length - 1) + c] );
                    c++;
                }
            }
            if ( ( i + 1 ) < names.length ) 
            {
                jMenuAddRatioMap.add( new JSeparator( ) );
            }
        }
    }

    @Override
    public void remove( Component comp ) 
    {
        super.remove( comp ); //To change body of generated methods, choose Tools | Templates.
        if ( this.getComponentCount() == 0 ) 
        {
            Container par = this.getParent( );
            par.remove( this );
            par.revalidate( );
            par.repaint( );
        }
        this.revalidate( );
        this.repaint( );
    }

    public void nameComponents(ArrayList<String> lvlPrst, ArrayList<String> typePrst, ArrayList<String> metabPrst) 
    {
        if ( !this.panelType.substring(panelType.length() - 2 ).matches( HORIZONTAL ) && !this.panelType.substring( panelType.length( ) - 2).matches( VERTICAL ) ) 
        {
            System.out.println( level );
            System.out.println( panelType );
            System.out.println( metaboliteMapName );
            lvlPrst.add( level );
            typePrst.add( panelType );
            metabPrst.add( metaboliteMapName );
        }
        for ( Component com : this.getComponents( ) ) 
        {
            if ( com instanceof CstmReportPanel ) 
            {
                ( (CstmReportPanel) com ).nameComponents( lvlPrst, typePrst, metabPrst );
            }
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu = new javax.swing.JPopupMenu();
        jMenuSplit = new javax.swing.JMenu();
        jMenuItemSplitHorizontal = new javax.swing.JMenuItem();
        jMenuItemSpliVertical = new javax.swing.JMenuItem();
        jMenuItemClose = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        jMenuAddMap = new javax.swing.JMenu();
        jMenuAddRatioMap = new javax.swing.JMenu();
        jMenuSpectra = new javax.swing.JMenu();
        jMenuItemSpectraRed = new javax.swing.JMenuItem();
        jMenuItemSpectraBlue = new javax.swing.JMenuItem();
        jMenuItemSpectraBoth = new javax.swing.JMenuItem();
        jMenuItemOverview = new javax.swing.JMenuItem();
        jMenuItemMetabTable = new javax.swing.JMenuItem();
        jMenuLocalizer = new javax.swing.JMenu();
        jMenuItemLocalizerHorizontal = new javax.swing.JMenuItem();
        jMenuItemLocalizerVertical = new javax.swing.JMenuItem();
        buttonGroupMetabRatio1 = new javax.swing.ButtonGroup();
        buttonGroupMetabRatio2 = new javax.swing.ButtonGroup();

        jMenuSplit.setText("Spit");

        jMenuItemSplitHorizontal.setText("Horizontal");
        jMenuItemSplitHorizontal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSplitHorizontalActionPerformed(evt);
            }
        });
        jMenuSplit.add(jMenuItemSplitHorizontal);

        jMenuItemSpliVertical.setText("Vertical");
        jMenuItemSpliVertical.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSpliVerticalActionPerformed(evt);
            }
        });
        jMenuSplit.add(jMenuItemSpliVertical);

        jPopupMenu.add(jMenuSplit);

        jMenuItemClose.setText("Close");
        jMenuItemClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemCloseActionPerformed(evt);
            }
        });
        jPopupMenu.add(jMenuItemClose);
        jPopupMenu.add(jSeparator1);

        jMenuAddMap.setText("add metabolite map...");
        jPopupMenu.add(jMenuAddMap);

        jMenuAddRatioMap.setText("add metabolite ratio map...");
        jPopupMenu.add(jMenuAddRatioMap);

        jMenuSpectra.setText("add spectra...");

        jMenuItemSpectraRed.setText("red");
        jMenuItemSpectraRed.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSpectraActionPerformed(evt);
            }
        });
        jMenuSpectra.add(jMenuItemSpectraRed);

        jMenuItemSpectraBlue.setText("blue");
        jMenuItemSpectraBlue.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSpectraActionPerformed(evt);
            }
        });
        jMenuSpectra.add(jMenuItemSpectraBlue);

        jMenuItemSpectraBoth.setText("both");
        jMenuItemSpectraBoth.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSpectraActionPerformed(evt);
            }
        });
        jMenuSpectra.add(jMenuItemSpectraBoth);

        jPopupMenu.add(jMenuSpectra);

        jMenuItemOverview.setText("add overview");
        jMenuItemOverview.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemOverviewActionPerformed(evt);
            }
        });
        jPopupMenu.add(jMenuItemOverview);

        jMenuItemMetabTable.setText("add metabolites table");
        jMenuItemMetabTable.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemMetabTableActionPerformed(evt);
            }
        });
        jPopupMenu.add(jMenuItemMetabTable);

        jMenuLocalizer.setText("add localizer...");

        jMenuItemLocalizerHorizontal.setText("Horizontal");
        jMenuItemLocalizerHorizontal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemLocalizerHorizontalActionPerformed(evt);
            }
        });
        jMenuLocalizer.add(jMenuItemLocalizerHorizontal);

        jMenuItemLocalizerVertical.setText("Vertical");
        jMenuItemLocalizerVertical.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemLocalizerVerticalActionPerformed(evt);
            }
        });
        jMenuLocalizer.add(jMenuItemLocalizerVertical);

        jPopupMenu.add(jMenuLocalizer);

        setBackground(new java.awt.Color(1, 1, 1));
        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(254, 254, 254)));
        setLayout(new java.awt.GridLayout(1, 0));
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItemSplitHorizontalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSplitHorizontalActionPerformed
        splitHorizontal( );
    }//GEN-LAST:event_jMenuItemSplitHorizontalActionPerformed

    public CstmReportPanel[] splitHorizontal( ) 
    {
        this.removeAll( );
        this.setLayout( new java.awt.GridLayout( 1, 0 ) );
        this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + HORIZONTAL;
        CstmReportPanel pnl1 = new CstmReportPanel( csimodel, mapListener, this.level + ".0", this.panelType + "." + EMPTY );
        CstmReportPanel pnl2 = new CstmReportPanel( csimodel, mapListener, this.level + ".1", this.panelType + "." + EMPTY );
        this.add( pnl1 );
        this.add( pnl2 );
        this.revalidate( );
        this.repaint( );
        return new CstmReportPanel[ ]{ pnl1, pnl2 };
    }

    private void jMenuItemSpliVerticalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSpliVerticalActionPerformed
        splitVertical();
    }//GEN-LAST:event_jMenuItemSpliVerticalActionPerformed

    public CstmReportPanel[] splitVertical( ) 
    {
        this.removeAll( );
        this.setLayout( new java.awt.GridLayout( 0, 1 ) );
        this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + VERTICAL;
        CstmReportPanel pnl1 = new CstmReportPanel( csimodel, mapListener, this.level + ".0", this.panelType + "." + EMPTY );
        CstmReportPanel pnl2 = new CstmReportPanel( csimodel, mapListener, this.level + ".1", this.panelType + "." + EMPTY );
        this.add( pnl1 );
        this.add( pnl2 );
        this.revalidate( );
        this.repaint( );
        return new CstmReportPanel[]{ pnl1, pnl2 };
    }

    private void jMenuItemCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemCloseActionPerformed
        this.getParent( ).remove( this );
    }//GEN-LAST:event_jMenuItemCloseActionPerformed

    private void jMenuItemSpectraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSpectraActionPerformed
        switch ( ( ( javax.swing.JMenuItem ) evt.getSource( ) ).getText( ).toUpperCase( ) ) 
        {
            case "RED":
                        addSpectraPanel( 0 );
                        break;
            case "BLUE":
                        addSpectraPanel( 1 );
                        break;
            default:
                        addSpectraPanel( 2 );
                        break;
        }
    }//GEN-LAST:event_jMenuItemSpectraActionPerformed

    public void addSpectraPanel(int spctPnlType) 
    {
        if ( csimodel != null && !csimodel.isSpectraNull( ) ) 
        {
            this.removeAll();
            ReportSpectraPanel newPnl = new ReportSpectraPanel( );
            this.add( newPnl );
            newPnl.initPanel( csimodel );
            switch ( spctPnlType ) 
            {
                case REDSPCPNL:
                                newPnl.clearBlueData( );
                                newPnl.setAxisVisible( true );
                                this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + SPECRED;
                                break;
                case BLUSPCPNL:
                                newPnl.clearRedData();
                                newPnl.setAxisVisible(true);
                                this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + SPECBLU;
                                break;
                default:
                                this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + SPECBOT;
                                break;
            }
            newPnl.autoZoomVertical( );
            newPnl.revalidate( );
            newPnl.repaint( );
            this.revalidate( );
            this.repaint( );
        }
    }

    private void jMenuItemOverviewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemOverviewActionPerformed
        addOverview( );
    }//GEN-LAST:event_jMenuItemOverviewActionPerformed

    public void addOverview( ) 
    {
        if ( csimodel != null && !csimodel.isSpectraNull( ) ) 
        {
            this.removeAll( );
            ReportOverviewPanel newPnl = new ReportOverviewPanel( );
            this.add( newPnl );
            newPnl.setSize( this.getWidth( ), this.getHeight( ) );
            newPnl.displayOverview( false, csimodel );
            this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + OVER;
            this.revalidate( );
            this.repaint( );
            newPnl.setSize( this.getWidth( ), this.getHeight( ) );
            newPnl.resetZoom( );
            newPnl.revalidate( );
            newPnl.repaint( );
        }
    }

    private void jMenuItemMetabTableActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemMetabTableActionPerformed
        addMetabTable( );
    }//GEN-LAST:event_jMenuItemMetabTableActionPerformed

    public void addMetabTable( ) 
    {
        if ( csimodel != null && !csimodel.isSpectraNull( ) ) 
        {
            this.removeAll( );
            ReportMetaboliteTable newPnl = new ReportMetaboliteTable( );
            this.add( newPnl );
            newPnl.fillTable( mapListener, csimodel );
            this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + TABLE;
            this.revalidate( );
            this.repaint( );
        }
    }

    private void jMenuItemLocalizerHorizontalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemLocalizerHorizontalActionPerformed
        addLocalizersH( );
    }//GEN-LAST:event_jMenuItemLocalizerHorizontalActionPerformed

    public void addLocalizersH( ) 
    {
        if ( csimodel != null && !csimodel.isSpectraNull( ) ) 
        {
            this.removeAll( );
            ReportLocalizerPanels newPnl = new ReportLocalizerPanels( );
            newPnl.setLayout( new java.awt.GridLayout( 1, 0 ) );
            this.add( newPnl );
            newPnl.initPanels( csimodel );
            this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + LOCH;
            this.repaint( );
            this.revalidate( );
        }
    }

    private void jMenuItemLocalizerVerticalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemLocalizerVerticalActionPerformed
        addLocalizersV( );
    }//GEN-LAST:event_jMenuItemLocalizerVerticalActionPerformed

    public void addLocalizersV( ) 
    {
        if ( csimodel != null && !csimodel.isSpectraNull( ) ) 
        {
            this.removeAll( );
            ReportLocalizerPanels newPnl = new ReportLocalizerPanels( );
            newPnl.setLayout( new java.awt.GridLayout( 0, 1 ) );
            this.add( newPnl );
            newPnl.initPanels( csimodel );
            this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + LOCV;
            this.repaint( );
            this.revalidate( );
        }
    }

    private void jMenuItemMetabMapActionPerformed(java.awt.event.ActionEvent evt) {
        String metabName = ( ( JMenuItem ) evt.getSource( ) ).getText( );
        addMetabMap( metabName );
    }

    public void addMetabMap(String metabName) 
    {
        if ( csimodel != null && !csimodel.isSpectraNull( ) ) 
        {
            this.removeAll( );
            metaboliteMapName = metabName;
            ReportMetaboliteMapPanel newPnl = new ReportMetaboliteMapPanel( );
            newPnl.setSize( this.getWidth( ), this.getHeight( ) );
            this.add( newPnl );
            newPnl.displayMap( metabName, csimodel, mapListener );
            this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + MAP;
            this.revalidate( );
            this.repaint( );
            newPnl.setSize( this.getWidth( ), this.getHeight( ) );
            newPnl.resetZoom( );
            newPnl.focusOnExcitedVoxels( );
            newPnl.revalidate( );
            newPnl.repaint( );
        }
    }

    private void jMenuItemMetabRatioActionPerformed(java.awt.event.ActionEvent evt) {
        String metabName = ( (JMenuItem) evt.getSource( ) ).getText( );
        addMetabRatioMap( metabName );
    }

    public void addMetabRatioMap( String metabName ) 
    {
        if ( csimodel != null && !csimodel.isSpectraNull( ) ) {
            this.removeAll( );
            metaboliteMapName = metabName;
            String metabName1 = metabName.split( "\t-\t", 2 )[0];
            String metabName2 = metabName.split( "\t-\t", 2 )[1];
            ReportMetaboliteRatioMapPanel newPnl = new ReportMetaboliteRatioMapPanel( );
            newPnl.setSize( this.getWidth( ), this.getHeight( ) );
            this.add( newPnl );
            newPnl.displayMap( metabName1, metabName2, csimodel, mapListener );
            this.panelType = this.panelType.substring( 0, panelType.length( ) - 2 ) + RATIO;
            this.revalidate( );
            this.repaint( );
            newPnl.setSize( this.getWidth( ), this.getHeight( ) );
            newPnl.resetZoom( );
            newPnl.focusOnExcitedVoxels( );
            newPnl.revalidate( );
            newPnl.repaint( );
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroupMetabRatio1;
    private javax.swing.ButtonGroup buttonGroupMetabRatio2;
    private javax.swing.JMenu jMenuAddMap;
    private javax.swing.JMenu jMenuAddRatioMap;
    private javax.swing.JMenuItem jMenuItemClose;
    private javax.swing.JMenuItem jMenuItemLocalizerHorizontal;
    private javax.swing.JMenuItem jMenuItemLocalizerVertical;
    private javax.swing.JMenuItem jMenuItemMetabTable;
    private javax.swing.JMenuItem jMenuItemOverview;
    private javax.swing.JMenuItem jMenuItemSpectraBlue;
    private javax.swing.JMenuItem jMenuItemSpectraBoth;
    private javax.swing.JMenuItem jMenuItemSpectraRed;
    private javax.swing.JMenuItem jMenuItemSpliVertical;
    private javax.swing.JMenuItem jMenuItemSplitHorizontal;
    private javax.swing.JMenu jMenuLocalizer;
    private javax.swing.JMenu jMenuSpectra;
    private javax.swing.JMenu jMenuSplit;
    private javax.swing.JPopupMenu jPopupMenu;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    // End of variables declaration//GEN-END:variables

    @Override
    public void mouseClicked(MouseEvent e) 
    {
        if ( SwingUtilities.isRightMouseButton( e ) ) 
        {
            jPopupMenu.show( this, e.getX( ), e.getY( ) );
        }
    }

    @Override
    public void mousePressed(MouseEvent e) 
    {
//        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void mouseReleased(MouseEvent e) 
    {
//        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void mouseEntered(MouseEvent e) 
    {
//        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void mouseExited(MouseEvent e) 
    {
//        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
}
