/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.report;


import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Enumeration;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.AbstractButton;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;
import org.spectrim.model.GlobalModel;
import org.spectrim.popups.jMRUIResultsMapListener;




/**
 *
 * @author Giezi
 */
public class Report extends javax.swing.JFrame {
    private GlobalModel csimodel;
    /**
     * Creates new form report
     * @param imagePanel
     */
    public Report(GlobalModel csimodel, jMRUIResultsMapListener mapListener) {
        
        this.csimodel = csimodel;
        this.mapListener = mapListener;
        initComponents();
        this.setVisible(true);
    }
    
    // Get selected button for the panel button group
    private int getSelectedButton(){
        int count = 0;
        for (Enumeration<AbstractButton> buttons = buttonGroupPanelSelection.getElements(); buttons.hasMoreElements();) {
            AbstractButton button = buttons.nextElement();

            if (button.isSelected()) {
                return count;
            }
            count ++;
        }
        return 99;
    }
    
    // Get selected Panel
    private JPanel getSelectedPanel()
    {
        switch(getSelectedButton()){
            case 0:
                return jPanelTL;
            case 1: 
                return jPanelTR;
            case 2: 
                return jPanelBL;
            default: 
                return null;
        }
    }
    
    // Change Window Size
    private void changeFrameSize()
    {
        Dimension dim = new Dimension();
        dim.height = (int)(m_selectedPageSize[m_selectedOrientation] * dpiRatio * (float)m_selectedRes) + 53;
        dim.width = (int)(m_selectedPageSize[1 - m_selectedOrientation] * dpiRatio * (float)m_selectedRes);
        this.setSize(dim);
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroupPanelSelection = new javax.swing.ButtonGroup();
        buttonGroupFormat = new javax.swing.ButtonGroup();
        buttonGroupRes = new javax.swing.ButtonGroup();
        buttonGroupOrientation = new javax.swing.ButtonGroup();
        jPanelOptions = new javax.swing.JPanel();
        jRadioButtonPanel1 = new javax.swing.JRadioButton();
        jRadioButtonPanel2 = new javax.swing.JRadioButton();
        jRadioButtonPanel3 = new javax.swing.JRadioButton();
        jButtonImage = new javax.swing.JButton();
        jButtonSpectr = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jButtonLocalization = new javax.swing.JButton();
        jButtonMetabolites = new javax.swing.JButton();
        jComboBoxFontBox = new javax.swing.JComboBox();
        jPanelContainer = new javax.swing.JPanel();
        jSplitPane2 = new javax.swing.JSplitPane();
        jPanelLeft = new javax.swing.JPanel();
        jSplitPane3 = new javax.swing.JSplitPane();
        jPanelTL = new javax.swing.JPanel();
        jPanelBL = new javax.swing.JPanel();
        jPanelRight = new javax.swing.JPanel();
        jSplitPane4 = new javax.swing.JSplitPane();
        jPanelTR = new javax.swing.JPanel();
        jPanelBR = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanelLocalizerContainer = new ReportLocalizerPanels();
        jPanel1 = new javax.swing.JPanel();
        jSplitPane5 = new javax.swing.JSplitPane();
        jPanelMetabolites = new ReportMetaboliteTable();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jMenuBar = new javax.swing.JMenuBar();
        jMenuFile = new javax.swing.JMenu();
        jMenuItemPNG = new javax.swing.JMenuItem();
        jMenuItemClear = new javax.swing.JMenuItem();
        jMenuItemDimension = new javax.swing.JMenuItem();
        jMenuOptions = new javax.swing.JMenu();
        jMenuFormat = new javax.swing.JMenu();
        jRadioButtonPageFormatA4 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonPageFormatA5 = new javax.swing.JRadioButtonMenuItem();
        jMenuRes = new javax.swing.JMenu();
        jRadioButtonRes30 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonRes60 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonRes90 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonRes110 = new javax.swing.JRadioButtonMenuItem();
        jMenuOrientation = new javax.swing.JMenu();
        jRadioButtonOrientationLandscape = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonOrientationPortrait = new javax.swing.JRadioButtonMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("SpectrIm - Report");

        jPanelOptions.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jPanelOptions.setMinimumSize(new java.awt.Dimension(800, 30));
        jPanelOptions.setPreferredSize(new java.awt.Dimension(800, 30));
        jPanelOptions.setLayout(new java.awt.GridLayout(1, 8));

        buttonGroupPanelSelection.add(jRadioButtonPanel1);
        jRadioButtonPanel1.setText("Panel Top Left");
        jRadioButtonPanel1.setFocusable(false);
        jRadioButtonPanel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jRadioButtonPanel1.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jRadioButtonPanel1.setSelected(true);
        jRadioButtonPanel1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonPanel1ActionPerformed(evt);
            }
        });
        jPanelOptions.add(jRadioButtonPanel1);

        buttonGroupPanelSelection.add(jRadioButtonPanel2);
        jRadioButtonPanel2.setText("Panel Top Right");
        jRadioButtonPanel2.setFocusable(false);
        jRadioButtonPanel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jRadioButtonPanel2.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanelOptions.add(jRadioButtonPanel2);

        buttonGroupPanelSelection.add(jRadioButtonPanel3);
        jRadioButtonPanel3.setText("Panel Bottom Left");
        jRadioButtonPanel3.setFocusable(false);
        jRadioButtonPanel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jRadioButtonPanel3.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanelOptions.add(jRadioButtonPanel3);

        jButtonImage.setText("Import Image");
        jButtonImage.setFocusable(false);
        jButtonImage.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonImage.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonImage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonImageActionPerformed(evt);
            }
        });
        jPanelOptions.add(jButtonImage);

        jButtonSpectr.setText("Import Spectra");
        jButtonSpectr.setFocusable(false);
        jButtonSpectr.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonSpectr.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonSpectr.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSpectrActionPerformed(evt);
            }
        });
        jPanelOptions.add(jButtonSpectr);

        jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);
        jSeparator1.setToolTipText("");
        jSeparator1.setMinimumSize(new java.awt.Dimension(1, 4));
        jSeparator1.setPreferredSize(new java.awt.Dimension(1, 4));
        jPanelOptions.add(jSeparator1);

        jButtonLocalization.setText("Import Localization");
        jButtonLocalization.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLocalizationActionPerformed(evt);
            }
        });
        jPanelOptions.add(jButtonLocalization);

        jButtonMetabolites.setText("Import Metabolites");
        jButtonMetabolites.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMetabolitesActionPerformed(evt);
            }
        });
        jPanelOptions.add(jButtonMetabolites);

        jComboBoxFontBox.setEditable(true);
        jComboBoxFontBox.setFont(new java.awt.Font("Ubuntu", 0, 15)); // NOI18N
        jComboBoxFontBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "10", "12", "14","16","18", "20" }));
        jComboBoxFontBox.setMaximumSize(new java.awt.Dimension(10, 10));
        jComboBoxFontBox.setMinimumSize(new java.awt.Dimension(0, 0));
        jComboBoxFontBox.setPreferredSize(new java.awt.Dimension(10, 10));
        jComboBoxFontBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxFontBoxActionPerformed(evt);
            }
        });
        jPanelOptions.add(jComboBoxFontBox);
        jComboBoxFontBox.setSelectedItem(14);

        getContentPane().add(jPanelOptions, java.awt.BorderLayout.PAGE_END);

        jPanelContainer.setPreferredSize(new java.awt.Dimension(800, 800));
        jPanelContainer.setLayout(new java.awt.BorderLayout());

        jPanelLeft.setMinimumSize(new java.awt.Dimension(100, 6));
        jPanelLeft.setLayout(new java.awt.BorderLayout());

        jSplitPane3.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanelTL.setBackground(new java.awt.Color(1, 1, 1));
        jPanelTL.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(165, 160, 160)));
        jPanelTL.setPreferredSize(new java.awt.Dimension(400, 400));
        jPanelTL.setLayout(new java.awt.GridLayout(1, 0));
        jSplitPane3.setTopComponent(jPanelTL);

        jPanelBL.setBackground(new java.awt.Color(1, 1, 1));
        jPanelBL.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(165, 160, 160)));
        jPanelBL.setPreferredSize(new java.awt.Dimension(400, 400));
        jPanelBL.setLayout(new java.awt.GridLayout(1, 0));
        jSplitPane3.setBottomComponent(jPanelBL);

        jPanelLeft.add(jSplitPane3, java.awt.BorderLayout.CENTER);

        jSplitPane2.setLeftComponent(jPanelLeft);

        jPanelRight.setLayout(new java.awt.BorderLayout());

        jSplitPane4.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanelTR.setBackground(new java.awt.Color(1, 1, 1));
        jPanelTR.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(165, 160, 160)));
        jPanelTR.setPreferredSize(new java.awt.Dimension(400, 400));
        jPanelTR.setLayout(new java.awt.GridLayout(1, 0));
        jSplitPane4.setTopComponent(jPanelTR);

        jPanelBR.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(165, 160, 160)));
        jPanelBR.setPreferredSize(new java.awt.Dimension(400, 400));
        jPanelBR.setLayout(new java.awt.BorderLayout());

        jSplitPane1.setMinimumSize(new java.awt.Dimension(0, 0));

        jPanelLocalizerContainer.setBackground(new java.awt.Color(1, 1, 1));
        jPanelLocalizerContainer.setMinimumSize(new java.awt.Dimension(50, 200));
        jPanelLocalizerContainer.setPreferredSize(new java.awt.Dimension(400, 50));
        jPanelLocalizerContainer.setLayout(new java.awt.GridLayout(3, 1));
        jSplitPane1.setLeftComponent(jPanelLocalizerContainer);

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));

        jSplitPane5.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanelMetabolites.setMinimumSize(new java.awt.Dimension(60, 76));
        jPanelMetabolites.setLayout(new java.awt.GridLayout(2, 1));
        jSplitPane5.setTopComponent(jPanelMetabolites);

        jScrollPane1.setMinimumSize(new java.awt.Dimension(400, 200));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(400, 400));

        jTextPane1.setFont(new java.awt.Font("Ubuntu", 0, 14)); // NOI18N
        jTextPane1.setMinimumSize(new java.awt.Dimension(0, 200));
        jTextPane1.setPreferredSize(new java.awt.Dimension(200, 200));
        jScrollPane1.setViewportView(jTextPane1);

        jSplitPane5.setBottomComponent(jScrollPane1);

        jPanel1.add(jSplitPane5);

        jSplitPane1.setRightComponent(jPanel1);

        jPanelBR.add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jSplitPane4.setBottomComponent(jPanelBR);

        jPanelRight.add(jSplitPane4, java.awt.BorderLayout.CENTER);

        jSplitPane2.setRightComponent(jPanelRight);

        jPanelContainer.add(jSplitPane2, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanelContainer, java.awt.BorderLayout.CENTER);

        jMenuBar.setPreferredSize(new java.awt.Dimension(800, 23));

        jMenuFile.setText("File");

        jMenuItemPNG.setText("Generate png...");
        jMenuItemPNG.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemPNGActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemPNG);

        jMenuItemClear.setText("Clear All");
        jMenuItemClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClearActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemClear);

        jMenuItemDimension.setText("Restore Dimensions");
        jMenuItemDimension.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemDimensionActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemDimension);

        jMenuBar.add(jMenuFile);

        jMenuOptions.setText("Options");
        jMenuOptions.setToolTipText("");

        jMenuFormat.setText("Page Format...");

        buttonGroupFormat.add(jRadioButtonPageFormatA4);
        jRadioButtonPageFormatA4.setSelected(true);
        jRadioButtonPageFormatA4.setText("A4");
        jRadioButtonPageFormatA4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonPageFormatA4ActionPerformed(evt);
            }
        });
        jMenuFormat.add(jRadioButtonPageFormatA4);

        buttonGroupFormat.add(jRadioButtonPageFormatA5);
        jRadioButtonPageFormatA5.setText("A5");
        jRadioButtonPageFormatA5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonPageFormatA5ActionPerformed(evt);
            }
        });
        jMenuFormat.add(jRadioButtonPageFormatA5);

        jMenuOptions.add(jMenuFormat);

        jMenuRes.setText("Resolution...");

        buttonGroupRes.add(jRadioButtonRes30);
        jRadioButtonRes30.setText("30 dpi");
        jRadioButtonRes30.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonRes30ActionPerformed(evt);
            }
        });
        jMenuRes.add(jRadioButtonRes30);

        buttonGroupRes.add(jRadioButtonRes60);
        jRadioButtonRes60.setText("60 dpi");
        jRadioButtonRes60.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonRes60ActionPerformed(evt);
            }
        });
        jMenuRes.add(jRadioButtonRes60);

        buttonGroupRes.add(jRadioButtonRes90);
        jRadioButtonRes90.setText("90 dpi");
        jRadioButtonRes90.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonRes90ActionPerformed(evt);
            }
        });
        jMenuRes.add(jRadioButtonRes90);

        buttonGroupRes.add(jRadioButtonRes110);
        jRadioButtonRes110.setSelected(true);
        jRadioButtonRes110.setText("110 dpi");
        jRadioButtonRes110.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonRes110ActionPerformed(evt);
            }
        });
        jMenuRes.add(jRadioButtonRes110);

        jMenuOptions.add(jMenuRes);

        jMenuOrientation.setText("Orientation...");

        buttonGroupOrientation.add(jRadioButtonOrientationLandscape);
        jRadioButtonOrientationLandscape.setSelected(true);
        jRadioButtonOrientationLandscape.setText("Landscape");
        jRadioButtonOrientationLandscape.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonOrientationLandscapeActionPerformed(evt);
            }
        });
        jMenuOrientation.add(jRadioButtonOrientationLandscape);

        buttonGroupOrientation.add(jRadioButtonOrientationPortrait);
        jRadioButtonOrientationPortrait.setText("Portrait");
        jRadioButtonOrientationPortrait.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonOrientationPortraitActionPerformed(evt);
            }
        });
        jMenuOrientation.add(jRadioButtonOrientationPortrait);

        jMenuOptions.add(jMenuOrientation);

        jMenuBar.add(jMenuOptions);

        setJMenuBar(jMenuBar);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonImageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonImageActionPerformed
        getSelectedPanel().removeAll();
        ReportOverviewPanel rprtOverview = new ReportOverviewPanel();
        getSelectedPanel().add(rprtOverview);
        rprtOverview.displayOverview(false, csimodel);
        revalidate();
        repaint();
        rprtOverview.resetZoom();
    }//GEN-LAST:event_jButtonImageActionPerformed

    private void jButtonSpectrActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSpectrActionPerformed
        getSelectedPanel().removeAll();
        ReportSpectraPanel spcrtpnl = new ReportSpectraPanel();
        getSelectedPanel().add(spcrtpnl);
        spcrtpnl.initPanel(csimodel);
        revalidate();
        repaint();
    }//GEN-LAST:event_jButtonSpectrActionPerformed

    private void jButtonLocalizationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLocalizationActionPerformed
        ((ReportLocalizerPanels)jPanelLocalizerContainer).initPanels(csimodel);
        repaint();
    }//GEN-LAST:event_jButtonLocalizationActionPerformed

    private void jMenuItemClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClearActionPerformed
        jPanelTL.removeAll();
        jPanelTR.removeAll();
        jPanelBL.removeAll();
        jPanelLocalizerContainer.removeAll();
    }//GEN-LAST:event_jMenuItemClearActionPerformed

    private void jMenuItemDimensionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemDimensionActionPerformed
        changeFrameSize();
    }//GEN-LAST:event_jMenuItemDimensionActionPerformed

    // Save Panel to PNG
    private void jMenuItemPNGActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemPNGActionPerformed
    JFileChooser jFileChooserSaveJpg = new JFileChooser();
    jFileChooserSaveJpg.setSelectedFile(new File("newReport.png"));
    FileNameExtensionFilter filter = new FileNameExtensionFilter("PNG FILES", "png", "png");
    jFileChooserSaveJpg.setFileFilter(filter);
    int returnVal = jFileChooserSaveJpg.showSaveDialog(this);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
        File imageToSave = jFileChooserSaveJpg.getSelectedFile();
        BufferedImage bi = new BufferedImage(jPanelContainer.getWidth(), jPanelContainer.getHeight(), BufferedImage.TYPE_INT_RGB);
        Graphics g = bi.createGraphics();
        jPanelContainer.print(g);
        g.dispose();
        try {
            ImageIO.write(bi, "PNG", imageToSave);
        } catch (IOException ex) {
            Logger.getLogger(Report.class.getName()).log(Level.SEVERE, null, ex);
        }
    } else {
        //log.append("Open command cancelled by user." + newline);
    }
    }//GEN-LAST:event_jMenuItemPNGActionPerformed

    private void jComboBoxFontBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxFontBoxActionPerformed
        try{
            int newFontSize = Integer.parseInt(jComboBoxFontBox.getSelectedItem().toString());
            StyleConstants.setFontSize(jTextPane1.getInputAttributes(), newFontSize);
            StyledDocument doc = jTextPane1.getStyledDocument();
            doc.setCharacterAttributes(0, doc.getLength() + 1, jTextPane1.getInputAttributes(), false);
        } catch (NumberFormatException ex){}
    }//GEN-LAST:event_jComboBoxFontBoxActionPerformed

    private void jRadioButtonPageFormatA4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonPageFormatA4ActionPerformed
        m_selectedPageSize = pageSizes[0];
        changeFrameSize();
    }//GEN-LAST:event_jRadioButtonPageFormatA4ActionPerformed

    private void jRadioButtonPageFormatA5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonPageFormatA5ActionPerformed
        m_selectedPageSize = pageSizes[1];
        changeFrameSize();
    }//GEN-LAST:event_jRadioButtonPageFormatA5ActionPerformed

    private void jRadioButtonRes30ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonRes30ActionPerformed
        m_selectedRes = res[0];
        changeFrameSize();
    }//GEN-LAST:event_jRadioButtonRes30ActionPerformed

    private void jRadioButtonRes60ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonRes60ActionPerformed
        m_selectedRes = res[1];
        changeFrameSize();
    }//GEN-LAST:event_jRadioButtonRes60ActionPerformed

    private void jRadioButtonRes90ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonRes90ActionPerformed
        m_selectedRes = res[2];
        changeFrameSize();
    }//GEN-LAST:event_jRadioButtonRes90ActionPerformed

    private void jRadioButtonRes110ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonRes110ActionPerformed
        m_selectedRes = res[3];
        changeFrameSize();
    }//GEN-LAST:event_jRadioButtonRes110ActionPerformed

    private void jRadioButtonOrientationLandscapeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonOrientationLandscapeActionPerformed
        m_selectedOrientation = 0;
        changeFrameSize();
    }//GEN-LAST:event_jRadioButtonOrientationLandscapeActionPerformed

    private void jRadioButtonOrientationPortraitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonOrientationPortraitActionPerformed
        m_selectedOrientation = 1;
        changeFrameSize();
    }//GEN-LAST:event_jRadioButtonOrientationPortraitActionPerformed

    private void jButtonMetabolitesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMetabolitesActionPerformed
        ((ReportMetaboliteTable)jPanelMetabolites).fillTable(mapListener, csimodel);
    }//GEN-LAST:event_jButtonMetabolitesActionPerformed

    private void jRadioButtonPanel1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonPanel1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jRadioButtonPanel1ActionPerformed

   
    
    private jMRUIResultsMapListener mapListener;
    
    private final static float [][] pageSizes = {{21f,29.7f},{14.8f,21f}};
    private float [] m_selectedPageSize = pageSizes[0];
    private final static int [] res = {30,60,90, 110};
    private int m_selectedRes = 110;
    private final static float dpiRatio = .393701f;
    private int m_selectedOrientation = 0; // 0: Landscape, 1: Portrait
    //1 dpi = 0.393701 pixel/cm

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroupFormat;
    private javax.swing.ButtonGroup buttonGroupOrientation;
    private javax.swing.ButtonGroup buttonGroupPanelSelection;
    private javax.swing.ButtonGroup buttonGroupRes;
    private javax.swing.JButton jButtonImage;
    private javax.swing.JButton jButtonLocalization;
    private javax.swing.JButton jButtonMetabolites;
    private javax.swing.JButton jButtonSpectr;
    private javax.swing.JComboBox jComboBoxFontBox;
    private javax.swing.JMenuBar jMenuBar;
    private javax.swing.JMenu jMenuFile;
    private javax.swing.JMenu jMenuFormat;
    private javax.swing.JMenuItem jMenuItemClear;
    private javax.swing.JMenuItem jMenuItemDimension;
    private javax.swing.JMenuItem jMenuItemPNG;
    private javax.swing.JMenu jMenuOptions;
    private javax.swing.JMenu jMenuOrientation;
    private javax.swing.JMenu jMenuRes;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanelBL;
    private javax.swing.JPanel jPanelBR;
    private javax.swing.JPanel jPanelContainer;
    private javax.swing.JPanel jPanelLeft;
    private javax.swing.JPanel jPanelLocalizerContainer;
    private javax.swing.JPanel jPanelMetabolites;
    private javax.swing.JPanel jPanelOptions;
    private javax.swing.JPanel jPanelRight;
    private javax.swing.JPanel jPanelTL;
    private javax.swing.JPanel jPanelTR;
    private javax.swing.JRadioButtonMenuItem jRadioButtonOrientationLandscape;
    private javax.swing.JRadioButtonMenuItem jRadioButtonOrientationPortrait;
    private javax.swing.JRadioButtonMenuItem jRadioButtonPageFormatA4;
    private javax.swing.JRadioButtonMenuItem jRadioButtonPageFormatA5;
    private javax.swing.JRadioButton jRadioButtonPanel1;
    private javax.swing.JRadioButton jRadioButtonPanel2;
    private javax.swing.JRadioButton jRadioButtonPanel3;
    private javax.swing.JRadioButtonMenuItem jRadioButtonRes110;
    private javax.swing.JRadioButtonMenuItem jRadioButtonRes30;
    private javax.swing.JRadioButtonMenuItem jRadioButtonRes60;
    private javax.swing.JRadioButtonMenuItem jRadioButtonRes90;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JSplitPane jSplitPane3;
    private javax.swing.JSplitPane jSplitPane4;
    private javax.swing.JSplitPane jSplitPane5;
    private javax.swing.JTextPane jTextPane1;
    // End of variables declaration//GEN-END:variables
}
