/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.report;

import java.awt.Color;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import org.spectrim.model.GlobalModel;
import org.spectrim.popups.jMRUIResultsMapListener;
import org.spectrim.view.ImageViewerPanel;

/**
 *
 * @author Giezi
 */
public class ReportMetaboliteMapPanel extends ImageViewerPanel {

    public ReportMetaboliteMapPanel() {
        super();
    }
    
    public void displayMap(String metabName, GlobalModel csimodelIn, jMRUIResultsMapListener mapListener)
    {
        int metabIndex = getMetaboliteIndex(metabName,mapListener);
        
        if(metabIndex != 289)
        {
            ImageViewerPanel oldPnl = csimodelIn.getImageViewer();
            csimodelIn.setImageViewer(this);
            mapListener.setColorMapfromjMRUIResults(metabIndex, 0, false,"report-"+metabName);
            GlobalModel csimodel = new GlobalModel(csimodelIn);
            autoWindowing();
            setModel(csimodel);
            csimodel.setGridTransparency(0.0f);
            resetZoom();
            focusOnExcitedVoxels();
            getModel().clearVoxelSelection();
            setMouseSelectionActive(false);
            csimodelIn.setImageViewer(oldPnl);
        }else
        {
            JLabel label1 = new JLabel("<html><h1>Not Found!</h1></html>",SwingConstants.CENTER);
            label1.setBounds(this.getWidth()/2 - 200, this.getHeight()/2 - 10, 400, 100);
            label1.setForeground(Color.red);
            this.add(label1);
        }
        
        
        JLabel label1 = new JLabel("<html><h1>"+metabName+"</h1></html>",SwingConstants.CENTER);
        label1.setVerticalAlignment(SwingConstants.CENTER);
        label1.setBounds(this.getWidth()/2 - 200, 20, 400, 100);
        label1.setForeground(Color.red);
        this.add(label1);
    }
    
    private int getMetaboliteIndex(String metabName, jMRUIResultsMapListener mapListener)
    {
        String[] names = mapListener.getMetabolitesNames();
        int index = 289;
        for(int i = 0; i < names.length; i++)
        {
            if(names[i].toUpperCase().contains(metabName.toUpperCase()))
                index = i;          
        }
        return index;
    }
    
}
