/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.report;

import java.awt.Color;
import java.awt.Component;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Vector;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.border.BevelBorder;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import org.spectrim.model.GlobalModel;
import org.spectrim.popups.jMRUIResultsMapListener;

/**
 *
 * @author Giezi
 */
public class ReportMetaboliteTable extends javax.swing.JPanel {

    /**
     * Creates new form metaboliteTable
     */
    public ReportMetaboliteTable() {
        initComponents();
    }
    
    public void fillTable(jMRUIResultsMapListener mapListener, GlobalModel csimodelIn)
    {
        GlobalModel csimodel = new GlobalModel(csimodelIn);
        // fill the tables with metabolites values
        LinkedHashMap<String,Double> blueMap = null;
        LinkedHashMap<String,Double> blueMapStd = null;
        LinkedHashMap<String,Double> redMap = null;
        LinkedHashMap<String,Double> redMapStd = null;
        
        LinkedHashMap<String,Double> refMap = null;
        
        if(csimodel.getSelectedVoxels(GlobalModel.SelectionGroup.BLUE).size() > 0)
        {
            blueMap = mapListener.getMetabolitesPerSelection(csimodel.getSelectedVoxels(GlobalModel.SelectionGroup.BLUE));
            blueMapStd = mapListener.getMetabolitesPerSelection(csimodel.getSelectedVoxels(GlobalModel.SelectionGroup.BLUE),true);
            refMap = blueMap;
        }
        if(csimodel.getSelectedVoxels(GlobalModel.SelectionGroup.RED).size() > 0)
        {
            redMap = mapListener.getMetabolitesPerSelection(csimodel.getSelectedVoxels(GlobalModel.SelectionGroup.RED));
            redMapStd = mapListener.getMetabolitesPerSelection(csimodel.getSelectedVoxels(GlobalModel.SelectionGroup.RED),true);
            refMap = redMap;
        }
        
        double ChoCrRatioBlue = 1.0, CoNAARatioBlue = 1.0,MLRatioBlue = 1.0;
        double ChoCrRatioRed = 1.0, CoNAARatioRed = 1.0,MLRatioRed = 1.0;
        boolean Cho = false, Cr = false, NAA = false, ML13 = false, ML9 = false;
        DefaultTableModel defaultModel = (DefaultTableModel) jTableMetabolite1.getModel();
                
        if(refMap != null)
        {
            for (String metabName: refMap.keySet()) {
                Vector newRow = new Vector();  
                newRow.add(metabName);
                try{
                    newRow.add(Math.round(blueMap.get(metabName) * 10.0) / 10.0+" ± "+Math.round(blueMapStd.get(metabName) * 10.0) / 10.0);
                } catch(Exception e){newRow.add("");}
                try{
                    newRow.add(Math.round(redMap.get(metabName) * 10.0) / 10.0+" ± "+ Math.round(redMapStd.get(metabName) * 10.0) / 10.0);
                } catch(Exception e){}
                
                defaultModel.addRow(newRow); 
                if(metabName.toUpperCase().contains("CHO"))
                {
                    try{
                        ChoCrRatioBlue *= blueMap.get(metabName);
                        CoNAARatioBlue *= blueMap.get(metabName);
                    } catch(Exception e){}
                    try{
                        ChoCrRatioRed *= redMap.get(metabName);
                        CoNAARatioRed *= redMap.get(metabName);
                    } catch(Exception e){}
                    Cho = true;
                }
                if(metabName.toUpperCase().contains("CR"))
                {
                    try{
                        if(blueMap.get(metabName) > 0.0)
                            ChoCrRatioBlue /= blueMap.get(metabName);
                        else ChoCrRatioBlue = Double.NaN;
                    } catch(Exception e){}
                    try{
                        if(redMap.get(metabName) > 0.0)
                            ChoCrRatioRed /= redMap.get(metabName);
                        else ChoCrRatioRed = Double.NaN;
                    } catch(Exception e){}
                    Cr = true;
                }
                if(metabName.toUpperCase().contains("NAA"))
                {
                    try{
                        if(blueMap.get(metabName) > 0.0)
                            CoNAARatioBlue /= blueMap.get(metabName);
                        else CoNAARatioBlue = Double.NaN;
                    } catch(Exception e){}
                    try{
                        if(redMap.get(metabName) > 0.0)
                            CoNAARatioRed /= redMap.get(metabName);
                        else CoNAARatioRed = Double.NaN;
                    } catch(Exception e){}
                    NAA = true;
                }
                if(metabName.toUpperCase().contains("1.3"))
                {
                    try{
                        MLRatioBlue *= blueMap.get(metabName);
                    } catch(Exception e){}
                    try{
                        MLRatioRed *= redMap.get(metabName);
                    } catch(Exception e){}
                    ML13 = true;
                }
                if(metabName.toUpperCase().contains("0.9"))
                {
                    try{
                        if(blueMap.get(metabName) > 0.0)
                            MLRatioBlue /= blueMap.get(metabName);
                        else MLRatioBlue = Double.NaN;
                    } catch(Exception e){}
                    try{
                        if(redMap.get(metabName) > 0.0)
                            MLRatioRed /= redMap.get(metabName);  
                        else MLRatioRed = Double.NaN;
                    } catch(Exception e){}
                    ML9 = true;
                }
            }

            if(Cho)
            {
                if(Cr)
                {
                    Vector newRow = new Vector();  
                    newRow.add("Cho/Cr - Ratio");
                    newRow.add(Math.round(ChoCrRatioBlue * 100.0) / 100.0);
                    newRow.add(Math.round(ChoCrRatioRed * 100.0) / 100.0);
                    defaultModel.addRow(newRow); 
                }
                if(NAA)
                {
                    Vector newRow = new Vector();  
                    newRow.add("Cho/NAA - Ratio");
                    newRow.add(Math.round(CoNAARatioBlue * 100.0) / 100.0);
                    newRow.add(Math.round(CoNAARatioRed * 100.0) / 100.0);
                    defaultModel.addRow(newRow); 
                }
            }

            if(ML13 && ML9)
            {
                Vector newRow = new Vector();  
                newRow.add("ML - Ratio");
                newRow.add(Math.round(MLRatioBlue * 100.0) / 100.0);
                newRow.add(Math.round(MLRatioRed * 100.0) / 100.0);
                defaultModel.addRow(newRow); 
            }
            if(csimodel.getSelectedVoxels(GlobalModel.SelectionGroup.BLUE).isEmpty())
            {
                jTableMetabolite1.removeColumn(jTableMetabolite1.getColumnModel().getColumn(1));
            }
            else if(csimodel.getSelectedVoxels(GlobalModel.SelectionGroup.RED).isEmpty())
            {
                jTableMetabolite1.removeColumn(jTableMetabolite1.getColumnModel().getColumn(2));
            }
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanelTables = new javax.swing.JPanel();
        jScrollPaneTableMetabolite1 = new javax.swing.JScrollPane();
        jTableMetabolite1 = new javax.swing.JTable();

        jPanelTables.setBackground(new java.awt.Color(0, 0, 0));
        jPanelTables.setPreferredSize(new java.awt.Dimension(500, 334));
        jPanelTables.setLayout(new java.awt.GridLayout(0, 1));

        jScrollPaneTableMetabolite1.setBackground(new java.awt.Color(0, 0, 0));

        jTableMetabolite1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Metabolite", "Amplitude", "Amplitude"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jTableMetabolite1.setRowSelectionAllowed(false);
        jScrollPaneTableMetabolite1.setViewportView(jTableMetabolite1);
        jTableMetabolite1.getTableHeader().setDefaultRenderer(new defaultHeaderRenderer());
        jTableMetabolite1.getColumnModel().getColumn(1).setHeaderRenderer(new metabHeaderRendererBlue());
        jTableMetabolite1.getColumnModel().getColumn(2).setHeaderRenderer(new metabHeaderRendererRed());
        //jTableMetabolite1.setBackground(Color.black);

        jPanelTables.add(jScrollPaneTableMetabolite1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 500, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addGap(0, 0, Short.MAX_VALUE)
                    .addComponent(jPanelTables, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, Short.MAX_VALUE)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 334, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addGap(0, 0, Short.MAX_VALUE)
                    .addComponent(jPanelTables, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, Short.MAX_VALUE)))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanelTables;
    private javax.swing.JScrollPane jScrollPaneTableMetabolite1;
    private javax.swing.JTable jTableMetabolite1;
    // End of variables declaration//GEN-END:variables
}

class metabHeaderRendererRed extends JLabel implements TableCellRenderer {
    
    public metabHeaderRendererRed() {
        //setFont(this.getFont().deriveFont(Font.BOLD));
        //setBackground(Color.white);
        //setBorder(UIManager.getBorder("TableHeader.cellBorder"));
        setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED, Color.white, Color.gray));
        setForeground(Color.red);
    }
    
    @Override
    public Component getTableCellRendererComponent(JTable jtable, Object o, boolean bln, boolean bln1, int i, int i1) {
        setText(o.toString());
        return this;
    }
}

class metabHeaderRendererBlue extends JLabel implements TableCellRenderer {
    
    public metabHeaderRendererBlue() {
        //setFont(this.getFont().deriveFont(Font.BOLD));
        //setBackground(Color.white);
        //setBorder(UIManager.getBorder("TableHeader.cellBorder"));
        setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED, Color.white, Color.gray));
        setForeground(Color.blue);
    }
    
    @Override
    public Component getTableCellRendererComponent(JTable jtable, Object o, boolean bln, boolean bln1, int i, int i1) {
        setText(o.toString());
        return this;
    }
}

class defaultHeaderRenderer extends JLabel implements TableCellRenderer {
    
    public defaultHeaderRenderer() {
        //setFont(this.getFont().deriveFont(Font.BOLD));
        setBackground(Color.white);
        setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED, Color.white, Color.gray));
        setForeground(Color.black);
    }
    
    @Override
    public Component getTableCellRendererComponent(JTable jtable, Object o, boolean bln, boolean bln1, int i, int i1) {
        setText(o.toString());
        return this;
    }
}
