/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.report;

import java.awt.Color;
import javax.swing.JLabel;
import org.spectrim.model.GlobalModel;
import org.spectrim.popups.jMRUIResultsMapListener;
import org.spectrim.view.ImageViewerPanel;

/**
 * Class that handles the creation of a standard report.
 * 
 * @author Giezi, JSlotboom
 */
public class StdReportComparisonControlPanel extends javax.swing.JPanel 
{
    
    private GlobalModel csimodel;
    private jMRUIResultsMapListener parent;
    private boolean showSpectraSeparatly = true;
    private ReportSpectraPanel scdSpktrPnl;
    
    /**
     * Creates new form stdReportComparisonControlPanel
     */
    public StdReportComparisonControlPanel( GlobalModel csimodel, 
                                            jMRUIResultsMapListener parent, 
                                            boolean showSpectraSeparatly ) 
    {
        initComponents( );
        this.showSpectraSeparatly = showSpectraSeparatly;
        this.csimodel = csimodel;
        this.parent = parent;
        this.setVisible( true );
        this.jPanelTop.setSize( 1000,500 );
        this.jPanelBottom.setSize( 1000,500 );
        this.jPanelTL.setSize( 1000, 500 );
        //this.jPanelTR.setSize(500, 500);
        this.jPanelBL.setSize( 500, 500 );
        this.jPanelBR.setSize( 500, 500 );
        this.jPanelLocalizer.setSize( 500, this.jPanelBottom.getHeight( ) / 3 );
        if( showSpectraSeparatly )
        {
            addSpectraPanel( );
        }
        initPanels( );
    }
    
    private void addSpectraPanel( )
    {
        scdSpktrPnl = new ReportSpectraPanel( );
        jPanelTL.setSize( 500,500 );
        jPanelTop.add( scdSpktrPnl );
    }
    
    private void initPanels( )
    {   
        // Load CSI model from spektrim and display it
        ( ( ReportOverviewPanel )jPanelBL).displayOverview( false, csimodel );
        
        ( ( ReportMetaboliteTable )jPanelTables ).fillTable( parent,csimodel );
        
        // Display spectral pane --- Note: layout has to be set to flowlayout in display manager
        ( ( ReportSpectraPanel )jPanelTL ).initPanel( csimodel );
        
        // If the option to show both spectra separatly is active, add second panel
        if( showSpectraSeparatly )
        {
            scdSpktrPnl.initPanel( csimodel );
            scdSpktrPnl.adjustZooming( (ReportSpectraPanel)jPanelTL, ReportSpectraPanel.KEEPRED );
            ( (ReportSpectraPanel)jPanelTL ).adjustZooming( scdSpktrPnl, ReportSpectraPanel.KEEPBLUE );
        }
        
        // add the localizers and link them to the current pannel
        ( (ReportLocalizerPanels)jPanelLocalizer ).initPanels( csimodel );
        
        // add label for academic use only
        JLabel label = new JLabel( );
        label.setText( "For Academic Use Only" );
        label.setBounds( 0, ( (ImageViewerPanel)jPanelBL ).getHeight( ) - 60, 400, 100 );
        label.setForeground( Color.red );
        ( (ImageViewerPanel)jPanelBL ).add( label );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanelTop = new javax.swing.JPanel();
        jPanelTL = new ReportSpectraPanel();
        jPanelBottom = new javax.swing.JPanel();
        jPanelBL = new org.spectrim.report.ReportOverviewPanel();
        jPanelBR = new javax.swing.JPanel();
        jPanelTables = new org.spectrim.report.ReportMetaboliteTable();
        jPanelLocalizer = new ReportLocalizerPanels();

        jPanelTop.setPreferredSize(new java.awt.Dimension(1000, 500));
        jPanelTop.setLayout(new java.awt.GridLayout(1, 0));

        jPanelTL.setBackground(new java.awt.Color(0, 0, 250));
        jPanelTL.setMinimumSize(new java.awt.Dimension(500, 500));
        jPanelTL.setPreferredSize(new java.awt.Dimension(500, 500));
        jPanelTop.add(jPanelTL);

        jPanelBottom.setLayout(new java.awt.GridLayout(1, 0));

        jPanelBL.setBackground(new java.awt.Color(0, 0, 0));
        jPanelBL.setMinimumSize(new java.awt.Dimension(500, 500));

        javax.swing.GroupLayout jPanelBLLayout = new javax.swing.GroupLayout(jPanelBL);
        jPanelBL.setLayout(jPanelBLLayout);
        jPanelBLLayout.setHorizontalGroup(
            jPanelBLLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 500, Short.MAX_VALUE)
        );
        jPanelBLLayout.setVerticalGroup(
            jPanelBLLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 500, Short.MAX_VALUE)
        );

        jPanelBottom.add(jPanelBL);

        jPanelBR.setBackground(new java.awt.Color(0, 0, 0));
        jPanelBR.setMinimumSize(new java.awt.Dimension(500, 500));
        jPanelBR.setLayout(new java.awt.BorderLayout());

        jPanelTables.setBackground(new java.awt.Color(0, 0, 0));
        jPanelTables.setPreferredSize(new java.awt.Dimension(500, 334));
        jPanelTables.setLayout(new java.awt.GridLayout(0, 1));
        jPanelBR.add(jPanelTables, java.awt.BorderLayout.PAGE_START);

        jPanelLocalizer.setBackground(new java.awt.Color(0, 0, 0));
        jPanelLocalizer.setPreferredSize(new java.awt.Dimension(500, 166));
        jPanelLocalizer.setLayout(new java.awt.GridLayout(1, 3));
        jPanelBR.add(jPanelLocalizer, java.awt.BorderLayout.PAGE_END);

        jPanelBottom.add(jPanelBR);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1000, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addGap(0, 0, Short.MAX_VALUE)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jPanelTop, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jPanelBottom, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGap(0, 0, Short.MAX_VALUE)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1000, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addGap(0, 0, Short.MAX_VALUE)
                    .addComponent(jPanelTop, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, 0)
                    .addComponent(jPanelBottom, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, Short.MAX_VALUE)))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanelBL;
    private javax.swing.JPanel jPanelBR;
    private javax.swing.JPanel jPanelBottom;
    private javax.swing.JPanel jPanelLocalizer;
    private javax.swing.JPanel jPanelTL;
    private javax.swing.JPanel jPanelTables;
    private javax.swing.JPanel jPanelTop;
    // End of variables declaration//GEN-END:variables
}
