/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.tdfdfit;

/**
 * 
 * Class handling what should be done with TDFDFit data which are produced 
 * during fitting.
 * 
 * @author johan
 */
public class TDFDFitOutputFilesHandlingPanel extends javax.swing.JPanel 
{ 
    /**
     * Creates new form TDFDFitOutputFilesHandlingPanel
     */
    public TDFDFitOutputFilesHandlingPanel( ) 
    {
        initComponents( );
        
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        
        String dBasePath= tdfdFitDefaults.getProperty( TDFDFittingDefaults.PATIENT_DATABASE_ROOT_PATH );
        this.m_currentPatientDirectoryValueLabel.setText( dBasePath );
        
        m_deleteDotParFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_PAR );
        if ( m_deleteDotParFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        else
        {
            if ( m_deleteDotParFile.compareTo( "yes" ) == 0 )
            {
                this.m_deleteDotParFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteVerboseDotParFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_VERBOSE_PAR );
        if ( m_deleteVerboseDotParFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        else
        {
            if ( m_deleteVerboseDotParFile.compareTo( "yes" ) == 0 )
            {
                this.m_deleteVerboseParFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteDotParFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_PAR );
        if ( m_deleteDotParFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        else
        {
            if ( m_deleteDotParFile.compareTo( "yes" ) == 0 )
            {
                this.m_deleteDotParFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN );
        if ( m_deleteBinFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        else
        {
            if ( m_deleteBinFile.compareTo( "yes" ) == 0 )
            {
                this.m_deleteDotBinFileCheckBox.setSelected( true );
            }
        }
    
        m_deleteBinFitFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT );
        if ( m_deleteBinFitFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT, "no" );
        }
        else
        {
            if ( m_deleteBinFitFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotFitFileCheckBox.setSelected( true );
            }
        }
        
        
        m_deleteBinFit0File = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT0 );
        if ( m_deleteBinFit0File == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "no" );
        }
        else
        {
            if ( m_deleteBinFit0File.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotFit0FileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinOrgFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ORG );
        if ( m_deleteBinOrgFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ORG, "no" );
        }
        else
        {
            if ( m_deleteBinOrgFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotOrgFileCheckBox.setSelected( true );
            }
        }
        
        
        m_deleteBinFitresFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FITRES );
        if ( m_deleteBinFitresFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "no" );
        }
        else
        {
            if ( m_deleteBinFitresFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotFitResFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinResFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_RES );
        if ( m_deleteBinResFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_RES, "no" );
        }
        else
        {
            if ( m_deleteBinResFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotResFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinCororgFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_CORORG );
        if ( m_deleteBinCororgFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "no" );
        }
        else
        {
            if ( m_deleteBinCororgFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotCorOrgFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinExlFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_EXL );
        if ( m_deleteBinExlFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_EXL, "no" );
        }
        else
        {
            if ( m_deleteBinExlFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotExlFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinNLN0File = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_NLN0 );
        if ( m_deleteBinNLN0File == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "no" );
        }
        else
        {
            if ( m_deleteBinNLN0File.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotnln0FileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinMatFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_MAT );
        if ( m_deleteBinMatFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_MAT, "no" );
        }
        else
        {
            if ( m_deleteBinMatFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotMatFileCheckBox.setSelected( true );
            }
        }
        
        m_deleteBinErrFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ERR );
        if ( m_deleteBinErrFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ERR, "no" );
        }
        else
        {
            if ( m_deleteBinErrFile.compareTo( "yes" ) == 0 )
            {
                m_deleteDotBinDotErrFileCheckBox.setSelected( true );
            }
        }
       
        
        // ==================================================================
        // Single file storage handling
        // ==================================================================


        m_store2OneBinFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN );
        if ( m_store2OneBinFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        else
        {
            if ( m_store2OneBinFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinFileCheckBox2.setSelected( true );
            }
        }

        m_store2OneBinFitFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT );
        if ( m_store2OneBinFitFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT, "no" );
        }
        else
        {
            if ( m_store2OneBinFitFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotFitFileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinFit0File = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT0 );
        if ( m_store2OneBinFit0File == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "no" );
        }
        else
        {
            if ( m_store2OneBinFit0File.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotFit0FileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinOrgFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ORG );
        if ( m_store2OneBinOrgFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ORG, "no" );
        }
        else
        {
            if ( m_store2OneBinOrgFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotOrgFileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinFitresFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FITRES );
        if ( m_store2OneBinFitresFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "no" );
        }
        else
        {
            if ( m_store2OneBinFitresFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotFitResFileCheckBox.setSelected( true );
            }
        }
        
        m_store2OneBinResFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_RES );
        if ( m_store2OneBinResFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_RES, "no" );
        }
        else
        {
            if ( m_store2OneBinResFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotResFileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinCororgFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_CORORG );
        if ( m_store2OneBinCororgFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "no" );
        }
        else
        {
            if ( m_store2OneBinCororgFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinExlFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_EXL );
        if ( m_store2OneBinExlFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_EXL, "no" );
        }
        else
        {
            if ( m_store2OneBinExlFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotExlFileCheckBox1.setSelected( true );
            }
        }
        
        m_store2OneBinNLN0File = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_NLN0 );
        if ( m_store2OneBinNLN0File == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "no" );
        }
        else
        {
            if ( m_store2OneBinNLN0File.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotnln0FileCheckBox2.setSelected( true );
            }
        }
        
        m_store2OneBinMatFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_MAT );
        if ( m_store2OneBinMatFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_MAT, "no" );
        }
        else
        {
            if ( m_store2OneBinMatFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotMatFileCheckBox1.setSelected( true );
            }
        }
        
        m_store2OneBinErrFile = tdfdFitDefaults.getProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ERR );
        if ( m_store2OneBinErrFile == null )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ERR, "no" );
        }
        else
        {
            if ( m_store2OneBinErrFile.compareTo( "yes" ) == 0 )
            {
                m_storeToOneOutputFileDotBinDotErrFileCheckBox1.setSelected( true );
            }
        }
        // Save the changes in the settings file.
        tdfdFitDefaults.save( );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        m_deleteAfterFittingPanel = new javax.swing.JPanel();
        m_deleteDotBinFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotFitFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotFit0FileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotFitResFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotResFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotOrgFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotCorOrgFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotnln0FileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotMatFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotErrFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotBinDotExlFileCheckBox = new javax.swing.JCheckBox();
        m_deleteDotParFileCheckBox = new javax.swing.JCheckBox();
        m_deleteVerboseParFileCheckBox = new javax.swing.JCheckBox();
        m_storeToOneOutputFilePanel = new javax.swing.JPanel();
        m_storeToOneOutputFileDotBinDotFitResFileCheckBox = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotFit0FileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotResFileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotOrgFileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotnln0FileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotMatFileCheckBox1 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotErrFileCheckBox1 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotExlFileCheckBox1 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinFileCheckBox2 = new javax.swing.JCheckBox();
        m_storeToOneOutputFileDotBinDotFitFileCheckBox2 = new javax.swing.JCheckBox();
        jPanel1 = new javax.swing.JPanel();
        m_deletePatientDirectoryButton = new javax.swing.JButton();
        m_currentPatientDirectoryLabel = new javax.swing.JLabel();
        m_currentPatientDirectoryValueLabel = new javax.swing.JLabel();

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        m_deleteAfterFittingPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Delete TDFDFit output file types"));

        m_deleteDotBinFileCheckBox.setText("[Filename].bin");
        m_deleteDotBinFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotFitFileCheckBox.setText("[Filename].bin.fit");
        m_deleteDotBinDotFitFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotFitFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotFit0FileCheckBox.setText("[Filename].bin.fit0");
        m_deleteDotBinDotFit0FileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotFit0FileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotFitResFileCheckBox.setText("[Filename].bin.fitres");
        m_deleteDotBinDotFitResFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotFitResFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotResFileCheckBox.setText("[Filename].bin.res");
        m_deleteDotBinDotResFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotResFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotOrgFileCheckBox.setText("[Filename].bin.org");
        m_deleteDotBinDotOrgFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotOrgFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotCorOrgFileCheckBox.setText("[Filename].bin.cororg");
        m_deleteDotBinDotCorOrgFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotCorOrgFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotnln0FileCheckBox.setText("[Filename].bin.nln0");
        m_deleteDotBinDotnln0FileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotnln0FileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotMatFileCheckBox.setText("[Filename].bin.mat");
        m_deleteDotBinDotMatFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotMatFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotErrFileCheckBox.setText("[Filename].bin.err");
        m_deleteDotBinDotErrFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotErrFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotBinDotExlFileCheckBox.setText("[Filename].bin.exl");
        m_deleteDotBinDotExlFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotBinDotExlFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteDotParFileCheckBox.setText("[Filename].par");
        m_deleteDotParFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteDotParFileCheckBoxActionPerformed(evt);
            }
        });

        m_deleteVerboseParFileCheckBox.setText("[Filename]verbose.par");
        m_deleteVerboseParFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteVerboseParFileCheckBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout m_deleteAfterFittingPanelLayout = new javax.swing.GroupLayout(m_deleteAfterFittingPanel);
        m_deleteAfterFittingPanel.setLayout(m_deleteAfterFittingPanelLayout);
        m_deleteAfterFittingPanelLayout.setHorizontalGroup(
            m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                        .addComponent(m_deleteDotBinDotResFileCheckBox)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                        .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, m_deleteAfterFittingPanelLayout.createSequentialGroup()
                                .addComponent(m_deleteDotBinFileCheckBox)
                                .addGap(138, 138, 138))
                            .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                                .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(m_deleteDotBinDotFitFileCheckBox)
                                    .addComponent(m_deleteDotBinDotFitResFileCheckBox)
                                    .addComponent(m_deleteDotBinDotOrgFileCheckBox)
                                    .addComponent(m_deleteDotBinDotFit0FileCheckBox))
                                .addGap(108, 108, 108)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_deleteDotBinDotExlFileCheckBox)
                            .addComponent(m_deleteDotBinDotCorOrgFileCheckBox)
                            .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                                .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(m_deleteDotBinDotnln0FileCheckBox)
                                    .addComponent(m_deleteDotBinDotMatFileCheckBox)
                                    .addComponent(m_deleteDotBinDotErrFileCheckBox))
                                .addGap(12, 12, 12)))
                        .addGap(125, 125, 125)
                        .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_deleteDotParFileCheckBox)
                            .addComponent(m_deleteVerboseParFileCheckBox))))
                .addContainerGap())
        );
        m_deleteAfterFittingPanelLayout.setVerticalGroup(
            m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_deleteAfterFittingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                        .addComponent(m_deleteDotBinFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotFitFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotFitResFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotOrgFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotFit0FileCheckBox))
                    .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                        .addComponent(m_deleteDotParFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteVerboseParFileCheckBox))
                    .addGroup(m_deleteAfterFittingPanelLayout.createSequentialGroup()
                        .addComponent(m_deleteDotBinDotCorOrgFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotExlFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotnln0FileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotMatFileCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(m_deleteDotBinDotErrFileCheckBox)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(m_deleteDotBinDotResFileCheckBox)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_storeToOneOutputFilePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Store MRSI TDFDFit result data in one file"));

        m_storeToOneOutputFileDotBinDotFitResFileCheckBox.setText("[Filename].bin.fitres");
        m_storeToOneOutputFileDotBinDotFitResFileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotFitResFileCheckBoxActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotFit0FileCheckBox2.setText("[Filename].bin.fit0");
        m_storeToOneOutputFileDotBinDotFit0FileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotFit0FileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotResFileCheckBox2.setText("[Filename].bin.res");
        m_storeToOneOutputFileDotBinDotResFileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotResFileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotOrgFileCheckBox2.setText("[Filename].bin.org");
        m_storeToOneOutputFileDotBinDotOrgFileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotOrgFileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2.setText("[Filename].bin.cororg");
        m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotnln0FileCheckBox2.setText("[Filename].bin.nln0");
        m_storeToOneOutputFileDotBinDotnln0FileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotnln0FileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotMatFileCheckBox1.setText("[Filename].bin.mat");
        m_storeToOneOutputFileDotBinDotMatFileCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotMatFileCheckBox1ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotErrFileCheckBox1.setText("[Filename].bin.err");
        m_storeToOneOutputFileDotBinDotErrFileCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotErrFileCheckBox1ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotExlFileCheckBox1.setText("[Filename].bin.exl");
        m_storeToOneOutputFileDotBinDotExlFileCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotExlFileCheckBox1ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinFileCheckBox2.setText("[Filename].bin");
        m_storeToOneOutputFileDotBinFileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinFileCheckBox2ActionPerformed(evt);
            }
        });

        m_storeToOneOutputFileDotBinDotFitFileCheckBox2.setText("[Filename].bin.fit");
        m_storeToOneOutputFileDotBinDotFitFileCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_storeToOneOutputFileDotBinDotFitFileCheckBox2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout m_storeToOneOutputFilePanelLayout = new javax.swing.GroupLayout(m_storeToOneOutputFilePanel);
        m_storeToOneOutputFilePanel.setLayout(m_storeToOneOutputFilePanelLayout);
        m_storeToOneOutputFilePanelLayout.setHorizontalGroup(
            m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_storeToOneOutputFilePanelLayout.createSequentialGroup()
                .addGap(98, 98, 98)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(m_storeToOneOutputFilePanelLayout.createSequentialGroup()
                        .addComponent(m_storeToOneOutputFileDotBinDotResFileCheckBox2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(m_storeToOneOutputFileDotBinDotFit0FileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotFitFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotOrgFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotFitResFileCheckBox))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_storeToOneOutputFileDotBinDotErrFileCheckBox1)
                    .addComponent(m_storeToOneOutputFileDotBinDotMatFileCheckBox1)
                    .addComponent(m_storeToOneOutputFileDotBinDotnln0FileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotExlFileCheckBox1))
                .addGap(168, 168, 168))
        );
        m_storeToOneOutputFilePanelLayout.setVerticalGroup(
            m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_storeToOneOutputFilePanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_storeToOneOutputFileDotBinFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_storeToOneOutputFileDotBinDotFitFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotExlFileCheckBox1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_storeToOneOutputFileDotBinDotFit0FileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotnln0FileCheckBox2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_storeToOneOutputFileDotBinDotOrgFileCheckBox2)
                    .addComponent(m_storeToOneOutputFileDotBinDotMatFileCheckBox1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_storeToOneOutputFilePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_storeToOneOutputFileDotBinDotFitResFileCheckBox)
                    .addComponent(m_storeToOneOutputFileDotBinDotErrFileCheckBox1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(m_storeToOneOutputFileDotBinDotResFileCheckBox2)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Delete all results in patient output directory"));

        m_deletePatientDirectoryButton.setText("Delete all output files in patient output directory");

        m_currentPatientDirectoryLabel.setText("Patient output file directory :");

        m_currentPatientDirectoryValueLabel.setText("Patient output folder not defined!");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(20, Short.MAX_VALUE)
                .addComponent(m_currentPatientDirectoryLabel)
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_deletePatientDirectoryButton)
                    .addComponent(m_currentPatientDirectoryValueLabel))
                .addGap(215, 215, 215))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_currentPatientDirectoryLabel)
                    .addComponent(m_currentPatientDirectoryValueLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, Short.MAX_VALUE)
                .addComponent(m_deletePatientDirectoryButton)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_storeToOneOutputFilePanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(m_deleteAfterFittingPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_deleteAfterFittingPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_storeToOneOutputFilePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void m_storeToOneOutputFileDotBinDotFit0FileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotFit0FileCheckBox2ActionPerformed
       TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
       tdfdFitDefaults.load( );
       
       if ( m_storeToOneOutputFileDotBinDotFit0FileCheckBox2.isSelected( ) )
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "yes" );
       }
       else
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "no" );
       }
       tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotFit0FileCheckBox2ActionPerformed

    
    private void m_deleteDotBinFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinFileCheckBoxActionPerformed
      
       TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
       tdfdFitDefaults.load( );
       
       if ( m_deleteDotBinFileCheckBox.isSelected( ) )
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "yes" );
       }
       else
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN, "no" );
       }
       tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinFileCheckBoxActionPerformed

    private void m_deleteDotBinDotFitFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotFitFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( ); 
        tdfdFitDefaults.load( );
       if ( m_deleteDotBinDotFitFileCheckBox.isSelected( ) )
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT, "yes" );
       }
       else
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT, "no" );
       }
       tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotFitFileCheckBoxActionPerformed

    private void m_deleteDotBinDotFitResFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotFitResFileCheckBoxActionPerformed
       TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
       tdfdFitDefaults.load( );
       
       if ( m_deleteDotBinDotFitResFileCheckBox.isSelected( ) )
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "yes" );
       }
       else
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "no" );
       }
       tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotFitResFileCheckBoxActionPerformed

    private void m_deleteDotBinDotOrgFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotOrgFileCheckBoxActionPerformed
       TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
       tdfdFitDefaults.load( );
       if ( m_deleteDotBinDotOrgFileCheckBox.isSelected( ) )
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ORG, "yes" );
       }
       else
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ORG, "no" );
       }
       tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotOrgFileCheckBoxActionPerformed

    private void m_deleteDotBinDotFit0FileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotFit0FileCheckBoxActionPerformed
       TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( ); 
       tdfdFitDefaults.load( );
       if ( m_deleteDotBinDotFit0FileCheckBox.isSelected( ) )
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "yes" );
       }
       else
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_FIT0, "no" );
       }
       tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotFit0FileCheckBoxActionPerformed

    private void m_deleteDotBinDotResFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotResFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotResFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_RES, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_RES, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotResFileCheckBoxActionPerformed

    private void m_deleteDotBinDotCorOrgFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotCorOrgFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotCorOrgFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotCorOrgFileCheckBoxActionPerformed

    private void m_deleteDotBinDotExlFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotExlFileCheckBoxActionPerformed
       TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
       tdfdFitDefaults.load( );
       
       if ( m_deleteDotBinDotExlFileCheckBox.isSelected( ) )
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_EXL, "yes" );
       }
       else
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_EXL, "no" );
       }
       tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotExlFileCheckBoxActionPerformed

    private void m_deleteDotBinDotnln0FileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotnln0FileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotnln0FileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotnln0FileCheckBoxActionPerformed

    private void m_deleteDotBinDotMatFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotMatFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_deleteDotBinDotMatFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_MAT, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_MAT, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotMatFileCheckBoxActionPerformed

    private void m_deleteDotBinDotErrFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotBinDotErrFileCheckBoxActionPerformed
       TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( ); 
       tdfdFitDefaults.load( );
       if ( m_deleteDotBinDotErrFileCheckBox.isSelected( ) )
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ERR, "yes" );
       }
       else
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_BIN_ERR, "no" );
       }
       tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotBinDotErrFileCheckBoxActionPerformed

    private void m_storeToOneOutputFileDotBinFileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinFileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinFileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinFileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotFitFileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotFitFileCheckBox2ActionPerformed
       TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
       tdfdFitDefaults.load( );
       if ( m_storeToOneOutputFileDotBinDotFitFileCheckBox2.isSelected( ) )
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT, "yes" );
       }
       else
       {
           tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FIT, "no" );
       }
       tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotFitFileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotOrgFileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotOrgFileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinDotOrgFileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ORG, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ORG, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotOrgFileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotFitResFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotFitResFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinDotFitResFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_FITRES, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotFitResFileCheckBoxActionPerformed

    private void m_storeToOneOutputFileDotBinDotResFileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotResFileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( ); 
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinDotResFileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_RES, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_RES, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotResFileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( ); 
        tdfdFitDefaults.load( );
        if ( m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_CORORG, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotExlFileCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotExlFileCheckBox1ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( ); 
        tdfdFitDefaults.load( );
        if (  m_storeToOneOutputFileDotBinDotExlFileCheckBox1.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_EXL, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_EXL, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotExlFileCheckBox1ActionPerformed

    private void m_storeToOneOutputFileDotBinDotnln0FileCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotnln0FileCheckBox2ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( ); 
        tdfdFitDefaults.load( );
        if (  m_storeToOneOutputFileDotBinDotnln0FileCheckBox2.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_NLN0, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotnln0FileCheckBox2ActionPerformed

    private void m_storeToOneOutputFileDotBinDotMatFileCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotMatFileCheckBox1ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if (  m_storeToOneOutputFileDotBinDotMatFileCheckBox1.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_MAT, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_MAT, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotMatFileCheckBox1ActionPerformed

    private void m_storeToOneOutputFileDotBinDotErrFileCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_storeToOneOutputFileDotBinDotErrFileCheckBox1ActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( ); 
        tdfdFitDefaults.load( );
        if (  m_storeToOneOutputFileDotBinDotErrFileCheckBox1.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ERR, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.STORE_SINGLE_TDFDFIT_OUTPUTFILE_BIN_ERR, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_storeToOneOutputFileDotBinDotErrFileCheckBox1ActionPerformed

    private void m_deleteDotParFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteDotParFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if (  m_deleteDotParFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_PAR, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_PAR, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteDotParFileCheckBoxActionPerformed

    private void m_deleteVerboseParFileCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteVerboseParFileCheckBoxActionPerformed
        TDFDFittingDefaults tdfdFitDefaults = TDFDFittingDefaults.getInstance( );
        tdfdFitDefaults.load( );
        if (  this.m_deleteVerboseParFileCheckBox.isSelected( ) )
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_VERBOSE_PAR, "yes" );
        }
        else
        {
            tdfdFitDefaults.setProperty( TDFDFittingDefaults.DELETE_TDFDFIT_OUTPUTFILE_DOT_VERBOSE_PAR, "no" );
        }
        tdfdFitDefaults.save( );
    }//GEN-LAST:event_m_deleteVerboseParFileCheckBoxActionPerformed
    
    // Manually added attributes
    private String m_deleteDotParFile;
    private String m_deleteVerboseDotParFile;
    
    
    private String m_deleteBinFile;
    private String m_deleteBinFitFile;
    private String m_deleteBinFit0File;
    private String m_deleteBinOrgFile;
    private String m_deleteBinFitresFile;
    private String m_deleteBinResFile;
    private String m_deleteBinCororgFile;
    private String m_deleteBinExlFile;
    private String m_deleteBinNLN0File;
    private String m_deleteBinMatFile;
    private String m_deleteBinErrFile;
    
    private String m_store2OneBinFile;
    private String m_store2OneBinFitFile;
    private String m_store2OneBinFit0File;
    private String m_store2OneBinOrgFile;
    private String m_store2OneBinFitresFile;
    private String m_store2OneBinResFile;
    private String m_store2OneBinCororgFile;
    private String m_store2OneBinExlFile;
    private String m_store2OneBinNLN0File;
    private String m_store2OneBinMatFile;
    private String m_store2OneBinErrFile;


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel m_currentPatientDirectoryLabel;
    private javax.swing.JLabel m_currentPatientDirectoryValueLabel;
    private javax.swing.JPanel m_deleteAfterFittingPanel;
    private javax.swing.JCheckBox m_deleteDotBinDotCorOrgFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotErrFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotExlFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotFit0FileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotFitFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotFitResFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotMatFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotOrgFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotResFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinDotnln0FileCheckBox;
    private javax.swing.JCheckBox m_deleteDotBinFileCheckBox;
    private javax.swing.JCheckBox m_deleteDotParFileCheckBox;
    private javax.swing.JButton m_deletePatientDirectoryButton;
    private javax.swing.JCheckBox m_deleteVerboseParFileCheckBox;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotCorOrgFileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotErrFileCheckBox1;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotExlFileCheckBox1;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotFit0FileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotFitFileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotFitResFileCheckBox;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotMatFileCheckBox1;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotOrgFileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotResFileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinDotnln0FileCheckBox2;
    private javax.swing.JCheckBox m_storeToOneOutputFileDotBinFileCheckBox2;
    private javax.swing.JPanel m_storeToOneOutputFilePanel;
    // End of variables declaration//GEN-END:variables
}
