/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.spectrim.texturemaps;

/**
 * Computes the moments about the mean of a given input vector containing
 * @author slotboom
 */
public class MomentAboutTheMeanOfArrayCalculator
{
    /**
     * Computes the moments about the mean for given input array
     */
    public MomentAboutTheMeanOfArrayCalculator( int[] values )
    {
        
        m_inputValues = new float[values.length];
        for ( int i = 0; i < values.length; i++ )
        {
            m_inputValues[i] = (float)values[i];
        }

    }


    /**
     * Computes the moments about the mean for given input array
     */
    public MomentAboutTheMeanOfArrayCalculator( float[] values )
    {
        m_inputValues = new float[values.length];
        System.arraycopy(values, 0, m_inputValues, 0, values.length);
    }


    /**
     * Computes the moments about the mean for given input array
     */
    public MomentAboutTheMeanOfArrayCalculator( double[] values )
    {

        for ( int i = 0; i < values.length; i++ )
        {
            m_inputValues[i] = (float)values[i];
        }

    }


    /**
     * Returns the computed maoment about the mean object.
     * @return
     */
    public MomentsAboutTheMean getMomentsAboutTheMean( )
    {
        m_momentsAboutTheMean = computeStatisticsForArray( );
        return m_momentsAboutTheMean;
    }

    /**
     * Does the actual computation of the moments about the mean
     */
    public MomentsAboutTheMean computeStatisticsForArray( )
    {

        MomentsAboutTheMean momentAboutTheMean;

        // 1. compute first moment: sample mean
        for ( int i = 0; i < m_inputValues.length; i++ )
        {
            m_average += (float)m_inputValues[i];
        }

        m_average = m_average / m_inputValues.length;

        // 2. compute sample variance of the
        for ( int i = 0; i < m_inputValues.length; i++ )
        {
            m_variance += ( m_inputValues[i] - m_average ) * ( m_inputValues[i] - m_average );
        }

        m_variance = m_variance / ( m_inputValues.length - 1 );

        // 3. variance of sample variance
        double mhu_2 = 0.0f;
        for ( int i = 0; i < m_inputValues.length; i++ )
        {
            mhu_2 += m_inputValues[i] * m_inputValues[i];
        }
        mhu_2 = mhu_2 / m_inputValues.length;

        double mhu_4 = 0.0f;
        for ( int i = 0; i < m_inputValues.length; i++ )
        {
            mhu_4 += m_inputValues[i] * m_inputValues[i] * m_inputValues[i] * m_inputValues[i];
        }
        mhu_4 = mhu_4 / m_inputValues.length;

        double M = (double)m_inputValues.length;
        double n = (double)( m_inputValues.length - 1 );

        double a1 = M * ( M - n ) * ( M * n - M - n - 1 ) / ( ( M - 3 ) * ( M - 2 ) * ( M - 1 ) * ( n - 1 ) * n );
        double a2 = M * ( M - n ) * ( M * M * n - 3 * n - 3 * M * M + 6 * M - 3 ) / ( ( M - 3 ) * ( M - 2 ) * ( M - 1 ) * ( n - 1 ) * n );

        m_varianceOfVariance = Math.log( a1 * mhu_4 + a2 * mhu_2 );

        // 4. Sample skewness
        double numerator = 0.0;
        for ( int i = 0; i < m_inputValues.length; i++ )
        {
            numerator += ( m_inputValues[i] - m_average ) * ( m_inputValues[i] - m_average ) * ( m_inputValues[i] - m_average );
        }
        double dominator = 0.0;
        for ( int i = 0; i < m_inputValues.length; i++ )
        {
            dominator += ( m_inputValues[i] - m_average ) * ( m_inputValues[i] - m_average );
        }
        double factor = Math.sqrt( M * ( M - 1 ) )/( M - 2 );

        m_skewness = factor * Math.sqrt( M ) * numerator / ( dominator * Math.sqrt( dominator ) );

        // 5. variance of sample skewness (assume Gaussian distribution)
        m_varianceOfSkewness = 6 * M / ( ( M + 1 ) * ( M + 3 ) );

        // 6. Sample kurtosis
        double numerator_kur = 0.0;
        for ( int i = 0; i < m_inputValues.length; i++ )
        {
            double factor_kur = ( m_inputValues[i] - m_average );
            numerator_kur += factor_kur * factor_kur * factor_kur * factor_kur;
        }

        double G = ( M + 1 ) * M / ( ( M - 1 ) * ( M - 2 ) * ( M - 3 ) );
        double H = ( M - 1 ) * ( M - 1 ) / ( ( M - 2 ) * ( M - 3 ) );

        m_kurtosis = ( G * numerator_kur/ ( m_variance * m_variance ) ) - 3 * H;

        // 7. variance of sample kurtosis
        m_varianceOfKurtosis = 24 * M * ( M - 2 ) * ( M - 3 ) / ( ( M + 1 ) * ( M + 1 ) * (M + 3) * ( M + 5 ) );

        momentAboutTheMean = new MomentsAboutTheMean( );

        momentAboutTheMean.setMean( m_average );
        momentAboutTheMean.setStDev( Math.sqrt( m_variance ) );
        momentAboutTheMean.setVariance( m_variance );
        momentAboutTheMean.setVarianceOfVariance( m_varianceOfVariance );
        momentAboutTheMean.setSkewness( m_skewness );
        momentAboutTheMean.setVarianceOfSkewness( m_varianceOfSkewness );
        momentAboutTheMean.setKurtosis( m_kurtosis );
        momentAboutTheMean.setVarianceOfKurtosis( m_varianceOfKurtosis );
        
        return momentAboutTheMean;
    }

    // Attributes
    private float[]             m_inputValues;
    private MomentsAboutTheMean m_momentsAboutTheMean;


    private float[]         m_inputFloatValues;
    private double[]        m_inputDoubleValues;

     // attributes than contain the numeric values of the computation
    private double          m_average              = 0.0;
    private double          m_variance             = 0.0;
    private double          m_varianceOfVariance   = 0.0;
    private double          m_skewness             = 0.0;
    private double          m_varianceOfSkewness   = 0.0;
    private double          m_kurtosis             = 0.0;
    private double          m_varianceOfKurtosis   = 0.0;

}