/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.main;

import org.spectrim.settings.GlobalSettings;
import org.spectrim.popups.PopupPhasingFrame;
import org.spectrim.popups.PopupLorentzianFrame;
import org.spectrim.popups.PopupZeroFillingFrame;
import org.spectrim.popups.PopupApodizationFrame;
import org.spectrim.view.LocalizerPanel;
import org.spectrim.view.SpectraPanel;
import org.spectrim.view.ImageViewerPanel;
import org.spectrim.view.JFractionPanel;
import org.spectrim.model.GlobalModel;
import org.spectrim.data.FileReaderWorker;
import org.spectrim.dicom.DicomDataLoaderPanel;
import org.spectrim.dicom.DicomFileSelectionControl;
import org.spectrim.dicom.DicomFileSelectionTable;
import org.spectrim.dicom.DicomImageSeriesData;
import org.spectrim.dicom.DicomNetworkListenerPropertiesFrame;
import org.spectrim.dicom.DicomNetworkNodeDefinerAndSelectionFrame;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import org.spectrim.utilities.WaitLayerUI;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.nio.file.FileVisitResult;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.SimpleFileVisitor;
import java.nio.file.attribute.BasicFileAttributes;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JLayer;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingWorker;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.spectrim.autoqualitycontrol.LabellingHandler;
import org.spectrim.colormap.ColorMapUI;
import org.spectrim.colormap.InterfaceMainGUIColorMapUI;
import org.spectrim.data.FileReaderListener;
import org.spectrim.popups.ApodizationListener;
import org.spectrim.autoqualitycontrol.LabelAnalyser;
import org.spectrim.autoqualitycontrol.LabellingAnalyserListener;
import org.spectrim.autoqualitycontrol.LabellingListener;
import org.spectrim.popups.LorentzianListener;
import org.spectrim.popups.OverlayThresholdFrame;
import org.spectrim.popups.OverlayThresholdListener;
import org.spectrim.popups.PhasingListener;
import org.spectrim.popups.PopupMatlabReader;
import org.spectrim.popups.ShiftCorrectionListener;
import org.spectrim.popups.ZeroFillingListener;
import org.spectrim.popups.jMRUIResultsMapListener;
import org.spectrim.report.CstmReportFrame;
import org.spectrim.utilities.StayOpenCheckBoxMenuItem;
import org.spectrim.view.ColorModelGenerator;
import org.spectrim.report.StdReportFrame;
import org.spectrim.settings.ReportSettings;
import org.spectrim.settings.SettingsGUI;
import org.spectrim.settings.PythonSettings;
import java.util.TreeSet;
import javax.imageio.ImageIO;
import javax.swing.SwingWorker.StateValue;
import javax.swing.text.BadLocationException;
import org.dcm4che2.data.DicomObject;
import org.spectrim.automaticprocessing.AutomaticProcessingFileHandler;
import org.spectrim.batchprocessing.BatchProcessing;
import org.spectrim.batchprocessing.BatchProcessingTaskExecutor;
import org.spectrim.clinicalcasehandling.ClinicalSpectroscopyWorklistFrame;
import org.spectrim.io.dicom.DicomHandler;
import org.spectrim.io.dicom.DicomHeader;
import org.spectrim.patientbrowser.Patient;
import org.spectrim.patientbrowser.Series;
import org.spectrim.patientbrowser.Study;
import org.spectrim.popups.PopupAbout;
import org.spectrim.popups.ModelProviderInterface;
import org.spectrim.popups.PopupjMRUIResultsMap;
import org.spectrim.popups.ShiftCorrectionPopup;
import org.spectrim.popups.TumourRegionSelectionAssistant;
import org.spectrim.popups.jMRUIResultsInterface;
import org.spectrim.selectionprofile.SelectionProfileCorrection;
import org.spectrim.settings.ProcessingSettings;
import org.spectrim.settings.SettingsGUIListener;
import org.spectrim.settings.processing.MruiFile;
import org.spectrim.settings.processing.PreprocessingAction;
import org.spectrim.settings.processing.ProcessingAction;
import org.spectrim.settings.processing.QuantificationAction;
import org.spectrim.settings.processing.QuantificationSelectMetabolites;
import org.spectrim.settings.processing.ReferencePeak;
import org.spectrim.settings.processing.ResultsAction;
import org.spectrim.spectra.Spectra;
import org.spectrim.tdfdfit.NonInteractiveTDFDFitExecuter;
import org.spectrim.tdfdfit.TDFDFitControlFrame;
import org.spectrim.view.ImageSlice;
import org.spectrim.dicom.DicomDirectory;
import org.spectrim.grid.ImageSegmentationWithinSelectedSpectroscopicRegionFrame;
import org.spectrim.hlsvd.HLSVDResults;
import org.spectrim.hlsvd.NonInteractiveHLSVD;
import org.spectrim.hlsvd.HLSVDPro;
import org.spectrim.hlsvd.HLSVDPro_batch;
import org.spectrim.hlsvd.HLSVDResults_batch;
import org.spectrim.lib.DualProgressBar;
import org.spectrim.settings.processing.PreprocessingActionUI;
import org.spectrim.settings.processing.QuantificationTypeSelectionFrame;
import org.spectrim.spectra.Spectrum;
import org.spectrim.tdfdfit.OffsetRemovalParameterControl;
import org.spectrim.tdfdfit.QuickSort;
import org.spectrim.tdfdfit.SingleVoxelSpectralData;
import org.spectrim.tdfdfit.SpectrumPhasingDefinitionControl;
import org.spectrim.tdfdfit.TDFDFitResultsStore;
import org.spectrim.tdfdfit.TDFDFittingDefaults;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.RandomAccessFile;
import java.util.StringTokenizer;
import java.util.Vector;
import org.apache.commons.math3.analysis.interpolation.SplineInterpolator;
import org.apache.commons.math3.analysis.polynomials.PolynomialSplineFunction;
import org.spectrim.colormap.ImportedCSVDataColorMapOverlaySelectionFrame;
import org.spectrim.data.CSIData;
import org.spectrim.grid.FeatureBasedGridSelectionJFrame;
import org.spectrim.hlsvd.HLSVDControlFrame;
import org.spectrim.imageprocessing.QMRSIOutlierRemovalControlFrame;
import org.spectrim.popups.TDDomainTruncationListener;
import org.spectrim.popups.TDTruncationDataFrame;
import org.spectrim.signalprocessing.FFT;
import org.spectrim.signalprocessing.SignalTools;
import org.spectrim.spectra.FittedSpectra;
import org.spectrim.tdfdfit.BaseLineSplineSupportPointsDefinitionFrame;
import org.spectrim.tdfdfit.NonInteractiveBaselineRemovalExecuter;
import org.spectrim.tdfdfit.ExportMRSDataToCSVFileOptionFrame;
import org.spectrim.tdfdfit.JMRUIFile;
import org.spectrim.tdfdfit.MRFitStrategy;
import org.spectrim.tdfdfit.MRLineModelSpectralResponse;
import org.spectrim.tdfdfit.MRSignalProperties;
import org.spectrim.tdfdfit.NumericTDFDFitResults;
import org.spectrim.tdfdfit.OrderedBaseLinePointsDataModel;
import org.spectrim.tdfdfit.SingleVoxelMeasuredSpectralData;
import org.spectrim.tdfdfit.TDFDFitDefaultRuntimeSettingsDefinitionFrame;
import org.spectrim.tdfdfit.TDFDFitPrototypeModelSpectrumParameters;
import static org.spectrim.tdfdfit.TDFDFitRandomModelSignalGeneratorFrame.OVERALL_GAUSSWITDTH;
import static org.spectrim.tdfdfit.TDFDFitRandomModelSignalGeneratorFrame.OVERALL_LORENTZWIDTH;
import static org.spectrim.tdfdfit.TDFDFitRandomModelSignalGeneratorFrame.OVERALL_OFFSET;
import static org.spectrim.tdfdfit.TDFDFitRandomModelSignalGeneratorFrame.OVERALL_PHASE;
import static org.spectrim.tdfdfit.TDFDFitResultsStore.byteArrayToFloat;
import static org.spectrim.tdfdfit.TDFDFitResultsStore.floatToByteArray;
import org.spectrim.toolbars.DicomToolBar;
import org.spectrim.toolbars.SpectrImMainSignalPreprocessingToolbar;
import static org.spectrim.toolbars.SpectrImMainSignalPreprocessingToolbar.APPLY_COMPLEX_CONJUGATION;
import static org.spectrim.toolbars.SpectrImMainSignalPreprocessingToolbar.APPLY_COMPLEX_CONJUGATION_ID;
import static org.spectrim.toolbars.SpectrImMainSignalPreprocessingToolbar.APPLY_MANUAL_BASELINE_REMOVAL_ID;
import org.spectrim.toolbars.TDFDFitFileMenuToolbar;
import org.spectrim.utilities.ClientSocket;
import org.spectrim.xyplot.Curve;
import org.spectrim.xyplot.MultiXYPlotFrame;
import org.spectrim.xyplot.XYPlotFrame;

/**
 * This class is the main class of spectrIm.
 * @author nunopbarros updated 2nd 3rd and 4th quarter 2018 by Johannes Slotboom.
 */
public class ClinicalViewer extends javax.swing.JFrame implements ActionListener, ApodizationListener,
        LorentzianListener, PhasingListener, ShiftCorrectionListener, ZeroFillingListener,
        FileReaderListener, OverlayThresholdListener, LabellingListener, LabellingAnalyserListener,
        InterfaceMainGUIColorMapUI, ModelProviderInterface, BatchProcessingTaskExecutor, SettingsGUIListener,
        jMRUIResultsInterface, TDDomainTruncationListener 
{

    // Attributes
    
    int     numberOfBaselineRemovalThreadsActive = 0;
    private ImageViewerPanel        imagePanel;
    private File                    currentFile;
    private File                    currentLabellingFile;
    private File                    currentLabellingReferenceFile;
    private SpectraPanel            spectraPanel;
    private DicomDataLoaderPanel    dicomManager;
    private PopupZeroFillingFrame   popupzerofilling;
    private TDTruncationDataFrame   m_td_truncation_data_frame;
    private PopupPhasingFrame       popupphasingframe;
    private PopupApodizationFrame   popupapodizationframe;
    private PopupLorentzianFrame    popuplorentzianframe;
    private ShiftCorrectionPopup    popupshiftcorrection;
    private OverlayThresholdFrame   popupoverlaythreshold;
    private LabelAnalyser           labelAnalyser;
    private PopupMatlabReader       matReader;
    private int                     currentVectorSize;
    private GlobalModel             model = new GlobalModel( );
    private JLayer<JPanel>          waitlayer;
    private DicomFileSelectionTable dicomseltab;
    public  GlobalSettings           settings;
    private MruiViewerInterface     mruiViewerInterface;
    private ColorMapUI              cmapUI;
    private LabellingHandler        labellingHandler;
    private ArrayList<ProcessingAction> processingActions = new ArrayList<>();
    private DicomNetworkListenerPropertiesFrame m_dicomNetworkListenerPropertiesFrame;
    private ClinicalSpectroscopyWorklistFrame m_clinicalSpectroscopyFrame;
    private boolean m_removeWaterTDFDFit = false;
    private BaseLineSplineSupportPointsDefinitionFrame m_baseLineSplineSupportPointsDefinitionFrame; 
    private  HashMap<String, Double> m_allFittedWaterReferenceResonanceFrequencies;
    
    private OffsetRemovalParameterControl m_fdOffsetRemoverControl;
    private OffsetRemovalParameterControl m_tdOffsetRemoverControl;
    
    private DualProgressBar m_dualProgressBar;
    double m_lowerLimitFD;
    double m_upperLimitFD;
    
    double m_lowerLimitTD;
    double m_upperLimitTD;
    ImageSegmentationWithinSelectedSpectroscopicRegionFrame m_ImSegOfSpectroscopicRegionFrame; 
    
    SpectrumPhasingDefinitionControl        m_phasingControl;
    QMRSIOutlierRemovalControlFrame         m_QMRSIOutlierRemovalControlFrame;
    PopupjMRUIResultsMap                    m_popupjMRUIResultsMap;
    JPanel                                  m_toolBarCollectionPanel;
    TDFDFitFileMenuToolbar                  m_basicFileToolbar;
    SpectrImMainSignalPreprocessingToolbar  m_TDFDFitSignalPreprocessingToolbar;
    DicomToolBar                            m_dicomToolbar;
    HLSVDControlFrame                       m_hlsvdWaterRemovalGUI;
    ExportMRSDataToCSVFileOptionFrame       m_exportMRSDataToCSVFileOptionFrame;
    MidasPreprocessedEPSIDataImporterParameterSettingsControl m_midasEPSIDataImporter;
    
    
    /**
     * Creates new form Viewer.
     * @param mruiViewerInterface
     */
    public ClinicalViewer( MruiViewerInterface mruiViewerInterface ) 
    {
        initComponents( );
        
        m_toolBarCollectionPanel = new JPanel( );
        m_toolBarCollectionPanel.setLayout( new FlowLayout( FlowLayout.LEFT ) );
        
//        m_basicFileToolbar = new TDFDFitFileMenuToolbar( );
//        m_basicFileToolbar.addActionListener( this );
        
        m_dicomToolbar = new DicomToolBar( );
        m_dicomToolbar.addActionListener( this );
        
        m_TDFDFitSignalPreprocessingToolbar = new SpectrImMainSignalPreprocessingToolbar( );
        m_TDFDFitSignalPreprocessingToolbar.addActionListener( this );
        
//        m_toolBarCollectionPanel.add( m_basicFileToolbar );
        m_toolBarCollectionPanel.add( m_dicomToolbar );
        m_toolBarCollectionPanel.add( m_TDFDFitSignalPreprocessingToolbar );
          
        this.getContentPane( ).add( m_toolBarCollectionPanel, BorderLayout.NORTH );
        
        this.mruiViewerInterface    = mruiViewerInterface;
        this.imagePanel             = (ImageViewerPanel) this.pnlImage;
        this.imagePanel.addActionListener(this);
        this.spectraPanel           = (SpectraPanel) this.pnlSpectrum;
        currentFile                 = new File("");
        imagePanel.setFocusable(true);
        dicomManager = (DicomDataLoaderPanel) pnlFileManager;
        dicomManager.addActionListener(this);
        dicomseltab = dicomManager.getDicomFileSelectionTable();
        for (Spectra.Domain domain : Spectra.Domain.values()) {
            jComboBoxSpectraDomain.addItem(domain.txt);
        }
        for (Spectra.CombinationFunction func : Spectra.CombinationFunction.values()) {
            jComboBoxSpectraCombinationFunction.addItem(func.txt);
        }

        settings = GlobalSettings.getInstance();
        BatchProcessing.setTaskExecutor(this);//Enables Batch Processing
//        this.jMenuReports.remove(this.jMenuStdReport);//TEMP
        m_clinicalSpectroscopyFrame = ClinicalSpectroscopyWorklistFrame.getInstance();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroupSelection = new javax.swing.ButtonGroup();
        jMenuItem2 = new javax.swing.JMenuItem();
        jSplitPane1 = new javax.swing.JSplitPane();
        pnlMain = new javax.swing.JPanel();
        jSlider1 = new javax.swing.JSlider();
        pnlImage = new ImageViewerPanel();
        pnlView = pnlViewSag = new JFractionPanel(1,3);
        pnlViewTra = new org.spectrim.view.LocalizerPanel();
        pnlViewCor = new org.spectrim.view.LocalizerPanel();
        pnlViewSag = new org.spectrim.view.LocalizerPanel();
        pnlData = new javax.swing.JPanel();
        jSplitPane2 = new javax.swing.JSplitPane();
        pnlSpectrum = new SpectraPanel();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextAreaOutput = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        jCheckBoxClipboard = new javax.swing.JCheckBox();
        jComboBoxSpectraCombinationFunction = new javax.swing.JComboBox();
        jComboBoxSpectraDomain = new javax.swing.JComboBox();
        jPanel4 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jRadioButtonSelectBlue = new javax.swing.JRadioButton();
        jRadioButtonSelectRed = new javax.swing.JRadioButton();
        jPanel5 = new javax.swing.JPanel();
        jCheckBoxAbsorption = new javax.swing.JCheckBox();
        jCheckBoxDispersion = new javax.swing.JCheckBox();
        jCheckBoxMagnitude = new javax.swing.JCheckBox();
        jLabel5 = new javax.swing.JLabel();
        jComboBoxProcessingAction = new javax.swing.JComboBox();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jSeparator18 = new javax.swing.JSeparator();
        jSeparator19 = new javax.swing.JSeparator();
        jPanel7 = new javax.swing.JPanel();
        jButtonProcessData = new javax.swing.JButton();
        jButtonJustPreprocess = new javax.swing.JButton();
        jButtonJustQuantify = new javax.swing.JButton();
        jButtonJustHandleResults = new javax.swing.JButton();
        jButtonSelectMetabolites = new javax.swing.JButton();
        pnlFileManager = new DicomDataLoaderPanel(this, model);
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabelIntensityValue = new javax.swing.JLabel();
        jLabelXValue = new javax.swing.JLabel();
        jLabelYValue = new javax.swing.JLabel();
        jMenuBar2 = new javax.swing.JMenuBar();
        jMenuFile = new javax.swing.JMenu();
        jMenuItemOpenCSI = new javax.swing.JMenuItem();
        jMenuItemOpenMRUIFormattedCSI = new javax.swing.JMenuItem();
        jMenuItemMountDir = new javax.swing.JMenuItem();
        jSeparator10 = new javax.swing.JPopupMenu.Separator();
        jMenuItemSaveAllToMAT = new javax.swing.JMenuItem();
        jMenuItemSaveSelectionToMAT = new javax.swing.JMenuItem();
        jMenuItemExportTDSignalsToCSV = new javax.swing.JMenuItem();
        jMenuItemImportTDSignalsFromCSV = new javax.swing.JMenuItem();
        jMenuItemExportSelectedSpectraTojMRUIFormat = new javax.swing.JMenuItem();
        jMenuItemImportSelectedSpectraFromjMRUIFormat = new javax.swing.JMenuItem();
        jMenuItemImportjMRUIFormattedResultsFile = new javax.swing.JMenuItem();
        jMenuItemImportAIPredictedValuesFromCSV = new javax.swing.JMenuItem();
        jMenuItemImportMidasPreprocessedValuesFromBinaryFile = new javax.swing.JMenuItem();
        jMenuItemSaveSelectionTojMRUI = new javax.swing.JMenuItem();
        jSeparator9 = new javax.swing.JPopupMenu.Separator();
        jMenuItemClearImage = new javax.swing.JMenuItem();
        jMenuItemClearGrid = new javax.swing.JMenuItem();
        jSeparator6 = new javax.swing.JPopupMenu.Separator();
        jMenuItemSettings = new javax.swing.JMenuItem();
        m_onlineHelpFileMenuItem = new javax.swing.JMenuItem();
        jMenuView = new javax.swing.JMenu();
        jCheckBoxMenuItemShowPatientName = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItemShowSeriesInfo = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItemViewSliceOrientation = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItemViewSpectraThumbnail = new javax.swing.JCheckBoxMenuItem();
        jSeparator16 = new javax.swing.JPopupMenu.Separator();
        jCheckBoxMenuItemShowIntersectsMain = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItemViewGrid = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItemViewSaturationBands = new javax.swing.JCheckBoxMenuItem();
        jSeparator17 = new javax.swing.JPopupMenu.Separator();
        jCheckBoxShowMapValues = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxShowColorBar = new javax.swing.JCheckBoxMenuItem();
        jSeparator15 = new javax.swing.JPopupMenu.Separator();
        jCheckBoxShowOriginalSpectra = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxShowFittedSpectra = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxShowDifference = new javax.swing.JCheckBoxMenuItem();
        m_onlineHelpViewjMenuItem = new javax.swing.JMenuItem();
        jMenuImage = new javax.swing.JMenu();
        jMenuItemAutoWindowing = new javax.swing.JMenuItem();
        jMenuColorMode = new javax.swing.JMenu();
        jMenuItemColorModeGray = new javax.swing.JMenuItem();
        jMenuItemColorModeRGB = new javax.swing.JMenuItem();
        jMenuItemColorModeBGR = new javax.swing.JMenuItem();
        jMenuItemColorModeRBG = new javax.swing.JMenuItem();
        jMenuItemColorModeBRG = new javax.swing.JMenuItem();
        jMenuItemColorModeGBR = new javax.swing.JMenuItem();
        jMenuItemColorModeGRB = new javax.swing.JMenuItem();
        jMenuItemImageInfo = new javax.swing.JMenuItem();
        jMenuItemImageSegmentationWithinSelectedSpectroscopicVolume = new javax.swing.JMenuItem();
        m_onlineHelpImageMenuItem = new javax.swing.JMenuItem();
        jMenuVoxelSelection = new javax.swing.JMenu();
        jMenuItemSelectAll = new javax.swing.JMenuItem();
        jMenuItemSelectExcitedVoxels = new javax.swing.JMenuItem();
        jMenuItemSelectInnerExcitedVoxels = new javax.swing.JMenuItem();
        jMenuItemSelectVoxelsFeatureBased = new javax.swing.JMenuItem();
        jMenuItemSelectFreeHand = new javax.swing.JMenuItem();
        jMenuItemSelectGoodQualityVoxels = new javax.swing.JMenuItem();
        jMenuItemRemoveSaturatedVoxels = new javax.swing.JMenuItem();
        jMenuItemChangeSelectionGroup = new javax.swing.JMenuItem();
        jMenuItemMirrorSelection = new javax.swing.JMenuItem();
        jMenuItemDisplayXYPlotGridOfSelection = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JPopupMenu.Separator();
        jMenuItemSvGridPrst = new javax.swing.JMenuItem();
        jCheckBoxMenuItemAddToCurrentGridSelection = new javax.swing.JCheckBoxMenuItem();
        jMenuLdGridPrst = new javax.swing.JMenu();
        jMenuRmGridPrst = new javax.swing.JMenu();
        jMenuItemTumourRegionSelection = new javax.swing.JMenuItem();
        m_onlineHelpMRSIvoxelSelection = new javax.swing.JMenuItem();
        jMenuProcessing = new javax.swing.JMenu();
        jMenuItemRemoveWaterHLSVDPro = new javax.swing.JMenuItem();
        jMenuItemRemoveWaterHLSVDKernal = new javax.swing.JMenuItem();
        jMenuItemRemoveWaterHLSVD64 = new javax.swing.JMenuItem();
        jMenuItemRemoveWaterTDFDFit = new javax.swing.JMenuItem();
        jCheckBoxMenuItemNormalize = new javax.swing.JCheckBoxMenuItem();
        jMenuItemZeroFilling = new javax.swing.JMenuItem();
        jMenuItemTruncateDataTD = new javax.swing.JMenuItem();
        jMenuItemOffsetCorrectionFD = new javax.swing.JMenuItem();
        jMenuItemOffsetCorrectionTD = new javax.swing.JMenuItem();
        jMenuItemApodization = new javax.swing.JMenuItem();
        jMenuItemShiftScale = new javax.swing.JMenuItem();
        jMenuItemAutoPhasing = new javax.swing.JMenuItem();
        jMenuItemManualPhasing = new javax.swing.JMenuItem();
        jMenuItemComplexConjugation = new javax.swing.JMenuItem();
        jMenuItemWritejMRUIResults = new javax.swing.JMenuItem();
        jMenuItemPrintQulatificationResultsforSelectedVoxels = new javax.swing.JMenuItem();
        jMenuItemPrintjMRUIResults = new javax.swing.JMenuItem();
        jSeparator5 = new javax.swing.JPopupMenu.Separator();
        jMenuItemNewTDFDfitModelling = new javax.swing.JMenuItem();
        jMenuItemEditSelectedTDFDfitModel = new javax.swing.JMenuItem();
        jMenuItemQuantitativeClinicalCaseTDFDfitting = new javax.swing.JMenuItem();
        jMenuItemQuantifyTDFDfit = new javax.swing.JMenuItem();
        jMenuItemOutlierRemovalUsingNeighbours = new javax.swing.JMenuItem();
        jMenuItemPrintTDFDFitResultsToScreen = new javax.swing.JMenuItem();
        jMenuItemWriteTDFDFitResultsToTextFile = new javax.swing.JMenuItem();
        jMenuItemWriteAverageTDFDFitResultsToTextFile = new javax.swing.JMenuItem();
        m_automaticStoreTDFDFitResultsCheckBoxMenuItem = new javax.swing.JCheckBoxMenuItem();
        jMenuItemLoadTDFDFitQuantificationResults = new javax.swing.JMenuItem();
        jSeparator4 = new javax.swing.JPopupMenu.Separator();
        jMenuItemProcessAllSeries = new javax.swing.JMenuItem();
        jMenuItemProcessAllSeriesFolder = new javax.swing.JMenuItem();
        jSeparator21 = new javax.swing.JPopupMenu.Separator();
        jMenuItemReadMatchingPreproceesingResults = new javax.swing.JMenuItem();
        jMenuItemWriteMatchingPreproceesingResults1 = new javax.swing.JMenuItem();
        m_onlineHelpProcessingjMenuItem = new javax.swing.JMenuItem();
        jMenuMap = new javax.swing.JMenu();
        jMenuItemClearMap = new javax.swing.JMenuItem();
        jSeparator8 = new javax.swing.JPopupMenu.Separator();
        jMenuItemColorMapUI = new javax.swing.JMenuItem();
        jMenuItemMapjMRUIResults = new javax.swing.JMenuItem();
        jSeparator11 = new javax.swing.JPopupMenu.Separator();
        jMenuItemPrintMapStats = new javax.swing.JMenuItem();
        jMenuItemPrintMapSelectionStats = new javax.swing.JMenuItem();
        jSeparator7 = new javax.swing.JPopupMenu.Separator();
        jMenuItemMapFromMAT = new javax.swing.JMenuItem();
        jMenuItemExportMapToMAT = new javax.swing.JMenuItem();
        jMenuItemExportNormalizedMapToMAT = new javax.swing.JMenuItem();
        jMenuItemCorrectMapFromMAT = new javax.swing.JMenuItem();
        jSeparator20 = new javax.swing.JPopupMenu.Separator();
        jMenuItemImportExternalLabelCSVFile = new javax.swing.JMenuItem();
        m_onlineHelpMapjMenuItem = new javax.swing.JMenuItem();
        jMenuReports = new javax.swing.JMenu();
        jMenuItemGenerateCstm = new javax.swing.JMenuItem();
        jMenuLoadCstm = new javax.swing.JMenu();
        jMenuRmCstm = new javax.swing.JMenu();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        jMenuStdReport = new javax.swing.JMenu();
        jMenuItemGenerateStdMetMap = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        jMenuItemCompCtrl = new javax.swing.JMenuItem();
        jCheckBoxSeparateSpectra = new StayOpenCheckBoxMenuItem();
        m_onlineHelpReportjMenuItem = new javax.swing.JMenuItem();
        jMenuQualityControl = new javax.swing.JMenu();
        jMenuItemLabelling = new javax.swing.JMenuItem();
        jMenuItemLabellingConsensus = new javax.swing.JMenuItem();
        jSeparator13 = new javax.swing.JPopupMenu.Separator();
        jMenuItemLabellingAnalyser = new javax.swing.JMenuItem();
        jSeparator12 = new javax.swing.JPopupMenu.Separator();
        jMenuItemClassifyQuality = new javax.swing.JMenuItem();
        m_qualityControljMenuItem = new javax.swing.JMenuItem();
        jMenuImportExport = new javax.swing.JMenu();
        jMenuItemExportSpectrum = new javax.swing.JMenuItem();
        jMenuItemExportSelectedSpectra = new javax.swing.JMenuItem();
        jMenuItemImportSpectrum = new javax.swing.JMenuItem();
        jSeparator14 = new javax.swing.JPopupMenu.Separator();
        jMenuItemImportJMruiResults = new javax.swing.JMenuItem();
        jMenuItemClearJMRUIData = new javax.swing.JMenuItem();
        m_onlineHelpjMRUIImportExportMenuItem = new javax.swing.JMenuItem();
        jMenu1 = new javax.swing.JMenu();
        jMenuItemConfigNetworkNodes = new javax.swing.JMenuItem();
        jMenuItemDICOMNetworkListenerControl = new javax.swing.JMenuItem();
        jCheckBoxMenuItemAutomaticProcessing = new javax.swing.JCheckBoxMenuItem();
        m_onlineHelpDicomNetworkjMenuItem = new javax.swing.JMenuItem();
        jMenuPatient = new javax.swing.JMenu();
        jMenuPatientBrowser = new javax.swing.JMenuItem();
        m_onlineHelpClinicalCasesjMenuItem = new javax.swing.JMenuItem();
        jMenuHelp = new javax.swing.JMenu();
        jMenuItemAbout = new javax.swing.JMenuItem();
        jMenuItemOnlineHelp = new javax.swing.JMenuItem();

        jMenuItem2.setText("jMenuItem2");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setResizeWeight(1.0);
        jSplitPane1.setToolTipText("");
        jSplitPane1.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jSplitPane1.setMinimumSize(new java.awt.Dimension(0, 0));

        pnlMain.setMinimumSize(new java.awt.Dimension(132, 99));
        pnlMain.setPreferredSize(new java.awt.Dimension(1280, 384));
        pnlMain.setLayout(new java.awt.GridBagLayout());

        jSlider1.setAlignmentY(0.0F);
        jSlider1.setPreferredSize(new java.awt.Dimension(384, 24));
        jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider1StateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 20, 0);
        pnlMain.add(jSlider1, gridBagConstraints);

        pnlImage.setBackground(new java.awt.Color(0, 0, 0));
        pnlImage.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED, new java.awt.Color(0, 0, 255), new java.awt.Color(0, 0, 255)));
        pnlImage.setMinimumSize(new java.awt.Dimension(256, 256));
        pnlImage.setPreferredSize(new java.awt.Dimension(33, 33));
        pnlImage.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        pnlMain.add(pnlImage, gridBagConstraints);

        pnlView.setBackground(new java.awt.Color(0, 0, 0));
        pnlView.setPreferredSize(new java.awt.Dimension(33, 99));
        pnlView.setLayout(new java.awt.GridLayout(3, 1));

        pnlViewTra.setBackground(new java.awt.Color(0, 0, 0));
        pnlViewTra.setBorder(javax.swing.BorderFactory.createEtchedBorder(new java.awt.Color(0, 204, 0), new java.awt.Color(0, 204, 0)));
        pnlViewTra.setMinimumSize(new java.awt.Dimension(33, 33));
        pnlViewTra.setPreferredSize(new java.awt.Dimension(33, 33));
        pnlViewTra.setLayout(new java.awt.BorderLayout());
        pnlView.add(pnlViewTra);

        pnlViewCor.setBackground(new java.awt.Color(0, 0, 0));
        pnlViewCor.setBorder(javax.swing.BorderFactory.createEtchedBorder(new java.awt.Color(204, 204, 0), new java.awt.Color(204, 204, 0)));
        pnlViewCor.setMinimumSize(new java.awt.Dimension(33, 33));
        pnlViewCor.setPreferredSize(new java.awt.Dimension(33, 33));
        pnlViewCor.setLayout(new java.awt.BorderLayout());
        pnlView.add(pnlViewCor);

        pnlViewSag.setBackground(new java.awt.Color(0, 0, 0));
        pnlViewSag.setBorder(javax.swing.BorderFactory.createEtchedBorder(new java.awt.Color(255, 0, 0), new java.awt.Color(255, 0, 0)));
        pnlViewSag.setMinimumSize(new java.awt.Dimension(33, 33));
        pnlViewSag.setPreferredSize(new java.awt.Dimension(33, 33));
        pnlViewSag.setLayout(new java.awt.BorderLayout());
        pnlView.add(pnlViewSag);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 20, 0);
        pnlMain.add(pnlView, gridBagConstraints);

        pnlData.setPreferredSize(new java.awt.Dimension(598, 512));
        pnlData.setLayout(new java.awt.BorderLayout());

        jSplitPane2.setDividerLocation(200);
        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane2.setResizeWeight(0.8);

        pnlSpectrum.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        pnlSpectrum.setMaximumSize(new java.awt.Dimension(9999, 9999));
        pnlSpectrum.setPreferredSize(new java.awt.Dimension(800, 384));
        jSplitPane2.setTopComponent(pnlSpectrum);
        pnlSpectrum.setVisible(true);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jTextAreaOutput.setEditable(false);
        jTextAreaOutput.setColumns(20);
        jTextAreaOutput.setRows(5);
        jScrollPane1.setViewportView(jTextAreaOutput);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jCheckBoxClipboard.setText("Auto Copy to Clipboard");
        jCheckBoxClipboard.setToolTipText("Automatically copy to clipboard content printed on the Output Panel (Image parameters, Map parameters, etc.).");
        jCheckBoxClipboard.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxClipboardActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_END;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jCheckBoxClipboard, gridBagConstraints);

        jComboBoxSpectraCombinationFunction.setToolTipText("Grouping mode for selections of more than one spectrum.");
        jComboBoxSpectraCombinationFunction.setMinimumSize(new java.awt.Dimension(150, 25));
        jComboBoxSpectraCombinationFunction.setName(""); // NOI18N
        jComboBoxSpectraCombinationFunction.setPreferredSize(new java.awt.Dimension(90, 25));
        jComboBoxSpectraCombinationFunction.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxSpectraCombinationFunctionActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 100;
        gridBagConstraints.ipady = 3;
        gridBagConstraints.weightx = 0.7;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 1, 0, 0);
        jPanel2.add(jComboBoxSpectraCombinationFunction, gridBagConstraints);

        jComboBoxSpectraDomain.setMinimumSize(new java.awt.Dimension(150, 25));
        jComboBoxSpectraDomain.setName(""); // NOI18N
        jComboBoxSpectraDomain.setPreferredSize(new java.awt.Dimension(90, 25));
        jComboBoxSpectraDomain.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxSpectraDomainActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 100;
        gridBagConstraints.ipady = 3;
        gridBagConstraints.weightx = 0.3;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 1, 0, 0);
        jPanel2.add(jComboBoxSpectraDomain, gridBagConstraints);

        jPanel4.setLayout(new java.awt.GridLayout(1, 0));

        jLabel4.setText("Selection Group:");
        jPanel4.add(jLabel4);

        buttonGroupSelection.add(jRadioButtonSelectBlue);
        jRadioButtonSelectBlue.setSelected(true);
        jRadioButtonSelectBlue.setText("Blue");
        jRadioButtonSelectBlue.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSelectBlueActionPerformed(evt);
            }
        });
        jPanel4.add(jRadioButtonSelectBlue);

        buttonGroupSelection.add(jRadioButtonSelectRed);
        jRadioButtonSelectRed.setText("Red");
        jRadioButtonSelectRed.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSelectRedActionPerformed(evt);
            }
        });
        jPanel4.add(jRadioButtonSelectRed);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        jPanel2.add(jPanel4, gridBagConstraints);

        jCheckBoxAbsorption.setSelected(true);
        jCheckBoxAbsorption.setText("Absorption");
        jCheckBoxAbsorption.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxAbsorptionActionPerformed(evt);
            }
        });

        jCheckBoxDispersion.setText("Dispersion");
        jCheckBoxDispersion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxDispersionActionPerformed(evt);
            }
        });

        jCheckBoxMagnitude.setText("Magnitude");
        jCheckBoxMagnitude.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMagnitudeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCheckBoxAbsorption)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCheckBoxDispersion)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCheckBoxMagnitude)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCheckBoxAbsorption)
                    .addComponent(jCheckBoxDispersion)
                    .addComponent(jCheckBoxMagnitude)))
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_END;
        jPanel2.add(jPanel5, gridBagConstraints);

        jLabel5.setText("Processing Action:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        jPanel2.add(jLabel5, gridBagConstraints);

        jComboBoxProcessingAction.setToolTipText("Allows selecting the currently active Processing Action");
        jComboBoxProcessingAction.setEnabled(false);
        jComboBoxProcessingAction.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxProcessingActionActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipady = 3;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jComboBoxProcessingAction, gridBagConstraints);

        jLabel6.setText("Domain:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel2.add(jLabel6, gridBagConstraints);

        jLabel7.setText("Grouping:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanel2.add(jLabel7, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        jPanel2.add(jSeparator18, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        jPanel2.add(jSeparator19, gridBagConstraints);

        jPanel7.setLayout(new java.awt.GridBagLayout());

        jButtonProcessData.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jButtonProcessData.setText("Process Data");
        jButtonProcessData.setToolTipText("Executes Processing Action");
        jButtonProcessData.setEnabled(false);
        jButtonProcessData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonProcessDataActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanel7.add(jButtonProcessData, gridBagConstraints);

        jButtonJustPreprocess.setText("Just Pre-Process");
        jButtonJustPreprocess.setToolTipText("Executes just Pre-processing Action from currently selected Processing Action");
        jButtonJustPreprocess.setEnabled(false);
        jButtonJustPreprocess.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonJustPreprocessActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel7.add(jButtonJustPreprocess, gridBagConstraints);

        jButtonJustQuantify.setText("Just Quantify");
        jButtonJustQuantify.setToolTipText("Executes just Quantification Action from currently selected Processing Action");
        jButtonJustQuantify.setEnabled(false);
        jButtonJustQuantify.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonJustQuantifyActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel7.add(jButtonJustQuantify, gridBagConstraints);

        jButtonJustHandleResults.setText("Just Handle Results");
        jButtonJustHandleResults.setEnabled(false);
        jButtonJustHandleResults.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonJustHandleResultsActionPerformed(evt);
            }
        });
        jPanel7.add(jButtonJustHandleResults, new java.awt.GridBagConstraints());

        jButtonSelectMetabolites.setText("Select Metabolites");
        jButtonSelectMetabolites.setToolTipText("Only possible for Processing Actions whose Quantification uses separate .mrui files");
        jButtonSelectMetabolites.setEnabled(false);
        jButtonSelectMetabolites.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSelectMetabolitesActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel7.add(jButtonSelectMetabolites, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel2.add(jPanel7, gridBagConstraints);

        jPanel1.add(jPanel2, java.awt.BorderLayout.NORTH);

        jSplitPane2.setBottomComponent(jPanel1);

        pnlData.add(jSplitPane2, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 20, 0);
        pnlMain.add(pnlData, gridBagConstraints);

        jSplitPane1.setTopComponent(pnlMain);

        pnlFileManager.setFocusCycleRoot(true);
        pnlFileManager.setFocusable(false);
        pnlFileManager.setMinimumSize(new java.awt.Dimension(1280, 200));
        pnlFileManager.setPreferredSize(new java.awt.Dimension(1280, 200));
        pnlFileManager.setLayout(new java.awt.GridLayout(1, 0));
        jSplitPane1.setRightComponent(pnlFileManager);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jPanel3.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jPanel3.setMinimumSize(new java.awt.Dimension(20, 20));
        jPanel3.setPreferredSize(new java.awt.Dimension(100, 20));
        jPanel3.setRequestFocusEnabled(false);

        jLabel1.setText("X:");

        jLabel2.setText("Value:");

        jLabel3.setText("Y:");

        jLabelIntensityValue.setText("           ");

        jLabelXValue.setText("           ");

        jLabelYValue.setText("           ");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(1041, Short.MAX_VALUE)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 12, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelXValue)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 12, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelYValue)
                .addGap(18, 18, 18)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 39, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelIntensityValue, javax.swing.GroupLayout.PREFERRED_SIZE, 54, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jLabelIntensityValue)
                .addComponent(jLabelYValue)
                .addComponent(jLabelXValue))
        );

        getContentPane().add(jPanel3, java.awt.BorderLayout.SOUTH);

        jMenuFile.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jMenuFile.setMnemonic('F');
        jMenuFile.setText("File");
        jMenuFile.setToolTipText("");

        jMenuItemOpenCSI.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemOpenCSI.setText("Open Dicom Image/Spectroscopy File...");
        jMenuItemOpenCSI.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemOpenCSIActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemOpenCSI);

        jMenuItemOpenMRUIFormattedCSI.setText("Open jMRUI Spectroscopy File (.mrui)...");
        jMenuItemOpenMRUIFormattedCSI.setEnabled(false);
        jMenuItemOpenMRUIFormattedCSI.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemOpenMRUIFormattedCSIActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemOpenMRUIFormattedCSI);

        jMenuItemMountDir.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_M, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemMountDir.setText("Mount directory...");
        jMenuItemMountDir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemMountDirActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemMountDir);
        jMenuFile.add(jSeparator10);

        jMenuItemSaveAllToMAT.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSaveAllToMAT.setText("Export spectra to .MAT file ...");
        jMenuItemSaveAllToMAT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSaveAllToMATActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemSaveAllToMAT);

        jMenuItemSaveSelectionToMAT.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSaveSelectionToMAT.setText("Export selected spectra to .MAT file ...");
        jMenuItemSaveSelectionToMAT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSaveSelectionToMATActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemSaveSelectionToMAT);

        jMenuItemExportTDSignalsToCSV.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemExportTDSignalsToCSV.setText("Export TD and/or FD-signals to CSV format...");
        jMenuItemExportTDSignalsToCSV.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemExportTDSignalsToCSVActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemExportTDSignalsToCSV);

        jMenuItemImportTDSignalsFromCSV.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_I, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemImportTDSignalsFromCSV.setText("Import TD and/or FD-signals from CSV format...");
        jMenuItemImportTDSignalsFromCSV.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImportTDSignalsFromCSVActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemImportTDSignalsFromCSV);

        jMenuItemExportSelectedSpectraTojMRUIFormat.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_J, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemExportSelectedSpectraTojMRUIFormat.setText("Export selected signals to jMRUI format...");
        jMenuItemExportSelectedSpectraTojMRUIFormat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemExportSelectedSpectraTojMRUIFormatActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemExportSelectedSpectraTojMRUIFormat);

        jMenuItemImportSelectedSpectraFromjMRUIFormat.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_7, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemImportSelectedSpectraFromjMRUIFormat.setText("Import signals from jMRUI format (association) ...");
        jMenuItemImportSelectedSpectraFromjMRUIFormat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImportSelectedSpectraFromjMRUIFormatActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemImportSelectedSpectraFromjMRUIFormat);

        jMenuItemImportjMRUIFormattedResultsFile.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_R, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemImportjMRUIFormattedResultsFile.setText("Import jMRUI formatted results file (association) ...");
        jMenuItemImportjMRUIFormattedResultsFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImportjMRUIFormattedResultsFileActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemImportjMRUIFormattedResultsFile);

        jMenuItemImportAIPredictedValuesFromCSV.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_I, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemImportAIPredictedValuesFromCSV.setText("Import AI-predicted from CSV formatted file...");
        jMenuItemImportAIPredictedValuesFromCSV.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImportAIPredictedValuesFromCSVActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemImportAIPredictedValuesFromCSV);

        jMenuItemImportMidasPreprocessedValuesFromBinaryFile.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_E, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemImportMidasPreprocessedValuesFromBinaryFile.setText("Import Midas preprocessed EPSI data file...");
        jMenuItemImportMidasPreprocessedValuesFromBinaryFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImportMidasPreprocessedValuesFromBinaryFileActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemImportMidasPreprocessedValuesFromBinaryFile);

        jMenuItemSaveSelectionTojMRUI.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuItemSaveSelectionTojMRUI.setText("Save Quantification Results in jMRUI [.mrui] format...");
        jMenuItemSaveSelectionTojMRUI.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSaveSelectionTojMRUIActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemSaveSelectionTojMRUI);
        jMenuFile.add(jSeparator9);

        jMenuItemClearImage.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_U, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemClearImage.setText("Unload Image Stack");
        jMenuItemClearImage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClearImageActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemClearImage);

        jMenuItemClearGrid.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_U, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemClearGrid.setText("Unload Spectroscopy");
        jMenuItemClearGrid.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClearGridActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemClearGrid);
        jMenuFile.add(jSeparator6);

        jMenuItemSettings.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSettings.setText("Settings...");
        jMenuItemSettings.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSettingsActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemSettings);

        m_onlineHelpFileMenuItem.setText("Online help File menu ..");
        m_onlineHelpFileMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_onlineHelpFileMenuItemActionPerformed(evt);
            }
        });
        jMenuFile.add(m_onlineHelpFileMenuItem);

        jMenuBar2.add(jMenuFile);

        jMenuView.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jMenuView.setMnemonic('V');
        jMenuView.setText("View");
        jMenuView.setContentAreaFilled(false);

        jCheckBoxMenuItemShowPatientName.setSelected(true);
        jCheckBoxMenuItemShowPatientName.setText("Patient Name");
        jCheckBoxMenuItemShowPatientName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemShowPatientNameActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemShowPatientName);

        jCheckBoxMenuItemShowSeriesInfo.setSelected(true);
        jCheckBoxMenuItemShowSeriesInfo.setText("Series Information");
        jCheckBoxMenuItemShowSeriesInfo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemShowSeriesInfoActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemShowSeriesInfo);

        jCheckBoxMenuItemViewSliceOrientation.setText("Slice Orientation");
        jCheckBoxMenuItemViewSliceOrientation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemViewSliceOrientationActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemViewSliceOrientation);

        jCheckBoxMenuItemViewSpectraThumbnail.setSelected(true);
        jCheckBoxMenuItemViewSpectraThumbnail.setText("Mouseover Spectrum Preview");
        jCheckBoxMenuItemViewSpectraThumbnail.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemViewSpectraThumbnailActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemViewSpectraThumbnail);
        jMenuView.add(jSeparator16);

        jCheckBoxMenuItemShowIntersectsMain.setText("Intersections in main image");
        jCheckBoxMenuItemShowIntersectsMain.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemShowIntersectsMainActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemShowIntersectsMain);

        jCheckBoxMenuItemViewGrid.setSelected(true);
        jCheckBoxMenuItemViewGrid.setText("MRSI Grid");
        jCheckBoxMenuItemViewGrid.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemViewGridActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemViewGrid);

        jCheckBoxMenuItemViewSaturationBands.setSelected(true);
        jCheckBoxMenuItemViewSaturationBands.setText("Saturation Bands");
        jCheckBoxMenuItemViewSaturationBands.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemViewSaturationBandsActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemViewSaturationBands);
        jMenuView.add(jSeparator17);

        jCheckBoxShowMapValues.setSelected(true);
        jCheckBoxShowMapValues.setText("Numerical Values in Map");
        jCheckBoxShowMapValues.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxShowMapValuesActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxShowMapValues);

        jCheckBoxShowColorBar.setSelected(true);
        jCheckBoxShowColorBar.setText("Color Bar");
        jCheckBoxShowColorBar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxShowColorBarActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxShowColorBar);
        jMenuView.add(jSeparator15);

        jCheckBoxShowOriginalSpectra.setSelected(true);
        jCheckBoxShowOriginalSpectra.setText("Original Spectra");
        jCheckBoxShowOriginalSpectra.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxShowOriginalSpectraActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxShowOriginalSpectra);

        jCheckBoxShowFittedSpectra.setSelected(true);
        jCheckBoxShowFittedSpectra.setText("Fitted Spectra");
        jCheckBoxShowFittedSpectra.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxShowFittedSpectraActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxShowFittedSpectra);

        jCheckBoxShowDifference.setText("Show Difference");
        jCheckBoxShowDifference.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxShowDifferenceActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxShowDifference);

        m_onlineHelpViewjMenuItem.setText("Online help view menu ..");
        m_onlineHelpViewjMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_onlineHelpViewjMenuItemActionPerformed(evt);
            }
        });
        jMenuView.add(m_onlineHelpViewjMenuItem);

        jMenuBar2.add(jMenuView);

        jMenuImage.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jMenuImage.setMnemonic('I');
        jMenuImage.setText("Image");

        jMenuItemAutoWindowing.setText("Auto-Windowing");
        jMenuItemAutoWindowing.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAutoWindowingActionPerformed(evt);
            }
        });
        jMenuImage.add(jMenuItemAutoWindowing);

        jMenuColorMode.setText("Set Color Scale");

        jMenuItemColorModeGray.setText("Gray levels");
        jMenuItemColorModeGray.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemColorModeGrayActionPerformed(evt);
            }
        });
        jMenuColorMode.add(jMenuItemColorModeGray);

        jMenuItemColorModeRGB.setText("Red->Green->Blue");
        jMenuItemColorModeRGB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemColorModeRGBActionPerformed(evt);
            }
        });
        jMenuColorMode.add(jMenuItemColorModeRGB);

        jMenuItemColorModeBGR.setText("Blue->Green->Red");
        jMenuItemColorModeBGR.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemColorModeBGRActionPerformed(evt);
            }
        });
        jMenuColorMode.add(jMenuItemColorModeBGR);

        jMenuItemColorModeRBG.setText("Red->Blue->Green");
        jMenuItemColorModeRBG.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemColorModeRBGActionPerformed(evt);
            }
        });
        jMenuColorMode.add(jMenuItemColorModeRBG);

        jMenuItemColorModeBRG.setText("Blue->Red->Green");
        jMenuItemColorModeBRG.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemColorModeBRGActionPerformed(evt);
            }
        });
        jMenuColorMode.add(jMenuItemColorModeBRG);

        jMenuItemColorModeGBR.setText("Green->Blue->Red");
        jMenuItemColorModeGBR.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemColorModeGBRActionPerformed(evt);
            }
        });
        jMenuColorMode.add(jMenuItemColorModeGBR);

        jMenuItemColorModeGRB.setText("Green->Red->Blue");
        jMenuItemColorModeGRB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemColorModeGRBActionPerformed(evt);
            }
        });
        jMenuColorMode.add(jMenuItemColorModeGRB);

        jMenuImage.add(jMenuColorMode);

        jMenuItemImageInfo.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemImageInfo.setText("Print Image Statistical Parameters for Selected Region");
        jMenuItemImageInfo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImageInfoActionPerformed(evt);
            }
        });
        jMenuImage.add(jMenuItemImageInfo);

        jMenuItemImageSegmentationWithinSelectedSpectroscopicVolume.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemImageSegmentationWithinSelectedSpectroscopicVolume.setText("Image Segmentation with Selected Spectroscopic Region");
        jMenuItemImageSegmentationWithinSelectedSpectroscopicVolume.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImageSegmentationWithinSelectedSpectroscopicVolumeActionPerformed(evt);
            }
        });
        jMenuImage.add(jMenuItemImageSegmentationWithinSelectedSpectroscopicVolume);

        m_onlineHelpImageMenuItem.setText("On line help Image menu ..");
        m_onlineHelpImageMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_onlineHelpImageMenuItemActionPerformed(evt);
            }
        });
        jMenuImage.add(m_onlineHelpImageMenuItem);

        jMenuBar2.add(jMenuImage);

        jMenuVoxelSelection.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jMenuVoxelSelection.setMnemonic('V');
        jMenuVoxelSelection.setText("MRSI voxel selection");

        jMenuItemSelectAll.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSelectAll.setText("Select All Voxels");
        jMenuItemSelectAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSelectAllActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemSelectAll);

        jMenuItemSelectExcitedVoxels.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_E, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSelectExcitedVoxels.setText("Select Excited Voxels");
        jMenuItemSelectExcitedVoxels.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSelectExcitedVoxelsActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemSelectExcitedVoxels);

        jMenuItemSelectInnerExcitedVoxels.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_E, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSelectInnerExcitedVoxels.setText("Select Inner Excited Voxels");
        jMenuItemSelectInnerExcitedVoxels.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSelectInnerExcitedVoxelsActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemSelectInnerExcitedVoxels);

        jMenuItemSelectVoxelsFeatureBased.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSelectVoxelsFeatureBased.setText("Spectral Feature Based Selection");
        jMenuItemSelectVoxelsFeatureBased.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSelectVoxelsFeatureBasedActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemSelectVoxelsFeatureBased);

        jMenuItemSelectFreeHand.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_D, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSelectFreeHand.setText("Free Hand Selection");
        jMenuItemSelectFreeHand.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSelectFreeHandActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemSelectFreeHand);

        jMenuItemSelectGoodQualityVoxels.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSelectGoodQualityVoxels.setText("Select Good Quality Voxels");
        jMenuItemSelectGoodQualityVoxels.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSelectGoodQualityVoxelsActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemSelectGoodQualityVoxels);

        jMenuItemRemoveSaturatedVoxels.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemRemoveSaturatedVoxels.setText("Remove Saturated Voxels");
        jMenuItemRemoveSaturatedVoxels.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemoveSaturatedVoxelsActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemRemoveSaturatedVoxels);

        jMenuItemChangeSelectionGroup.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_SPACE, 0));
        jMenuItemChangeSelectionGroup.setText("Change Selection Group");
        jMenuItemChangeSelectionGroup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemChangeSelectionGroupActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemChangeSelectionGroup);

        jMenuItemMirrorSelection.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_SPACE, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemMirrorSelection.setText("Mirror Selection");
        jMenuItemMirrorSelection.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemMirrorSelectionActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemMirrorSelection);

        jMenuItemDisplayXYPlotGridOfSelection.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_G, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemDisplayXYPlotGridOfSelection.setText("XY-plots of Selection ");
        jMenuItemDisplayXYPlotGridOfSelection.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemDisplayXYPlotGridOfSelectionActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemDisplayXYPlotGridOfSelection);
        jMenuVoxelSelection.add(jSeparator3);

        jMenuItemSvGridPrst.setText("Save selection as preset...");
        jMenuItemSvGridPrst.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSvGridPrstActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemSvGridPrst);

        jCheckBoxMenuItemAddToCurrentGridSelection.setSelected(true);
        jCheckBoxMenuItemAddToCurrentGridSelection.setText("Add to Current Selection");
        jMenuVoxelSelection.add(jCheckBoxMenuItemAddToCurrentGridSelection);

        jMenuLdGridPrst.setText("Load selection preset");
        jMenuLdGridPrst.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jMenuLdGridPrstMouseEntered(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuLdGridPrst);

        jMenuRmGridPrst.setText("Remove selection preset");
        jMenuRmGridPrst.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jMenuRmGridPrstMouseEntered(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuRmGridPrst);

        jMenuItemTumourRegionSelection.setText("Tumour Region Selection");
        jMenuItemTumourRegionSelection.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemTumourRegionSelectionActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(jMenuItemTumourRegionSelection);

        m_onlineHelpMRSIvoxelSelection.setText("Online help MRSI voxel selection menu ..");
        m_onlineHelpMRSIvoxelSelection.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_onlineHelpMRSIvoxelSelectionActionPerformed(evt);
            }
        });
        jMenuVoxelSelection.add(m_onlineHelpMRSIvoxelSelection);

        jMenuBar2.add(jMenuVoxelSelection);

        jMenuProcessing.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jMenuProcessing.setMnemonic('P');
        jMenuProcessing.setText("Processing");

        jMenuItemRemoveWaterHLSVDPro.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_H, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemRemoveWaterHLSVDPro.setText("Remove Water (HLSVDPro)");
        jMenuItemRemoveWaterHLSVDPro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemoveWaterHLSVDProActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemRemoveWaterHLSVDPro);

        jMenuItemRemoveWaterHLSVDKernal.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_H, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemRemoveWaterHLSVDKernal.setText("Remove Water (HLSVD) ..");
        jMenuItemRemoveWaterHLSVDKernal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemoveWaterHLSVDKernalActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemRemoveWaterHLSVDKernal);

        jMenuItemRemoveWaterHLSVD64.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_H, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemRemoveWaterHLSVD64.setText("Remove Water (HLSVD 64-bits)");
        jMenuItemRemoveWaterHLSVD64.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemoveWaterHLSVD64ActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemRemoveWaterHLSVD64);

        jMenuItemRemoveWaterTDFDFit.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_T, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemRemoveWaterTDFDFit.setText("Remove Water (TDFDfit)");
        jMenuItemRemoveWaterTDFDFit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemoveWaterTDFDFitActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemRemoveWaterTDFDFit);

        jCheckBoxMenuItemNormalize.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.CTRL_MASK));
        jCheckBoxMenuItemNormalize.setText("Normalize (with Std. Dev. Noise)");
        jCheckBoxMenuItemNormalize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemNormalizeActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jCheckBoxMenuItemNormalize);

        jMenuItemZeroFilling.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Z, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemZeroFilling.setText("Zero Filling...");
        jMenuItemZeroFilling.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemZeroFillingActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemZeroFilling);

        jMenuItemTruncateDataTD.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_T, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemTruncateDataTD.setText("Truncate data in TD");
        jMenuItemTruncateDataTD.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemTruncateDataTDActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemTruncateDataTD);

        jMenuItemOffsetCorrectionFD.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemOffsetCorrectionFD.setText("Offset correction in Frequency Domain");
        jMenuItemOffsetCorrectionFD.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemOffsetCorrectionFDActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemOffsetCorrectionFD);

        jMenuItemOffsetCorrectionTD.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_T, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemOffsetCorrectionTD.setText("Offset correction in Time Domain");
        jMenuItemOffsetCorrectionTD.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemOffsetCorrectionTDActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemOffsetCorrectionTD);

        jMenuItemApodization.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemApodization.setText("Apodization...");
        jMenuItemApodization.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemApodizationActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemApodization);

        jMenuItemShiftScale.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemShiftScale.setText("Correct Frequency Shift...");
        jMenuItemShiftScale.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemShiftScaleActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemShiftScale);

        jMenuItemAutoPhasing.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemAutoPhasing.setText("Auto-Phasing...");
        jMenuItemAutoPhasing.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAutoPhasingActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemAutoPhasing);

        jMenuItemManualPhasing.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_M, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemManualPhasing.setText("Manual-Phasing...");
        jMenuItemManualPhasing.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemManualPhasingActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemManualPhasing);

        jMenuItemComplexConjugation.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemComplexConjugation.setText("Flip spectra (complex conjugation)");
        jMenuItemComplexConjugation.setToolTipText("");
        jMenuItemComplexConjugation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemComplexConjugationActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemComplexConjugation);

        jMenuItemWritejMRUIResults.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_W, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemWritejMRUIResults.setText("Write Quantitation Results...");
        jMenuItemWritejMRUIResults.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemWritejMRUIResultsActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemWritejMRUIResults);

        jMenuItemPrintQulatificationResultsforSelectedVoxels.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemPrintQulatificationResultsforSelectedVoxels.setText("Print Quantitation for Selected Voxels");
        jMenuItemPrintQulatificationResultsforSelectedVoxels.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemPrintQulatificationResultsforSelectedVoxelsActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemPrintQulatificationResultsforSelectedVoxels);

        jMenuItemPrintjMRUIResults.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemPrintjMRUIResults.setText("Print Quantitation Results");
        jMenuItemPrintjMRUIResults.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemPrintjMRUIResultsActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemPrintjMRUIResults);
        jMenuProcessing.add(jSeparator5);

        jMenuItemNewTDFDfitModelling.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemNewTDFDfitModelling.setText("Create new TDFDFit model...");
        jMenuItemNewTDFDfitModelling.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemNewTDFDfitModellingActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemNewTDFDfitModelling);

        jMenuItemEditSelectedTDFDfitModel.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuItemEditSelectedTDFDfitModel.setText("Edit selected TDFDFit model...");
        jMenuItemEditSelectedTDFDfitModel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemEditSelectedTDFDfitModelActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemEditSelectedTDFDfitModel);

        jMenuItemQuantitativeClinicalCaseTDFDfitting.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuItemQuantitativeClinicalCaseTDFDfitting.setText("Quantitative-SVS of loaded clinical case (TDFDFit) ...");
        jMenuItemQuantitativeClinicalCaseTDFDfitting.setEnabled(false);
        jMenuItemQuantitativeClinicalCaseTDFDfitting.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemQuantitativeClinicalCaseTDFDfittingActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemQuantitativeClinicalCaseTDFDfitting);

        jMenuItemQuantifyTDFDfit.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemQuantifyTDFDfit.setText("Quantify Spectra (TDFDFit)");
        jMenuItemQuantifyTDFDfit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemQuantifyTDFDfitActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemQuantifyTDFDfit);

        jMenuItemOutlierRemovalUsingNeighbours.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemOutlierRemovalUsingNeighbours.setText("Outlier removal - (using neighbour information)");
        jMenuItemOutlierRemovalUsingNeighbours.setEnabled(false);
        jMenuItemOutlierRemovalUsingNeighbours.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemOutlierRemovalUsingNeighboursActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemOutlierRemovalUsingNeighbours);

        jMenuItemPrintTDFDFitResultsToScreen.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemPrintTDFDFitResultsToScreen.setText("Print TDFDFit results to screen");
        jMenuItemPrintTDFDFitResultsToScreen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemPrintTDFDFitResultsToScreenActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemPrintTDFDFitResultsToScreen);

        jMenuItemWriteTDFDFitResultsToTextFile.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_W, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemWriteTDFDFitResultsToTextFile.setText("Write individual subvoxel TDFDFit results to text file ..");
        jMenuItemWriteTDFDFitResultsToTextFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemWriteTDFDFitResultsToTextFileActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemWriteTDFDFitResultsToTextFile);

        jMenuItemWriteAverageTDFDFitResultsToTextFile.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuItemWriteAverageTDFDFitResultsToTextFile.setText("Write average TDFDFit voxel results to text file ..");
        jMenuItemWriteAverageTDFDFitResultsToTextFile.setToolTipText("");
        jMenuItemWriteAverageTDFDFitResultsToTextFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemWriteAverageTDFDFitResultsToTextFileActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemWriteAverageTDFDFitResultsToTextFile);

        m_automaticStoreTDFDFitResultsCheckBoxMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.ALT_MASK));
        m_automaticStoreTDFDFitResultsCheckBoxMenuItem.setSelected(true);
        m_automaticStoreTDFDFitResultsCheckBoxMenuItem.setText("Automatic store TDFDFit results after fitting");
        m_automaticStoreTDFDFitResultsCheckBoxMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_automaticStoreTDFDFitResultsCheckBoxMenuItemActionPerformed(evt);
            }
        });
        jMenuProcessing.add(m_automaticStoreTDFDFitResultsCheckBoxMenuItem);

        jMenuItemLoadTDFDFitQuantificationResults.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_L, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemLoadTDFDFitQuantificationResults.setText("Load TDFDFit results if available");
        jMenuItemLoadTDFDFitQuantificationResults.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemLoadTDFDFitQuantificationResultsActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemLoadTDFDFitQuantificationResults);
        jMenuProcessing.add(jSeparator4);

        jMenuItemProcessAllSeries.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemProcessAllSeries.setText("Process All Spectroscopy Series (Mounted)...");
        jMenuItemProcessAllSeries.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemProcessAllSeriesActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemProcessAllSeries);

        jMenuItemProcessAllSeriesFolder.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemProcessAllSeriesFolder.setText("Process All Spectroscopy Series in Folder(s)...");
        jMenuItemProcessAllSeriesFolder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemProcessAllSeriesFolderActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemProcessAllSeriesFolder);
        jMenuProcessing.add(jSeparator21);

        jMenuItemReadMatchingPreproceesingResults.setText("Load matching preprocessed data");
        jMenuItemReadMatchingPreproceesingResults.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemReadMatchingPreproceesingResultsActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemReadMatchingPreproceesingResults);

        jMenuItemWriteMatchingPreproceesingResults1.setText("Write matching preprocessed data");
        jMenuItemWriteMatchingPreproceesingResults1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemWriteMatchingPreproceesingResults1ActionPerformed(evt);
            }
        });
        jMenuProcessing.add(jMenuItemWriteMatchingPreproceesingResults1);

        m_onlineHelpProcessingjMenuItem.setText("Online help Processing menu ..");
        m_onlineHelpProcessingjMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_onlineHelpProcessingjMenuItemActionPerformed(evt);
            }
        });
        jMenuProcessing.add(m_onlineHelpProcessingjMenuItem);

        jMenuBar2.add(jMenuProcessing);

        jMenuMap.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jMenuMap.setMnemonic('M');
        jMenuMap.setText("Map");

        jMenuItemClearMap.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Y, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemClearMap.setText("Clear Map");
        jMenuItemClearMap.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClearMapActionPerformed(evt);
            }
        });
        jMenuMap.add(jMenuItemClearMap);
        jMenuMap.add(jSeparator8);

        jMenuItemColorMapUI.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemColorMapUI.setText("Map Features...");
        jMenuItemColorMapUI.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemColorMapUIActionPerformed(evt);
            }
        });
        jMenuMap.add(jMenuItemColorMapUI);

        jMenuItemMapjMRUIResults.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_R, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemMapjMRUIResults.setText("Map Quantification Results...");
        jMenuItemMapjMRUIResults.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemMapjMRUIResultsActionPerformed(evt);
            }
        });
        jMenuMap.add(jMenuItemMapjMRUIResults);
        jMenuMap.add(jSeparator11);

        jMenuItemPrintMapStats.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_M, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        jMenuItemPrintMapStats.setText("Print Map Statistical Parameters (All Voxels)");
        jMenuItemPrintMapStats.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemPrintMapStatsActionPerformed(evt);
            }
        });
        jMenuMap.add(jMenuItemPrintMapStats);

        jMenuItemPrintMapSelectionStats.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_M, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemPrintMapSelectionStats.setText("Print Map Statistical Parameters (Selected Voxels)");
        jMenuItemPrintMapSelectionStats.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemPrintMapSelectionStatsActionPerformed(evt);
            }
        });
        jMenuMap.add(jMenuItemPrintMapSelectionStats);
        jMenuMap.add(jSeparator7);

        jMenuItemMapFromMAT.setText("Create Map from .MAT");
        jMenuItemMapFromMAT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemMapFromMATActionPerformed(evt);
            }
        });
        jMenuMap.add(jMenuItemMapFromMAT);

        jMenuItemExportMapToMAT.setText("Export Map values to .MAT");
        jMenuItemExportMapToMAT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemExportMapToMATActionPerformed(evt);
            }
        });
        jMenuMap.add(jMenuItemExportMapToMAT);

        jMenuItemExportNormalizedMapToMAT.setText("Export Normalized Map values to .MAT");
        jMenuItemExportNormalizedMapToMAT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemExportNormalizedMapToMATActionPerformed(evt);
            }
        });
        jMenuMap.add(jMenuItemExportNormalizedMapToMAT);

        jMenuItemCorrectMapFromMAT.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemCorrectMapFromMAT.setText("Correct Map from .MAT file");
        jMenuItemCorrectMapFromMAT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemCorrectMapFromMATActionPerformed(evt);
            }
        });
        jMenuMap.add(jMenuItemCorrectMapFromMAT);
        jMenuMap.add(jSeparator20);

        jMenuItemImportExternalLabelCSVFile.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemImportExternalLabelCSVFile.setText("Import external label .CSV file...");
        jMenuItemImportExternalLabelCSVFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImportExternalLabelCSVFileActionPerformed(evt);
            }
        });
        jMenuMap.add(jMenuItemImportExternalLabelCSVFile);

        m_onlineHelpMapjMenuItem.setText("Online help Map menu ..");
        m_onlineHelpMapjMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_onlineHelpMapjMenuItemActionPerformed(evt);
            }
        });
        jMenuMap.add(m_onlineHelpMapjMenuItem);

        jMenuBar2.add(jMenuMap);

        jMenuReports.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jMenuReports.setMnemonic('R');
        jMenuReports.setText("Reports");

        jMenuItemGenerateCstm.setText("Create New Custom Report...");
        jMenuItemGenerateCstm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemGenerateCstmActionPerformed(evt);
            }
        });
        jMenuReports.add(jMenuItemGenerateCstm);

        jMenuLoadCstm.setText("Load Custom Report");
        jMenuLoadCstm.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jMenuLoadCstmMouseEntered(evt);
            }
        });
        jMenuReports.add(jMenuLoadCstm);

        jMenuRmCstm.setText("Delete Custom Report");
        jMenuRmCstm.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jMenuRmCstmMouseEntered(evt);
            }
        });
        jMenuReports.add(jMenuRmCstm);
        jMenuReports.add(jSeparator1);

        jMenuStdReport.setText("Generate Standard Report");

        jMenuItemGenerateStdMetMap.setText("Metabolite Maps...");
        jMenuItemGenerateStdMetMap.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemGenerateStdMetMapActionPerformed(evt);
            }
        });
        jMenuStdReport.add(jMenuItemGenerateStdMetMap);
        jMenuStdReport.add(jSeparator2);

        jMenuReports.add(jMenuStdReport);

        jMenuItemCompCtrl.setText("Comparison Control...");
        jMenuItemCompCtrl.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemCompCtrlActionPerformed(evt);
            }
        });
        jMenuReports.add(jMenuItemCompCtrl);

        jCheckBoxSeparateSpectra.setSelected(true);
        jCheckBoxSeparateSpectra.setText("Show Spectra Separatly");
        jCheckBoxSeparateSpectra.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxSeparateSpectraActionPerformed(evt);
            }
        });
        jMenuReports.add(jCheckBoxSeparateSpectra);

        m_onlineHelpReportjMenuItem.setText("Online help Reports menu ..");
        m_onlineHelpReportjMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_onlineHelpReportjMenuItemActionPerformed(evt);
            }
        });
        jMenuReports.add(m_onlineHelpReportjMenuItem);

        jMenuBar2.add(jMenuReports);

        jMenuQualityControl.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jMenuQualityControl.setMnemonic('Q');
        jMenuQualityControl.setText("Quality Control");

        jMenuItemLabelling.setText("Label Selected Spectra...");
        jMenuItemLabelling.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemLabellingActionPerformed(evt);
            }
        });
        jMenuQualityControl.add(jMenuItemLabelling);

        jMenuItemLabellingConsensus.setText("Label Selected Spectra - Consensus...");
        jMenuItemLabellingConsensus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemLabellingConsensusActionPerformed(evt);
            }
        });
        jMenuQualityControl.add(jMenuItemLabellingConsensus);
        jMenuQualityControl.add(jSeparator13);

        jMenuItemLabellingAnalyser.setText("Labelling Analyser...");
        jMenuItemLabellingAnalyser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemLabellingAnalyserActionPerformed(evt);
            }
        });
        jMenuQualityControl.add(jMenuItemLabellingAnalyser);
        jMenuQualityControl.add(jSeparator12);

        jMenuItemClassifyQuality.setText("Classify Spectral Quality Using Custom Classifier...");
        jMenuItemClassifyQuality.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClassifyQualityActionPerformed(evt);
            }
        });
        jMenuQualityControl.add(jMenuItemClassifyQuality);

        m_qualityControljMenuItem.setText("Online help Quality Control menu ..");
        m_qualityControljMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_qualityControljMenuItemActionPerformed(evt);
            }
        });
        jMenuQualityControl.add(m_qualityControljMenuItem);

        jMenuBar2.add(jMenuQualityControl);

        jMenuImportExport.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jMenuImportExport.setMnemonic('J');
        jMenuImportExport.setText("jMRUI Import/Export");

        jMenuItemExportSpectrum.setText("Export All Spectra");
        jMenuItemExportSpectrum.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemExportSpectrumActionPerformed(evt);
            }
        });
        jMenuImportExport.add(jMenuItemExportSpectrum);

        jMenuItemExportSelectedSpectra.setText("Export Selected Spectra");
        jMenuItemExportSelectedSpectra.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemExportSelectedSpectraActionPerformed(evt);
            }
        });
        jMenuImportExport.add(jMenuItemExportSelectedSpectra);

        jMenuItemImportSpectrum.setText("Import Spectra");
        jMenuItemImportSpectrum.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImportSpectrumActionPerformed(evt);
            }
        });
        jMenuImportExport.add(jMenuItemImportSpectrum);
        jMenuImportExport.add(jSeparator14);

        jMenuItemImportJMruiResults.setText("Import Quantification Results");
        jMenuItemImportJMruiResults.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImportJMruiResultsActionPerformed(evt);
            }
        });
        jMenuImportExport.add(jMenuItemImportJMruiResults);

        jMenuItemClearJMRUIData.setText("Clear Quantification Data");
        jMenuItemClearJMRUIData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClearJMRUIDataActionPerformed(evt);
            }
        });
        jMenuImportExport.add(jMenuItemClearJMRUIData);

        m_onlineHelpjMRUIImportExportMenuItem.setText("Online help jMRUI Import/Export menu ..");
        m_onlineHelpjMRUIImportExportMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_onlineHelpjMRUIImportExportMenuItemActionPerformed(evt);
            }
        });
        jMenuImportExport.add(m_onlineHelpjMRUIImportExportMenuItem);

        jMenuBar2.add(jMenuImportExport);

        jMenu1.setMnemonic('N');
        jMenu1.setText("DICOM Network");

        jMenuItemConfigNetworkNodes.setText("Configure DICOM Network Nodes");
        jMenuItemConfigNetworkNodes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemConfigNetworkNodesActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItemConfigNetworkNodes);

        jMenuItemDICOMNetworkListenerControl.setText("DICOM Network Listener and Renaming Control");
        jMenuItemDICOMNetworkListenerControl.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemDICOMNetworkListenerControlActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItemDICOMNetworkListenerControl);

        jCheckBoxMenuItemAutomaticProcessing.setText("Activate Automatic Processing");
        jCheckBoxMenuItemAutomaticProcessing.setEnabled(false);
        jCheckBoxMenuItemAutomaticProcessing.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemAutomaticProcessingActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItemAutomaticProcessing);

        m_onlineHelpDicomNetworkjMenuItem.setText("Online help DICOM Network menu ..");
        m_onlineHelpDicomNetworkjMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_onlineHelpDicomNetworkjMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(m_onlineHelpDicomNetworkjMenuItem);

        jMenuBar2.add(jMenu1);

        jMenuPatient.setMnemonic('C');
        jMenuPatient.setText("Clinical Cases");

        jMenuPatientBrowser.setText("Patient Browser");
        jMenuPatientBrowser.setEnabled(false);
        jMenuPatientBrowser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuPatientBrowserActionPerformed(evt);
            }
        });
        jMenuPatient.add(jMenuPatientBrowser);

        m_onlineHelpClinicalCasesjMenuItem.setText("Online help Clinical Cases menu..");
        m_onlineHelpClinicalCasesjMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_onlineHelpClinicalCasesjMenuItemActionPerformed(evt);
            }
        });
        jMenuPatient.add(m_onlineHelpClinicalCasesjMenuItem);

        jMenuBar2.add(jMenuPatient);

        jMenuHelp.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jMenuHelp.setMnemonic('H');
        jMenuHelp.setText("Help");

        jMenuItemAbout.setText("About...");
        jMenuItemAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAboutActionPerformed(evt);
            }
        });
        jMenuHelp.add(jMenuItemAbout);

        jMenuItemOnlineHelp.setText("Online help ..");
        jMenuItemOnlineHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemOnlineHelpActionPerformed(evt);
            }
        });
        jMenuHelp.add(jMenuItemOnlineHelp);

        jMenuBar2.add(jMenuHelp);

        setJMenuBar(jMenuBar2);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItemOpenCSIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemOpenCSIActionPerformed
        try {
            getFile();
        } catch (IOException ex) {
            Logger.getLogger(ClinicalViewer.class
                    .getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jMenuItemOpenCSIActionPerformed

    private void jSlider1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider1StateChanged
        if (model != null) {
            model.setSlice(jSlider1.getValue());
        }
    }//GEN-LAST:event_jSlider1StateChanged

    private void jMenuItemMountDirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemMountDirActionPerformed
        dicomManager.mountDirectory( );
    }//GEN-LAST:event_jMenuItemMountDirActionPerformed

    private void jMenuItemClearGridActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClearGridActionPerformed
        if (model != null) {
            model.clearGrid();
            model.setSpectraAxisVisible(false);
            model.clearColorMap();
            model.clearVoxelSelection();
        }
        this.updateProcessingActions();
    }//GEN-LAST:event_jMenuItemClearGridActionPerformed

    private void jMenuItemSelectAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSelectAllActionPerformed
        if (model != null) {
            if (model.getGridSize() > 0) {
                model.selectAllVoxels();
            }
        }
    }//GEN-LAST:event_jMenuItemSelectAllActionPerformed

    
    
    /**
     * Method the select all excited voxels at once; This method need to check
     * whether there are excited voxels at all: if FIDCSI there is no
     * excited voxel like in PRESS, STEAM or semiLASER.
     * @param evt 
     */
    private void jMenuItemSelectExcitedVoxelsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSelectExcitedVoxelsActionPerformed
        if ( model != null )
        {
            if ( model.getExcitedVoxels( ) != null )
            {
                if ( ( model.getGridSize( ) > 0 ) && ( model.getFidCSIDataLoaded( ) == false ) ) 
                {
                    model.selectExcitedVoxels( );
                }
            }
            else
            {
                model.selectAllVoxels( );
            }
        }
        
    }//GEN-LAST:event_jMenuItemSelectExcitedVoxelsActionPerformed

    private void jMenuItemImageInfoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImageInfoActionPerformed
        if ( model != null ) 
        {
            if ( model.getGridSize( ) > 0 ) 
            {
                if ( model.getSelectedVoxels().size( ) > 0)
                {
                    model.analyseSelectedVoxelsSubImage( );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Cannot image information to spectrIm output console!\n First load and select spectroscopic voxels!" );
                }
            }
            else
            {
                JOptionPane.showMessageDialog( this, "Cannot image information to spectrIm output console!\n No valid spectral grid dimensions!" );
            }
        }
    }//GEN-LAST:event_jMenuItemImageInfoActionPerformed

    private void jMenuItemZeroFillingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemZeroFillingActionPerformed
        if ( model != null ) 
        {
            if ( model.getGridSize() > 0 ) 
            {
                if ( popupzerofilling == null ) 
                {
                    PopupZeroFillingFrame popup = new PopupZeroFillingFrame(model.getSpectraVectorSize(), currentVectorSize, this);
                    popupzerofilling = popup;
                } 
                else 
                {
                    popupzerofilling.setVisible( true );
                }
                popupzerofilling.setLocationRelativeTo( this );
            }
        }
    }//GEN-LAST:event_jMenuItemZeroFillingActionPerformed

    public void refreshSpectra() {
        if (model != null) {
            model.updateSpectraPanel();
        }
    }

    private void jMenuItemAutoPhasingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAutoPhasingActionPerformed
         if ( model != null && !model.isSpectraNull( ) ) 
         {
            if (model.getGridSize() > 0) {
                if (popupphasingframe == null) {
                    PopupPhasingFrame popup = new PopupPhasingFrame(this, 1.5f, 4.4f);
                    popupphasingframe = popup;
                } else {
                    popupphasingframe.setVisible(true);
                }
                popupphasingframe.setLocationRelativeTo(this);
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot perform autophasing on dataset:\n First load valid MRS(I) data set!" );
        }
    }//GEN-LAST:event_jMenuItemAutoPhasingActionPerformed

    private void jMenuItemSaveAllToMATActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSaveAllToMATActionPerformed
        if ( model != null && !model.isSpectraNull( ) )  
        {
            if ( model.getGridSize( ) > 0 ) 
            {
                JFileChooser fileChooser = new JFileChooser( );
                fileChooser.setCurrentDirectory( currentFile );
                FileNameExtensionFilter filter = new FileNameExtensionFilter( "MATLAB", "mat" );
                fileChooser.setFileFilter(filter);
                fileChooser.setSelectedFile(new File(model.getPatientName() + "_" + model.getStudyDate() + "_" + model.getSeriesNumber() + "_" + model.getSeriesDescription() + ".mat"));
                int result = fileChooser.showSaveDialog(this);
                File selected_file;

                switch (result) 
                {
                    case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed

                        selected_file = fileChooser.getSelectedFile( );
                        currentFile = fileChooser.getCurrentDirectory( );
                        if ( selected_file != null ) 
                        {
                            model.saveAllSpectraToMAT( selected_file.toString( ) );
                        }
                        break;
                    case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                        break;
                    case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                        break;
                }
            }
            else
            {
                JOptionPane.showMessageDialog( this, "<html><br>No dataset loaded :  " + "<br><br><br>Cannot export all spectra to .MAT file :<br></html>");
            }
        }
        
    }//GEN-LAST:event_jMenuItemSaveAllToMATActionPerformed

    private void jMenuItemSaveSelectionToMATActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSaveSelectionToMATActionPerformed
        if (model != null) {
            if (model.getGridSize() > 0) {
                JFileChooser fileChooser = new JFileChooser();
                fileChooser.setCurrentDirectory(currentFile);
                FileNameExtensionFilter filter = new FileNameExtensionFilter("MATLAB", "mat");
                fileChooser.setFileFilter(filter);
                fileChooser.setSelectedFile(new File(model.getPatientName() + "_" + model.getStudyDate() + "_" + model.getSeriesNumber() + "_" + model.getSeriesDescription() + ".mat"));
                int result = fileChooser.showSaveDialog(this);
                File selected_file;

                switch (result) {
                    case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed

                        selected_file = fileChooser.getSelectedFile();
                        currentFile = fileChooser.getCurrentDirectory();
                        if (selected_file != null) {
                            model.saveSelectedSpectraToMAT(selected_file.toString());
                        }
                        break;
                    case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                        break;
                    case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                        break;
                }
            }
            else
            {
                JOptionPane.showMessageDialog( this, "<html><br>No dataset loaded :  " + "<br><br><br>Cannot export selected spectra to .MAT file :<br></html>");
            }
        }
    }//GEN-LAST:event_jMenuItemSaveSelectionToMATActionPerformed

    private void jMenuItemApodizationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemApodizationActionPerformed
        if ( model != null && !model.isSpectraNull( ) )  
        {
            if ( model.getGridSize( ) > 0 ) 
            {
                if ( popupapodizationframe == null ) 
                {
                    PopupApodizationFrame popup = new PopupApodizationFrame( this );
                    popupapodizationframe = popup;
                } else {
                    popupapodizationframe.setVisible( true );
                }
                popupapodizationframe.setLocationRelativeTo( this );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "<html><br>No dataset loaded :  " + "<br><br><br>Cannot perform apodization to data set!<br></html>");
        }
    }//GEN-LAST:event_jMenuItemApodizationActionPerformed

    private void jMenuItemClearMapActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClearMapActionPerformed
        if ( model != null ) 
        {
            model.clearColorMap();
        }
    }//GEN-LAST:event_jMenuItemClearMapActionPerformed

    private void jMenuItemShiftScaleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemShiftScaleActionPerformed
        if ( model != null && !model.isSpectraNull( ) )  
        {
            if ( model.getGridSize( ) > 0 ) 
            {
                if ( popupshiftcorrection == null ) 
                {
                    ShiftCorrectionPopup popup = new ShiftCorrectionPopup( this );
                    popupshiftcorrection = popup;
                } 
                else 
                {
                    popupshiftcorrection.setVisible( true );
                }
                popupshiftcorrection.setLocationRelativeTo( this );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "<html><br>No dataset loaded :  " + "<br><br><br>Cannot perform alignment to data set!<br></html>");
        }
    }//GEN-LAST:event_jMenuItemShiftScaleActionPerformed

    private void jMenuItemClearImageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClearImageActionPerformed
        if ( model != null ) 
        {
            model.clearImageStack( );
            model.setBlankImageStack( );
            for ( int i = 0; i < model.getLocalizerList( ).size( ); i++ ) 
            {
                setLocalizer(model.getLocalizerList().get(i));
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "<html><br>No dataset loaded :  " + "<br><br><br>Cannot clear image stack!<br></html>");
        }
    }//GEN-LAST:event_jMenuItemClearImageActionPerformed

    private void jMenuItemColorModeBGRActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemColorModeBGRActionPerformed
        if (model != null) {
            model.setColorMode(ColorModelGenerator.COLMODE_BGR);
        }
    }//GEN-LAST:event_jMenuItemColorModeBGRActionPerformed

    private void jMenuItemColorModeRGBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemColorModeRGBActionPerformed
        if (model != null) {
            model.setColorMode(ColorModelGenerator.COLMODE_RGB);
        }
    }//GEN-LAST:event_jMenuItemColorModeRGBActionPerformed

    private void jMenuItemColorModeGrayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemColorModeGrayActionPerformed
        if (model != null) {
            model.setColorMode(ColorModelGenerator.COLMODE_GRAY);
        }
    }//GEN-LAST:event_jMenuItemColorModeGrayActionPerformed

    private void jMenuItemColorModeRBGActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemColorModeRBGActionPerformed
        if (model != null) {
            model.setColorMode(ColorModelGenerator.COLMODE_RBG);
        }
    }//GEN-LAST:event_jMenuItemColorModeRBGActionPerformed

    private void jMenuItemColorModeBRGActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemColorModeBRGActionPerformed
        if (model != null) {
            model.setColorMode(ColorModelGenerator.COLMODE_BRG);
        }
    }//GEN-LAST:event_jMenuItemColorModeBRGActionPerformed

    private void jMenuItemColorModeGBRActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemColorModeGBRActionPerformed
        if (model != null) {
            model.setColorMode(ColorModelGenerator.COLMODE_GBR);
        }
    }//GEN-LAST:event_jMenuItemColorModeGBRActionPerformed

    private void jMenuItemColorModeGRBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemColorModeGRBActionPerformed
        if (model != null) {
            model.setColorMode(ColorModelGenerator.COLMODE_GRB);
        }
    }//GEN-LAST:event_jMenuItemColorModeGRBActionPerformed

    private void jMenuItemAutoWindowingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAutoWindowingActionPerformed
        if (model != null && !model.isImageBlank()) {
            model.autoWindowing();
        }
    }//GEN-LAST:event_jMenuItemAutoWindowingActionPerformed

    private void jComboBoxSpectraDomainActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxSpectraDomainActionPerformed
        model.setSpectraDomain(getSelectedSpectraDomain());
    }//GEN-LAST:event_jComboBoxSpectraDomainActionPerformed

    private Spectra.Domain getSelectedSpectraDomain() {
        String selected = (String) jComboBoxSpectraDomain.getSelectedItem();
        for (Spectra.Domain domain : Spectra.Domain.values()) {
            if (domain.txt.matches(selected)) {
                return domain;
            }
        }
        return null;
    }

    private Spectra.CombinationFunction getSelectedSpectraCombinationFunction() {
        String selected = (String) jComboBoxSpectraCombinationFunction.getSelectedItem();
        for (Spectra.CombinationFunction func : Spectra.CombinationFunction.values()) {
            if (func.txt.equals(selected)) {
                return func;
            }
        }
        return null;
    }

    @Override
    public void setSpectraDomain(String selected) {
        jComboBoxSpectraDomain.setSelectedItem(selected);
    }

    private void jCheckBoxDispersionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxDispersionActionPerformed
        if (model != null) {
            model.setDispersionVisible(jCheckBoxDispersion.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxDispersionActionPerformed

    private void jCheckBoxAbsorptionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxAbsorptionActionPerformed
        if (model != null) {
            model.setAbsorptionVisible(jCheckBoxAbsorption.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxAbsorptionActionPerformed

    private void jCheckBoxMagnitudeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMagnitudeActionPerformed
        if (model != null) {
            model.setMagnitudeVisible(jCheckBoxMagnitude.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxMagnitudeActionPerformed

    private void jCheckBoxClipboardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxClipboardActionPerformed
        if (model != null) {
            model.setAutoCopyClipboard(this.jCheckBoxClipboard.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxClipboardActionPerformed

    private void jCheckBoxShowMapValuesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxShowMapValuesActionPerformed
        if (model != null) {
            model.setValuesVisible(this.jCheckBoxShowMapValues.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxShowMapValuesActionPerformed

    private void jCheckBoxMenuItemViewSliceOrientationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemViewSliceOrientationActionPerformed
        this.imagePanel.setSpacialInfoVisible(jCheckBoxMenuItemViewSliceOrientation.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItemViewSliceOrientationActionPerformed

    private void jMenuItemPrintMapStatsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemPrintMapStatsActionPerformed
        if (model != null) {
            if (model.getGridSize() > 0) {
                model.getColorMap().publishValueMapStatistics(false);
            }
        }
    }//GEN-LAST:event_jMenuItemPrintMapStatsActionPerformed

    private void jCheckBoxMenuItemShowIntersectsMainActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemShowIntersectsMainActionPerformed
        if (model != null) {
            this.model.showIntersectionsInMain(this.jCheckBoxMenuItemShowIntersectsMain.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxMenuItemShowIntersectsMainActionPerformed

    private void jCheckBoxMenuItemShowPatientNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemShowPatientNameActionPerformed
        if (model != null) {
            this.model.setPatientNameVisible(this.jCheckBoxMenuItemShowPatientName.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxMenuItemShowPatientNameActionPerformed

    private void jCheckBoxMenuItemShowSeriesInfoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemShowSeriesInfoActionPerformed
        if (model != null) {
            this.model.setSeriesInfoVisible(this.jCheckBoxMenuItemShowSeriesInfo.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxMenuItemShowSeriesInfoActionPerformed

    private void jMenuItemLabellingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemLabellingActionPerformed
        if (model != null && model.getGridSize() > 1) {
            labellingHandler = new LabellingHandler(model);
            labellingHandler.labelSpectra(this, currentLabellingFile, null, GlobalModel.LABELLING_QUAL, this);
        }
    }//GEN-LAST:event_jMenuItemLabellingActionPerformed

    private void jMenuItemSelectFreeHandActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSelectFreeHandActionPerformed
        if (model != null && model.getGridSize() > 1) {
            model.printTxt("Draw ROI by dragging the mouse over the image.");
            if (model.getGridSize() > 1) {
                model.activateFreeHandSelection();
            }
        }
    }//GEN-LAST:event_jMenuItemSelectFreeHandActionPerformed

    private void jMenuItemPrintMapSelectionStatsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemPrintMapSelectionStatsActionPerformed
        if (model != null) {
            if (model.getGridSize() > 0) {
                model.getColorMap().publishValueMapStatistics(true);
            }
        }
    }//GEN-LAST:event_jMenuItemPrintMapSelectionStatsActionPerformed

    private void jMenuItemClassifyQualityActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClassifyQualityActionPerformed
        if (model != null && model.getGridSize() > 0) {
            String tasks = getMissingTasksQuality("dummy");
            if (tasks.matches("")) {
                String file = getQualityClassifierFile();
                if (file != null) {
                    model.classifySpectralQuality(file, true);
                }
            } else {
                JOptionPane.showMessageDialog(this, "<html>Automatic Quality Control can not be performed:" + tasks + "<br><br>For help setting up Automatic Quality Control, contact nuno.barros@insel.ch</html>");
            }
        }
    }//GEN-LAST:event_jMenuItemClassifyQualityActionPerformed

    private String getQualityClassifierFile() {
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Set Classifier");
        fileChooser.setCurrentDirectory(this.currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("RData", "RData");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = fileChooser.getCurrentDirectory();
                if (selected_file != null) {
                    return selected_file.toString();
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
        return null;
    }

    private String getjMRUIFormattedDataFile( ) 
    {
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle( "Open 1D-jMRUI datafile" );
        fileChooser.setCurrentDirectory(this.currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter( "MRUI", "mrui" );
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) 
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = fileChooser.getCurrentDirectory();
                if (selected_file != null) 
                {
                    return selected_file.toString();
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
        return null;
    }
    
    private File getCSVFormattedTDSignalExportDataFileName( ) 
    {
        JFileChooser fileChooser = new JFileChooser( );
        fileChooser.setDialogTitle( "Export TD-signal as CSV-file" );
        fileChooser.setCurrentDirectory( currentFile );
        FileNameExtensionFilter filter = new FileNameExtensionFilter( "CSV", "csv" );
        fileChooser.setFileFilter( filter );
        fileChooser.setSelectedFile( new File( model.getPatientName( ) + "_" + 
                                               model.getStudyDate( ) + "_" + 
                                               model.getSeriesNumber( ) + "_" + 
                                               model.getSeriesDescription( ) + ".csv" ) );
        
        int result = fileChooser.showOpenDialog( this );
        File selected_file;
        switch ( result ) 
        {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = new File( fileChooser.getSelectedFile( ) + ".csv" );
                
                if ( selected_file != null ) 
                {
                    return selected_file;
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
        return null;
    }
    
    private void jCheckBoxMenuItemNormalizeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemNormalizeActionPerformed
        if (model != null) {
            model.normalizeSpectra(this.jCheckBoxMenuItemNormalize.isSelected(), true);
        }
    }//GEN-LAST:event_jCheckBoxMenuItemNormalizeActionPerformed

    private void jMenuItemLabellingAnalyserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemLabellingAnalyserActionPerformed
        if (labelAnalyser == null) {
            labelAnalyser = new LabelAnalyser(this);
        } else {
            labelAnalyser.setVisible(true);
        }
        labelAnalyser.setLocationRelativeTo(this);
    }//GEN-LAST:event_jMenuItemLabellingAnalyserActionPerformed

    private void jMenuItemSelectInnerExcitedVoxelsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSelectInnerExcitedVoxelsActionPerformed
        if (model != null) {
            if (model.getGridSize() > 0) {
                model.selectInnerExcitedVoxels();
            }
        }
    }//GEN-LAST:event_jMenuItemSelectInnerExcitedVoxelsActionPerformed

    private void jMenuItemMapFromMATActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemMapFromMATActionPerformed
        if (model != null && model.getGridSize() > 0) {
            if (matReader == null) {
                PopupMatlabReader popup = new PopupMatlabReader(this);
                matReader = popup;
            } else {
                matReader.setVisible(true);
            }
            matReader.setLocationRelativeTo(this);
        }
    }//GEN-LAST:event_jMenuItemMapFromMATActionPerformed

    private void jMenuItemGenerateCstmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemGenerateCstmActionPerformed
//        new Report(this.csimodel, (jMRUIResultsMapListener)mruiViewerInterface);
        //new StdReportFrame(StdReportFrame.CUSTOM, csimodel, (jMRUIResultsMapListener)mruiViewerInterface);
        if ( model != null && model.getImageStackSize( ) > 0 )
        {
            if ( model.getTDFDFitStore( ) == null )
            {
                new CstmReportFrame( StdReportFrame.CUSTOM, model, (jMRUIResultsMapListener) mruiViewerInterface ).setLocationRelativeTo( this );
            }
            else
            {
                new CstmReportFrame( StdReportFrame.CUSTOM, model, (jMRUIResultsMapListener)model.getTDFDFitStore( ) ).setLocationRelativeTo( this );
            }
        }
    }//GEN-LAST:event_jMenuItemGenerateCstmActionPerformed

    private void jMenuItemExportSpectrumActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemExportSpectrumActionPerformed
        mruiViewerInterface.exportSpectra( );
    }//GEN-LAST:event_jMenuItemExportSpectrumActionPerformed

    private void jMenuItemExportSelectedSpectraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemExportSelectedSpectraActionPerformed
        mruiViewerInterface.exportSelectedSpectra( );
    }//GEN-LAST:event_jMenuItemExportSelectedSpectraActionPerformed

    private void jMenuItemImportSpectrumActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImportSpectrumActionPerformed
        mruiViewerInterface.importSpectra( );
    }//GEN-LAST:event_jMenuItemImportSpectrumActionPerformed
    
    private void jMenuItemRemoveWaterHLSVDKernalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemoveWaterHLSVDKernalActionPerformed
        
        if ( model.getCSIData( ) != null )
        {
            applyInterActiveHLSVD64Filter( );
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Water removal using HLSVD cannot be performed: \n first load a dataset!." );
        }



//        if ( model != null && !model.isSpectraNull( ) ) 
//        {
//            PreprocessingAction action = this.processingActions.get( this.jComboBoxProcessingAction.getSelectedIndex( ) ).getPreprocessingAction( );
//            if ( action == null ) 
//            {
//                action = new PreprocessingAction( "default" );
//            }
//            BatchProcessing.cancel( );
//            this.setWaitLayerActive( true );
//            model.clearColorMap( );
//            BatchProcessing.addWaterPeakRemovalHLSVD64( action.getHLSVD64WaterRemovalMin( ), 
//                                                        action.getHLSVD64WaterRemovalMax( ), 
//                                                        action.getHLSVD64WaterRemovalNumberOfPeaks( ) );
//            BatchProcessing.run( );
//        }
    }//GEN-LAST:event_jMenuItemRemoveWaterHLSVDKernalActionPerformed

    private void jMenuItemMapjMRUIResultsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemMapjMRUIResultsActionPerformed
        
        try
        {
            if ( mruiViewerInterface.getQuantificationResults( ) != null )
            {
                mruiViewerInterface.mapjMRUIResults( this );
            }
        }
        catch ( UnsupportedOperationException e )
        {
            // Do nothing!
        }
                
        if ( model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( ) != null )
        {
             m_popupjMRUIResultsMap = PopupjMRUIResultsMap.getInstance( model.getTDFDFitStore( ), 
                                                                        model.getTDFDFitStore( ).getAvailableMetabolites( ), 
                                                                        model.getTDFDFitStore( ).getFeatureNames( ), 
                                                                        false );
        }
    }//GEN-LAST:event_jMenuItemMapjMRUIResultsActionPerformed

    private void jMenuItemPrintjMRUIResultsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemPrintjMRUIResultsActionPerformed
        mruiViewerInterface.printJMRUIResults( );
    }//GEN-LAST:event_jMenuItemPrintjMRUIResultsActionPerformed

    private void jCheckBoxShowOriginalSpectraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxShowOriginalSpectraActionPerformed
        if (model != null) {
            model.setOriginalSpectraVisible(jCheckBoxShowOriginalSpectra.isSelected());
        }
	    }//GEN-LAST:event_jCheckBoxShowOriginalSpectraActionPerformed

    private void jCheckBoxShowFittedSpectraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxShowFittedSpectraActionPerformed
        if (model != null) {
            model.setFittedSpectraVisible(jCheckBoxShowFittedSpectra.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxShowFittedSpectraActionPerformed

    private void jMenuItemGenerateStdMetMapActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemGenerateStdMetMapActionPerformed
        if ( model != null && model.getGridSize( ) > 1 ) 
        {
            if ( model.getTDFDFitStore( ) == null )
            {
                // jMRUI-kernal was used to obtain the results
                new StdReportFrame( StdReportFrame.STDMETAB, this.model, (jMRUIResultsMapListener)model.getTDFDFitStore( ) ).setLocationRelativeTo( this );
            }
            else
            {
                new StdReportFrame( StdReportFrame.STDMETAB, this.model, (jMRUIResultsMapListener)model.getTDFDFitStore( ) ).setLocationRelativeTo( this );
            }
        }
    }//GEN-LAST:event_jMenuItemGenerateStdMetMapActionPerformed

    private void jMenuItemSelectGoodQualityVoxelsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSelectGoodQualityVoxelsActionPerformed
        if (model != null && !model.isQScoresEmpty()) {
            model.selectGoodQualityVoxels(0.5, true);
        }
    }//GEN-LAST:event_jMenuItemSelectGoodQualityVoxelsActionPerformed

    private void jMenuItemChangeSelectionGroupActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemChangeSelectionGroupActionPerformed
        if (this.jRadioButtonSelectBlue.isSelected()) {
            this.jRadioButtonSelectRed.setSelected(true);
            model.setCurrentSelectionGroup(GlobalModel.SelectionGroup.RED);
        } else {
            this.jRadioButtonSelectBlue.setSelected(true);
            model.setCurrentSelectionGroup(GlobalModel.SelectionGroup.BLUE);
        }
    }//GEN-LAST:event_jMenuItemChangeSelectionGroupActionPerformed

    private void jRadioButtonSelectBlueActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSelectBlueActionPerformed
        if (model != null) {
            model.setCurrentSelectionGroup(GlobalModel.SelectionGroup.BLUE);
        }
    }//GEN-LAST:event_jRadioButtonSelectBlueActionPerformed

    private void jRadioButtonSelectRedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSelectRedActionPerformed
        if (model != null) {
            model.setCurrentSelectionGroup(GlobalModel.SelectionGroup.RED);
        }
    }//GEN-LAST:event_jRadioButtonSelectRedActionPerformed

    private void jMenuItemMirrorSelectionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemMirrorSelectionActionPerformed
        if (model != null) {
            model.mirrorSelection();
        }
    }//GEN-LAST:event_jMenuItemMirrorSelectionActionPerformed

    private void jMenuItemCompCtrlActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemCompCtrlActionPerformed
        if ( model != null && model.getGridSize( ) > 1 ) 
        {
            if ( model.isBlueGroupSelected( ) && model.isRedGroupSelected( ) ) 
            {
                if ( model.getTDFDFitStore( ) == null )
                {
                    new StdReportFrame( StdReportFrame.STDCOMP, this.model, 
                                        (jMRUIResultsMapListener) mruiViewerInterface, 
                                        jCheckBoxSeparateSpectra.getState( ) ).setLocationRelativeTo( this );
                }
                else
                {
                    new StdReportFrame( StdReportFrame.STDCOMP, this.model, 
                                        (jMRUIResultsMapListener) model.getTDFDFitStore( ), 
                                        jCheckBoxSeparateSpectra.getState( ) ).setLocationRelativeTo( this );
                }
            } 
            else 
            {
                model.printTxt("Please define a Blue and a Red selection. To change the selection group, simply press SPACE. Keep Ctrl pressed for additive selection.");
                model.printTxt("For mirroring the current selection into the other group press Ctrl+SPACE");
            }
        }
    }//GEN-LAST:event_jMenuItemCompCtrlActionPerformed

    private void jMenuItemSettingsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSettingsActionPerformed
        if ( model.getCSIData() != null )
        {
            SettingsGUI.getInstance(this).setLocationRelativeTo(this);
        }
        else
        {
            JOptionPane.showMessageDialog( this, "<html><br>spectrIms' default settings cannot be defined : " + "<br><br>First load a dataset!</html>");
        }
    }//GEN-LAST:event_jMenuItemSettingsActionPerformed

    private void jMenuItemSvGridPrstActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSvGridPrstActionPerformed
        if (model != null && model.getSelectedVoxels().size() > 0) {
            String prsPath = "";
            String prstName = "";
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setDialogTitle("Save Selection Preset");
//            fileChooser.setCurrentDirectory(new File(GlobalSettings.getInstance().getCSIGrdPrstFolder()));
            fileChooser.setSelectedFile(new File(GlobalSettings.getInstance().getCSIGrdPrstFolder() + File.separator + "myNewPreset.csiprst"));
            fileChooser.setAcceptAllFileFilterUsed(false);
            fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
            FileNameExtensionFilter filter = new FileNameExtensionFilter("CSIPRST FILE", "csiprst", "csiprst");
            fileChooser.setFileFilter(filter);
            int result = fileChooser.showSaveDialog(this);
            switch (result) {
                case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                    prsPath = fileChooser.getCurrentDirectory().toString();
                    prstName = fileChooser.getSelectedFile().getName().split("\\.")[0];
                    break;
                case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                    return;
                case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                    return;
            }
//            if (!prsPath.matches(GlobalSettings.getInstance().getCSIGrdPrstFolder())) {
//                GlobalSettings.getInstance().setCSIGrdPrstFolder(prsPath);
//                GlobalSettings.getInstance().saveParamChanges();
//            }
            File prsFile = new File(prsPath + File.separator + model.getSOPInstanceUID().replace(".", "_") + "_id_-_n_" + prstName + ".csiprst");
            try {
                FileWriter writer = new FileWriter(prsFile);
                writer.write("RED\n");
                for (String coord : model.getSelectedVoxels(GlobalModel.SelectionGroup.RED)) {
                    writer.write(coord + "\n");
                }
                writer.write("BLUE\n");
                for (String coord : model.getSelectedVoxels(GlobalModel.SelectionGroup.BLUE)) {
                    writer.write(coord + "\n");
                }
                writer.close();
            } catch (IOException ex) {
                System.out.println("Couldn't save preset for some obscure reason (damn it!)");
            }
        }
    }//GEN-LAST:event_jMenuItemSvGridPrstActionPerformed

    private void jMenuLdGridPrstMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuLdGridPrstMouseEntered
        jMenuLdGridPrst.removeAll();
        if (model != null) {
            File[] files = new File(GlobalSettings.getInstance().getCSIGrdPrstFolder()).listFiles(new FilenameFilter() {
                public boolean accept(File dir, String filename) {
                    return filename.endsWith(".csiprst");
                }
            });

            try {
                for (File f : files) {
                    if (f.getName().split("_id_-_n_")[0].matches(model.getSOPInstanceUID().replace(".", "_"))) {
                        JMenuItem slctPrst = new JMenuItem(f.getName().split("_id_-_n_", 2)[1].split("\\.csiprst")[0]);
                        slctPrst.addActionListener(new java.awt.event.ActionListener() {
                            public void actionPerformed(java.awt.event.ActionEvent evt) {
                                gridSlctPrstActionPerformed(evt);
                            }
                        });
                        jMenuLdGridPrst.add(slctPrst);
                    }
                }
                if (jMenuLdGridPrst.getMenuComponentCount() == 0) {
                    throw new Exception();
                }
            } catch (Exception ex) {
                jMenuLdGridPrst.add(new JMenuItem("No selection preset available to load for this grid"));
            }
        }
    }//GEN-LAST:event_jMenuLdGridPrstMouseEntered

    private void jMenuItemPrintQulatificationResultsforSelectedVoxelsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemPrintQulatificationResultsforSelectedVoxelsActionPerformed
        this.mruiViewerInterface.printJMRUIResultsSelectedVoxels( );
    }//GEN-LAST:event_jMenuItemPrintQulatificationResultsforSelectedVoxelsActionPerformed

    private void jMenuRmGridPrstMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuRmGridPrstMouseEntered
        jMenuRmGridPrst.removeAll();
        if (model != null) {
            File[] files = new File(GlobalSettings.getInstance().getCSIGrdPrstFolder()).listFiles(new FilenameFilter() {
                public boolean accept(File dir, String filename) {
                    return filename.endsWith(".csiprst");
                }
            });

            try {
                for (File f : files) {
                    if (f.getName().split("_id_-_n_")[0].matches(model.getSOPInstanceUID().replace(".", "_"))) {
                        JMenuItem slctPrst = new JMenuItem(f.getName().split("_id_-_n_", 2)[1].split("\\.csiprst")[0]);
                        slctPrst.addActionListener(new java.awt.event.ActionListener() {
                            public void actionPerformed(java.awt.event.ActionEvent evt) {
                                rmGridPrstActionPerformed(evt);
                            }
                        });
                        jMenuRmGridPrst.add(slctPrst);
                    }
                }
                if (jMenuRmGridPrst.getMenuComponentCount() == 0) {
                    throw new Exception();
                }
            } catch (Exception ex) {
                jMenuRmGridPrst.add(new JMenuItem("No selection preset available to remove for this grid"));
            }
        }
    }//GEN-LAST:event_jMenuRmGridPrstMouseEntered

    private void jMenuLoadCstmMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuLoadCstmMouseEntered
        jMenuLoadCstm.removeAll();

        File[] files = ReportSettings.getInstance().getPrstsPath().listFiles(new FilenameFilter() {
            public boolean accept(File dir, String filename) {
                return filename.endsWith(".rprst");
            }
        });

        try {
            JMenuItem[] JMenuItemcstmReportPrst = new JMenuItem[files.length];

            for (int i = 0; i < files.length; i++) {
                JMenuItemcstmReportPrst[i] = new JMenuItem();
                JMenuItemcstmReportPrst[i].setText(files[i].getName().split("\\.rprst")[0]);
                JMenuItemcstmReportPrst[i].addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        JMenuItemcstmReportPrstActionPerformed(evt);
                    }
                });
                jMenuLoadCstm.add(JMenuItemcstmReportPrst[i]);
            }
            if (jMenuLoadCstm.getMenuComponentCount() == 0) {
                throw new Exception();
            }
        } catch (Exception e) {
            jMenuLoadCstm.add(new JMenuItem("No preset found"));
        }
    }//GEN-LAST:event_jMenuLoadCstmMouseEntered

    private void jMenuRmCstmMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuRmCstmMouseEntered
        jMenuRmCstm.removeAll();
        File[] files = ReportSettings.getInstance().getPrstsPath().listFiles(new FilenameFilter() {
            public boolean accept(File dir, String filename) {
                return filename.endsWith(".rprst");
            }
        });

        try {
            JMenuItem[] JMenuItemRmCstmReport = new JMenuItem[files.length];

            for (int i = 0; i < files.length; i++) {
                JMenuItemRmCstmReport[i] = new JMenuItem();
                JMenuItemRmCstmReport[i].setText(files[i].getName().split("\\.rprst")[0]);
                JMenuItemRmCstmReport[i].addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jMenuRmCstmActionPerformed(evt);
                    }
                });
                jMenuRmCstm.add(JMenuItemRmCstmReport[i]);
            }
            if (jMenuRmCstm.getMenuComponentCount() == 0) {
                throw new Exception();
            }
        } catch (Exception e) {
            jMenuRmCstm.add(new JMenuItem("No preset found"));
        }
    }//GEN-LAST:event_jMenuRmCstmMouseEntered

    private void jMenuItemWritejMRUIResultsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemWritejMRUIResultsActionPerformed
        mruiViewerInterface.writeJMRUIResults(this.currentFile);
    }//GEN-LAST:event_jMenuItemWritejMRUIResultsActionPerformed

    private void jCheckBoxShowColorBarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxShowColorBarActionPerformed
        if (model != null) {
            model.setColorBarVisible(this.jCheckBoxShowColorBar.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxShowColorBarActionPerformed

    /**
     * Opens the dialog that enables the user to map features.
     * @param evt 
     */
    private void jMenuItemColorMapUIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemColorMapUIActionPerformed
        if ( model != null && !model.isSpectraNull( ) ) 
        {
            if ( cmapUI != null ) 
            {
                cmapUI.dispose( );
            }
            cmapUI = new ColorMapUI( this, model );
            model.setColorMapUI( cmapUI );
            cmapUI.setLocationRelativeTo( this );
        }
    }//GEN-LAST:event_jMenuItemColorMapUIActionPerformed

    private void jMenuItemLabellingConsensusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemLabellingConsensusActionPerformed
        if (model != null && model.getGridSize() > 1) {
            labellingHandler = new LabellingHandler(model);
            labellingHandler.labelSpectra(this, currentLabellingFile, currentLabellingReferenceFile, GlobalModel.LABELLING_CONSENSUS, this);
        }
    }//GEN-LAST:event_jMenuItemLabellingConsensusActionPerformed

    private void jMenuItemImportJMruiResultsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImportJMruiResultsActionPerformed
        mruiViewerInterface.importjMRUIData(this);
    }//GEN-LAST:event_jMenuItemImportJMruiResultsActionPerformed

    private void jMenuItemClearJMRUIDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClearJMRUIDataActionPerformed
        mruiViewerInterface.clearData();
        m_popupjMRUIResultsMap.closeWindow();
        if (model != null && model.hasFittedSpectra()) {
            model.setFittedSpectra(null);
            model.updateSpectraPanel();
        }
        if (model != null) {
            model.clearColorMap();
        }
    }//GEN-LAST:event_jMenuItemClearJMRUIDataActionPerformed

    private void jMenuItemAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAboutActionPerformed
        (new PopupAbout()).setLocationRelativeTo(this);
    }//GEN-LAST:event_jMenuItemAboutActionPerformed

    private void jMenuItemExportMapToMATActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemExportMapToMATActionPerformed
        if (model != null && model.getGridSize() > 1) {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setMultiSelectionEnabled(true);
            fileChooser.setDialogTitle("Save Map to .MAT");
            fileChooser.setCurrentDirectory(this.currentFile);

            int result = fileChooser.showOpenDialog(this);
            File selected_file;
            switch (result) {
                case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                    selected_file = fileChooser.getSelectedFile();
                    this.currentFile = fileChooser.getCurrentDirectory();
                    if (selected_file != null) {
                        if (!selected_file.toString().endsWith(".mat")) {
                            selected_file = new File(selected_file.toString() + ".mat");
                        }
                        model.getColorMap().saveMapToMAT(selected_file, false);
                    }
                    break;
                case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                    break;
                case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                    break;
            }
        }
    }//GEN-LAST:event_jMenuItemExportMapToMATActionPerformed

    private void jMenuItemCorrectMapFromMATActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemCorrectMapFromMATActionPerformed
        if (model != null && model.getGridSize() > 1) {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setMultiSelectionEnabled(true);
            fileChooser.setDialogTitle("Correct Map from .MAT");
            fileChooser.setCurrentDirectory(this.currentFile);
            FileNameExtensionFilter filter = new FileNameExtensionFilter("MATLAB", "mat");
            fileChooser.setFileFilter(filter);
            int result = fileChooser.showOpenDialog(this);
            File selected_file;
            switch (result) {
                case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                    selected_file = fileChooser.getSelectedFile();
                    this.currentFile = fileChooser.getCurrentDirectory();
                    if (selected_file != null) {
                        if (!selected_file.toString().endsWith(".mat")) {
                            selected_file = new File(selected_file.toString() + ".mat");
                        }
                        model.getColorMap().correctMapFromTemplate(selected_file);
                        model.updateViewImagePanels();
                    }
                    break;
                case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                    break;
                case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                    break;
            }
        }
    }//GEN-LAST:event_jMenuItemCorrectMapFromMATActionPerformed

    private void jMenuItemExportNormalizedMapToMATActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemExportNormalizedMapToMATActionPerformed
        if (model != null && model.getGridSize() > 1) {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setMultiSelectionEnabled(true);
            fileChooser.setDialogTitle("Save Map to .MAT");
            fileChooser.setCurrentDirectory(this.currentFile);

            int result = fileChooser.showOpenDialog(this);
            File selected_file;
            switch (result) {
                case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                    selected_file = fileChooser.getSelectedFile();
                    this.currentFile = fileChooser.getCurrentDirectory();
                    if (selected_file != null) {
                        if (!selected_file.toString().endsWith(".mat")) {
                            selected_file = new File(selected_file.toString() + ".mat");
                        }
                        model.getColorMap().saveMapToMAT(selected_file, true);
                    }
                    break;
                case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                    break;
                case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                    break;
            }
        }
    }//GEN-LAST:event_jMenuItemExportNormalizedMapToMATActionPerformed

    private void jMenuItemRemoveSaturatedVoxelsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemoveSaturatedVoxelsActionPerformed
        if (model != null) {
            model.removedSaturatedVoxels();
        }
    }//GEN-LAST:event_jMenuItemRemoveSaturatedVoxelsActionPerformed

    private void jCheckBoxMenuItemViewGridActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemViewGridActionPerformed
        if (model != null) {
            if (model.getGridSize() > 0) {
                model.setGridVisible(this.jCheckBoxMenuItemViewGrid.isSelected());
            }
        }
    }//GEN-LAST:event_jCheckBoxMenuItemViewGridActionPerformed

    private void jComboBoxSpectraCombinationFunctionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxSpectraCombinationFunctionActionPerformed
        model.setSpectraCombinationFunction(getSelectedSpectraCombinationFunction());
    }//GEN-LAST:event_jComboBoxSpectraCombinationFunctionActionPerformed

    private void jCheckBoxSeparateSpectraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxSeparateSpectraActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jCheckBoxSeparateSpectraActionPerformed

    private void jCheckBoxMenuItemViewSpectraThumbnailActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemViewSpectraThumbnailActionPerformed
        this.imagePanel.setSpectraThumbnailVisible(this.jCheckBoxMenuItemViewSpectraThumbnail.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItemViewSpectraThumbnailActionPerformed

    private void jComboBoxProcessingActionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxProcessingActionActionPerformed
        if (!processingActions.isEmpty() && this.jComboBoxProcessingAction.getItemCount() > 0 && !model.isSpectraNull()) {
            ProcessingAction procAction = processingActions.get(this.jComboBoxProcessingAction.getSelectedIndex());
            this.jButtonSelectMetabolites.setEnabled(procAction.getQuantificationAction() != null && procAction.getQuantificationAction().getMlFileSelectionMode() == QuantificationAction.MRUI);
            this.jButtonJustPreprocess.setEnabled(procAction.getPreprocessingAction() != null);
            this.jButtonJustQuantify.setEnabled(procAction.getQuantificationAction() != null); 
            this.jButtonProcessData.setEnabled(procAction.getPreprocessingAction() != null && procAction.getQuantificationAction() != null);
        }
    }//GEN-LAST:event_jComboBoxProcessingActionActionPerformed

    private void jButtonProcessDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonProcessDataActionPerformed
        this.processSpectra();
    }//GEN-LAST:event_jButtonProcessDataActionPerformed

    private void jButtonJustPreprocessActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonJustPreprocessActionPerformed
        this.preprocessSpectra( );
    }//GEN-LAST:event_jButtonJustPreprocessActionPerformed

    
    /**
     * This routine now selects the type of quantification the user want to 
     * perform.
     * @param evt 
     */
    private void jButtonJustQuantifyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonJustQuantifyActionPerformed
        BatchProcessing.cancel( );
        this.setWaitLayerActive( true );
        model.clearColorMap( );
        QuantificationAction quantAction = this.selectProcessingAction( ).getQuantificationAction( );
        BatchProcessing.addQuantification( quantAction );
        BatchProcessing.run( );
        this.setWaitLayerActive( false );
    }//GEN-LAST:event_jButtonJustQuantifyActionPerformed

    private void jButtonSelectMetabolitesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSelectMetabolitesActionPerformed
        if (model != null && !model.isSpectraNull()) {
            QuantificationAction action = this.processingActions.get(this.jComboBoxProcessingAction.getSelectedIndex()).getQuantificationAction();
            QuantificationSelectMetabolites dialog = new QuantificationSelectMetabolites(this, action);
        }
    }//GEN-LAST:event_jButtonSelectMetabolitesActionPerformed

    private void jMenuItemSaveSelectionTojMRUIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSaveSelectionTojMRUIActionPerformed
        mruiViewerInterface.saveResultsToJmrui( );
    }//GEN-LAST:event_jMenuItemSaveSelectionTojMRUIActionPerformed

    private void jMenuItemConfigNetworkNodesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemConfigNetworkNodesActionPerformed
        DicomNetworkNodeDefinerAndSelectionFrame dicomNodesFrame = new DicomNetworkNodeDefinerAndSelectionFrame(this);
    }//GEN-LAST:event_jMenuItemConfigNetworkNodesActionPerformed

    private void jMenuItemDICOMNetworkListenerControlActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemDICOMNetworkListenerControlActionPerformed
        if ( m_dicomNetworkListenerPropertiesFrame == null ) 
        {
            m_dicomNetworkListenerPropertiesFrame = new DicomNetworkListenerPropertiesFrame( this );
        }
        m_dicomNetworkListenerPropertiesFrame.setVisible( true );
    }//GEN-LAST:event_jMenuItemDICOMNetworkListenerControlActionPerformed

    private void jCheckBoxMenuItemAutomaticProcessingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemAutomaticProcessingActionPerformed
        AutomaticProcessingFileHandler.getInstance().setActivityStatus(jCheckBoxMenuItemAutomaticProcessing.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItemAutomaticProcessingActionPerformed

    private void jMenuItemTumourRegionSelectionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemTumourRegionSelectionActionPerformed
        TumourRegionSelectionAssistant.getInstance(this, this);
    }//GEN-LAST:event_jMenuItemTumourRegionSelectionActionPerformed

    private void jMenuItemNewTDFDfitModellingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemNewTDFDfitModellingActionPerformed
        if ( model != null ) 
        {
            if ( model.getSpectroscopyFile( ).length( ) != 0 ) 
            {
                DicomDirectory ddir = ((DicomDataLoaderPanel) pnlFileManager).getDicomDirObject( );
                TDFDFitControlFrame frame = new TDFDFitControlFrame( this, model, model.getSpectroscopyFile( ), ddir, false );
                frame.addActionListener( this );
            } 
            else 
            {
                TDFDFitControlFrame frame = new TDFDFitControlFrame( this, model, false );
                frame.addActionListener( this );
            }
        }
    }//GEN-LAST:event_jMenuItemNewTDFDfitModellingActionPerformed

    private void jMenuPatientBrowserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuPatientBrowserActionPerformed
        m_clinicalSpectroscopyFrame.setVisible(true);
    }//GEN-LAST:event_jMenuPatientBrowserActionPerformed

    private void jButtonJustHandleResultsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonJustHandleResultsActionPerformed
        BatchProcessing.cancel();
        this.setWaitLayerActive(true);
        model.clearColorMap();
        ProcessingAction procAction = processingActions.get(this.jComboBoxProcessingAction.getSelectedIndex());
        ResultsAction resAction = procAction.getResultsAction();
        if (resAction != null) {
            switch (resAction.getType()) {
                case ResultsAction.SAVE_RESULTS:
                    BatchProcessing.addSaveResultsCommand(resAction.getResultsFolder());
                    break;
                case ResultsAction.SAVE_METAB_MAT:
                    BatchProcessing.addSaveMetaboliteMapsCommand(resAction.getResultsFolder(), true);
            }
            BatchProcessing.run();
        }
    }//GEN-LAST:event_jButtonJustHandleResultsActionPerformed

    private void jMenuItemProcessAllSeriesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemProcessAllSeriesActionPerformed
        
        if ( dicomseltab.getPatientList( )!= null )
        {
            if (this.dicomseltab.getPatientList().getPatients().size() > 0) {
                ProcessingAction procAction = this.selectProcessingAction();
                ArrayList<File> mrsFiles = new ArrayList<>();
                if (procAction != null) {
                    for (Patient patient : this.dicomseltab.getPatientList().getPatients()) {
                        for (Study study : patient.getStudies()) {
                            for (Series series : study.getSeries()) {
                                if (series.isSpectroscopy()) {
                                    mrsFiles.add(new File(series.getFiles().getFirst()));
                                }
                            }
                        }
                    }
                    if (mrsFiles.size() > 0) {
                        printTxt(mrsFiles.size() + " Spectroscopy series found in mounted directory!");
                        BatchProcessSpectroscopyFiles(mrsFiles, procAction);
                    } else {
                        printTxt("No Spectroscopy series found in mounted directory!");
                    }
                }
            } else {
                printTxt("Please mount a directory first.");
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot process all spectroscopy data:\n First mount a directory with valid MRS(I) data-sets!" );
        }
    }//GEN-LAST:event_jMenuItemProcessAllSeriesActionPerformed

    private void jMenuItemProcessAllSeriesFolderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemProcessAllSeriesFolderActionPerformed
        final JFileChooser fileChooser = new JFileChooser();
        fileChooser.setCurrentDirectory(currentFile);
        fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fileChooser.setMultiSelectionEnabled(true);
        int result = fileChooser.showOpenDialog(this);

        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                setWaitLayerActive(true);
                String res = "";
                for (int i = 0; i < fileChooser.getSelectedFiles().length; i++) {
                    res = res + fileChooser.getSelectedFiles()[i] + "; ";
                }
                printTxt("Selected folder(s): " + res);
                printTxt("Analyzing selected folder(s)...");
                printTxt("");
                final ArrayList<File> mrsFiles = new ArrayList<>();
                SwingWorker worker = new SwingWorker<Integer, String>() {
                    @Override
                    public Integer doInBackground() {
                        final File[] selected_files = fileChooser.getSelectedFiles();
                        for (int i = 0; i < selected_files.length; i++) {
                            currentFile = selected_files[0];
                            try {
                                Files.walkFileTree(selected_files[i].toPath(), new SimpleFileVisitor<Path>() {
                                    @Override
                                    public FileVisitResult visitFile(Path file, BasicFileAttributes attrs)
                                            throws IOException {
                                        if (file.toFile().toString().endsWith(".dcm") || file.toFile().toString().endsWith(".DCM")
                                                || file.toFile().toString().endsWith(".ima") || file.toFile().toString().endsWith(".IMA") || file.toFile().toString().endsWith(".cdm")) {
                                            DicomObject object = DicomHandler.getDicomObject(file.toFile().toString());
                                            if (object != null) {
                                                String classUID = DicomHandler.getSOPClassUID(object);
                                                String imagetype = DicomHandler.getImageType(object);
                                                boolean isSpectroscopy = false;
                                                switch (classUID) {
                                                    case "1.2.840.10008.5.1.4.1.1.4.2": // Spectro std
                                                        isSpectroscopy = true;
                                                        break;
                                                    case "1.3.12.2.1107.5.9.1": // Spectro/Tensor Siemens
                                                        if (imagetype.indexOf("TENSOR") < 0) {
                                                            isSpectroscopy = true;
                                                        }
                                                        break;
                                                }
                                                if (isSpectroscopy) {
                                                    mrsFiles.add(file.toFile());
                                                    publish(mrsFiles.size() + " Spectroscopy series found up till now. Searching...");
                                                }
                                            }
                                        }
                                        return FileVisitResult.CONTINUE;
                                    }
                                });
                            } catch (IOException ex) {
                                Logger.getLogger(ClinicalViewer.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        return 1;
                    }

                    @Override
                    public void done() {
                        setWaitLayerActive(false);
                    }

                    @Override
                    public void process(final List<String> chunks) {
                        for (final String string : chunks) {
                            eraseLastLineTextArea();
                            printTxt(string);
                        }
                    }
                };
                worker.addPropertyChangeListener(new PropertyChangeListener() {
                    @Override
                    public void propertyChange(final PropertyChangeEvent event) {
                        switch (event.getPropertyName()) {
                            case "state":
                                String res = "";
                                for (int i = 0; i < fileChooser.getSelectedFiles().length; i++) {
                                    res = res + fileChooser.getSelectedFiles()[i] + "; ";
                                }
                                switch ((StateValue) event.getNewValue()) {
                                    case DONE:
                                        if ((mrsFiles.size()) > 0) {
                                            eraseLastLineTextArea();
                                            printTxt(mrsFiles.size() + " Spectroscopy series found under folder(s): " + res);
                                            dicomManager.clearDicomDir();
                                            ((DicomDataLoaderPanel) pnlFileManager).unmountDirectory();
                                            BatchProcessSpectroscopyFiles(mrsFiles, selectProcessingAction());
                                        } else {
                                            printTxt("No Spectroscopy series found under folder(s): " + res);
                                        }
                                        break;
                                    case STARTED:
                                        break;
                                }
                        }
                    }
                });
                worker.execute( );
                break;
        }
    }//GEN-LAST:event_jMenuItemProcessAllSeriesFolderActionPerformed
    
    /**
     * This method launches the processing of TDFDFit. 
     * @param evt 
     */
    private void jMenuItemQuantifyTDFDfitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemQuantifyTDFDfitActionPerformed

        if ( model != null && !model.isSpectraNull( ) )  
        {   
            
            TDFDFitPrototypeModelSpectrumParameters protoTypeModel = TDFDFitPrototypeModelSpectrumParameters.getInstance( );
            protoTypeModel.isWaterRemovalModel( true );
            int modelPointsToFit = protoTypeModel.getMeasuredSpectrum( ).getAbsorptionChannelFD( ).length;
            
            if ( modelPointsToFit == model.getVectorSize( ) )
            {
                TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                def.load( );

                String defaultModelName = def.getProperty( TDFDFittingDefaults.DEFAULT_TDFDFIT_FIT_MODEL_NAME );
                String defaultModelPath = def.getProperty( TDFDFittingDefaults.DEFAULT_USED_TDFDFIT_MODEL_PATH );

                if ( defaultModelName.endsWith( ".tfm" ) == false )
                {
                    defaultModelName = defaultModelName + ".tfm";
                }

                String modelReference = defaultModelPath + System.getProperty( "file.separator" ) + defaultModelName;
                File defaultModelFile = new File( modelReference );

                if ( defaultModelFile.exists( ) == true )
                {
                    NonInteractiveTDFDFitExecuter tdfdfitExecutor = new NonInteractiveTDFDFitExecuter( this, modelReference, model, false );
                    tdfdfitExecutor.loadTDFDFitPrototypeModelSpectrumFile( );
                        
                    if ( tdfdfitExecutor.getSingleVoxelMeasuredSpectralData( ).getAbsorptionChannelFD( ).length == model.getVectorSize( ) )
                    {

                        tdfdfitExecutor.addActionListener( this );
                        tdfdfitExecutor.executeTDFDFitting( true );
                    }
                    else
                    {
                         JOptionPane.showMessageDialog( this, "TDFDFitting cannot be performed: \n Number of points of selected model does not match the number of points in the data!." );
                    }
                    
//                    tdfdfitExecutor.addActionListener( this );
//                    tdfdfitExecutor.executeTDFDFitting( true );
                }
            }
            else
            {
                JOptionPane.showMessageDialog( this, "Cannot apply TDFDFitting of dataset:\n Number datapoints of prototype spectra does not match the currently loaded data!" );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot apply TDFDFitting of dataset:\n First load valid MRS(I) data set and define valid default TDFDFit model!" );
        }
        
    }//GEN-LAST:event_jMenuItemQuantifyTDFDfitActionPerformed

    
    private void jMenuItemQuantitativeClinicalCaseTDFDfittingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemQuantitativeClinicalCaseTDFDfittingActionPerformed
        // Launch the Clinical Case Fitting enviroment!
        if ( model != null ) 
        {
            if ( model.getSpectroscopyFile( ).length( ) != 0 ) 
            {
                DicomDirectory ddir = ((DicomDataLoaderPanel) pnlFileManager).getDicomDirObject( );
                TDFDFitControlFrame frame = new TDFDFitControlFrame( this, model.getCSIData( ), ddir, model );
            } 
            else 
            {
                JOptionPane.showMessageDialog( this, "<html><br /><font color=\"red\"><b>No (clinical) dataset loaded yet.</b></font><br /> <br />First load a dataset!</html>", "Missing data", JOptionPane.ERROR_MESSAGE );
            }
        }
    }//GEN-LAST:event_jMenuItemQuantitativeClinicalCaseTDFDfittingActionPerformed

    private void jCheckBoxMenuItemViewSaturationBandsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemViewSaturationBandsActionPerformed
        if (model != null) {
            if (model.getGridSize() > 0) {
                model.setSaturationBandsVisible(this.jCheckBoxMenuItemViewSaturationBands.isSelected());
            }
        }
    }//GEN-LAST:event_jCheckBoxMenuItemViewSaturationBandsActionPerformed

    private void performOutlierCorrectionInSwingWorkerTread( )
    {
        int numberOfProgressSteps = model.getSelectedVoxels( ).size( );
        
        m_dualProgressBar = new DualProgressBar( this, numberOfProgressSteps, 0, new Dimension( 900, 150 ), false );
        m_dualProgressBar.setTitle( "Performing outlier correction  on dataset .."  );
        m_dualProgressBar.setUpperProgressVisible( true );
        m_dualProgressBar.setUpperProgress( 0 );
        m_dualProgressBar.setUpperLabel( "<HTML><BR>     Correcting signal number : " + 0 + "</HTML>" );
        m_dualProgressBar.setLowerProgressVisible( false );
       
        final org.spectrim.lib.SwingWorker worker = new org.spectrim.lib.SwingWorker( )
        {

            @Override
            public Object construct( )
            {
                // default call: filtering on first line, first feature
                performOutlierCorrectionOnDataset( 1, 1, -1.5f, 1.5f);
                return null;
            }

            // runs in the event dispatching thread
            @Override
            public void finished( )
            {
                // After calculation set enabled again
                m_dualProgressBar.setVisible( false );
                m_dualProgressBar.dispose( );
            }
        };

        worker.start( );
    }
    
    public void applyOffsetCorrectionTDInSwingWorkerThread( )
    {

        int numberOfProgressSteps = model.getSelectedVoxels( ).size( );
        
        m_dualProgressBar = new DualProgressBar( this, numberOfProgressSteps, 0, new Dimension( 900, 150 ), false );
        m_dualProgressBar.setTitle( "Applying time domain offset correction .."  );
        m_dualProgressBar.setUpperProgressVisible( true );
        m_dualProgressBar.setUpperProgress( 0 );
        m_dualProgressBar.setUpperLabel( "<HTML><BR>     Correcting signal number : " + 0 + "</HTML>" );
        m_dualProgressBar.setLowerProgressVisible( false );
       
        final org.spectrim.lib.SwingWorker worker = new org.spectrim.lib.SwingWorker( )
        {

            @Override
            public Object construct( )
            {
                performTimeDomainOffsetCorrectionOnDataset( );
                return null;
            }

            // runs in the event dispatching thread
            @Override
            public void finished( )
            {
                // After calculation set enabled again
                m_dualProgressBar.setVisible( false );
                m_dualProgressBar.dispose( );
            }
        };

        worker.start( );
    }
    
    
    /**
     * Performs in frequency domain the removal of an amplitude offset ("DC").
     * @param minTDRange
     * @param maxFDRange
     */
    public void applyOffsetCorrectionTDInSwingWorkerThread( double minTDRange, double maxFDRange  )
    {
        int numberOfProgressSteps = model.getSelectedVoxels( ).size( );
        
        m_dualProgressBar = new DualProgressBar( this, numberOfProgressSteps, 0, new Dimension( 900, 150 ), false );
        m_dualProgressBar.setTitle( "Applying frequency domain offset correction .."  );
        m_dualProgressBar.setUpperProgressVisible( true );
        m_dualProgressBar.setUpperProgress( 0 );
        m_dualProgressBar.setUpperLabel( "<HTML><BR>     Correcting spectrum number : " + 0 + "</HTML>" );
        m_dualProgressBar.setLowerProgressVisible( false );
        
        launchPerformTimeDomainOffsetCorrectionOnDataset( (int)minTDRange, (int)maxFDRange );
        
    }        
                     
    /**
     * Performs in frequency domain the removal of an amplitude offset ("DC").
     */
    public void applyOffsetCorrectionFDInSwingWorkerThread( )
    {        
        int numberOfProgressSteps = model.getSelectedVoxels( ).size( );
        
        m_dualProgressBar = new DualProgressBar( this, numberOfProgressSteps, 0, new Dimension( 900, 150 ), false );
        m_dualProgressBar.setTitle( "Applying frequency domain offset correction .."  );
        m_dualProgressBar.setUpperProgressVisible( true );
        m_dualProgressBar.setUpperProgress( 0 );
        m_dualProgressBar.setUpperLabel( "<HTML><BR>     Correcting spectrum number : " + 0 + "</HTML>" );
        m_dualProgressBar.setLowerProgressVisible( false );
       
        final org.spectrim.lib.SwingWorker worker = new org.spectrim.lib.SwingWorker( )
        {

            @Override
            public Object construct( )
            {
                performFrequencyDomainOffsetCorrectionOnDataset( );
                return null;
            }

            // runs in the event dispatching thread
            @Override
            public void finished( )
            {
                // After calculation set enabled again
                m_dualProgressBar.setVisible( false );
                m_dualProgressBar.dispose( );
            }
        };

        worker.start( );
    }
    
    /**
     * This routine applies HLSVD64 in a separate swing worker thread.
     */
    public void applyHLSVD64FilterInSwingWorkerThread( )
    {

        
        
        int numberOfProgressSteps = model.getSelectedVoxels( ).size( );
        
        final DualProgressBar dualProgressBar = new DualProgressBar( this, numberOfProgressSteps, 0, new Dimension( 900, 150 ), false );
        dualProgressBar.setTitle( "Applying HLSVD 64 filtering .."  );
        dualProgressBar.setUpperProgressVisible( true );
        dualProgressBar.setUpperProgress( 0 );
        dualProgressBar.setUpperLabel( "<HTML><BR>     Filtering spectrum number : " + 0 + "</HTML>" );
        dualProgressBar.setLowerProgressVisible( false );
       
        final org.spectrim.lib.SwingWorker worker = new org.spectrim.lib.SwingWorker( )
        {

            @Override
            public Object construct( )
            {
                performHLSVDOnDataset( dualProgressBar );
                return null;
            }

            // runs in the event dispatching thread
            @Override
            public void finished( )
            {
                // After calculation set enabled again
                dualProgressBar.setVisible( false );
                dualProgressBar.dispose( );
                BatchProcessing.resume( );
            }
        };

        worker.start( );
    }
    
    /**
     * This routine applies HLSVDPro in a separate swing worker thread.
     */
    public void applyHLSVDProFilterInSwingWorkerThread( )
    {

        int numberOfProgressSteps = model.getSelectedVoxels( ).size( );
        //Load the 
        TDFDFittingDefaults defaults = TDFDFittingDefaults.getInstance( );
        defaults.load( );
        final String HLSVDpro_version = defaults.getProperty( TDFDFittingDefaults.HLSVDPRO_VERSION );
        final DualProgressBar dualProgressBar = new DualProgressBar( this, numberOfProgressSteps, 0, new Dimension( 900, 150 ), false );
        dualProgressBar.setTitle( "Applying HLSVDPro filtering .."  );
        dualProgressBar.setUpperProgressVisible( true );
        dualProgressBar.setUpperProgress( 0 );
        dualProgressBar.setUpperLabel( "<HTML><BR>     Filtering spectrum number : " + 0 + "</HTML>" );
        dualProgressBar.setLowerProgressVisible( false );

        final org.spectrim.lib.SwingWorker worker = new org.spectrim.lib.SwingWorker( )
        {

            @Override
            public Object construct( )
            {
                if ( HLSVDpro_version.compareTo( TDFDFittingDefaults.HLSVDPRO_VERSION_PARALLEL ) == 0 ){
                    performHLSVDProOnDatasetBatch( dualProgressBar );
                }
                else{
                    performHLSVDProOnDataset( dualProgressBar );
                }
                return null;
            }

            // runs in the event dispatching thread
            @Override
            public void finished( )
            {
                // After calculation set enabled again
                dualProgressBar.setVisible( false );
                dualProgressBar.dispose( );
                BatchProcessing.resume( );
            }
        };

        worker.start( );
    }
    
    
    /**
     * This routine applies HLSVD64 in a separate swing worker thread.
     */
    public void applyInterActiveHLSVD64Filter( )
    {
        if ( model.getCSIData( ) != null )
        {
            TDFDFittingDefaults defs = TDFDFittingDefaults.getInstance( );
            defs.load( );
            
            defs.setProperty( TDFDFittingDefaults.DISPLAY_DOMAIN, TDFDFittingDefaults.FREQ_DOMAIN );
            defs.setProperty( TDFDFittingDefaults.DISPLAY_UNIT, TDFDFittingDefaults.FREQUENCY_DOMAIN_PPM );
            defs.save( );
            
            CSIData csiData = model.getCSIData( );

            Spectra spectra = csiData.getSpectra( );

//            Iterator it = spectra.getData( ).keySet( ).iterator( );
//            String key = spectra.getData( ).keySet( ).iterator( ).next( );

            ArrayList<String> ids = model.getSelectedVoxels( );
            float[] absTD = spectra.getMeanSpectrum( ids, Spectra.Domain.TD, Spectra.Mode.ABS );
            float[] dispTD = spectra.getMeanSpectrum( ids, Spectra.Domain.TD, Spectra.Mode.DISP );

            for ( int i = 0; i < dispTD.length; i++ )
            {
                dispTD[i] = -dispTD[i];
            }
            
            MRSignalProperties.getInstance( ).setNumberOfSamplePoints( model.getVectorSize( ) );
            MRSignalProperties.getInstance( ).setHz_pp( (float)( model.getBandwidth( ) / model.getVectorSize( ) ) );
            MRSignalProperties.getInstance( ).setResonanceFrequency( new Double( "" + model.getResonanceFrequency( ) ).longValue( ) );
            MRSignalProperties.getInstance( ).setPPMValueInCenterOfSpectrum( (float)model.getPPMReference( ) );
            SingleVoxelMeasuredSpectralData singleVoxelMeasuredData = new SingleVoxelMeasuredSpectralData( absTD, dispTD );

            m_hlsvdWaterRemovalGUI = new HLSVDControlFrame( singleVoxelMeasuredData, false );
            m_hlsvdWaterRemovalGUI.addActionListener( this );
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot open interactive HLSVD tool: \nFirst load a MRS(I) dataset!" );
        } 
    }
    
    /**
     * This applies offset correct on the dataset in frequency domain.
     * This is necessary in TDFDfit in order to prevent possible biassing
     * of component amplitudes, i.e. peak areas.
     */
    private void performFrequencyDomainOffsetCorrectionOnDataset( )
    {
        
        
        if ( model.getCSIData( ) != null )
        {
       
            Spectra spectra = model.getSpectra( );
            ArrayList<String> selVox = model.getSelectedVoxels( );

            HashMap<String, Spectrum> data =  spectra.getData( );
            Iterator it = data.entrySet( ).iterator( );


            if ( it.hasNext( ) ) 
            {
                Map.Entry pair = (Map.Entry)it.next( );
                Spectrum spectrum = (Spectrum) pair.getValue( );
                float[] absSignal = spectrum.getAbsorptionFD( );

                m_fdOffsetRemoverControl = new OffsetRemovalParameterControl( "Frequency Domain Offset Removal", 
                                                                              this, SpectrumPhasingDefinitionControl.SINGLE_RESPONSE_DISPLAY,
                                                                              0.0f, 0.2f * absSignal.length );
                m_fdOffsetRemoverControl.addActionListener( this );
            }
            else
            {
                JOptionPane.showMessageDialog( this, "Offset correction in time domain cannot be performed" );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot perform frequency domain offset correction on dataset: \nFirst load a MRS(I) dataset!" );
        }
    }
    
    /**
     * Routine to eliminate outliers in metabolic maps using local statistical
     * properties.
     */
    private void performOutlierCorrectionOnDataset( int metaboliteNumber, int featureNumber,
                                                    float minimumPercentile, float maximumPercentile )
    {
        boolean dataDefined = true;
        
        int nd1 = model.getGridDim1( );
        int nd2 = model.getGridDim2( );
        int nd3 = model.getGridDim3( );  
        
        double[] dataAs1DArray = new double[ model.getSelectedVoxels( ).size( ) ];
        
        TDFDFitResultsStore store = model.getTDFDFitStore( );
        
        double[][][] pars = null;
        String[] metabNames = store.getMetabolitesNames( );
        

        // int ii = metabNames.length - 1;

        switch ( featureNumber )
        {
            case MetaboliteFeatures.AREA:      pars = store.getFittingParameters( metabNames[metaboliteNumber], MetaboliteFeatures.AREA );
                                               for ( int i = 0; i < nd1; i++ )
                                               {
                                                   for ( int j = 0; j < nd2; j++ )
                                                   {
                                                        for ( int k = 0; k < nd3; k++ )
                                                        {
                                                            pars[i][j][k] = Math.abs( pars[i][j][k] );
                                                        }
                                                   }
                                                }
                                               break;
            case MetaboliteFeatures.AMPLITUDE: pars = store.getFittingParameters( metabNames[metaboliteNumber], MetaboliteFeatures.AREA );
                                               break;
            case MetaboliteFeatures.FRQSHIFT:  pars = store.getFittingParameters( metabNames[metaboliteNumber], MetaboliteFeatures.FRQSHIFT );
                                               break;                             
            case MetaboliteFeatures.PHASE:     pars = store.getFittingParameters( metabNames[metaboliteNumber], MetaboliteFeatures.PHASE );
                                               break;
            case MetaboliteFeatures.DAMPING:   pars = store.getFittingParameters( metabNames[metaboliteNumber], MetaboliteFeatures.DAMPING );
                                               break;
            case MetaboliteFeatures.GDAMPING:  pars = store.getFittingParameters( metabNames[metaboliteNumber], MetaboliteFeatures.GDAMPING );
                                               break;
            default:                           dataDefined = false;
                                               break;
        }
        
        
        if ( pars != null )
        {
            System.out.println( "Starting outlier detection ... " );
            System.out.println( "Metabolite : " + metabNames[metaboliteNumber] );

            int cntr = 0;
            for ( int i = 0 ; i < nd1 ; i++ )
            {
                for ( int j = 0; j < nd2 ; j++ )
                {
                    for ( int k = 0; k < nd3; k++ )
                    {
                        if ( model.getSelectedVoxels( ).contains( "" + i + "_" + j + "_" + k ) )
                        {
                            System.out.println( metabNames[metaboliteNumber] + " - pars[" + i + "][" + j + "][" + k + "] = " + pars[i][j][k] );
                            dataAs1DArray[cntr] = pars[i][j][k];
                            System.out.println( "cntr = " + cntr++ );
                        }  
                    }
                }
            }

            int[] orderIndex = new int[dataAs1DArray.length];
        
            double[] orderedData = QuickSort.quickSort( orderIndex, dataAs1DArray );
            double median;
            if ( ( orderedData.length % 2 ) == 0 )
            {
                median = 0.5 * ( orderedData[ ( ( orderedData.length-1 )/2 ) ] + orderedData[ orderedData.length/2 ] );
            }
            else
            {
                median = 0.5 * ( orderedData[ orderedData.length/2 ] );
            }
        
            double q1;
        
            if ( ( orderedData.length % 4 ) == 0 )
            {
                q1 = 0.5 * ( orderedData[ ( ( orderedData.length - 1 ) / 4 ) ] + orderedData[ orderedData.length / 4 ] );
            }
            else
            {
                q1 = 0.5 * ( orderedData[ orderedData.length / 4 ] );
            }
        
            double q3;
        
            if ( ( 3 * orderedData.length % 4 ) == 0 )
            {
                q3 = 0.5 * ( orderedData[ ( ( 3 * orderedData.length - 1 )/4 ) ] + orderedData[ 3 * orderedData.length / 4 ] );
            }
            else
            {
                q3 = 0.5 * ( orderedData[ 3 * orderedData.length / 4 ] );
            }
        
            double interQuartileRange = (q3 - q1);
        
        
            double outerFenceMin = q1 + minimumPercentile * interQuartileRange;
            double outerFenceMax = q3 + maximumPercentile * interQuartileRange;
        
            System.out.println( " Outer fence minimum : " + outerFenceMin );
            System.out.println( " Outer fence maximum : " + outerFenceMax );
        
            // Focus on outerFence violations
            // Number of outliers
            int outliers = 0;
            for ( int i = 0; i < orderedData.length; i++ )
            {
                if ( ( orderedData[i] < outerFenceMin ) || 
                     ( orderedData[i] > outerFenceMax ) )
                {
                    System.out.println( "Outlier found : " + orderedData[i] + " at index : " + orderIndex[i] );
                    outliers++;
                }
            }

            int[] outlierIndexArray = new int[outliers];

            for ( int i = 0; i < outlierIndexArray.length; i++ )
            {
                if ( ( orderedData[i] < outerFenceMin ) || 
                     ( orderedData[i] > outerFenceMax ) )
                {
                    outlierIndexArray[i] = orderIndex[i]; 
                }
            }
        
            System.out.println( "Done outlier detection" );
            System.out.println( "Number of outliers found : " + outliers );

 //           int cntr2 = 0;
            
            // Removing outlier voxels from selected voxel list

            ArrayList<String> copySelVoxels = (ArrayList<String>)model.getSelectedVoxels( ).clone( );

            for ( int i = 0 ; i < nd1 ; i++ )
            {
                for ( int j = 0; j < nd2 ; j++ )
                {
                    for ( int k = 0; k < nd3; k++ )
                    {
                        
                        
                        if ( ( pars[i][j][k] < outerFenceMin ) || 
                             ( pars[i][j][k] > outerFenceMax ) )   
                        {
                            String key =  "" + i + "_" + j + "_" + k;
                            System.out.println( "key : " + key );
                            copySelVoxels.remove( key );

                        }  
                    }
                }
            }
            
            // now redraw the panels!
            // model.updateSpectraPanel( );
            System.out.println( "Number of selected voxels                 : " + model.getSelectedVoxels( ).size( ) );
            System.out.println( "Number of selected voxels after filtering : " + copySelVoxels.size( ) );
            
            model.setSelectedVoxels( copySelVoxels );
            model.updateViewSelectionChange( );
            model.updateViewImagePanels( );
        }
    }
    
    
    /**
     * This applies offset correct on the dataset in frequency domain.
     * This is necessary in order to prevent possible biassing in 
     * quantification algorithm that follows.
     */
    private void performTimeDomainOffsetCorrectionOnDataset( )
    { 
        
        if ( model.getCSIData( ) != null )
        {
        
        
            Spectra spectra = model.getSpectra( );
            ArrayList<String> selVox = model.getSelectedVoxels( );

            HashMap<String, Spectrum> data =  spectra.getData( );
            Iterator it = data.entrySet( ).iterator( );


            if ( it.hasNext( ) ) 
            {
               Map.Entry pair = (Map.Entry)it.next( );
               Spectrum spectrum = (Spectrum) pair.getValue( );
               float[] absSignal = spectrum.getAbsorptionTD( );


                m_tdOffsetRemoverControl = new OffsetRemovalParameterControl( "Time Domain Offset Removal", 
                                           this, SpectrumPhasingDefinitionControl.SINGLE_RESPONSE_DISPLAY,
                                           0.8f * absSignal.length, 0.95f * absSignal.length );
                m_tdOffsetRemoverControl.addActionListener( this );
            }
            else
            {
                JOptionPane.showMessageDialog( this, "Offset correction in time domain cannot be performed." );
            }
        }
        else
        {
              JOptionPane.showMessageDialog( this, "Cannot offset correction in TD on dataset: \nFirst load a MRS(I) dataset!" );
        }
    }
    
    
    
    /**
     * Performs the actual frequency domain offset correction.
     * @param minRangeIntValue
     * @param maxRangeIntValue 
     */
    private void launchPerformFrequencyDomainOffsetCorrectionOnDataset( int minRangeIntValue, int maxRangeIntValue )
    {
         
        Spectra spectra = model.getSpectra( );
        ArrayList<String> selVox = model.getSelectedVoxels( );
        
        HashMap<String, Spectrum> data =  spectra.getData( );
        Iterator it = data.entrySet( ).iterator( );
        
        int cntr = 0;
        
        while ( it.hasNext( ) ) 
        {
            
            Map.Entry pair = (Map.Entry)it.next( );
            
            // Iterate over all selected voxels
            if ( selVox.contains( pair.getKey( ) ) )
            {
                
                m_dualProgressBar.setUpperProgress( cntr++ );
                m_dualProgressBar.setUpperLabel( "<HTML><BR>     Offset correction of spectrum number : " + cntr + " of " + model.getSelectedVoxels( ).size( ) + " </HTML>" );
                
                // System.out.println( pair.getKey( ) + " = " + pair.getValue( ) );
                Spectrum spectrum = (Spectrum) pair.getValue( );
                
                float[] absSignal = spectrum.getAbsorptionFD( );
                float[] dispSignal = spectrum.getDispersionFD( );
                
//                float[] xaxis = new float[absSignal.length];
//                for ( int i=0; i < absSignal.length; i++ )
//                {
//                    xaxis[i] = i * 1.0f;
//                }
//                
//                XYPlotFrame xyPlot = new XYPlotFrame( "absorption", this );
//                xyPlot.addCurve( new Curve( xaxis, absSignal ), true );
//                
//                
                double[] abs = new double[absSignal.length];
                double[] disp = new double[absSignal.length];
                
                float avrReal = 0f;
                float avrImag = 0f;
                
                // The response is mirrored, therefore strange boundaries! 
                for ( int i = ( absSignal.length - minRangeIntValue - 1 ); i > (absSignal.length - maxRangeIntValue) ; i-- )
                {
                    avrReal += absSignal[i];
                    avrImag += dispSignal[i];
                }
                
                avrReal = avrReal / ( maxRangeIntValue - minRangeIntValue );
                avrImag = avrImag / ( maxRangeIntValue - minRangeIntValue );
                
//                System.out.println( "avrReal  : " + avrReal + "  avrImag   : " + avrImag );
                
                for ( int i = 0; i < absSignal.length; i++ )
                {
                    abs[i]  = (double)absSignal[i]  - avrReal;
                    disp[i] = (double)dispSignal[i] - avrImag;
                }
                
                for ( int i = 0; i < absSignal.length; i++ )
                {
                    absSignal[i] = (float)abs[i];
                    dispSignal[i] = (float)disp[i];
                }

                SingleVoxelSpectralData svsData = new SingleVoxelSpectralData( absSignal, dispSignal, SingleVoxelSpectralData.FREQ_DOMAIN );
                
                Spectrum filtered = new Spectrum( svsData.getAbsorptionChannelTD( ), 
                                                  svsData.getDispersionChannelTD( ), 
                                                  spectra );

                float FDNoise = filtered.getNoiseStdDevFD( );
                float TDNoise = filtered.getNoiseStdDevTD( );

                filtered.setNoiseStdFD( FDNoise );
                filtered.setNoiseStdTD( TDNoise );

                data.put( (String)pair.getKey( ), filtered );
            }
        }
        m_dualProgressBar.dispose( );
        model.updateSpectraPanel( );
        
    }
    
    
     /**
     * Performs the actual frequency domain offset correction.
     * @param minRangeIntValue
     * @param maxRangeIntValue 
     */
    private void launchPerformTimeDomainOffsetCorrectionOnDataset( int minRangeIntValue, int maxRangeIntValue )
    {
         
        Spectra spectra = model.getSpectra( );
        ArrayList<String> selVox = model.getSelectedVoxels( );
        
        HashMap<String, Spectrum> data =  spectra.getData( );
        Iterator it = data.entrySet( ).iterator( );
        
        int cntr = 0;
        
        while ( it.hasNext( ) ) 
        {
            
            Map.Entry pair = (Map.Entry)it.next( );
            
            // Iterate over all selected voxels
            if ( selVox.contains( pair.getKey( ) ) )
            {
                
                m_dualProgressBar.setUpperProgress( cntr++ );
                m_dualProgressBar.setUpperLabel( "<HTML><BR>     Offset correction of spectrum number : " + cntr + " of " + model.getSelectedVoxels( ).size( ) + " </HTML>" );
                
                // System.out.println( pair.getKey( ) + " = " + pair.getValue( ) );
                Spectrum spectrum = (Spectrum) pair.getValue( );
                
                float[] absSignal = spectrum.getAbsorptionTD( );
                float[] dispSignal = spectrum.getDispersionTD( );
                
                double[] abs = new double[absSignal.length];
                double[] disp = new double[absSignal.length];
                
                float avrReal = 0f;
                float avrImag = 0f;
                
                for ( int i = minRangeIntValue; i < maxRangeIntValue ; i++ )
                {
                    avrReal += absSignal[i];
                    avrImag += dispSignal[i];
                }
                
                avrReal = avrReal / ( maxRangeIntValue - minRangeIntValue );
                avrImag = avrImag / ( maxRangeIntValue - minRangeIntValue );
                
                for ( int i = 0; i < absSignal.length; i++ )
                {
                    abs[i]  = (double)absSignal[i]  - avrReal;
                    disp[i] = (double)dispSignal[i] - avrImag;
                }
                
                for ( int i = 0; i < absSignal.length; i++ )
                {
                    absSignal[i] = (float)abs[i];
                    dispSignal[i] = (float)disp[i];
                }
                
                Spectrum filtered = new Spectrum( absSignal, 
                                                  dispSignal, 
                                                  spectra );

                float FDNoise = filtered.getNoiseStdDevFD( );
                float TDNoise = filtered.getNoiseStdDevTD( );

                filtered.setNoiseStdFD( FDNoise );
                filtered.setNoiseStdTD( TDNoise );

                data.put( (String)pair.getKey( ), filtered );
            }
        }
        m_dualProgressBar.dispose( );
        model.updateSpectraPanel( );
        
    }
    
    /**
     * This (second routine) also computes HLSVD 64 in a separate swing worker
     * thread.
     * @param dualProgressBar 
     */
    private void performHLSVDOnDataset( DualProgressBar dualProgressBar )
    {
        if ( model.getCSIData( ) != null )
        {
            Spectra spectra = model.getSpectra( );
            ArrayList<String> selVox = model.getSelectedVoxels( );

            HashMap<String, Spectrum> data =  spectra.getData( );
            Iterator it = data.entrySet( ).iterator( );

            int cntr = 0;

            while ( it.hasNext( ) ) 
            {

                Map.Entry pair = (Map.Entry)it.next( );

                // Iterate over all selected voxels
                if ( selVox.contains( pair.getKey( ) ) )
                {
                    System.out.println( "Applying HLSVD to voxel ID :" + pair.getKey( ) );
                    dualProgressBar.setUpperProgress( cntr++ );
                    dualProgressBar.setUpperLabel( "<HTML><BR>     Filtering spectrum number : " + cntr + " of " + model.getSelectedVoxels( ).size( ) + " </HTML>" );

                    // System.out.println( pair.getKey( ) + " = " + pair.getValue( ) );
                    Spectrum spectrum = (Spectrum) pair.getValue( );
                    float[] absSignal = spectrum.getAbsorptionTD( );
                    float[] dispSignal = spectrum.getDispersionTD( );
                    double[] abs;
                    double[] disp;

                    int hlsvdNumberOfPoints = absSignal.length;

                    if ( absSignal.length > 4096 )
                    {
                        abs = new double[4096];
                        disp = new double[4096];
                        hlsvdNumberOfPoints = 4096;
                    }
                    else
                    {
                        abs = new double[ absSignal.length  ];
                        disp = new double[ absSignal.length ];
                        hlsvdNumberOfPoints = absSignal.length;
                    }

                    for ( int i = 0; i < hlsvdNumberOfPoints; i++ )
                    {
                        abs[i] = (double)absSignal[i];
                        disp[i] = (double)dispSignal[i];
                    }
                    
                    NonInteractiveHLSVD hlsvd = new NonInteractiveHLSVD( abs, disp, 
                                                                         model.getBandwidth( ), 
                                                                         model.getResonanceFrequency( ) );
                    HLSVDResults results = hlsvd.getHLSVDResults( );

                    abs     = results.getFilteredSignalRealPart( );
                    disp    = results.getFilteredSignalImagenaryPart( );

                    for ( int i = 0; i < absSignal.length; i++ )
                    {                    
                        // if ( i < 1024 )
                        // {
                            absSignal[i] = (float)abs[i];
                            dispSignal[i] = (float)disp[i];
                        // }
                    }

                    Spectrum filtered = new Spectrum( absSignal, dispSignal, spectra );

                    float FDNoise = filtered.getNoiseStdDevFD( );
                    float TDNoise = filtered.getNoiseStdDevTD( );

                    filtered.setNoiseStdFD( FDNoise );
                    filtered.setNoiseStdTD( TDNoise );
                    System.out.println( "Putting HLSVD output data to voxel ID :" + pair.getKey( ) );
                    data.put( (String)pair.getKey( ), filtered );
                }
            }

            model.updateSpectraPanel( );
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot perform HLSVD on dataset: \nFirst load an MRS(I) dataset!" );
        }
    }
    
    private Process commandExists( String[] command )
    {
        try
        {
            return Runtime.getRuntime().exec( command );
        }
        catch ( Throwable e )
        {
            return null;
        }
    }
    /**
     * This computes HLSVDPro using a socket connection to Python.
     * @param dualProgressBar 
     */
    @SuppressWarnings("empty-statement")
    private void performHLSVDProOnDataset( DualProgressBar dualProgressBar )
    {
        dualProgressBar.setUpperLabel( "<HTML><BR>     Opening HLSVD server     </HTML>" );
        Process process;
        ClientSocket socket = null;
        String executionPath = System.getProperty("user.dir");
        executionPath = executionPath + "\\bin\\Python\\HLSVD_server.py";
        TDFDFittingDefaults defaults = TDFDFittingDefaults.getInstance( );
        defaults.load( );
        String python_command = defaults.getProperty( TDFDFittingDefaults.PYTHON_EXECUTABLE_FILENAME );
        if( python_command == null || python_command.equals("")){
            PythonSettings Pysetting = new PythonSettings();
            boolean test = false;
            while( test == false ){
                test = Pysetting.GetStatusAccept();
                //return;
            }
            defaults.load();
            python_command = defaults.getProperty( TDFDFittingDefaults.PYTHON_EXECUTABLE_FILENAME );
        }
        String[] command = { "cmd", "/c", python_command, executionPath};
        int ping;
        try{
            socket = new ClientSocket(33356);
            socket.write_str("PING");
            ping = socket.readInt();
            socket.write_str("FINISHED");
            socket.closeConnection();
        } catch (IOException e){
            socket = null;
            ping = 0;
        }
        if(ping==0){
            process = commandExists(command);
            if(process==null){
                PythonSettings Pysetting = new PythonSettings();
                boolean test = false;
                while( test == false ){
                    test = Pysetting.GetStatusAccept();
                //return;
                }
                defaults.load();
                python_command = defaults.getProperty( TDFDFittingDefaults.PYTHON_EXECUTABLE_FILENAME );
                command[2] = python_command;
                try {
                    process = Runtime.getRuntime().exec(command);
                } catch (IOException e2) {
                    socket = null;
                    System.out.println(e2.toString());
                    return;
                }
            }
            do{
                try{
                    socket = new ClientSocket(33356);
                    socket.write_str("FINISHED");
                    socket.closeConnection();
                } catch(IOException e3){
                    System.out.println("ERROR sending PING to server");
                }
            } while(socket==null);
        }
        else{
            System.out.println("Server was open...");
        }
        if ( model.getCSIData( ) != null )
        {
            Spectra spectra = model.getSpectra( );
            ArrayList<String> selVox = model.getSelectedVoxels( );

            HashMap<String, Spectrum> data =  spectra.getData( );
            Iterator it = data.entrySet( ).iterator( );

            int cntr = 0;
            while ( it.hasNext( ) ) 
            {

                Map.Entry pair = (Map.Entry)it.next( );

                // Iterate over all selected voxels
                // Here we iterate generating the batch and we execute HLSVDPro only when cntr
                if ( selVox.contains( pair.getKey( ) ) )
                {
                    
                    dualProgressBar.setUpperProgress( cntr++ );
                    dualProgressBar.setUpperLabel( "<HTML><BR>     Filtering spectrum number : " + cntr + " of " + model.getSelectedVoxels( ).size( ) + " </HTML>" );

                    // System.out.println( pair.getKey( ) + " = " + pair.getValue( ) );
                    Spectrum spectrum = (Spectrum) pair.getValue( );
                    float[] absSignal = spectrum.getAbsorptionTD( );
                    float[] dispSignal = spectrum.getDispersionTD( );
                    double[] abs;
                    double[] disp;

                    int hlsvdNumberOfPoints = absSignal.length;

                    if ( absSignal.length > 4096 )
                    {
                        abs = new double[4096];
                        disp = new double[4096];
                        hlsvdNumberOfPoints = 4096;
                    }
                    else
                    {
                        abs = new double[ absSignal.length  ];
                        disp = new double[ absSignal.length ];
                        hlsvdNumberOfPoints = absSignal.length;
                    }

                    for ( int i = 0; i < hlsvdNumberOfPoints; i++ )
                    {
                        abs[i] = (double)absSignal[i];
                        disp[i] = (double)dispSignal[i];
                    }
                    
                    HLSVDPro hlsvd = new HLSVDPro( abs, disp, 
                                                   model.getBandwidth( ), 
                                                   model.getResonanceFrequency( ), 
                                                   model.getPPMReference( ) );
                    HLSVDResults results = hlsvd.getHLSVDResults( );

                    abs     = results.getFilteredSignalRealPart( );
                    disp    = results.getFilteredSignalImagenaryPart( );

                    for ( int i = 0; i < absSignal.length; i++ )
                    {
                        absSignal[i] = (float)abs[i];
                        dispSignal[i] = (float)disp[i];
                    }

                    Spectrum filtered = new Spectrum( absSignal, dispSignal, spectra );

                    float FDNoise = filtered.getNoiseStdDevFD( );
                    float TDNoise = filtered.getNoiseStdDevTD( );

                    filtered.setNoiseStdFD( FDNoise );
                    filtered.setNoiseStdTD( TDNoise );

                    data.put( (String)pair.getKey( ), filtered );
                }
            }

            model.updateSpectraPanel( );
            try {
                socket = new ClientSocket(33356);
                socket.write_str("TERMINATE");
                socket.closeConnection();
            } catch (IOException e) {
                socket = null;
                System.out.println( "ERROR connecting to socket" );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot perform HLSVD on dataset: \nFirst load an MRS(I) dataset!" );
        }
    }
    
    
    //TODO: Change the function to use 
        /**
     * This computes HLSVDPro using a socket connection to Python.
     * @param dualProgressBar 
     */
    @SuppressWarnings("empty-statement")
    private void performHLSVDProOnDatasetBatch( DualProgressBar dualProgressBar )
    {
        dualProgressBar.setUpperLabel( "<HTML><BR>     Opening parallel HLSVD server     </HTML>" );
        Process process;
        ClientSocket socket = null;
        String executionPath = System.getProperty("user.dir");
        executionPath = executionPath + "\\bin\\Python\\HLSVD_server_parallel.py";
        TDFDFittingDefaults defaults = TDFDFittingDefaults.getInstance( );
        defaults.load( );
        int batch_size = Integer.parseInt(defaults.getProperty( TDFDFittingDefaults.HLSVDPRO_BATCH_SIZE ));
        String python_command = defaults.getProperty( TDFDFittingDefaults.PYTHON_EXECUTABLE_FILENAME );
        if( python_command == null || python_command.equals("")){
            PythonSettings Pysetting = new PythonSettings();
            boolean test = false;
            while( test == false ){
                test = Pysetting.GetStatusAccept();
            }
            defaults.load();
            python_command = defaults.getProperty( TDFDFittingDefaults.PYTHON_EXECUTABLE_FILENAME );
            if( python_command == null || python_command.equals("")){
                return;
            }
        }
        String[] command = { "cmd", "/c", python_command, executionPath};
        int ping;
        try{
            socket = new ClientSocket(33356);
            socket.write_str("PING");
            ping = socket.readInt();
            socket.write_str("FINISHED");
            socket.closeConnection();
        } catch (IOException e){
            socket = null;
            ping = 0;
        }
        if(ping==0){
            process = commandExists(command);
            if(process==null){
                PythonSettings Pysetting = new PythonSettings();
                boolean test = false;
                while( test == false ){
                    test = Pysetting.GetStatusAccept();
                    //return;
                }
                python_command = defaults.getProperty( TDFDFittingDefaults.PYTHON_EXECUTABLE_FILENAME );
                command[2] = python_command;
                if( python_command == null || python_command.equals("")){
                    return;
                }
            }
            try {
                process = Runtime.getRuntime().exec(command);
            } catch (IOException e2) {
                socket = null;
                System.out.println(e2.toString());
                return;
            }
            do{
                try{
                    socket = new ClientSocket(33356);
                    socket.write_str("FINISHED");
                    socket.closeConnection();
                } catch(IOException e3){
                    System.out.println("ERROR sending PING to server");
                }
            } while(socket==null);
        }
        else{
            System.out.println("Server was open...");
        }

        if ( model.getCSIData( ) != null)
        {
            Spectra spectra = model.getSpectra( );
            ArrayList<String> selVox = model.getSelectedVoxels( );
            HashMap<String, Spectrum> data =  spectra.getData( );
            Iterator it = data.entrySet( ).iterator( );

            int cntr = 0;
            double[] batch_re = null;
            double[] batch_im = null;
            String[] batch_key = null;
            double[] abs = null;
            double[] disp = null;
            int discount_batch = 0;
            int numberOfBatches;
            int numberOfSelectedVoxels = model.getSelectedVoxels( ).size( );
            numberOfBatches = numberOfSelectedVoxels/batch_size;
            int batch_nro = 0;
            int printNumberOfBatches = numberOfBatches;
            Spectrum[] spectrum = null;
            if (numberOfSelectedVoxels%batch_size!=0){
                printNumberOfBatches = numberOfBatches + 1;
            }
            if (numberOfSelectedVoxels<batch_size){
                batch_size = numberOfSelectedVoxels;
            }
            while ( it.hasNext( ) ) 
            {

                Map.Entry pair = (Map.Entry)it.next( );
                // Iterate over all selected voxels
                if ( selVox.contains( pair.getKey( ) ) )
                {
                    dualProgressBar.setUpperProgress( cntr+1 );
                    batch_nro++;
                    dualProgressBar.setUpperLabel( "<HTML><BR>     Filtering batch number : " + batch_nro + " of " + printNumberOfBatches + " </HTML>" );
                    batch_nro--;
                    int hlsvdNumberOfPoints = ((Spectrum)pair.getValue( )).getAbsorptionFD().length;
                    
                    //I don't like this!
                    hlsvdNumberOfPoints = Math.min(hlsvdNumberOfPoints, 4096);
                    
                    if ( batch_re==null | batch_im==null | batch_key==null | abs==null |disp==null | spectrum==null){
                        spectrum = new Spectrum[batch_size];
                        batch_re = new double[ hlsvdNumberOfPoints*batch_size ];
                        batch_im = new double[ hlsvdNumberOfPoints*batch_size ];
                        batch_key = new String[batch_size];
                        abs = new double[ hlsvdNumberOfPoints ];
                        disp = new double[ hlsvdNumberOfPoints ];
                    }
                    
                    spectrum[(cntr-discount_batch)%batch_size] = (Spectrum) pair.getValue( );
                    
                    float[] absSignal = spectrum[(cntr-discount_batch)%batch_size].getAbsorptionTD( );
                    float[] dispSignal = spectrum[(cntr-discount_batch)%batch_size].getDispersionTD( );
                    //Create the batch with the concatenation of all of them
                    for ( int i = 0; i < hlsvdNumberOfPoints; i++ ){
                        //TODO: Replace with ArrayCopy
                        batch_re[((cntr-discount_batch)%batch_size)*hlsvdNumberOfPoints + i] = (double)absSignal[i];
                        batch_im[((cntr-discount_batch)%batch_size)*hlsvdNumberOfPoints + i] = (double)dispSignal[i];
                    }
                    batch_key[(cntr-discount_batch)%batch_size] = (String)pair.getKey( );

                    if ( ((cntr-discount_batch)+1) % batch_size == 0){
                        //Call HLSVD with batch_re and batch_im
                        HLSVDPro_batch hlsvd_batch = new HLSVDPro_batch(batch_re, batch_im, hlsvdNumberOfPoints, batch_size, model.getBandwidth( ), model.getResonanceFrequency( ), model.getPPMReference( ));
                        HLSVDResults_batch results_batch = hlsvd_batch.getHLSVDResults();
                        for(int j = 0; j < batch_size; j++){
                            abs = results_batch.getFilteredSignalRealPart( j );
                            disp = results_batch.getFilteredSignalImagenaryPart( j );

                            for ( int i = 0; i < hlsvdNumberOfPoints; i++ )
                            {
                                absSignal[i] = (float)abs[i];
                                dispSignal[i] = (float)disp[i];
                            }
                            
                            Spectrum filtered = new Spectrum( absSignal, dispSignal, spectra );
                            
                            float FDNoise = filtered.getNoiseStdDevFD( );
                            float TDNoise = filtered.getNoiseStdDevTD( );
                            filtered.setNoiseStdFD( FDNoise );
                            filtered.setNoiseStdTD( TDNoise );
                            data.put( batch_key[j], filtered);
                        }
                        batch_nro++;
                        if ( batch_nro==numberOfBatches ){
                            if ( numberOfBatches*batch_size!=numberOfSelectedVoxels && discount_batch==0){
                                discount_batch = numberOfBatches*batch_size;
                                batch_size = numberOfSelectedVoxels%batch_size;
                            }
                        }

                    }
                    cntr++;
                }
            }

            model.updateSpectraPanel( );
            try {
                socket = new ClientSocket(33356);
                socket.write_str("TERMINATE");
                socket.closeConnection();
            } catch (IOException e) {
                socket = null;
                System.out.println( "ERROR connecting to socket" );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot perform HLSVD on dataset: \nFirst load an MRS(I) dataset!" );
        }
    }

    
    
    /**
     * Callback routine for invoking HLSVD64.
     * @param evt 
     */
    private void jMenuItemRemoveWaterHLSVD64ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemoveWaterHLSVD64ActionPerformed
        
        applyHLSVD64FilterInSwingWorkerThread( );
    }//GEN-LAST:event_jMenuItemRemoveWaterHLSVD64ActionPerformed

    
    /**
     * Callback to evoke TDFDFit in a separate swing worker 
     * (NonInteractiveTDFDFitExecuter).
     * @param evt 
     */
    private void jMenuItemRemoveWaterTDFDFitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemoveWaterTDFDFitActionPerformed
        
        
        if ( model.getCSIData( ) != null )
        {
            
            TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
            def.load( );
            String defaultWaterModelName = def.getProperty( TDFDFittingDefaults.TDFDFIT_WATER_MODEL_NAME );
            String defaultWaterModelPath = def.getProperty( TDFDFittingDefaults.TDFDFIT_WATER_MODEL_PATH );
            
            m_removeWaterTDFDFit = true;

            if ( defaultWaterModelName.endsWith( ".tfm" ) == false )
            {
                defaultWaterModelName = defaultWaterModelName + ".tfm";
            }

            String modelReference = defaultWaterModelPath + System.getProperty( "file.separator" ) + defaultWaterModelName;
            File defaultModelFile = new File( modelReference );

            if ( defaultModelFile.exists( ) == true )
            {
                NonInteractiveTDFDFitExecuter tdfdfitExecutor = new NonInteractiveTDFDFitExecuter( this, modelReference, model, m_removeWaterTDFDFit );
                tdfdfitExecutor.loadTDFDFitPrototypeModelSpectrumFile( );
                        
                if ( tdfdfitExecutor.getSingleVoxelMeasuredSpectralData( ).getAbsorptionChannelFD( ).length == model.getVectorSize( ) )
                {

                    tdfdfitExecutor.addActionListener( this );
                    tdfdfitExecutor.executeTDFDFitting( true );
                }
                else
                {
                     JOptionPane.showMessageDialog( this, "TDFDFitting cannot be performed: \n Number of points of selected model does not match the number of points in the data!." );
                }
                
            
//                tdfdfitExecutor.addActionListener( this );
//                tdfdfitExecutor.executeTDFDFitting( true );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot perform TDFDFit on dataset: \nFirst load a MRS(I) dataset!" );
        }
    }//GEN-LAST:event_jMenuItemRemoveWaterTDFDFitActionPerformed

    
    
    /**
     * Callback method to perform FD offset correction in a separate thread.
     * @param evt 
     */
    private void jMenuItemOffsetCorrectionFDActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemOffsetCorrectionFDActionPerformed
        applyOffsetCorrectionFDInSwingWorkerThread( );
    }//GEN-LAST:event_jMenuItemOffsetCorrectionFDActionPerformed

    
    /**
     * Callback method to perform TD offset correction in a separate thread.
     * @param evt 
     */
    private void jMenuItemOffsetCorrectionTDActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemOffsetCorrectionTDActionPerformed
        applyOffsetCorrectionTDInSwingWorkerThread( );
    }//GEN-LAST:event_jMenuItemOffsetCorrectionTDActionPerformed

    private void jMenuItemOutlierRemovalUsingNeighboursActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemOutlierRemovalUsingNeighboursActionPerformed
          
        if ( model.getCSIData( ) != null )
        {
            if ( model.getTDFDFitStore( ) != null )
            {
                m_QMRSIOutlierRemovalControlFrame = new QMRSIOutlierRemovalControlFrame( model, 
                                                                                         m_popupjMRUIResultsMap.getSelectedMetabolite1( ),
                                                                                         m_popupjMRUIResultsMap.getSelectedFeature1( ) );

                m_QMRSIOutlierRemovalControlFrame.addActionListener( this );
            }
            else
            {
                JOptionPane.showMessageDialog( this, "Cannot remove outliers from the TDFDFit fitted data: \nFirst fit the loaded MRS(I) dataset!" );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot remove outliers from the TDFDFit fitted data: \nFirst load an MRS(I) dataset, and quantify it!" );
        }
        
    }//GEN-LAST:event_jMenuItemOutlierRemovalUsingNeighboursActionPerformed

    private void jMenuItemPrintTDFDFitResultsToScreenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemPrintTDFDFitResultsToScreenActionPerformed
        
        if ( model.getCSIData( ) != null )
        {
            if ( model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( ) != null )
            {
                TDFDFitResultsStore store = model.getTDFDFitStore( );
                store.printTDFDFitResultsSelectedVoxelsToScreen( );
            }
            else
            {
                JOptionPane.showMessageDialog( this, "Cannot write TDFDFit fitted data to spectrIm output console: \nFirst fit the loaded MRS(I) dataset!" );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot write TDFDFit fitted data to spectrIm console: \nFirst load an MRS(I) dataset, and quantify it!" );
        }
        
    }//GEN-LAST:event_jMenuItemPrintTDFDFitResultsToScreenActionPerformed

    private void jMenuItemWriteTDFDFitResultsToTextFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemWriteTDFDFitResultsToTextFileActionPerformed
        if ( model.getCSIData( ) != null )
        {
            if ( model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( ) != null )
            {
                TDFDFitResultsStore store = model.getTDFDFitStore( );
                store.writeTDFDFitResultsSelectedVoxelsToTextFile( );
            }
            else
            {
                JOptionPane.showMessageDialog( this, "Cannot write TDFDFit fitted data to a text file: \nFirst fit the loaded MRS(I) dataset!" );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot write TDFDFit fitted data to a text file: \nFirst load an MRS(I) dataset, and quantify it!" );
        }
    }//GEN-LAST:event_jMenuItemWriteTDFDFitResultsToTextFileActionPerformed

    private void jMenuItemWriteAverageTDFDFitResultsToTextFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemWriteAverageTDFDFitResultsToTextFileActionPerformed
        if ( model.getCSIData( ) != null )
        {
            if ( model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( ) != null )
            {
                TDFDFitResultsStore store = model.getTDFDFitStore( );
                store.writeTDFDFitAverageResults( );
            }
            else
            {
                JOptionPane.showMessageDialog( this, "Cannot write TDFDFit fitted data to a text file: \nFirst fit the loaded MRS(I) dataset!" );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot write TDFDFit fitted data to a text file: \nFirst load an MRS(I) dataset, and quantify it!" );
        }
    }//GEN-LAST:event_jMenuItemWriteAverageTDFDFitResultsToTextFileActionPerformed

    private void jMenuItemImageSegmentationWithinSelectedSpectroscopicVolumeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImageSegmentationWithinSelectedSpectroscopicVolumeActionPerformed
        
        ImageSegmentationWithinSelectedSpectroscopicRegionFrame frm = new ImageSegmentationWithinSelectedSpectroscopicRegionFrame( model );
        frm.setImagePixelIntensityRange( );
        frm.getAndSetTDFDFitDefaultValues( );
        frm.activateChangeListeners( );
        frm.activateKeyboardListeners( );
        frm.activateItemListeners( );
    }//GEN-LAST:event_jMenuItemImageSegmentationWithinSelectedSpectroscopicVolumeActionPerformed

    private void jMenuItemManualPhasingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemManualPhasingActionPerformed
        
        if ( model != null && !model.isSpectraNull( ) )  
        {
            m_phasingControl = new SpectrumPhasingDefinitionControl( "Zero and First Order Phasing", this, SpectrumPhasingDefinitionControl.SINGLE_RESPONSE_DISPLAY );
            m_phasingControl.addActionListener( this );
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot apply manual phasing to data set!\n First load a MRS(I) dataset!" ); 
        }
    }//GEN-LAST:event_jMenuItemManualPhasingActionPerformed

    private void jMenuItemTruncateDataTDActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemTruncateDataTDActionPerformed

        if ( model != null ) 
        {
            if ( model.getGridSize( ) > 0 ) 
            {
                if ( m_td_truncation_data_frame == null ) 
                {
                    TDTruncationDataFrame popup = new TDTruncationDataFrame( model.getSpectraVectorSize( ), 
                                                                             currentVectorSize, this );
                    m_td_truncation_data_frame = popup;
                } 
                else 
                {
                    m_td_truncation_data_frame.setVisible( true );
                }
                m_td_truncation_data_frame.setLocationRelativeTo( this );
            }
        }       
       
    }//GEN-LAST:event_jMenuItemTruncateDataTDActionPerformed

    private void jMenuItemLoadTDFDFitQuantificationResultsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemLoadTDFDFitQuantificationResultsActionPerformed
       
        if ( model.getCSIData( ) != null )
        {
            if ( model.getTDFDFitStore( ).readTDFDFitResultsStore( ) == true )
            {

                putPreprocessedSpectraIntoGlobalModel( );
                putFittedSpectraIntoGlobalModel( true );

                model.updateViewImagePanels( );
                m_popupjMRUIResultsMap = PopupjMRUIResultsMap.getInstance( model.getTDFDFitStore( ), 
                                                                           model.getTDFDFitStore( ).getAvailableMetabolites( ), 
                                                                           model.getTDFDFitStore( ).getFeatureNames( ), 
                                                                           false );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot load previously stored TDFDFit-ted!\n First load a MRS(I) dataset to make association!" ); 
        }
    }//GEN-LAST:event_jMenuItemLoadTDFDFitQuantificationResultsActionPerformed

    private void jMenuItemEditSelectedTDFDfitModelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemEditSelectedTDFDfitModelActionPerformed
        System.out.println( "Launch model editor!" );
        if ( model != null ) 
        {
            if ( model.getSpectroscopyFile( ).length( ) != 0 ) 
            {
                 // -> add code here to lauch editor on combobox selected model file
                DicomDirectory ddir = ((DicomDataLoaderPanel) pnlFileManager).getDicomDirObject( );
                TDFDFitControlFrame frame = new TDFDFitControlFrame( this, model, model.getSpectroscopyFile( ), ddir, true );
            } 
            else 
            {
                TDFDFitControlFrame frame = new TDFDFitControlFrame( this, model, true );
            }
        }
    }//GEN-LAST:event_jMenuItemEditSelectedTDFDfitModelActionPerformed

    
    /**
     * This method is part of a workaround. You should have a 1D MRS signal 
     * loaded before. 
     * @param evt 
     */
    private void jMenuItemOpenMRUIFormattedCSIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemOpenMRUIFormattedCSIActionPerformed
        
        String mruiFileName = getjMRUIFormattedDataFile( ); 
        JMRUIFile mruiFile = new JMRUIFile( mruiFileName );
        
        if ( mruiFile.loadMRUITypedData( ) == true )
        {
            float[] dispersion = new float[mruiFile.getDispersionTDResponse( ).length];
            dispersion = mruiFile.getDispersionTDResponse( );
            
            for ( int i = 0 ; i < mruiFile.getDispersionTDResponse( ).length; i++ )
            {
                dispersion[i] = -dispersion[i];
            }
            
            model.setSpectrum( mruiFile.getAbsorbtionTDResponse( ), 
                               mruiFile.getDispersionTDResponse( ), 0, 0, 0 );
            
       }
       model.updateSpectraPanel( ); 
    }//GEN-LAST:event_jMenuItemOpenMRUIFormattedCSIActionPerformed

    private void jMenuItemExportTDSignalsToCSVActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemExportTDSignalsToCSVActionPerformed

        
        if ( model.getCSIData( ) != null )
        {
            m_exportMRSDataToCSVFileOptionFrame = new ExportMRSDataToCSVFileOptionFrame( ); 
            m_exportMRSDataToCSVFileOptionFrame.addActionListener( this );
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot export selected TD/FD signals to CSV file!\n First load a MRS(I) dataset!" );
        }
    }
        
   private void exportSelectedModelSignalsToCSVFile( ExportMRSDataToCSVFileOptionFrame sender )
   {
        
        File csvOutputFile = getCSVFormattedTDSignalExportDataFileName( );
        
        boolean doComplexConjugationBeforeExport = sender.getDoComplexConjugationBeforeExport( );
        
        // test whether a non null file name was selected.
        if ( csvOutputFile != null )
        {

            org.spectrim.lib.TextFileWriter fidSignalWriter = null;
            try 
            {
                fidSignalWriter = new org.spectrim.lib.TextFileWriter( new FileWriter( csvOutputFile ) );
            } 
            catch ( IOException ex ) 
            {
                Logger.getLogger( ClinicalViewer.class.getName( ) ).log( Level.SEVERE, null, ex );
            }

            fidSignalWriter.setNumberFormat( "0.00000000E00" );

            System.out.println( "Writing results to collection parameter file :" + csvOutputFile.getAbsolutePath( ) );

            Spectra spectra = model.getSpectra( );
            ArrayList<String> selVox = model.getSelectedVoxels( );

            HashMap<String, Spectrum> data =  spectra.getData( );
            Iterator it = data.entrySet( ).iterator( );
            Iterator it2 = data.entrySet( ).iterator( );
            
            Map.Entry peekPair = (Map.Entry)it2.next( );
                
            System.out.println( peekPair.getKey( ) + " = " + peekPair.getValue( ) );
            Spectrum spectrumPeek = (Spectrum) peekPair.getValue( );
            int samplepoints = spectrumPeek.getAbsorptionTD( ).length;
            
            
            int cntr = 0;
            int firstIndexTD    = sender.getTDFirstIndexPoint( );
            int lastIndexTD     = sender.getTDLastIndexPoint( );
            int firstIndexFD    = sender.getFDFirstIndexPoint( );
            int lastIndexFD     = sender.getFDLastIndexPoint( );
            
            boolean writeTDAbs  = sender.includeWriteTDAbs( );
            boolean writeTDDisp = sender.includeWriteTDDisp( );
            boolean writeFDAbs  = sender.includeWriteFDAbs( );
            boolean writeFDDisp = sender.includeWriteFDDisp( );
            
            // check boundaries
            if ( firstIndexTD < 0 )
            {
                firstIndexTD = 0;
                System.out.println( "Warning: first index TD < 0 => value set to 0" );
            }
            
            if ( firstIndexTD > samplepoints )
            {
                firstIndexTD = samplepoints;
                System.out.println( "Warning: first index TD > " + samplepoints + "=> value set to: 0" );
            }
            
             // check boundaries
            if ( firstIndexFD < 0 )
            {
                firstIndexFD = 0;
                System.out.println( "Warning: first index FD < 0 => value set to 0" );
            }
            
            if ( firstIndexFD > samplepoints )
            {
                firstIndexFD = samplepoints;
                System.out.println( "Warning: first index FD > " + samplepoints + "=> value set to: " + 0 );
            }
            
            // check boundaries 2
            if ( lastIndexTD < 0 )
            {
                lastIndexTD = 0;
                System.out.println( "Warning: last index TD < 0 => value set to 0" );
            }
            
            if ( lastIndexTD >= samplepoints )
            {
                lastIndexTD = samplepoints - 1;
                System.out.println( "Warning: last index TD > " + samplepoints + "=> value set to: " + ( samplepoints - 1 ) );
            }
            
             // check boundaries
            if ( lastIndexFD < 0 )
            {
                lastIndexFD = 0;
                System.out.println( "Warning: last index FD < 0 => value set to 0" );
            }
            
            if ( lastIndexFD >= samplepoints )
            {
                lastIndexFD = samplepoints - 1;
                System.out.println( "Warning: last index FD > " + samplepoints + "=> value set to : " + ( samplepoints - 1 ) );
            }
            
            int numberOfChannelsToExport = 0;
            int numberOfChannelsToExportForHeader = 0;
            if ( writeTDAbs )
            {
                numberOfChannelsToExport = numberOfChannelsToExport + 1;
            }
            if ( writeTDDisp )
            {
                numberOfChannelsToExport = numberOfChannelsToExport + 1;
            }
            if ( writeFDAbs )
            {
                numberOfChannelsToExport = numberOfChannelsToExport + 1;
            }
            if ( writeFDDisp )
            {
                numberOfChannelsToExport = numberOfChannelsToExport + 1;
            }
            
            numberOfChannelsToExportForHeader = numberOfChannelsToExport;
            
            int copyOfNumberOfChannelsToExport = numberOfChannelsToExport;
            
            try 
            {
                fidSignalWriter.writeString( "voxel_ID," );
            } 
            catch ( IOException ex ) 
            {
                Logger.getLogger(ClinicalViewer.class.getName( ) ).log(Level.SEVERE, null, ex);
            }
            
            if ( writeFDAbs )
            {
                numberOfChannelsToExportForHeader = numberOfChannelsToExportForHeader - 1;
                
                if ( numberOfChannelsToExportForHeader != 0 )
                {
                    for ( int i = firstIndexFD; i <= lastIndexFD; i++ )
                    {
                        try 
                        {
                            fidSignalWriter.writeString( "fdAbs[" + i + "]," );    
                        } 
                        catch ( IOException ex ) 
                        {
                            Logger.getLogger( ClinicalViewer.class.getName( ) ).log( Level.SEVERE, null, ex );
                        }
                    }
                }
                else
                {
                    for ( int i = firstIndexFD; i <= lastIndexFD; i++ )
                    {
                        try 
                        {
                            if ( i < lastIndexFD )
                            {
                                fidSignalWriter.writeString( "fdAbs[" + i + "]," );
                            }
                            else
                            {
                                fidSignalWriter.writeStringLn( "fdAbs[" + i + "]" );
                            }
                        } 
                        catch ( IOException ex ) 
                        {
                            Logger.getLogger( ClinicalViewer.class.getName( ) ).log( Level.SEVERE, null, ex );
                        }
                    }
                }
            }
            
            if ( writeFDDisp )
            {
                numberOfChannelsToExportForHeader = numberOfChannelsToExportForHeader - 1;
                if ( numberOfChannelsToExportForHeader != 0 )
                {
                    for ( int i = firstIndexFD; i <= lastIndexFD; i++ )
                    {
                        try 
                        {
                            fidSignalWriter.writeString( "fdDisp[" + i + "]," );
                        } 
                        catch ( IOException ex ) 
                        {
                            Logger.getLogger( ClinicalViewer.class.getName( ) ).log( Level.SEVERE, null, ex );
                        }
                    }
                }
                else
                {
                    for ( int i = firstIndexFD; i <= lastIndexFD; i++ )
                    {
                        try 
                        {
                            if ( i < lastIndexFD )
                            {
                                fidSignalWriter.writeString( "fdDisp[" + i + "]," );
                            }
                            else
                            {
                                fidSignalWriter.writeStringLn( "fdDisp[" + i + "]" );
                            }
                        } 
                        catch ( IOException ex ) 
                        {
                            Logger.getLogger( ClinicalViewer.class.getName( ) ).log( Level.SEVERE, null, ex );
                        }
                    }
                }
            }
            
            if ( writeTDAbs )
            {
                numberOfChannelsToExportForHeader = numberOfChannelsToExportForHeader - 1;
                if ( numberOfChannelsToExportForHeader != 0 )
                {
                    for ( int i = firstIndexTD; i <= lastIndexTD; i++ )
                    {
                        try 
                        {
                            fidSignalWriter.writeString( "tdAbs[" + i + "]," );
                        } 
                        catch ( IOException ex ) 
                        {
                            Logger.getLogger( ClinicalViewer.class.getName( ) ).log( Level.SEVERE, null, ex );
                        }
                    }
                }
                else
                {
                    for ( int i = firstIndexTD; i <= lastIndexTD; i++ )
                    {
                        try 
                        {
                            if ( i < lastIndexTD )
                            {    
                                fidSignalWriter.writeString( "tdAbs[" + i + "]," );
                            }
                            else
                            {
                                fidSignalWriter.writeStringLn( "tdAbs[" + i + "]" );
                            }
                        } 
                        catch ( IOException ex ) 
                        {
                            Logger.getLogger( ClinicalViewer.class.getName( ) ).log( Level.SEVERE, null, ex );
                        }
                    }
                }
            }
            
            if ( writeTDDisp )
            {
                numberOfChannelsToExportForHeader = numberOfChannelsToExportForHeader - 1;
                if ( numberOfChannelsToExportForHeader != 0 )
                {
                    for ( int i = firstIndexTD; i <= lastIndexTD; i++ )
                    {
                        try 
                        {
                            fidSignalWriter.writeString( "tdDisp[" + i + "],"); 
                        } 
                        catch ( IOException ex )
                        {
                            Logger.getLogger( ClinicalViewer.class.getName( ) ).log( Level.SEVERE, null, ex );
                        }
                    }
                }
                else
                {
                    for ( int i = firstIndexTD; i <= lastIndexTD; i++ )
                    {
                        try 
                        {
                            fidSignalWriter.writeString( "tdDisp[" + i + "]"); 
                            if ( i < lastIndexTD )
                            {
                                fidSignalWriter.writeString( "," ); 
                            }
                            else
                            {
                                fidSignalWriter.writeStringLn( "" );    
                            };
                        } 
                        catch ( IOException ex )
                        {
                            Logger.getLogger( ClinicalViewer.class.getName( ) ).log( Level.SEVERE, null, ex );
                        }
                    }
                }
            }
//            boolean once = true;
//            float[] xaxis;
            while ( it.hasNext( ) ) 
            {
                
                numberOfChannelsToExport = copyOfNumberOfChannelsToExport;
                
                Map.Entry pair = (Map.Entry)it.next( );
                
                // Iterate over all selected voxels
                if ( selVox.contains( pair.getKey( ) ) )
                {
                    System.out.println( pair.getKey( ) + " = " + pair.getValue( ) );
                    Spectrum spectrum = (Spectrum) pair.getValue( );
                    
                    float[] absTDSignal = spectrum.getAbsorptionTD( );
                    float[] dispTDSignal = spectrum.getDispersionTD( );
                    
                    float[] absFDSignal = spectrum.getAbsorptionFD( );
                    float[] dispFDSignal = spectrum.getDispersionFD( );
                    
                    float[] dummyAbsFDSignal  = new float[absFDSignal.length];
                    float[] dummyDispFDSignal  = new float[absFDSignal.length];
                    
                    for ( int i = 0; i < absTDSignal.length; i++ )
                    {
                        // dispTDSignal[i] = -dispTDSignal[i];
                        dummyAbsFDSignal[absTDSignal.length-1-i] = absFDSignal[i];
                        dummyDispFDSignal[absTDSignal.length-1-i] = dispFDSignal[i];
                    }
                    
                    
                    // If user wants complex conjugation before export ...
                    if ( doComplexConjugationBeforeExport == true )
                    {
                        for ( int i = 0; i < absTDSignal.length; i++ )
                        {
                            dispTDSignal[i] = -dispTDSignal[i];
                            dummyDispFDSignal[i] = -dummyDispFDSignal[i];
                        }                        
                    }
                    
//                    xaxis = new float[ absTDSignal.length ];
                    
                    // copy back to structure ...
                     for ( int i = 0; i < absTDSignal.length; i++ )
                     {
                         absFDSignal[i] = dummyAbsFDSignal[i];
                         dispFDSignal[i] = dummyDispFDSignal[i];
//                         xaxis[i] = (float)i;
                     }
                    
//                    xaxis = new float[ absTDSignal.length ];
                    
//                    for ( int i = 0; i < absTDSignal.length; i++ )
//                    {
//                        xaxis[i] = (float)i;
//                    }
//                    
//                    
//                    if  ( once )
//                    {
//                        XYPlotFrame plot = new XYPlotFrame( "TD Abs", null );
//                        plot.addCurve( new Curve( xaxis, absTDSignal, Color.blue ), true );
//                            
//                        XYPlotFrame plot1 = new XYPlotFrame( "TD Disp", null );
//                        plot1.addCurve( new Curve( xaxis, dispTDSignal, Color.blue ), true );
//                            
//                        XYPlotFrame plot2 = new XYPlotFrame( "FD Abs", null );
//                        plot2.addCurve( new Curve( xaxis, absFDSignal, Color.blue ), true );
//                            
//                        XYPlotFrame plot3 = new XYPlotFrame( "FD Disp", null );
//                        plot3.addCurve( new Curve( xaxis, dispFDSignal, Color.blue ), true );
//                        once = false;
//                    }
                    
                    
                    try 
                    { 
                        fidSignalWriter.writeString( "" + pair.getKey( ) );
                        fidSignalWriter.writeString( "," );
                        if ( writeFDAbs )
                        {
                            numberOfChannelsToExport = numberOfChannelsToExport - 1;
                            if ( numberOfChannelsToExport != 0 )
                            {
                                fidSignalWriter.writeArray( firstIndexFD, lastIndexFD, absFDSignal, true );
                                fidSignalWriter.writeString( "," );
                            }
                            else
                            {
                                fidSignalWriter.writeArray( firstIndexFD, lastIndexFD, absFDSignal, false );
                            }
                            
                        }
                        
                        if ( writeFDDisp )
                        {
                            numberOfChannelsToExport = numberOfChannelsToExport - 1;
                            if ( numberOfChannelsToExport != 0 )
                            {
                                fidSignalWriter.writeArray(  firstIndexFD, lastIndexFD, dispFDSignal, true );
                                fidSignalWriter.writeString( "," );
                            }
                            else
                            {
                                fidSignalWriter.writeArray(  firstIndexFD, lastIndexFD, dispFDSignal, false );
                            }
                           
                        }
                        
                        if ( writeTDAbs )
                        {
                            numberOfChannelsToExport = numberOfChannelsToExport - 1;
                            if ( numberOfChannelsToExport != 0 )
                            {
                                fidSignalWriter.writeArray( firstIndexTD, lastIndexTD, absTDSignal, true );
                                fidSignalWriter.writeString( "," );
                            }
                            else
                            {
                                fidSignalWriter.writeArray( firstIndexTD, lastIndexTD, absTDSignal, false );
                            }
                        }
                        
                        if ( writeTDDisp )
                        {
                            numberOfChannelsToExport = numberOfChannelsToExport - 1;
                            if ( numberOfChannelsToExport != 0 )
                            {
                                fidSignalWriter.writeArray(  firstIndexTD, lastIndexTD, dispTDSignal, false );
                            }
                            else
                            {
                                fidSignalWriter.writeArray(  firstIndexTD, lastIndexTD, dispTDSignal, false );
                            }
                        }
                        
                        fidSignalWriter.flush( );

                    } 
                    catch ( IOException ex ) 
                    {
                        Logger.getLogger( ClinicalViewer.class.getName( ) ).log( Level.SEVERE, null, ex );
                    }
                }
            }
            try 
            { 
                fidSignalWriter.close( );
            } 
            catch ( IOException ex ) 
            {
                Logger.getLogger( ClinicalViewer.class.getName(  )).log(Level.SEVERE, null, ex);
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "No valid CSV file name was defined!" );
        }
       
    }//GEN-LAST:event_jMenuItemExportTDSignalsToCSVActionPerformed

    private void jMenuItemImportAIPredictedValuesFromCSVActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImportAIPredictedValuesFromCSVActionPerformed
       
        
        if ( model.getCSIData( ) != null )
        {
        
            model.getTDFDFitStore( ).readTDFDFitResultsStore( );
            putPreprocessedSpectraIntoGlobalModel( );
            putFittedSpectraIntoGlobalModel( true );

            m_popupjMRUIResultsMap = PopupjMRUIResultsMap.getInstance( model.getTDFDFitStore( ), 
                                                                       model.getTDFDFitStore( ).getAvailableMetabolites( ), 
                                                                       model.getTDFDFitStore( ).getFeatureNames( ), 
                                                                       false );

            String importAIPredictedParametersCSVFileName = getFile( "csv", System.getProperty( "user.home" ) );
            
            if ( importAIPredictedParametersCSVFileName != null )
            {
                // loadAIPredictedModelParameterFile( importAIPredictedParametersCSVFileName );

                putFittedSpectraIntoGlobalModel( false );

                loadAIPredictedModelParameterFile( importAIPredictedParametersCSVFileName );

                model.updateViewImagePanels( );
                model.updateSpectraPanel( );
            }
            else
            {
                 JOptionPane.showMessageDialog( this, "<html>Cannot import AI prediction CSV file ! " + "<br><br>No valid .csv file name defined!</html>" );       
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot import AI predicted imput signals:\n First load a MRS(I) dataset!" );
        }
        
    }//GEN-LAST:event_jMenuItemImportAIPredictedValuesFromCSVActionPerformed

    private void jMenuItemImportMidasPreprocessedValuesFromBinaryFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImportMidasPreprocessedValuesFromBinaryFileActionPerformed
        
        if ( model.getImageStack( ) == null )
        {
            JOptionPane.showMessageDialog( this, "<html>Midas data can only be imported if a Dicom formatted metabolite map has been loaded before!" + "<br><br>Please load metabolite map first!</html>" );       
        }
        else
        {
            m_midasEPSIDataImporter = new MidasPreprocessedEPSIDataImporterParameterSettingsControl( model );
            m_midasEPSIDataImporter.addActionListener( this );
        }
    }//GEN-LAST:event_jMenuItemImportMidasPreprocessedValuesFromBinaryFileActionPerformed

    private void jMenuItemRemoveWaterHLSVDProActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemoveWaterHLSVDProActionPerformed
        boolean process = true;
        TDFDFittingDefaults defaults = TDFDFittingDefaults.getInstance( );
        defaults.load( );
        String python_command = defaults.getProperty( TDFDFittingDefaults.PYTHON_EXECUTABLE_FILENAME );
        if( python_command == null || python_command.equals("")){
            PythonSettings Pysetting = new PythonSettings();
            defaults.load();
            process = false;
        }
        if( process == true )
        {
            if ( model != null && !model.isSpectraNull( ) ) 
            {
                PreprocessingAction action = this.processingActions.get( this.jComboBoxProcessingAction.getSelectedIndex( ) ).getPreprocessingAction( );
                if ( action == null ) 
                {
                    action = new PreprocessingAction( "default" );
                }
                BatchProcessing.cancel( );
                this.setWaitLayerActive( true );
                model.clearColorMap( );
                BatchProcessing.addWaterPeakRemovalHLSVDPro( action.getHLSVD64WaterRemovalMin( ), 
                                                             action.getHLSVD64WaterRemovalMax( ), 
                                                             action.getHLSVD64WaterRemovalNumberOfPeaks( ) );
                BatchProcessing.run( );
            }
            else
            {
                JOptionPane.showMessageDialog( this, "Cannot perform HLSVDpro : \n first load a dataset!." );
            }
        }
    }//GEN-LAST:event_jMenuItemRemoveWaterHLSVDProActionPerformed
    
    
    /**
     * This method opens a frame allows you to define segmentation based on 
     * spectral features.
     * @param evt 
     */
    private void jMenuItemSelectVoxelsFeatureBasedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSelectVoxelsFeatureBasedActionPerformed
        FeatureBasedGridSelectionJFrame frm = new FeatureBasedGridSelectionJFrame( model ); 
    }//GEN-LAST:event_jMenuItemSelectVoxelsFeatureBasedActionPerformed
    /**
     * This method handles the import of CSV typed data.
     * @param evt 
    */
    private void jMenuItemImportExternalLabelCSVFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImportExternalLabelCSVFileActionPerformed
        
        if ( model.getGridSize( ) > 0 ) 
        {
            JFileChooser fileChooser = new JFileChooser( );
            
            if ( model.getImageStack( ).getFiles( ).get( 0 ) != null )
            {
                if ( new File( model.getImageStack( ).getFiles( ).get( 0 ) ).getParentFile( ) != null )
                {
                    fileChooser.setCurrentDirectory( new File( model.getImageStack( ).getFiles( ).get( 0 ) ).getParentFile( ) );
                }
                else
                {
                    fileChooser.setCurrentDirectory( new File( model.getImageStack( ).getFiles( ).get( 0 ) ) );
                }

                FileNameExtensionFilter filter = new FileNameExtensionFilter( "CVS", "csv" );
                fileChooser.setFileFilter(filter);

                int result = fileChooser.showOpenDialog( this );
                File selected_file;

                switch ( result ) 
                {
                    case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed

                        selected_file = fileChooser.getSelectedFile( );

                        if ( selected_file != null ) 
                        {
                            model.loadExternalCSVOverlayLabelFile( selected_file.toString( ) );

                            ImportedCSVDataColorMapOverlaySelectionFrame frm =  
                                    new ImportedCSVDataColorMapOverlaySelectionFrame( selected_file.toString( ),
                                                                                      model.getOverlayCSVTypedDataMatrix( ), 
                                                                                      model.getOverlayDataMatrixHeaderColumnDataDescription( ),
                                                                                      model.getOverlayDataMatrixHeaderColumnDataType( ),
                                                                                      model
                                                                                     ); 
                        }
                        break;
                    case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                        break;
                    case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                        break;
                }
            }
            else
            {
                JOptionPane.showMessageDialog( this, "Current MRS(I) data has non-defined image background: \n First load valid background dataset!." );
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot load CSV file: \n First load valid MRSI data set and set background MRI data!." );
        }
    }//GEN-LAST:event_jMenuItemImportExternalLabelCSVFileActionPerformed

    private void jMenuItemDisplayXYPlotGridOfSelectionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemDisplayXYPlotGridOfSelectionActionPerformed
        MultiXYPlotFrame pltFrame = new MultiXYPlotFrame( "XYPlots of Selection", this, model );
    }//GEN-LAST:event_jMenuItemDisplayXYPlotGridOfSelectionActionPerformed

    private void jMenuItemExportSelectedSpectraTojMRUIFormatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemExportSelectedSpectraTojMRUIFormatActionPerformed
        
        
        if ( model.getCSIData( ) != null )
        {
            JFileChooser fileChooser = new JFileChooser( );

            if ( new File( model.getSpectroscopyFile( ) ) != null )
            {
                fileChooser.setCurrentDirectory( new File(  model.getSpectroscopyFile( ) ) );
                fileChooser.setDialogTitle( "Export to jMRUI format" );
                FileNameExtensionFilter filter = new FileNameExtensionFilter( "MRUI", "mrui" );
                fileChooser.setFileFilter(filter);
                fileChooser.setApproveButtonText( "Export to .mrui formatted file" );
                int result = fileChooser.showOpenDialog( this );
                File selected_file;
                File export_file;
                switch ( result ) 
                {
                    case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed

                        selected_file = fileChooser.getSelectedFile( );
                        if ( !selected_file.getName( ).endsWith( ".mrui" ) )
                        {
                            export_file = new File( selected_file.getAbsoluteFile( ) + ".mrui" );
                        }
                        else
                        {
                            export_file = selected_file;
                        }
                        
                        if ( export_file != null ) 
                        {
                            JMRUIFile exportTojMRUIFile = new JMRUIFile( export_file.getAbsolutePath( ) );
                            try 
                            {
                                exportTojMRUIFile.saveMRUITypedData( model, false );
                            } 
                            catch (IOException ex) 
                            {
                                Logger.getLogger(ClinicalViewer.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        break;
                    case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                        break;
                    case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                        break;
                }
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot export data to jMRUI: \n first load a dataset!." );
        }
    }//GEN-LAST:event_jMenuItemExportSelectedSpectraTojMRUIFormatActionPerformed

    private void m_automaticStoreTDFDFitResultsCheckBoxMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_automaticStoreTDFDFitResultsCheckBoxMenuItemActionPerformed
        // do nothing
    }//GEN-LAST:event_m_automaticStoreTDFDFitResultsCheckBoxMenuItemActionPerformed

    private void jMenuItemImportTDSignalsFromCSVActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImportTDSignalsFromCSVActionPerformed
        
        if ( model.getCSIData( ) != null )
        {
            
            String importAssociatedCSVDataFileName = getFile( "csv", System.getProperty( "user.home" ) );
            
            if ( importAssociatedCSVDataFileName != null )
            {
                loadExternalPreprocessedMRSSourceData( importAssociatedCSVDataFileName );

                model.updateViewImagePanels( );
                model.updateSpectraPanel( );
            }
            else
            {
                 JOptionPane.showMessageDialog( this, "<html>Cannot import associated CVS formatted input signals ! " + "<br><br>No valid .csv file name defined!</html>" );       
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot import associated CVS formatted input signals:\n First load a MRS(I) dataset!" );
        }
    }//GEN-LAST:event_jMenuItemImportTDSignalsFromCSVActionPerformed

    private void jMenuItemReadMatchingPreproceesingResultsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemReadMatchingPreproceesingResultsActionPerformed
        if ( readreprocessingResultsFromBinaryFile( ) == true )
        {
            JOptionPane.showMessageDialog( this, "Successfully read associated preprocessed data file!" );
            model.updateViewImagePanels( );
            model.updateSpectraPanel( );
        }
    }//GEN-LAST:event_jMenuItemReadMatchingPreproceesingResultsActionPerformed

    private void jMenuItemWriteMatchingPreproceesingResults1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemWriteMatchingPreproceesingResults1ActionPerformed
        if ( writePreprocessingResultsToBinaryFile( ) == true )
        {
            JOptionPane.showMessageDialog( this, "Successfully created associated preprocessed data file!" );
        }
    }//GEN-LAST:event_jMenuItemWriteMatchingPreproceesingResults1ActionPerformed

    private void jMenuItemImportSelectedSpectraFromjMRUIFormatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImportSelectedSpectraFromjMRUIFormatActionPerformed
        
        if ( model.getCSIData( ) != null )
        {
            JFileChooser fileChooser = new JFileChooser( );

            if ( new File( model.getSpectroscopyFile( ) ) != null )
            {
                fileChooser.setCurrentDirectory( new File(  model.getSpectroscopyFile( ) ) );
                fileChooser.setDialogTitle( "Import from jMRUI formatted files." );
                FileNameExtensionFilter filter = new FileNameExtensionFilter( "MRUI", "mrui" );
                fileChooser.setFileFilter( filter );
                fileChooser.setApproveButtonText( "Import from .mrui formatted file" );
                fileChooser.setMultiSelectionEnabled( true );
                int result = fileChooser.showOpenDialog( this );
                // File selected_file;
                File import_file;
                String key;
                switch ( result ) 
                {
                    case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed

                        File[] selected_files = fileChooser.getSelectedFiles( );
                        
                        for ( int i = 0; i < selected_files.length; i++ )
                        {
                            if ( !selected_files[i].getName( ).endsWith( ".mrui" ) )
                            {
                                import_file = new File( selected_files[i].getAbsoluteFile( ) + ".mrui" );
                                key = import_file.getName( ).substring(import_file.getName( ).lastIndexOf("-") + 1, import_file.getName( ).lastIndexOf(".") );
                                System.out.println( "Found jMRUIfile with voxel id = " + key );
                            }
                            else
                            {
                                import_file = selected_files[i];
                                key = import_file.getName( ).substring(import_file.getName( ).lastIndexOf("-") + 1, import_file.getName( ).lastIndexOf(".") );
                                System.out.println( "Found jMRUI file with voxel id = " + key );
                            }
                        
                            if ( import_file != null ) 
                            {
                                JMRUIFile importFromjMRUIFile = new JMRUIFile( import_file.getAbsolutePath( ) );
                                
                                if ( importFromjMRUIFile.loadMRUITypedData( ) == true )
                                {
                                    float[] dispersion = new float[importFromjMRUIFile.getDispersionTDResponse( ).length];
                                    dispersion = importFromjMRUIFile.getDispersionTDResponse( );

                                    for ( int j = 0 ; j < importFromjMRUIFile.getDispersionTDResponse( ).length; j++ )
                                    {
                                        dispersion[j] = -dispersion[j];
                                    }

                                    model.setSpectrum( importFromjMRUIFile.getAbsorbtionTDResponse( ), 
                                                       importFromjMRUIFile.getDispersionTDResponse( ),key );
                               }  
                            }
                        }
                            break;
                    case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                            break;
                    case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                            break;
                }
            }
        }
        else
        {
            JOptionPane.showMessageDialog( this, "Cannot export data to jMRUI: \n first load a dataset!." );
        }  
    }//GEN-LAST:event_jMenuItemImportSelectedSpectraFromjMRUIFormatActionPerformed

    public javax.swing.JCheckBoxMenuItem GetShowDifferenceCheckBox(){
        return jCheckBoxShowDifference;
    }
    
    private void jCheckBoxShowDifferenceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxShowDifferenceActionPerformed
        ArrayList<String> blue_voxels = model.getSelectedVoxels(GlobalModel.SelectionGroup.BLUE);
        ArrayList<String> red_voxels = model.getSelectedVoxels(GlobalModel.SelectionGroup.RED);
        if(blue_voxels.size() == 0 || red_voxels.size() == 0) {
            JOptionPane.showMessageDialog( this, "<html>Difference can not be computed!<br><br>To use this feature, both BLUE and RED voxels must be selected</html>");
            model.SetShowDifference(false);
            jCheckBoxShowDifference.setSelected(false);
            model.updateSpectraPanel();
        } else {
            if (model.getShowDifference()==true){
                model.SetShowDifference(false);
            }
            else{
                model.SetShowDifference(true);
            }
            model.updateSpectraPanel();
        }
    }//GEN-LAST:event_jCheckBoxShowDifferenceActionPerformed

    private void jMenuItemComplexConjugationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemComplexConjugationActionPerformed
        if ( model != null ) 
        {
            model.complexConjugateAllSpectra( );
        }
    }//GEN-LAST:event_jMenuItemComplexConjugationActionPerformed

    private void jMenuItemImportjMRUIFormattedResultsFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImportjMRUIFormattedResultsFileActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jMenuItemImportjMRUIFormattedResultsFileActionPerformed

    private void jMenuItemOnlineHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemOnlineHelpActionPerformed
         try 
         {
            String url = "http://spectrim.diskstation.me/spectrImWeb/index.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch (java.io.IOException e) 
        {
            System.out.println(e.getMessage());
        }
    }//GEN-LAST:event_jMenuItemOnlineHelpActionPerformed

    private void m_onlineHelpViewjMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_onlineHelpViewjMenuItemActionPerformed
        try 
         {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-view-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch ( java.io.IOException e ) 
        {
            System.out.println( e.getMessage( ) );
        }
    }//GEN-LAST:event_m_onlineHelpViewjMenuItemActionPerformed

    private void m_onlineHelpFileMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_onlineHelpFileMenuItemActionPerformed
       try 
         {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-file-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch ( java.io.IOException e ) 
        {
            System.out.println( e.getMessage( ) );
        }
    }//GEN-LAST:event_m_onlineHelpFileMenuItemActionPerformed

    private void m_onlineHelpImageMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_onlineHelpImageMenuItemActionPerformed
         try 
         {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-image-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch ( java.io.IOException e ) 
        {
            System.out.println( e.getMessage( ) );
        }
    }//GEN-LAST:event_m_onlineHelpImageMenuItemActionPerformed

    private void m_onlineHelpMRSIvoxelSelectionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_onlineHelpMRSIvoxelSelectionActionPerformed
         try 
         {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-mrsi-voxel-selection-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch ( java.io.IOException e ) 
        {
            System.out.println( e.getMessage( ) );
        }
    }//GEN-LAST:event_m_onlineHelpMRSIvoxelSelectionActionPerformed

    private void m_onlineHelpProcessingjMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_onlineHelpProcessingjMenuItemActionPerformed
        try 
        {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-mrsi-processing-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch ( java.io.IOException e ) 
        {
            System.out.println( e.getMessage( ) );
        }
    }//GEN-LAST:event_m_onlineHelpProcessingjMenuItemActionPerformed

    private void m_onlineHelpMapjMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_onlineHelpMapjMenuItemActionPerformed
       
       try 
        {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-map-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch (java.io.IOException e) 
        {
            System.out.println( e.getMessage( ) );
        }
       
    }//GEN-LAST:event_m_onlineHelpMapjMenuItemActionPerformed

    private void m_onlineHelpReportjMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_onlineHelpReportjMenuItemActionPerformed
        try 
        {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-report-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch (java.io.IOException e) 
        {
            System.out.println( e.getMessage( ) );
        }
    }//GEN-LAST:event_m_onlineHelpReportjMenuItemActionPerformed

    private void m_qualityControljMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_qualityControljMenuItemActionPerformed
        try 
        {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-quality-control-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch (java.io.IOException e) 
        {
            System.out.println( e.getMessage( ) );
        }
    }//GEN-LAST:event_m_qualityControljMenuItemActionPerformed

    private void m_onlineHelpjMRUIImportExportMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_onlineHelpjMRUIImportExportMenuItemActionPerformed
       try 
        {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-jmrui-import-export-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch (java.io.IOException e) 
        {
            System.out.println( e.getMessage( ) );
        }
    }//GEN-LAST:event_m_onlineHelpjMRUIImportExportMenuItemActionPerformed

    private void m_onlineHelpDicomNetworkjMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_onlineHelpDicomNetworkjMenuItemActionPerformed
       try 
        {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-dicom-network-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch (java.io.IOException e) 
        {
            System.out.println( e.getMessage( ) );
        }
    }//GEN-LAST:event_m_onlineHelpDicomNetworkjMenuItemActionPerformed

    private void m_onlineHelpClinicalCasesjMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_onlineHelpClinicalCasesjMenuItemActionPerformed
        try 
        {
            String url = "http://spectrim.diskstation.me/spectrImWeb/spectrim-qmrs-clinical-cases-menu.html";
            java.awt.Desktop.getDesktop().browse(java.net.URI.create(url));
        } catch (java.io.IOException e) 
        {
            System.out.println( e.getMessage( ) );
        }
    }//GEN-LAST:event_m_onlineHelpClinicalCasesjMenuItemActionPerformed

    
    private void loadExternalPreprocessedMRSSourceData( String importAIPredictedParametersCSVFileName )
    {
      
        int sample_points = model.getSpectraVectorSize( );  
        int numberOfSpectralComponentsToFit = model.getSelectedVoxels( ).size( );
        
        MRLineModelSpectralResponse response = null;
        float[] absFD = new float[ sample_points ];
        float[] dispFD = new float[ sample_points ];
        
        float[] outputAbsTD  = new float[ sample_points ];
        float[] outputDispTD = new float[ sample_points ];
        
        BufferedReader br;
        int linecounter = -1;
        
        String voxel_ID;
        
        try 
        {
            br = new BufferedReader( new FileReader( importAIPredictedParametersCSVFileName ) );
            String line;
            // read the header of the csv file
            line = br.readLine( );
            
            while ( ( line = br.readLine( ) ) != null ) 
            {
                linecounter++;
                if ( linecounter < model.getSelectedVoxels( ).size( ) )
                {
                    
                    System.out.println( "Reading voxel information : " + linecounter );
                    
                    if ( line.trim( ).equals( "" ) ) break;
                    
                    StringTokenizer lineTokenizer = new StringTokenizer( line, "," );
                    
                    // first test if the first line is numeric or just the title
                    voxel_ID = lineTokenizer.nextToken( );
                    
                    StringTokenizer voxelIDTokenizer = new StringTokenizer( voxel_ID, "_" );
                    
                    float firstValue = 0f;
                                        
                    // if the line contains numerical values it is OK
                    if ( voxelIDTokenizer.countTokens( ) == 3 )
                    {
                        
                        for ( int i = 0; i < sample_points; i++ )
                        {
                            absFD[i] = new Float( "" + lineTokenizer.nextToken( ) );  
                        }
                        
                        for ( int i = 0; i < sample_points; i++ )
                        {
                            dispFD[i] = new Float( "" + lineTokenizer.nextToken( ) );
                        }
                        
                        float[][] vaux = new float[absFD.length][2];

                        for ( int m = 0; m < absFD.length; m++ ) 
                        {
                            int d = (m + 1 + absFD.length / 2) % absFD.length;
                            vaux[d][0] = absFD[absFD.length - 1 - m];
                            vaux[d][1] = -dispFD[dispFD.length - 1 - m];
                        }

                        vaux = fft(vaux);

                        for ( int t = 0; t < (absFD.length); t++ )  
                        {
                            int d = t % (absFD.length);
                            outputAbsTD[d] = vaux[t][0] / absFD.length;
                            outputDispTD[d] = -vaux[t][1] / absFD.length;
                        }
 
                        // Overwrite the signal in the model...
                        model.setSpectrum( outputAbsTD, 
                                           outputDispTD, 
                                           voxel_ID );
                        
                        System.out.println( "Read external preprocessed response # " + linecounter );
                        
                    }
                }
            }
            br.close( ); 
        }
        catch ( Exception ex ) 
        {
            ex.printStackTrace( );
        }
    }
    
    /**
     * Local utility function.
     */
    public float[][] fft( float[][] array ) 
    {
        float u_r, u_i, w_r, w_i, t_r, t_i;
        int ln, nv2, k, l, le, le1, j, ip, i, n;

        n = array.length;
        ln = (int) (Math.log((double) n) / Math.log(2) + 0.5);
        nv2 = n / 2;
        j = 1;
        for (i = 1; i < n; i++) {
            if (i < j) {
                t_r = array[i - 1][0];
                t_i = array[i - 1][1];
                array[i - 1][0] = array[j - 1][0];
                array[i - 1][1] = array[j - 1][1];
                array[j - 1][0] = t_r;
                array[j - 1][1] = t_i;
            }
            k = nv2;
            while (k < j) {
                j = j - k;
                k = k / 2;
            }
            j = j + k;
        }

        for (l = 1; l <= ln; l++) /* loops thru stages */ {
            le = (int) (Math.exp((double) l * Math.log(2)) + 0.5);
            le1 = le / 2;
            u_r = 1.0f;
            u_i = 0.0f;
            w_r = (float) Math.cos(Math.PI / (float) le1);
            w_i = -(float) Math.sin(Math.PI / (float) le1);
            for (j = 1; j <= le1; j++) /* loops thru 1/2 twiddle values per stage */ {
                for (i = j; i <= n; i += le) /* loops thru points per 1/2 twiddle */ {
                    ip = i + le1;
                    t_r = array[ip - 1][0] * u_r - u_i * array[ip - 1][1];
                    t_i = array[ip - 1][1] * u_r + u_i * array[ip - 1][0];

                    array[ip - 1][0] = array[i - 1][0] - t_r;
                    array[ip - 1][1] = array[i - 1][1] - t_i;

                    array[i - 1][0] = array[i - 1][0] + t_r;
                    array[i - 1][1] = array[i - 1][1] + t_i;
                }
                t_r = u_r * w_r - w_i * u_i;
                u_i = w_r * u_i + w_i * u_r;
                u_r = t_r;
            }
        }
        return array;
    } /* end of FFT_1d */




    private void loadAIPredictedModelParameterFile( String importAIPredictedParametersCSVFileName ) 
    {    
        // First make sure that the default model is loaded ...
        TDFDFittingDefaults fdefs = TDFDFittingDefaults.getInstance( );
        
        String defaultTDFDFitModelFileReference = fdefs.getProperty( TDFDFittingDefaults.DEFAULT_TDFDFIT_FIT_MODEL_NAME );
        String defaultTDFDFitModelFilePath = fdefs.getProperty( TDFDFittingDefaults.DEFAULT_USED_TDFDFIT_MODEL_PATH );
        
        File prototypeFileReference = new File( defaultTDFDFitModelFilePath + System.getProperty( "file.separator" ) + defaultTDFDFitModelFileReference );
        loadTDFDFitPrototypeModelSpectrumFile( prototypeFileReference );
        
        // now the prototype model is loaded and ready to use ...
        TDFDFitPrototypeModelSpectrumParameters currentTDFDFitPrototypeModelSpectrumParameters = TDFDFitPrototypeModelSpectrumParameters.getInstance( );
        
        int sample_points = model.getSpectraVectorSize( );  
        int numberOfSpectralComponentsToFit = model.getSelectedVoxels( ).size( );
        
        //MRLineModelSpectralResponse[] predictedParameterResponses = new MRLineModelSpectralResponse[ numberOfSpectralComponentsToFit ];
        
        float[][] gtParametersAll = new float[ 4 + numberOfSpectralComponentsToFit][model.getSelectedVoxels( ).size( )]; 
        float[]   gtParameters  = new float[ 4 + numberOfSpectralComponentsToFit ]; 
        MRLineModelSpectralResponse response = null;
        float[] absTD = new float[ sample_points ];
        float[] dispTD = new float[ sample_points ];
        
        BufferedReader br;
        int linecounter = -1;
        int tokenCounter = 0;
        int responsecounter = 0;
        int verificationResponsesCounter = 0;
        String voxel_ID;
        
        try 
        {
            br = new BufferedReader( new FileReader( importAIPredictedParametersCSVFileName ) );
            String line;
            // read the header of the csv file
            line = br.readLine( );
            
            while ( ( line = br.readLine( ) ) != null ) 
            {
                linecounter++;
                //if ( linecounter < model.getSelectedVoxels( ).size( ) )
                //{
                    
                System.out.println( "AI predicted parameters : " + linecounter );


                if ( line.trim( ).equals( "" ) ) break;

                StringTokenizer lineTokenizer = new StringTokenizer( line, "," );

                // first test if the first line is numeric or just the title
                voxel_ID = lineTokenizer.nextToken( );


                if ( model.getSelectedVoxels( ).contains( voxel_ID ) == true )
                {
                    StringTokenizer voxelIDTokenizer = new StringTokenizer( voxel_ID, "_" );

                    float firstValue = 0f;


                    // if the line contains numerical values it is OK
                    if ( voxelIDTokenizer.countTokens( ) == 3 )
                    {

                        // StringTokenizer sTok = new StringTokenizer( line, "," );

                        while ( ( lineTokenizer.hasMoreTokens( ) ) )
                        {    
                            switch ( tokenCounter )
                            {
                                case OVERALL_OFFSET:    gtParametersAll[OVERALL_OFFSET][responsecounter] = Float.parseFloat( lineTokenizer.nextToken( ) );
                                                        gtParameters[OVERALL_OFFSET] = gtParametersAll[OVERALL_OFFSET][responsecounter];
                                                        break;

                                case OVERALL_GAUSSWITDTH:   gtParametersAll[OVERALL_GAUSSWITDTH][responsecounter] = Float.parseFloat( lineTokenizer.nextToken( ) );
                                                        gtParameters[OVERALL_GAUSSWITDTH] = gtParametersAll[OVERALL_GAUSSWITDTH][responsecounter];
                                                        break;

                                case OVERALL_PHASE:     gtParametersAll[OVERALL_PHASE][responsecounter] = Float.parseFloat( lineTokenizer.nextToken( ) );
                                                        gtParameters[OVERALL_PHASE] = gtParametersAll[OVERALL_PHASE][responsecounter];
                                                        break;

                                case OVERALL_LORENTZWIDTH:  gtParametersAll[OVERALL_LORENTZWIDTH][responsecounter] = Float.parseFloat( lineTokenizer.nextToken( ) );
                                                        gtParameters[OVERALL_LORENTZWIDTH] = gtParametersAll[OVERALL_LORENTZWIDTH][responsecounter];
                                                        break;

                                default:                gtParametersAll[tokenCounter][responsecounter] = Float.parseFloat( lineTokenizer.nextToken( ) );
                                                        gtParameters[tokenCounter] = gtParametersAll[tokenCounter][responsecounter];
                            }
                            tokenCounter++;
                        }



                        VoxelMetabolites metabolitesOfStore = model.getTDFDFitStore( ).getMetabolitesAt( voxel_ID );

                        // First compute the ground thruth response
                        response = currentTDFDFitPrototypeModelSpectrumParameters.calculateCompleteModelSpectralResponseBasedUponRandomForestRegressionPredictedParameters( gtParameters );

                        model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( ).get( voxel_ID ).setFittedSpectrumRealFD( response.getAbsorptionChannelFD( ) );
                        model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( ).get( voxel_ID ).setFittedSpectrumImagFD( response.getDispersionChannelFD( ) );
                        model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( ).get( voxel_ID ).setFittedSpectrumRealTD( response.getAbsorptionChannelTD( ) );
                        model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( ).get( voxel_ID ).setFittedSpectrumImagTD( response.getDispersionChannelTD( ) );

                        VoxelMetabolites updatedTDFDFitResultsStore = currentTDFDFitPrototypeModelSpectrumParameters.updateVoxelMetabolites( gtParameters, metabolitesOfStore );
                        model.getTDFDFitStore( ).setMetabolitesAt( voxel_ID, updatedTDFDFitResultsStore );

                        // predictedParameterResponses[ responsecounter ] = response;
                        verificationResponsesCounter++;
                        responsecounter++;
                        tokenCounter = 0;
                        System.out.println( "Read AI predicted response # " + linecounter );

                    }
                }
            }
            br.close( ); 
        }
        catch ( Exception ex ) 
        {
            ex.printStackTrace( );
        }
    }
    
    /**
     * Loads the TDFDFit prototype model spectrum from a file which is 
     * measured, and serves as prototype for fitting other signals with.
     */
    private void loadTDFDFitPrototypeModelSpectrumFile( File prototypeFileReference )
    {
        if ( ( prototypeFileReference != null ) && 
             ( prototypeFileReference.exists( ) ) )
        {
            try
            {
                RandomAccessFile reader = new RandomAccessFile( prototypeFileReference, "rw" );
            
                MRSignalProperties TDFDFitModelSignalProperties = MRSignalProperties.getInstance( );
                
                // Load all essential object attritubutes to a file.
                TDFDFitModelSignalProperties.read( reader );
                
                // Load the fitting strategy; if not defined you will get the 
                // default strategy.
                MRFitStrategy TDFDFitModelFitStrategy = MRFitStrategy.getInstance( );
                TDFDFitModelFitStrategy.read( reader );
                
                // Read the TDFDFitPrototypeModelSpectrum object from file.
                TDFDFitPrototypeModelSpectrumParameters prototypeModelParamters = TDFDFitPrototypeModelSpectrumParameters.getInstance( );
                prototypeModelParamters.read( reader );
                
                // Read the single voxel spectral data response
                SingleVoxelMeasuredSpectralData singleVoxelMeasuredData = new SingleVoxelMeasuredSpectralData(); 
                singleVoxelMeasuredData.read( reader, false );
                
                // The model spectrum must know its m_MRSignalProperties object
                TDFDFitPrototypeModelSpectrumParameters.getInstance( ).setMRSignalProperties( TDFDFitModelSignalProperties );
                TDFDFitPrototypeModelSpectrumParameters.getInstance( ).setMeasuredSpectrum( singleVoxelMeasuredData );
                
                // Reads the baseline points from file
                OrderedBaseLinePointsDataModel baseLineModel = OrderedBaseLinePointsDataModel.getInstance( );
                baseLineModel.read( reader );
                
                try 
                {
                    // Load the patient database, and get a reference to it
                    reader.close( );
                } 
                catch ( IOException ex ) 
                {
                    Logger.getLogger(ClinicalViewer.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
            catch ( FileNotFoundException e )
            {
                // Not handled yet.
            }
        }
    }
    
    /**
     * Puts the computed fitting results into the GlobalModel.
     */
    public void putFittedSpectraIntoGlobalModel( boolean doConjugate ) 
    {
        FittedSpectra fittedSpectra = null;
        HashMap<String, NumericTDFDFitResults> tdfdfitResults = null;
        
        if ( model != null ) 
        {
            Spectra globModelSpectra = model.getSpectra( );
            fittedSpectra = globModelSpectra.cloneAsFittedSpectra( );
            tdfdfitResults = model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( );
            
            // Iterate over all entries...        
            for ( String key : tdfdfitResults.keySet( ) ) 
            {
                String[] coord = key.split( "_" );
                if ( coord.length == 3 )
                {
                    NumericTDFDFitResults result = tdfdfitResults.get( key );
                    
                    float[] abs = result.getFittedSpectrumRealTD( );
                    float[] disp = result.getFittedSpectrumImagTD( );
                    if ( doConjugate == true )
                    {
                        // do complex conjugation ..
                        for ( int i = 0; i < disp.length; i++)
                        {
                            disp[i] = -disp[i];
                        }
                    }
                    fittedSpectra.setSpectrum( abs, disp, key ); 
                }
            }
            
            if ( fittedSpectra != null )
            {
                model.setFittedSpectra( fittedSpectra );
            }
            
            if ( tdfdfitResults != null )
            {
                model.setTDFDFitResultsStore( tdfdfitResults, null, null );
            }
            
            model.updateViewSelectionChange( );
            
        }
    }
    
    
    /**
     * Puts the computed fitting results into the GlobalModel.
     */
    public void putExternalPreprocessedDataIntoGlobalModel( ) 
    {
        FittedSpectra fittedSpectra = null;
        HashMap<String, NumericTDFDFitResults> tdfdfitResults = null;
        
        if ( model != null ) 
        {
            Spectra globModelSpectra = model.getSpectra( );
            fittedSpectra = globModelSpectra.cloneAsFittedSpectra( );
            tdfdfitResults = model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( );
            
            // Iterate over all entries...        
            for ( String key : tdfdfitResults.keySet( ) ) 
            {
                String[] coord = key.split( "_" );
                if ( coord.length == 3 )
                {
                    NumericTDFDFitResults result = tdfdfitResults.get( key );
                    
                    float[] abs = result.getFittedSpectrumRealTD( );
                    float[] disp = result.getFittedSpectrumImagTD( );
                    
                    // do complex conjugation ..
                    for ( int i = 0; i < disp.length; i++)
                    {
                        disp[i] = -disp[i];
                    }
                    
                    fittedSpectra.setSpectrum( abs, disp, key ); 
                }
            }
            
            if ( fittedSpectra != null )
            {
                model.setFittedSpectra( fittedSpectra );
            }
            
            if ( tdfdfitResults != null )
            {
                model.setTDFDFitResultsStore( tdfdfitResults, null, null );
            }
            
            model.updateViewSelectionChange( );
            
        }
    }
    
    
    /**
     * Puts the computed fitting results into the GlobalModel.
     */
    public void putPreprocessedSpectraIntoGlobalModel( ) 
    {
        FittedSpectra fittedSpectra = null;
        HashMap<String, NumericTDFDFitResults> tdfdfitResults = null;
        
        if ( model != null ) 
        {
//            Spectra globModelSpectra = model.getSpectra( );
//            fittedSpectra = globModelSpectra.cloneAsFittedSpectra( );
            tdfdfitResults = model.getTDFDFitStore( ).getNumericTDFDFitResultsHashMap( );
            
            // Iterate over all entries...        
            for ( String key : tdfdfitResults.keySet( ) ) 
            {
                String[] coord = key.split( "_" );
                if ( coord.length == 3 )
                {
                    NumericTDFDFitResults result = tdfdfitResults.get( key );
                    
                    float[] abs = result.getPreprocessedInputSignalRealTD( );
                    float[] disp = result.getPreprocessedInputSignalImagTD( );
                    
                    // do complex conjugation ..
                    for ( int i = 0; i < disp.length; i++)
                    {
                        disp[i] = -disp[i];
                    }
                    model.getCSIData( ).getSpectra( ).setSpectrum( abs, disp, key );
                    
                }
            }
            
            model.updateViewSelectionChange( );
            
        }
    }
    
    
    /**
     * Routine letting the user choose the processing action.
     * @return 
     */
    private ProcessingAction selectProcessingAction( ) 
    {
        
        String[] actionNames = new String[ProcessingSettings.getInstance( ).getProcessingActions( ).size( ) + 1];
        actionNames[0] = "*Default*";
        for ( int i = 0; i < (actionNames.length - 1); i++ ) 
        {
            actionNames[i + 1] = ProcessingSettings.getInstance( ).getProcessingActions( ).get( i ).getName( );
        }

        String procActionSelected = (String) JOptionPane.showInputDialog( this,
                                                        "Processing action:",
                                                        "Select Processing Action",
                                                        JOptionPane.QUESTION_MESSAGE,
                                                        null,
                                                        actionNames,
                                                        actionNames[0] );

        if ( procActionSelected != null ) 
        {
            ProcessingAction procAction = new ProcessingAction( );
            if ( procActionSelected == "*Default*" ) 
            {
                procAction.setPreprocessingAction( new PreprocessingAction( model ) );
                procAction.setQuantificationAction( new QuantificationAction( QuantificationTypeSelectionFrame.TDFDFIT_SELECTED ) );
                procAction.setName( "*Default*" );
                procAction.getPreprocessingAction( ).setName( "*Default*" );
                procAction.getQuantificationAction( ).setName( "*Default*" );
            } 
            else 
            {
                for ( ProcessingAction actionAux : ProcessingSettings.getInstance( ).getProcessingActions( ) ) 
                {
                    if ( actionAux.getName( ).matches( procActionSelected ) ) 
                    {
                        procAction = actionAux;
                        break;
                    }
                }
            }
            return procAction;
        }
        return null;
    }

    /**
     * This method has been updated to enable further signal processing steps in
     * the 
     * @param files
     * @param procAction 
     */
    private void BatchProcessSpectroscopyFiles( ArrayList<File> files, 
                                                ProcessingAction procAction ) 
    {
        if ( procAction != null ) 
        {
            BatchProcessing.cancel( );
            this.setWaitLayerActive( true );
            model.clearColorMap( );
            int counter = 0;
            for ( File file : files ) 
            {
                DicomObject dcmobject = DicomHandler.getDicomObject( file.toString( ) );
                DicomHeader header = DicomHandler.getHeader( dcmobject );
                DicomHandler.readSiemensData( dcmobject, header );
                if ( procAction.getSeriesFilter( ) == null || 
                     procAction.getSeriesFilter( ).evaluate( header ) ) 
                {
                    BatchProcessing.addOpenSpectroscopyFileCommand( file.toString( ) );
                    BatchProcessing.addSelectionCommand( BatchProcessing.SELECT_INNEREXCITEDVOL );
                    PreprocessingAction preproAction = procAction.getPreprocessingAction( );
                    counter++;
                    if ( preproAction != null ) 
                    {
                        int[] order = preproAction.getPanelOrder( );

                        // Add the different preprocessing steps depending on the choice
                        for ( int i = 0; i < order.length; i++ ) 
                        {
                            for ( int j = 0; j < order.length; j++ ) 
                            {
                                if ( i == order[j] ) 
                                {
                                    switch ( j ) 
                                    {
                                        case ( PreprocessingActionUI.APODIZATION ): 
                                                    {
                                                        if ( preproAction.isApodisationUse( ) ) 
                                                        {
                                                            BatchProcessing.addApodization(preproAction.getApodisationType(), preproAction.getApodisationLineBroadning());
                                                        }
                                                        break;
                                                    }
                                        case ( PreprocessingActionUI.QUALITY_FILTERING ): 
                                                    {
                                                        if ( preproAction.isQualityUse( ) ) 
                                                        {
                                                            String tasks = getMissingTasksQuality(preproAction.getQualityRFile());
                                                            if ( tasks.matches( "" ) ) 
                                                            {
                                                                BatchProcessing.addQualityFiltering(preproAction.getQualityRFile(), preproAction.getQualityThreshold());
                                                                //TEMP: We want to save quality maps of everything and do quantification of everything to do filtering later on
                                                                BatchProcessing.addSelectionCommand(BatchProcessing.SELECT_INNEREXCITEDVOL);
                                                            } 
                                                            else 
                                                            {
                                                                JOptionPane.showMessageDialog( this, "<html>Automatic Quality Control can not be performed:" + 
                                                                                               tasks + "<br><br>For help setting up Automatic Quality Control, contact nuno.barros@insel.ch</html>");
                                                            }
                                                        }
                                                        break;
                                                    }
                                        case ( PreprocessingActionUI.BASELINE_REMOVAL ):
                                                    {
                                                        if ( preproAction.isBaselineUse( ) ) 
                                                        {
                                                            BatchProcessing.addBaselineCorrection( preproAction.getBaselineNR( ) );
                                                        }
                                                        break;
                                                    }
                                        case ( PreprocessingActionUI.WATER_REMOVAL_HLSVD64 ):   
                                                    {
                                                        if ( preproAction.isHLSVD64WaterRemovalUse( ) ) 
                                                        {
                                                            BatchProcessing.addWaterPeakRemovalHLSVD64( preproAction.getHLSVD64WaterRemovalMin( ), 
                                                                                                        preproAction.getHLSVD64WaterRemovalMax( ), 
                                                                                                        preproAction.getHLSVD64WaterRemovalNumberOfPeaks( ) );
                                                        }
                                                        break;
                                                    }
                                        case ( PreprocessingActionUI.WATER_REMOVAL_HLSVDPRO ):   
                                                    {
                                                        if ( preproAction.isHLSVDProWaterRemovalUse( ) ) 
                                                        {
                                                            BatchProcessing.addWaterPeakRemovalHLSVDPro( preproAction.getHLSVDProWaterRemovalMin( ), 
                                                                                                        preproAction.getHLSVDProWaterRemovalMax( ), 
                                                                                                        preproAction.getHLSVDProWaterRemovalNumberOfPeaks( ) );
                                                        }
                                                        break;
                                                    }
                                        case ( PreprocessingActionUI.WATER_REMOVAL_TDFDFIT ):   
                                                    {
                                                        if ( preproAction.isTDFDFitWaterRemovalUse( ) ) 
                                                        {
                                                            BatchProcessing.addWaterPeakRemovalTDFDFit( preproAction.getTDFDFitWaterModelName( ) ); 
                                                        }
                                                        break;
                                                    }
                                                    
                                        case ( PreprocessingActionUI.OFFSET_CORRECTION_FD ):   
                                                    {
                                                        if ( preproAction.isUseRemoveAmplitudeOffsetFD( ) ) 
                                                        {
                                                            BatchProcessing.addAmplitudeOffsetRemovalFD( (float)preproAction.getMinFDOffsetRange( ), 
                                                                                                         (float)preproAction.getMaxFDOffsetRange( ) ); 
                                                        }
                                                        break;
                                                    }
                                                    
                                        case ( PreprocessingActionUI.OFFSET_CORRECTION_TD ):   
                                                    {
                                                        if ( preproAction.isUseRemoveAmplitudeOffsetTD( ) ) 
                                                        {
                                                            BatchProcessing.addAmplitudeOffsetRemovalTD( (float)preproAction.getMinTDOffsetRange( ), 
                                                                                                         (float)preproAction.getMaxTDOffsetRange( ) ); 
                                                        }
                                                        break;
                                                    }            
                                                    
                                        case ( PreprocessingActionUI.AUTO_PHASING ): 
                                                    {
                                                        if ( preproAction.isAutoPhasingUse( ) )
                                                        {
                                                            BatchProcessing.addAutoPhasing( (float)preproAction.getAutoPhasingMinPPM( ), 
                                                                                            (float)preproAction.getAutoPhasingMaxPPM( ) );
                                                        }
                                                        break;
                                                    }
                                        case ( PreprocessingActionUI.FREQUENCY_SHIFT ): 
                                                    {
                                                        if ( preproAction.isFreqShiftUse( ) ) 
                                                        {
                                                            double[] minvals = new double[preproAction.getFreqShiftPeaks().size()];
                                                            double[] maxvals = new double[preproAction.getFreqShiftPeaks().size()];
                                                            double[] targets = new double[preproAction.getFreqShiftPeaks().size()];
                                                            int[] multiplicities = new int[preproAction.getFreqShiftPeaks().size()];
                                                            int k = 0;
                                                            for ( ReferencePeak peak : preproAction.getFreqShiftPeaks( ) ) 
                                                            {
                                                                minvals[k] = peak.getMinppm();
                                                                maxvals[k] = peak.getMaxppm();
                                                                targets[k] = peak.getTargetppm();
                                                                multiplicities[k++] = peak.getMultiplicity();
                                                            }
                                                            if ( this.checkValuesFrequencyShiftCorrection( minvals, 
                                                                                                           maxvals, 
                                                                                                           targets, 
                                                                                                           preproAction.getFreqShiftMinPPM( ), 
                                                                                                           preproAction.getFreqShiftMaxPPM( ) ) ) 
                                                            {
                                                                BatchProcessing.addFrequencyShiftCorrection( minvals, maxvals, targets, multiplicities, 
                                                                                                             preproAction.getFreqShiftSNR( ), 
                                                                                                             preproAction.getFreqShiftMinPPM( ), 
                                                                                                             preproAction.getFreqShiftMaxPPM( ), 
                                                                                                             preproAction.getFreqShiftMaxLocalShift( ) );
                                                            } 
                                                            else 
                                                            {
                                                                JOptionPane.showMessageDialog( this, "<html>Freq. Shift Correction can not be performed: some values fall outside the current data PPM limits.<br> Please revise Freq. Shift Correction Settings for the current Processing Action.</html>" );
                                                            }
                                                        }
                                                        break;
                                                    }
                                    }
                                    break;
                                }
                            }
                        }
                    }
                    
                    // Add quantification
                    // Since there can be more than one type of quantification
                    // (was QUEST up till now we must make this selectable
                    QuantificationAction quantAction = procAction.getQuantificationAction( );
                     
                    BatchProcessing.addQuantification( quantAction );                               
                    // add results action
                    ResultsAction resAction = procAction.getResultsAction( );
                    if ( resAction != null ) 
                    {
                        switch ( resAction.getType( ) ) 
                        {
                            case ResultsAction.SAVE_RESULTS:
                                BatchProcessing.addSaveResultsCommand( resAction.getResultsFolder( ) );
                                break;
                            case ResultsAction.SAVE_METAB_MAT:
                                BatchProcessing.addSaveMetaboliteMapsCommand( resAction.getResultsFolder( ), true );
                        }

                    }
                }
            }
            this.printTxt( counter + " Spectroscopy Series passed the Series Filter of the selected Processing Action." );
            BatchProcessing.run( );
        }
    }

    private void generateGrid( ) 
    {
        String baseSpectraFile  = "/media/sf_dev/spectraComb/modified_TD/normal_base.txt";
        String lacSpectraFile   = "/media/sf_dev/spectraComb/modified_TD/lac.txt";
        String lip09SpectraFile = "/media/sf_dev/spectraComb/modified_TD/09.txt";
        String lip13SpectraFile = "/media/sf_dev/spectraComb/modified_TD/13.txt";

        float[] bReal = new float[1024];
        float[] bIm = new float[1024];
        float[] lacReal = new float[1024];
        float[] lacIm = new float[1024];
        float[] lip09Real = new float[1024];
        float[] lip09Im = new float[1024];
        float[] lip13Real = new float[1024];
        float[] lip13Im = new float[1024];

        try {
            int i = 0;
            Scanner scanner = new Scanner(new File(baseSpectraFile));
            scanner.useDelimiter("\n");
            while (scanner.hasNext()) {
                String nextInput = scanner.next();
                String[] val = nextInput.split("\t");
                bReal[i] = Float.parseFloat(val[0]);
                bIm[i] = Float.parseFloat(val[1]);
                i++;
            }
            scanner.close();

            i = 0;
            scanner = new Scanner(new File(lacSpectraFile));
            scanner.useDelimiter("\n");
            while (scanner.hasNext()) {
                String nextInput = scanner.next();
                String[] val = nextInput.split("\t");
                lacReal[i] = Float.parseFloat(val[0]);
                lacIm[i] = Float.parseFloat(val[1]);
                i++;
            }
            scanner.close();

//            i = 0;
//            scanner = new Scanner(new File(lipSpectraFile));
//            scanner.useDelimiter("\n");
//            while(scanner.hasNext()){
//                String nextInput = scanner.next();
//                String[] val = nextInput.split("\t");
//                lipReal[i] = Float.parseFloat(val[0]);
//                lipIm[i] = Float.parseFloat(val[1]);
//                i++;
//            }
            i = 0;
            scanner = new Scanner(new File(lip09SpectraFile));
            scanner.useDelimiter("\n");
            while (scanner.hasNext()) {
                String nextInput = scanner.next();
                String[] val = nextInput.split("\t");
                lip09Real[i] = Float.parseFloat(val[0]);
                lip09Im[i] = Float.parseFloat(val[1]);
                i++;
            }

            i = 0;
            scanner = new Scanner(new File(lip13SpectraFile));
            scanner.useDelimiter("\n");
            while (scanner.hasNext()) {
                String nextInput = scanner.next();
                String[] val = nextInput.split("\t");
                lip13Real[i] = Float.parseFloat(val[0]);
                lip13Im[i] = Float.parseFloat(val[1]);
                i++;
            }
            scanner.close();
        } catch (Exception e) {
            System.out.println("Loading files did not work, stopping here");
            return;
        }
//        model.setSpectrum(abs, disp, id, 0, 0);
        for (int i = 0; i < 32; i++) {
            for (int j = 0; j < 32; j++) {
                float[] re = new float[1024];
                float[] im = new float[1024];
                for (int k = 0; k < 1024; k++) {
                    re[k] = bReal[k] + 40.0f * (((float) i) / 32.0f) * lacReal[k] + 4.0f * (((float) j) / 32.0f) * lip13Real[k] + 1.0f * (((float) j) / 32.0f) * lip09Real[k];// + 4.0f *  (((float)j)/32.0f) * lipReal[k];
                    im[k] = bIm[k] + 40.0f * (((float) i) / 32.0f) * lacIm[k] + 4.0f * (((float) j) / 32.0f) * lip13Im[k] + 1.0f * (((float) j) / 32.0f) * lip09Im[k];// + 4.0f *  (((float)j)/32.0f) * lipIm[k];
                }
                model.setSpectrum(re, im, i, j, 0);
            }
        }
        model.updateViewSelectionChange();
    }

    public void showGlobalFittingRatioMap() {
        mruiViewerInterface.setGlobalErrorColorMap(false);
    }

    private void JMenuItemcstmReportPrstActionPerformed( ActionEvent e ) 
    {
        if ( model.getTDFDFitStore() == null )
        {
            new CstmReportFrame( StdReportFrame.CUSTOM, model, mruiViewerInterface, new File(ReportSettings.getInstance().getPrstsPath().toString() + File.separator + ((javax.swing.JMenuItem) e.getSource()).getText() + ".rprst")).setLocationRelativeTo(this);
        }
        else
        {
            new CstmReportFrame( StdReportFrame.CUSTOM, model, model.getTDFDFitStore( ), 
                                 new File( ReportSettings.getInstance( ).getPrstsPath( ).toString( ) + 
                                           File.separator + ( (javax.swing.JMenuItem ) e.getSource( ) ).getText( ) + ".rprst" ) ).setLocationRelativeTo( this );
        }
    }

    private void jMenuRmCstmActionPerformed( ActionEvent e ) 
    {
        File f = new File( ReportSettings.getInstance( ).getPrstsPath( ).toString( ) + 
                           File.separator + ( ( javax.swing.JMenuItem ) e.getSource( ) ).getText( ) + ".rprst" );
        try 
        {
            Files.delete( f.toPath( ) );
        } 
        catch ( Exception ex ) 
        {
            // output
        }
    }

    private void gridSlctPrstActionPerformed(ActionEvent e) {
        File f = new File(GlobalSettings.getInstance().getCSIGrdPrstFolder() + File.separator + model.getSOPInstanceUID().replace(".", "_") + "_id_-_n_" + ((javax.swing.JMenuItem) e.getSource()).getText() + ".csiprst");
        GlobalModel.SelectionGroup selGrp = model.getCurrentSelectionGroup();
        if (!jCheckBoxMenuItemAddToCurrentGridSelection.isSelected()) {
            model.clearVoxelSelection();
        }
        try {
            Scanner scanner = new Scanner(f);
            scanner.useDelimiter("\n");
            while (scanner.hasNext()) {
                String line = scanner.next();
                if (line.matches("RED")) {
                    model.setCurrentSelectionGroup(GlobalModel.SelectionGroup.RED);
                } else if (line.matches("BLUE")) {
                    model.setCurrentSelectionGroup(GlobalModel.SelectionGroup.BLUE);
                } else {
                    model.selectVoxel(Integer.parseInt(line.split("_", 3)[0]), Integer.parseInt(line.split("_", 3)[1]), Integer.parseInt(line.split("_", 3)[2]), GlobalModel.SELECTION_ADD);
                }
            }
            scanner.close();
        } catch (FileNotFoundException ex) {
            System.err.println("Couldn't load preset for some obscure reason (damn it!)");
        }
        model.setCurrentSelectionGroup(selGrp);
    }

    private void rmGridPrstActionPerformed(ActionEvent e) {
        File f = new File(GlobalSettings.getInstance().getCSIGrdPrstFolder() + File.separator + model.getSOPInstanceUID().replace(".", "_") + "_id_-_n_" + ((javax.swing.JMenuItem) e.getSource()).getText() + ".csiprst");
        try {
            Files.delete(f.toPath());
        } catch (Exception ex) {
        }
    }

    @Override
    public void clearZeroFillingPopup( ) {
        popupzerofilling = null;
    }

    @Override
    public void clearTDDomainTruncationPopup( ) {
        m_td_truncation_data_frame = null;
    }
    
    @Override
    public void phaseSelectedSpectra(float minv, float maxv) {
        if (model != null) {
            model.autoPhaseSelection(minv, maxv, true);
        }
    }

    @Override
    public void phaseAllSpectra(float minv, float maxv) {
        if (model != null) {
            model.autoPhase(minv, maxv, true);
        }
    }

    @Override
    public void resetPhase() {
        if (model != null) {
            model.setPhase(new double[]{0, 0}, true);
        }
    }

    @Override
    public void apodizeExponentialSelectedSpectra(double a) {
        if (model != null) {
            model.apodizeExponentialSelection(a, true);
        }
    }

    @Override
    public void apodizeExponentialAllSpectra(double a) {
        if (model != null) {
            model.apodizeExponential(a, true);
        }
    }

    @Override
    public void calcPPMshiftAll(double[] minvals, double[] maxvals, double[] targets, int[] multiplicities, double SNRLimit, double minPPM, double maxPPM, double maxLocalShift) {
        if (model != null) {
            model.calcPPMshift(minvals, maxvals, targets, multiplicities, SNRLimit, minPPM, maxPPM, maxLocalShift, true);
        }
    }

    @Override
    public void calcPPMshiftSelection(double[] minvals, double[] maxvals, double[] targets, int[] multiplicities, double SNRLimit, double minPPM, double maxPPM, double maxLocalShift) {
        if (model != null) {
            model.calcPPMshiftSelection(minvals, maxvals, targets, multiplicities, SNRLimit, minPPM, maxPPM, maxLocalShift, true);
        }
    }

    @Override
    public void apodizeGaussianSelectedSpectra(double a) {
        if (model != null) {
            model.apodizeGaussianSelection(a, true);
        }
    }

    @Override
    public void apodizeGaussianAllSpectra(double a) {
        if (model != null) {
            model.apodizeGaussian(a, true);
        }
    }

    @Override
    public void processZeroFilling(int vectorsize) {
        if (model != null) {
            currentVectorSize = vectorsize;
            model.zeroFilling(vectorsize, true);
        }
    }
    
    public void processTDTruncation( int truncated_vectorsize ) 
    {
        if ( model != null ) 
        {
            currentVectorSize = truncated_vectorsize;
            model.truncateTDModel( truncated_vectorsize, true );
        }
    }
    
    

    @Override
    public String addLorentzian(double x0, double y0, double w, double A) {
        String res = "";
        if (model != null) {
//            res = model.addLorentzian(x0, y0, w, A);
        }
        return res;
    }

    @Override
    public void updtadeLorentzian(String id, double x0, double y0, double w, double A) {
        if (model != null) {
//            model.updateLorentzian(id, x0, y0, w, A);
        }
    }

    @Override
    public void setGlobalModel(GlobalModel newModel) {
        clearLocalizerPanels();
        this.model = newModel;
        this.currentVectorSize = model.getSpectraVectorSize();
        model.setImageViewer(imagePanel);
        model.setSliceSlider(jSlider1);
        model.setTextArea(jTextAreaOutput);
        model.setTextLabelXVal(this.jLabelXValue);
        model.setTextLabelYVal(this.jLabelYValue);
        model.setTextLabelPixelVal(this.jLabelIntensityValue);
        model.setSpectraPanel(spectraPanel);
        model.setSpectraDomain(getSelectedSpectraDomain());
        model.setSpectraCombinationFunction(getSelectedSpectraCombinationFunction());
        model.setAbsorptionVisible(jCheckBoxAbsorption.isSelected());
        model.setMagnitudeVisible(jCheckBoxMagnitude.isSelected());
        model.setDispersionVisible(jCheckBoxDispersion.isSelected());
        model.setAutoCopyClipboard(jCheckBoxClipboard.isSelected());
        if (model.getImageStackSize() == 0) {
            model.setBlankImageStack();
        } else {
            jSlider1.setMinimum(0);
            jSlider1.setMaximum(model.getImageStackSize() - 1);
            model.showMiddleSliceWithIntersection();
            imagePanel.autoWindowing();
        }
        if (!model.isSpectraNull()) {
            model.setSpectraAxisVisible(true);
            model.updateSpectraPanel();
        }

        for (LocalizerPanel loc : model.getLocalizerList()) {
            setLocalizer(loc);
        }
        setMissingLocalizers();
        model.updateViewImagePanels();
        mruiViewerInterface.setGlobalModel(model);
        ((DicomDataLoaderPanel) pnlFileManager).setGlobalModel(model);
        if (cmapUI != null) {
            this.cmapUI.setGlobalModel(model);
        }
        updateProcessingActions();
        m_popupjMRUIResultsMap.closeWindow();
    }

    public void setLocalizer(LocalizerPanel loc) {
        switch (loc.getImageInfo().getOrientation()) {
            case TRANS:
                setLocalizerTra(loc);
                break;
            case COR:
                setLocalizerCor(loc);
                break;
            case SAG:
                setLocalizerSag(loc);
                break;
        }
    }

    private void setLocalizerCor(LocalizerPanel loc) {
        loc.setPreferredSize(pnlViewCor.getPreferredSize());
        loc.setSize(pnlViewCor.getSize());
        pnlViewCor.removeAll();
        pnlViewCor.add(loc, BorderLayout.CENTER);
        pnlViewCor.revalidate();
        loc.setVisible(true);
    }

    private void setLocalizerTra(LocalizerPanel loc) {
        loc.setPreferredSize(pnlViewTra.getPreferredSize());
        loc.setSize(pnlViewTra.getSize());
        pnlViewTra.removeAll();
        pnlViewTra.add(loc, BorderLayout.CENTER);
        pnlViewTra.revalidate();
    }

    private void setLocalizerSag(LocalizerPanel loc) {
        loc.setPreferredSize(pnlViewSag.getPreferredSize());
        loc.setSize(pnlViewSag.getSize());
        pnlViewSag.removeAll();
        pnlViewSag.add(loc, BorderLayout.CENTER);
        pnlViewSag.revalidate();
    }

    private void setMissingLocalizers() {
        if (model != null && !model.isSpectraNull()) {
            if (pnlViewSag.getComponentCount() == 0) {
                LocalizerPanel loc = model.getBlankLocalizerSagital();
                model.addLocalizerPanel(loc);
                setLocalizerSag(loc);
            }
            if (pnlViewCor.getComponentCount() == 0) {
                LocalizerPanel loc = model.getBlankLocalizerCoronal();
                model.addLocalizerPanel(loc);
                setLocalizerCor(loc);
            }
            if (pnlViewTra.getComponentCount() == 0) {
                LocalizerPanel loc = model.getBlankLocalizerTransversal();
                model.addLocalizerPanel(loc);
                setLocalizerTra(loc);
            }
        }
    }

    private void clearLocalizerPanels() {
        pnlViewSag.removeAll();
        pnlViewCor.removeAll();
        pnlViewTra.removeAll();
    }

    private void getFile() throws IOException {
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setCurrentDirectory(currentFile);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;

        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                currentFile = fileChooser.getCurrentDirectory();
                if (selected_file != null) {
                    processFile(selected_file.toString());
                    spectraPanel.clearDomainMarkers();
                }
                break;

            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }

    private void getReferenceFile() throws IOException {
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setCurrentDirectory(currentFile);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;

        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                currentFile = fileChooser.getCurrentDirectory();
                if (selected_file != null) {
                    processReferenceFile(selected_file.toString());
                    spectraPanel.clearDomainMarkers();
                }
                break;

            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }

    @Override
    public synchronized void setWaitLayerActive(boolean bool) {
        if (bool) {
            if (!pnlImage.isAncestorOf(waitlayer)) {
                WaitLayerUI waitlayerUI = new WaitLayerUI();
                JPanel panel = new JPanel();
                waitlayer = new JLayer<>(panel, waitlayerUI);
                pnlImage.add(waitlayer, java.awt.BorderLayout.CENTER);
                waitlayerUI.start();
            }
            jSlider1.setVisible(false);
            jSlider1.setEnabled(false);
            imagePanel.setEnabled(false);
            imagePanel.setMouseSelectionActive(false);

            if (model != null) {
                model.setLocalizersVisible(false);
                model.setGridVisible(false);
            }

        } else {
            if (pnlImage.isAncestorOf(waitlayer)) {
                pnlImage.remove(waitlayer);
                waitlayer = null;
            }
            jSlider1.setVisible(true);
            jSlider1.setEnabled(true);
            imagePanel.setEnabled(true);
            imagePanel.setMouseSelectionActive(true);

            if (model != null) {
                imagePanel.resetZoom();
                model.setLocalizersVisible(true);
                model.setGridVisible(this.jCheckBoxMenuItemViewGrid.isSelected());
                if (model.isSpectraNull()) {
                    model.setSpectraAxisVisible(false);
                }
            }
        }
    }

    public void processFile(String selectedFile) 
    {
        setWaitLayerActive( true );
        this.jRadioButtonSelectBlue.setSelected( true );
        FileReaderWorker fileworker = new FileReaderWorker( this, selectedFile, dicomManager, model );
        fileworker.execute( );
    }

    private void processReferenceFile( String selectedFile ) 
    {
        setWaitLayerActive( true );
        FileReaderWorker fileworker = new FileReaderWorker( this, selectedFile, dicomManager, model, true );
        fileworker.execute( );
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;

                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ClinicalViewer.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ClinicalViewer.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ClinicalViewer.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ClinicalViewer.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater( new Runnable( ) 
        {
            @Override
            public void run( ) 
            {
                ClinicalViewer viewer = new ClinicalViewer(new MruiViewerInterface());
                viewer.setVisible(true);
                viewer.setTitle( ".::SpectrIm::.   -  Version 2.0.10 [alpha] - 03.07.2024" );
            }
        } );
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroupSelection;
    private javax.swing.JButton jButtonJustHandleResults;
    private javax.swing.JButton jButtonJustPreprocess;
    private javax.swing.JButton jButtonJustQuantify;
    private javax.swing.JButton jButtonProcessData;
    private javax.swing.JButton jButtonSelectMetabolites;
    private javax.swing.JCheckBox jCheckBoxAbsorption;
    private javax.swing.JCheckBox jCheckBoxClipboard;
    private javax.swing.JCheckBox jCheckBoxDispersion;
    private javax.swing.JCheckBox jCheckBoxMagnitude;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemAddToCurrentGridSelection;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemAutomaticProcessing;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemNormalize;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemShowIntersectsMain;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemShowPatientName;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemShowSeriesInfo;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemViewGrid;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemViewSaturationBands;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemViewSliceOrientation;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemViewSpectraThumbnail;
    private javax.swing.JCheckBoxMenuItem jCheckBoxSeparateSpectra;
    private javax.swing.JCheckBoxMenuItem jCheckBoxShowColorBar;
    private javax.swing.JCheckBoxMenuItem jCheckBoxShowDifference;
    private javax.swing.JCheckBoxMenuItem jCheckBoxShowFittedSpectra;
    private javax.swing.JCheckBoxMenuItem jCheckBoxShowMapValues;
    private javax.swing.JCheckBoxMenuItem jCheckBoxShowOriginalSpectra;
    private javax.swing.JComboBox jComboBoxProcessingAction;
    private javax.swing.JComboBox jComboBoxSpectraCombinationFunction;
    private javax.swing.JComboBox jComboBoxSpectraDomain;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabelIntensityValue;
    private javax.swing.JLabel jLabelXValue;
    private javax.swing.JLabel jLabelYValue;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar2;
    private javax.swing.JMenu jMenuColorMode;
    private javax.swing.JMenu jMenuFile;
    private javax.swing.JMenu jMenuHelp;
    private javax.swing.JMenu jMenuImage;
    private javax.swing.JMenu jMenuImportExport;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItemAbout;
    private javax.swing.JMenuItem jMenuItemApodization;
    private javax.swing.JMenuItem jMenuItemAutoPhasing;
    private javax.swing.JMenuItem jMenuItemAutoWindowing;
    private javax.swing.JMenuItem jMenuItemChangeSelectionGroup;
    private javax.swing.JMenuItem jMenuItemClassifyQuality;
    private javax.swing.JMenuItem jMenuItemClearGrid;
    private javax.swing.JMenuItem jMenuItemClearImage;
    private javax.swing.JMenuItem jMenuItemClearJMRUIData;
    private javax.swing.JMenuItem jMenuItemClearMap;
    private javax.swing.JMenuItem jMenuItemColorMapUI;
    private javax.swing.JMenuItem jMenuItemColorModeBGR;
    private javax.swing.JMenuItem jMenuItemColorModeBRG;
    private javax.swing.JMenuItem jMenuItemColorModeGBR;
    private javax.swing.JMenuItem jMenuItemColorModeGRB;
    private javax.swing.JMenuItem jMenuItemColorModeGray;
    private javax.swing.JMenuItem jMenuItemColorModeRBG;
    private javax.swing.JMenuItem jMenuItemColorModeRGB;
    private javax.swing.JMenuItem jMenuItemCompCtrl;
    private javax.swing.JMenuItem jMenuItemComplexConjugation;
    private javax.swing.JMenuItem jMenuItemConfigNetworkNodes;
    private javax.swing.JMenuItem jMenuItemCorrectMapFromMAT;
    private javax.swing.JMenuItem jMenuItemDICOMNetworkListenerControl;
    private javax.swing.JMenuItem jMenuItemDisplayXYPlotGridOfSelection;
    private javax.swing.JMenuItem jMenuItemEditSelectedTDFDfitModel;
    private javax.swing.JMenuItem jMenuItemExportMapToMAT;
    private javax.swing.JMenuItem jMenuItemExportNormalizedMapToMAT;
    private javax.swing.JMenuItem jMenuItemExportSelectedSpectra;
    private javax.swing.JMenuItem jMenuItemExportSelectedSpectraTojMRUIFormat;
    private javax.swing.JMenuItem jMenuItemExportSpectrum;
    private javax.swing.JMenuItem jMenuItemExportTDSignalsToCSV;
    private javax.swing.JMenuItem jMenuItemGenerateCstm;
    private javax.swing.JMenuItem jMenuItemGenerateStdMetMap;
    private javax.swing.JMenuItem jMenuItemImageInfo;
    private javax.swing.JMenuItem jMenuItemImageSegmentationWithinSelectedSpectroscopicVolume;
    private javax.swing.JMenuItem jMenuItemImportAIPredictedValuesFromCSV;
    private javax.swing.JMenuItem jMenuItemImportExternalLabelCSVFile;
    private javax.swing.JMenuItem jMenuItemImportJMruiResults;
    private javax.swing.JMenuItem jMenuItemImportMidasPreprocessedValuesFromBinaryFile;
    private javax.swing.JMenuItem jMenuItemImportSelectedSpectraFromjMRUIFormat;
    private javax.swing.JMenuItem jMenuItemImportSpectrum;
    private javax.swing.JMenuItem jMenuItemImportTDSignalsFromCSV;
    private javax.swing.JMenuItem jMenuItemImportjMRUIFormattedResultsFile;
    private javax.swing.JMenuItem jMenuItemLabelling;
    private javax.swing.JMenuItem jMenuItemLabellingAnalyser;
    private javax.swing.JMenuItem jMenuItemLabellingConsensus;
    private javax.swing.JMenuItem jMenuItemLoadTDFDFitQuantificationResults;
    private javax.swing.JMenuItem jMenuItemManualPhasing;
    private javax.swing.JMenuItem jMenuItemMapFromMAT;
    private javax.swing.JMenuItem jMenuItemMapjMRUIResults;
    private javax.swing.JMenuItem jMenuItemMirrorSelection;
    private javax.swing.JMenuItem jMenuItemMountDir;
    private javax.swing.JMenuItem jMenuItemNewTDFDfitModelling;
    private javax.swing.JMenuItem jMenuItemOffsetCorrectionFD;
    private javax.swing.JMenuItem jMenuItemOffsetCorrectionTD;
    private javax.swing.JMenuItem jMenuItemOnlineHelp;
    private javax.swing.JMenuItem jMenuItemOpenCSI;
    private javax.swing.JMenuItem jMenuItemOpenMRUIFormattedCSI;
    private javax.swing.JMenuItem jMenuItemOutlierRemovalUsingNeighbours;
    private javax.swing.JMenuItem jMenuItemPrintMapSelectionStats;
    private javax.swing.JMenuItem jMenuItemPrintMapStats;
    private javax.swing.JMenuItem jMenuItemPrintQulatificationResultsforSelectedVoxels;
    private javax.swing.JMenuItem jMenuItemPrintTDFDFitResultsToScreen;
    private javax.swing.JMenuItem jMenuItemPrintjMRUIResults;
    private javax.swing.JMenuItem jMenuItemProcessAllSeries;
    private javax.swing.JMenuItem jMenuItemProcessAllSeriesFolder;
    private javax.swing.JMenuItem jMenuItemQuantifyTDFDfit;
    private javax.swing.JMenuItem jMenuItemQuantitativeClinicalCaseTDFDfitting;
    private javax.swing.JMenuItem jMenuItemReadMatchingPreproceesingResults;
    private javax.swing.JMenuItem jMenuItemRemoveSaturatedVoxels;
    private javax.swing.JMenuItem jMenuItemRemoveWaterHLSVD64;
    private javax.swing.JMenuItem jMenuItemRemoveWaterHLSVDKernal;
    private javax.swing.JMenuItem jMenuItemRemoveWaterHLSVDPro;
    private javax.swing.JMenuItem jMenuItemRemoveWaterTDFDFit;
    private javax.swing.JMenuItem jMenuItemSaveAllToMAT;
    private javax.swing.JMenuItem jMenuItemSaveSelectionToMAT;
    private javax.swing.JMenuItem jMenuItemSaveSelectionTojMRUI;
    private javax.swing.JMenuItem jMenuItemSelectAll;
    private javax.swing.JMenuItem jMenuItemSelectExcitedVoxels;
    private javax.swing.JMenuItem jMenuItemSelectFreeHand;
    private javax.swing.JMenuItem jMenuItemSelectGoodQualityVoxels;
    private javax.swing.JMenuItem jMenuItemSelectInnerExcitedVoxels;
    private javax.swing.JMenuItem jMenuItemSelectVoxelsFeatureBased;
    private javax.swing.JMenuItem jMenuItemSettings;
    private javax.swing.JMenuItem jMenuItemShiftScale;
    private javax.swing.JMenuItem jMenuItemSvGridPrst;
    private javax.swing.JMenuItem jMenuItemTruncateDataTD;
    private javax.swing.JMenuItem jMenuItemTumourRegionSelection;
    private javax.swing.JMenuItem jMenuItemWriteAverageTDFDFitResultsToTextFile;
    private javax.swing.JMenuItem jMenuItemWriteMatchingPreproceesingResults1;
    private javax.swing.JMenuItem jMenuItemWriteTDFDFitResultsToTextFile;
    private javax.swing.JMenuItem jMenuItemWritejMRUIResults;
    private javax.swing.JMenuItem jMenuItemZeroFilling;
    private javax.swing.JMenu jMenuLdGridPrst;
    private javax.swing.JMenu jMenuLoadCstm;
    private javax.swing.JMenu jMenuMap;
    private javax.swing.JMenu jMenuPatient;
    private javax.swing.JMenuItem jMenuPatientBrowser;
    private javax.swing.JMenu jMenuProcessing;
    private javax.swing.JMenu jMenuQualityControl;
    private javax.swing.JMenu jMenuReports;
    private javax.swing.JMenu jMenuRmCstm;
    private javax.swing.JMenu jMenuRmGridPrst;
    private javax.swing.JMenu jMenuStdReport;
    private javax.swing.JMenu jMenuView;
    private javax.swing.JMenu jMenuVoxelSelection;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JRadioButton jRadioButtonSelectBlue;
    private javax.swing.JRadioButton jRadioButtonSelectRed;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JPopupMenu.Separator jSeparator10;
    private javax.swing.JPopupMenu.Separator jSeparator11;
    private javax.swing.JPopupMenu.Separator jSeparator12;
    private javax.swing.JPopupMenu.Separator jSeparator13;
    private javax.swing.JPopupMenu.Separator jSeparator14;
    private javax.swing.JPopupMenu.Separator jSeparator15;
    private javax.swing.JPopupMenu.Separator jSeparator16;
    private javax.swing.JPopupMenu.Separator jSeparator17;
    private javax.swing.JSeparator jSeparator18;
    private javax.swing.JSeparator jSeparator19;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JPopupMenu.Separator jSeparator20;
    private javax.swing.JPopupMenu.Separator jSeparator21;
    private javax.swing.JPopupMenu.Separator jSeparator3;
    private javax.swing.JPopupMenu.Separator jSeparator4;
    private javax.swing.JPopupMenu.Separator jSeparator5;
    private javax.swing.JPopupMenu.Separator jSeparator6;
    private javax.swing.JPopupMenu.Separator jSeparator7;
    private javax.swing.JPopupMenu.Separator jSeparator8;
    private javax.swing.JPopupMenu.Separator jSeparator9;
    private javax.swing.JSlider jSlider1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JTextArea jTextAreaOutput;
    private javax.swing.JCheckBoxMenuItem m_automaticStoreTDFDFitResultsCheckBoxMenuItem;
    private javax.swing.JMenuItem m_onlineHelpClinicalCasesjMenuItem;
    private javax.swing.JMenuItem m_onlineHelpDicomNetworkjMenuItem;
    private javax.swing.JMenuItem m_onlineHelpFileMenuItem;
    private javax.swing.JMenuItem m_onlineHelpImageMenuItem;
    private javax.swing.JMenuItem m_onlineHelpMRSIvoxelSelection;
    private javax.swing.JMenuItem m_onlineHelpMapjMenuItem;
    private javax.swing.JMenuItem m_onlineHelpProcessingjMenuItem;
    private javax.swing.JMenuItem m_onlineHelpReportjMenuItem;
    private javax.swing.JMenuItem m_onlineHelpViewjMenuItem;
    private javax.swing.JMenuItem m_onlineHelpjMRUIImportExportMenuItem;
    private javax.swing.JMenuItem m_qualityControljMenuItem;
    private javax.swing.JPanel pnlData;
    private javax.swing.JPanel pnlFileManager;
    private javax.swing.JPanel pnlImage;
    private javax.swing.JPanel pnlMain;
    private javax.swing.JPanel pnlSpectrum;
    private javax.swing.JPanel pnlView;
    private javax.swing.JPanel pnlViewCor;
    private javax.swing.JPanel pnlViewSag;
    private javax.swing.JPanel pnlViewTra;
    // End of variables declaration//GEN-END:variables

    @Override
    public void actionPerformed( ActionEvent ae ) 
    {
        Object sender = ae.getSource( );
        
        if ( sender instanceof ImageViewerPanel )
        {
            if ( ae.getID( ) == ImageViewerPanel.LEAVE_DIFFENCE_MODE_ID )
            {
                if ( model.getShowDifference( ) == true )
                {
                    model.SetShowDifference(false);
                    this.jCheckBoxShowDifference.setSelected(false);
                }
            }
        }
        if ( sender instanceof TDFDFitControlFrame )
        {
            if ( ae.getID( ) == TDFDFitControlFrame.UPDATE_COMPO_BOX_ID )
            {
                m_TDFDFitSignalPreprocessingToolbar.fillComboboxes( );
            }
        }
        
        if ( sender instanceof NonInteractiveBaselineRemovalExecuter  )
        {
            if ( ae.getID( ) == NonInteractiveBaselineRemovalExecuter.ALL_BASELINEREMOVAL_THREADS_DONE )
            {
                // System.out.println( "NonInteractiveBaselineRemovalExecuter!" );
                
                model.updateSpectraPanel( );
            }
        }
                    
        if ( sender == m_baseLineSplineSupportPointsDefinitionFrame )
        {
            if ( ae.getID( ) == BaseLineSplineSupportPointsDefinitionFrame.ACCEPT_EVENT )
            {
                
                ArrayList<String> selVox = model.getSelectedVoxels( );
                
                if ( selVox.size( ) > 1 )
                {
                    
                    int confirm = JOptionPane.showOptionDialog( this, "Warning this operation overwrites all selected voxels with the baseline corrected responses!", "Do you want this", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, null);
                    
                    if ( confirm == JOptionPane.OK_OPTION ) 
                    {
                        float[] correctedRespReal = m_baseLineSplineSupportPointsDefinitionFrame.getBaselineCorrectedResponseReal( );
                        float[] correctedRespImag = m_baseLineSplineSupportPointsDefinitionFrame.getBaselineCorrectedResponseImag( );
                       
                        // complex conjugation needed!
                        for ( int i = 0; i < correctedRespImag.length; i++ )
                        {
                            correctedRespImag[i] = - correctedRespImag[i];
                        }
                
                        Iterator it = selVox.iterator( );

                        Spectra csiData = model.getCSIData( ).getSpectra( ); 
                
                        while ( it.hasNext( ) ) 
                        {
                            String key = (String)it.next( );
                            csiData.setSpectrum( correctedRespReal, correctedRespImag, key );
                            // System.out.println( "selected  key = " + key );
                        }
                    }
                    model.updateViewImagePanels( );
                    model.updateSpectraPanel( );
                    updateProcessingActions( );
                    
                    m_TDFDFitSignalPreprocessingToolbar.fillComboboxes( );
                    
                }
                else
                {
                    float[] correctedRespReal = m_baseLineSplineSupportPointsDefinitionFrame.getBaselineCorrectedResponseReal( );
                    float[] correctedRespImag = m_baseLineSplineSupportPointsDefinitionFrame.getBaselineCorrectedResponseImag( );
                    for ( int i=0; i <correctedRespImag.length; i++ )
                    {
                        correctedRespImag[i] = -correctedRespImag[i];
                    }

                    Iterator it = selVox.iterator();

                    Spectra csiData = model.getCSIData( ).getSpectra( ); 

                    while ( it.hasNext( ) ) 
                    {
                        String key = (String)it.next( );
                        csiData.setSpectrum( correctedRespReal, correctedRespImag, key );
                        System.out.println( "selected  key = " + key );
                    }
                    m_TDFDFitSignalPreprocessingToolbar.fillComboboxes( );
                }     
            }
                 
        }
        
        if ( sender ==  m_midasEPSIDataImporter )
        {
            if ( ae.getID( ) == MidasPreprocessedEPSIDataImporterParameterSettingsControl.EPSI_MIDAS_PREPROCESSED_DATA_LOADED_ID )
            {
                model.updateViewImagePanels( );
                model.updateSpectraPanel( );
                updateProcessingActions();
            }
        }
        
        if ( sender ==  m_exportMRSDataToCSVFileOptionFrame )
        {
            if ( ae.getID( ) == ExportMRSDataToCSVFileOptionFrame.NOTIFY_USER_WANTS_CSV_EXPORT_ID )
            {
                exportSelectedModelSignalsToCSVFile( (ExportMRSDataToCSVFileOptionFrame)sender );
            }
            
            if ( ae.getID( ) == ExportMRSDataToCSVFileOptionFrame.NOTIFY_USER_WANTS_COMPLEX_CONJUGATE_AND_CSV_EXPORT_ID )
            {
                exportSelectedModelSignalsToCSVFile( (ExportMRSDataToCSVFileOptionFrame)sender );
            }
        }
        
        if ( sender == this.m_dicomToolbar )
        {
             if ( ae.getID( ) == DicomToolBar.MOUNT_DICOM_DIRECTORY_ID )
             {
                dicomManager.mountDirectory( );
             }
             
             if ( ae.getID( ) == DicomToolBar.DICOM_NETWORK_NODE_PROPERTIES_ID )
             {
                 DicomNetworkNodeDefinerAndSelectionFrame dicomNodesFrame = new DicomNetworkNodeDefinerAndSelectionFrame( this );
             }
             
             if ( ae.getID( ) == DicomToolBar.DICOM_NETWORK_LISTENER_ID )
             {
                 if ( m_dicomNetworkListenerPropertiesFrame == null ) 
                {
                    m_dicomNetworkListenerPropertiesFrame = new DicomNetworkListenerPropertiesFrame( this );
                }
                m_dicomNetworkListenerPropertiesFrame.setVisible( true );
             }
             
             if ( ae.getID( ) == DicomToolBar.DICOMIZE_SCREENSHOT_ID )
             {
                 // to be defined
             }
             
             if ( ae.getID( ) == DicomToolBar.DICOMIZE_NON_DICOM_IMAGE_ID )
             {
                 // to be defined
             }
             
        }
        
        if ( sender == m_TDFDFitSignalPreprocessingToolbar )
        {
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_INTERACTIVE_TDFDFIT_WATER_REMOVAL_ID )
            {
                if ( model.getCSIData( ) != null )
                {
                    TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                    def.load( );
                    String defaultWaterModelName = def.getProperty( TDFDFittingDefaults.TDFDFIT_WATER_MODEL_NAME );
                    String defaultWaterModelPath = def.getProperty( TDFDFittingDefaults.TDFDFIT_WATER_MODEL_PATH );

                    m_removeWaterTDFDFit = true;

                    if ( defaultWaterModelName.endsWith( ".tfm" ) == false )
                    {
                        defaultWaterModelName = defaultWaterModelName + ".tfm";
                    }

                    String modelReference = defaultWaterModelPath + System.getProperty( "file.separator" ) + defaultWaterModelName;
                    File defaultModelFile = new File( modelReference );

                    if ( defaultModelFile.exists( ) == true )
                    {
                        NonInteractiveTDFDFitExecuter tdfdfitExecutor = new NonInteractiveTDFDFitExecuter( this, modelReference, model, m_removeWaterTDFDFit );
                        tdfdfitExecutor.loadTDFDFitPrototypeModelSpectrumFile( );
                        
                        if ( tdfdfitExecutor.getSingleVoxelMeasuredSpectralData( ).getAbsorptionChannelFD( ).length == model.getVectorSize( ) )
                        {

                            tdfdfitExecutor.addActionListener( this );
                            tdfdfitExecutor.executeTDFDFitting( true );
                        }
                        else
                        {
                             JOptionPane.showMessageDialog( this, "TDFDFitting cannot be performed: \n Number of points of selected model does not match the number of points in the data!." );
                        }
                        
                        
                        
//                        
//                        tdfdfitExecutor.addActionListener( this );
//                        tdfdfitExecutor.executeTDFDFitting( true );
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Water removal using TDFDfit cannot be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_INTERACTIVE_HLSVD_WATER_REMOVAL_ID )
            {
                if ( model.getCSIData( ) != null )
                {
                    applyInterActiveHLSVD64Filter( );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Water removal using HLSVD cannot be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_HLSVD_PRO_WATER_REMOVAL_ID )
            {
                if ( model.getCSIData( ) != null )
                {
                    applyHLSVDProFilterInSwingWorkerThread( );
                    // applyHLSVD64FilterInSwingWorkerThread( );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Water removal using HLSVD cannot be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_APODIZATION_ID )
            {
                if ( model != null && !model.isSpectraNull( ) ) 
                {
                    if ( model.getGridSize( ) > 0 ) 
                    {
                        if ( popupapodizationframe == null ) 
                        {
                            PopupApodizationFrame popup = new PopupApodizationFrame( this );
                            popupapodizationframe = popup;
                        } 
                        else 
                        {
                            popupapodizationframe.setVisible( true );
                        }
                        popupapodizationframe.setLocationRelativeTo( this );
                    }
                    else
                    {
                        JOptionPane.showMessageDialog( this, "Apodization cannot be performed: \n first load a dataset!." );
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Apodization cannot be performed: \n first load a dataset!." );
                }
                   
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_FIRST_TD_POINT_MULTIPLICATION_ID )
            {
                if ( model.getCSIData( ) != null )
                {
                    applyOffsetCorrectionTDInSwingWorkerThread( );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Offset correction in TD cannot be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_OFFSET_CORRECTION_FD_ID )
            {
                if ( model.getCSIData( ) != null )
                {
                    applyOffsetCorrectionFDInSwingWorkerThread( );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Offset correction in FD cannot be performed: \n first load a dataset!." );
                }
                     
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_OFFSET_CORRECTION_TD_ID )
            {
                if ( model.getCSIData( ) != null )
                {
                    applyOffsetCorrectionTDInSwingWorkerThread( );
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Offset correction in TD cannot be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_ZERO_FILLING_ID )
            {
                if ( model.getCSIData( ) != null )
                {
                    if ( model.getGridSize( ) > 0 ) 
                    {
                        if ( popupzerofilling == null ) 
                        {
                            PopupZeroFillingFrame popup = new PopupZeroFillingFrame( model.getSpectraVectorSize( ), currentVectorSize, this );
                            popupzerofilling = popup;
                        } 
                        else 
                        {
                            popupzerofilling.setVisible( true );
                        }
                        popupzerofilling.setLocationRelativeTo( this );
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Zero filling in TD cannot be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_MANUAL_PHASING_ID )
            {
                if ( model.getCSIData( ) != null )
                {
                    m_phasingControl = new SpectrumPhasingDefinitionControl( "Zero and First Order Phasing", this, 
                                                                             SpectrumPhasingDefinitionControl.SINGLE_RESPONSE_DISPLAY );
                    m_phasingControl.addActionListener( this );
                }
                else
                {
                     JOptionPane.showMessageDialog( this, "Manual phasing cannot be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_AUTOMATIC_PHASING_ID )
            {
               if ( model.getCSIData( ) != null )
               {
                    if ( model.getGridSize( ) > 0 ) 
                    {
                        if ( popupphasingframe == null ) 
                        {
                            PopupPhasingFrame popup = new PopupPhasingFrame( this, 1.5f, 4.4f );
                            popupphasingframe = popup;
                        } 
                        else
                        {
                            popupphasingframe.setVisible( true );
                        }
                        popupphasingframe.setLocationRelativeTo( this );
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Automatic phasing cannot be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_MANUAL_BASELINE_REMOVAL_ID )
            {
                if ( model.getCSIData( ) != null )
                {            
                    TDFDFittingDefaults defs = TDFDFittingDefaults.getInstance( );
                    defs.load( );

                    String splineNodeModelPath = defs.getProperty( TDFDFittingDefaults.BASELINE_SPLINE_MODEL_PATH );
                    String splineNodeModelName = defs.getProperty( TDFDFittingDefaults.BASELINE_SPLINE_MODEL_NAME );

                    String defaultPathAndName;
                    OrderedBaseLinePointsDataModel oBDPM = OrderedBaseLinePointsDataModel.getInstance(); 

                    if ( ( splineNodeModelName != null ) && ( splineNodeModelPath != null ) && ( splineNodeModelName.endsWith( ".snm" ) ) )
                    {
                        defaultPathAndName = splineNodeModelPath + System.getProperty( "file.separator" ) + splineNodeModelName;
                        oBDPM = OrderedBaseLinePointsDataModel.getInstance( );
                        Vector<Point2D.Double> splineNodes = oBDPM.getSplineNodeVector( );

                        // The xValues array will now re-used over and over again
                        // and has to be determined just once ...
//                        float[] dummyX = new float[ model.getSpectraVectorSize( ) ];
//                        float[] dummyY = new float[ model.getSpectraVectorSize( ) ];
//                        SingleVoxelMeasuredSpectralData specData = new SingleVoxelMeasuredSpectralData( dummyX, dummyY );
//                        specData.autoSetXaxis( );
                        
//                        float[] xValuesForInterpolation =  specData.getAbsorptionCurveFDPPM( ).getXvalues( );
                        float[] xValues = new float[ model.getSpectraVectorSize( ) ];

                        double minX = splineNodes.get( 0 ).x;
                        double maxX = splineNodes.get( splineNodes.size( ) - 1 ).x;

                        float[] xInterpolPoints = new float[model.getSpectraVectorSize( )];

                        for ( int i = 0; i < model.getSpectraVectorSize( ); i++ )
                        {
                            xInterpolPoints[i] = (float)( maxX - ( maxX - minX ) * i / ( model.getSpectraVectorSize( ) - 1 ) );
                        }

                        for ( int i = 0; i < model.getSpectraVectorSize( ); i++ )
                        {
                            xValues[i] = xInterpolPoints[ model.getSpectraVectorSize( ) - i - 1 ];
                        }

                        if ( ( model.getCSIData( ) != null ) && ( oBDPM.getSplineNodeVector( ).size( ) > 3 ) )
                        {   
                            NonInteractiveBaselineRemovalExecuter baselinRemovalExecuter = new NonInteractiveBaselineRemovalExecuter( this, model, splineNodes, xValues );           
                            baselinRemovalExecuter.addActionListener( this );
                            baselinRemovalExecuter.executeBaselineRemoval( true );
                        }
                        model.updateSpectraPanel( );
                    }
                    else
                    {
                        JOptionPane.showMessageDialog( this, "No valid baseline spline node model found : \n define spline node baseline set first!." );
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Automatic baseline model correction cannot be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) ==  SpectrImMainSignalPreprocessingToolbar.DEFINE_MANUAL_BASELINE_REMOVAL_SETTINGS_ID )
            {
                
                if ( model.getCSIData( ) != null )
                {
                
                    // user wants to define the spline points where the spectrum 
                    // does not have spectral components.
                    CSIData csiData = model.getCSIData( );

                    Spectra spectra = csiData.getSpectra( );

                    Iterator it = spectra.getData( ).keySet( ).iterator( );
                    String key = spectra.getData( ).keySet( ).iterator( ).next( );

                    ArrayList<String> ids = model.getSelectedVoxels( );
                    float[] absTD = spectra.getMeanSpectrum( ids, Spectra.Domain.TD, Spectra.Mode.ABS );
                    float[] dispTD = spectra.getMeanSpectrum( ids, Spectra.Domain.TD, Spectra.Mode.DISP );

                    MRSignalProperties.getInstance( ).setNumberOfSamplePoints( model.getVectorSize( ) );
                    MRSignalProperties.getInstance( ).setHz_pp( (float)( model.getBandwidth( ) / model.getVectorSize( ) ) );
                    MRSignalProperties.getInstance( ).setResonanceFrequency( new Double( "" + model.getResonanceFrequency( ) ).longValue( ) );
                    MRSignalProperties.getInstance( ).setPPMValueInCenterOfSpectrum( (float)model.getPPMReference( ) );

                    SingleVoxelMeasuredSpectralData singleVoxelMeasuredData = new SingleVoxelMeasuredSpectralData( absTD, dispTD );
                    singleVoxelMeasuredData.doComplexConjugation( );

                    m_baseLineSplineSupportPointsDefinitionFrame = new BaseLineSplineSupportPointsDefinitionFrame( singleVoxelMeasuredData );
                    m_baseLineSplineSupportPointsDefinitionFrame.addActionListener( this );
                    
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Cannot define baseline correction modeling can be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_INTERACTIVE_FREQ_SHIFT_ID )
            {
                if ( model.getCSIData( ) != null )
                {
                    if ( model.getGridSize( ) > 0 ) 
                    {
                        if ( popupshiftcorrection == null ) 
                        {
                            ShiftCorrectionPopup popup = new ShiftCorrectionPopup( this );
                            popupshiftcorrection = popup;
                        } 
                        else 
                        {
                            popupshiftcorrection.setVisible( true );
                        }
                        popupshiftcorrection.setLocationRelativeTo( this );
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Automatic frequency shift cannot be performed: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.EDIT_SELECTED_TDFDFIT_METABOLITE_MODEL_ID )
            {
                // System.out.println( "Launch model editor!" );
                if ( model.getCSIData( ) != null )
                {
                    if ( model.getSpectroscopyFile( ).length( ) != 0 ) 
                    {
                         // -> add code here to lauch editor on combobox selected model file
                        DicomDirectory ddir = ((DicomDataLoaderPanel) pnlFileManager).getDicomDirObject( );
                        TDFDFitControlFrame frame = new TDFDFitControlFrame( this, model, model.getSpectroscopyFile( ), ddir, true );
                        frame.addActionListener(this);
                    } 
                    else 
                    {
                        TDFDFitControlFrame frame = new TDFDFitControlFrame( this, model, true );
                        frame.addActionListener(this);
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Cannot open model editor: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.CREATE_AND_ADD_NEW_MODEL_ID )
            {
                if ( model.getCSIData( ) != null ) 
                {
                    if ( model.getSpectroscopyFile( ).length( ) != 0 ) 
                    {
                        DicomDirectory ddir = ((DicomDataLoaderPanel) pnlFileManager).getDicomDirObject( );
                        TDFDFitControlFrame frame = new TDFDFitControlFrame( this, model, model.getSpectroscopyFile( ), ddir, false );
                    } 
                    else 
                    {
                        TDFDFitControlFrame frame = new TDFDFitControlFrame( this, model, false );
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "Cannot open model editor: \n first load a dataset!." );
                }
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.EDIT_TDFDFIT_DEFAULTS_ID )
            {
                // MRFittingDefaultsFrame defaults =  new MRFittingDefaultsFrame( this );
                TDFDFitDefaultRuntimeSettingsDefinitionFrame defTDFDFitRuntimeSettings = new TDFDFitDefaultRuntimeSettingsDefinitionFrame( this );
            }
            
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_COMPLEX_CONJUGATION_ID )
            {
                if ( model != null ) 
                {
                    model.complexConjugateAllSpectra( );
                }
            }
           
            if ( ae.getID( ) == SpectrImMainSignalPreprocessingToolbar.APPLY_TDFDFIT_QUANTIFICATION_ID )
            {
                if ( model.getCSIData( ) != null )
                {                    
                    TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
                    def.load( );
                    String defaultModelName = def.getProperty( TDFDFittingDefaults.DEFAULT_TDFDFIT_FIT_MODEL_NAME );
                    String defaultModelPath = def.getProperty( TDFDFittingDefaults.DEFAULT_USED_TDFDFIT_MODEL_PATH );

                    if ( defaultModelName.compareTo( "No model defined yet!" ) != 0 )
                    {

                        if ( defaultModelName.endsWith( ".tfm" ) == false )
                        {
                            defaultModelName = defaultModelName + ".tfm";
                        }

                        String modelReference = defaultModelPath + System.getProperty( "file.separator" ) + defaultModelName;
                        File defaultModelFile = new File( modelReference );

                        if ( defaultModelFile.exists( ) == true )
                        {
                            NonInteractiveTDFDFitExecuter tdfdfitExecutor = new NonInteractiveTDFDFitExecuter( this, modelReference, model, false );
                            tdfdfitExecutor.loadTDFDFitPrototypeModelSpectrumFile( );
                            
                            if (tdfdfitExecutor.getSingleVoxelMeasuredSpectralData().getAbsorptionChannelFD().length == model.getVectorSize( ) )
                            {

                                tdfdfitExecutor.addActionListener( this );
                                tdfdfitExecutor.executeTDFDFitting( true );
                            }
                            else
                            {
                                 JOptionPane.showMessageDialog( this, "TDFDFitting cannot be performed: \n Number of points of selected model does not match the number of points in the data!." );
                            }
                        }
                    }
                    else
                    {
                        JOptionPane.showMessageDialog( this, "TDFDFitting cannot be performed: \n first select/define a valid TDFDFit model!." );
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog( this, "TDFDFitting cannot be performed: \n first load a dataset!." );
                }
            }   
        }
        
        if ( sender == m_QMRSIOutlierRemovalControlFrame )
        {
            if ( ae.getID( ) == QMRSIOutlierRemovalControlFrame.PREVIEW_OUTLIER_FILTERING_ID )
            {
                
                int selectedMetabNumber = m_popupjMRUIResultsMap.getSelectedMetabolite1( );
                int getSelectedFeature = m_popupjMRUIResultsMap.getSelectedFeature1( );
                
                float minimumInterQuartileMultiplicationFactor = m_QMRSIOutlierRemovalControlFrame.getMinimumInterQuartileFactor( );
                float maximumInterQuartileMultiplicationFactor = m_QMRSIOutlierRemovalControlFrame.getMaximumInterQuartileFactor( );
                
                performOutlierCorrectionOnDataset( selectedMetabNumber, getSelectedFeature,
                                                   minimumInterQuartileMultiplicationFactor,
                                                   maximumInterQuartileMultiplicationFactor );
                
                m_popupjMRUIResultsMap.refreshDisplayedMap( );
            }
            
            if ( ae.getID( ) == QMRSIOutlierRemovalControlFrame.UNDO_OUTLIER_FILTERING_ID )
            {
                m_popupjMRUIResultsMap.setSelectedMetabolite1( m_QMRSIOutlierRemovalControlFrame.getSelectedMetaboliteNumber( ) );
                m_popupjMRUIResultsMap.setSelectedFeature1( m_QMRSIOutlierRemovalControlFrame.getSelectedFeatureNumber( ) );
                
                selectExcitedVoxels( );
                
                m_popupjMRUIResultsMap.refreshDisplayedMap( );
                
//                int selectedMetabNumber = m_popupjMRUIResultsMap.getSelectedMetabolite1( );
//                int getSelectedFeature = m_popupjMRUIResultsMap.getSelectedFeature1( );
//                
//                float minimumInterQuartileMultiplicationFactor = m_QMRSIOutlierRemovalControlFrame.getMinimumInterQuartileFactor( );
//                float maximumInterQuartileMultiplicationFactor = m_QMRSIOutlierRemovalControlFrame.getMaximumInterQuartileFactor( );
//                
//                performOutlierCorrectionOnDataset( selectedMetabNumber, getSelectedFeature,
//                                                   minimumInterQuartileMultiplicationFactor,
//                                                   maximumInterQuartileMultiplicationFactor );
//                
//                m_popupjMRUIResultsMap.refreshDisplayedMap( );
            }
        }
        
        if ( sender == this.m_phasingControl )
        {
            if ( ae.getID( ) ==  SpectrumPhasingDefinitionControl.ZERO_ORDER_PHASING_EVENT )
            {
                applyManuelZeroOrderPhasing( (float)( ( ( SpectrumPhasingDefinitionControl )ae.getSource( ) ).getZeroOrderPhase( ) * ( Math.PI / 180.0 ) ),
                                             (float)( ( ( SpectrumPhasingDefinitionControl )ae.getSource( ) ).getFirstOrderPhase( ) * ( Math.PI / 180.0 ) ),
                                             true );
            }
            if ( ae.getID( ) ==  SpectrumPhasingDefinitionControl.FIRST_ORDER_PHASING_EVENT )
            {
                applyManuelZeroOrderPhasing( (float)( ( ( SpectrumPhasingDefinitionControl )ae.getSource( ) ).getZeroOrderPhase( ) * ( Math.PI / 180.0 ) ),
                                             (float)( ( ( SpectrumPhasingDefinitionControl )ae.getSource( ) ).getFirstOrderPhase( ) * ( Math.PI / 180.0 ) ),
                                             true );
            }
            
            if ( ae.getID( ) ==  SpectrumPhasingDefinitionControl.ACCEPT_EVENT )
            {
                
            }
            
            if ( ae.getID( ) ==  SpectrumPhasingDefinitionControl.CANCEL_EVENT )
            {
                
            }  
        }
        
        if ( sender == m_fdOffsetRemoverControl )
        // if ( ae.getSource( ) instanceof OffsetRemovalParameterControl )
        {
            if ( ae.getID( ) == OffsetRemovalParameterControl.ACCEPT_EVENT )
            {
                launchPerformFrequencyDomainOffsetCorrectionOnDataset( (int) ( ( OffsetRemovalParameterControl )sender ).getMinimumRangeValue( ),
                                                                       (int) ( ( OffsetRemovalParameterControl )sender ).getMaximumRangeValue( ) );
            }
            else
            {
                // do nothing!
            }
        }
          
        if ( sender == m_tdOffsetRemoverControl )
        // if ( ae.getSource( ) instanceof OffsetRemovalParameterControl )
        {
            if ( ae.getID( ) == OffsetRemovalParameterControl.ACCEPT_EVENT )
            {
                launchPerformTimeDomainOffsetCorrectionOnDataset( (int)( ( OffsetRemovalParameterControl )sender ).getMinimumRangeValue( ),
                                                                  (int)( ( OffsetRemovalParameterControl )sender ).getMaximumRangeValue( ) );
            }
            else
            {
                // do nothing!
            }
        }
           
        if ( ae.getSource( ) instanceof NonInteractiveTDFDFitExecuter )
        {
            if ( ae.getID( ) == NonInteractiveTDFDFitExecuter.ALL_FITTING_THREADS_DONE )
            {
//                System.out.println( "" );
//                System.out.println( "NonInteractiveTDFDFitExecuter finished processing!" );
//                System.out.println( "Results read successfully!" );
                            
                ( ( NonInteractiveTDFDFitExecuter )ae.getSource( ) ).collectAllFittingResults( m_removeWaterTDFDFit );
                ( ( NonInteractiveTDFDFitExecuter )ae.getSource( ) ).putFittedSpectraIntoGlobalModel( );
                ( ( NonInteractiveTDFDFitExecuter )ae.getSource( ) ).putPreprocessedSpectraIntoResultsStore( ); 
                ( ( NonInteractiveTDFDFitExecuter )ae.getSource( ) ).reduceNumberOfTFDFitResultDotFitFiles( );
                
                if ( m_removeWaterTDFDFit == true )
                {
                    ( ( NonInteractiveTDFDFitExecuter) ae.getSource( ) ).subtractFittedSpectraIntoGlobalModel( );
                    m_allFittedWaterReferenceResonanceFrequencies = ( ( NonInteractiveTDFDFitExecuter) ae.getSource( ) ).getAllFittedWaterResonanceFrequencies( );
                    model.setWaterResonanceFrequenciesForTemperatureMapping( m_allFittedWaterReferenceResonanceFrequencies );
                }
                
                m_removeWaterTDFDFit = false;
                
                TDFDFitResultsStore store = model.getTDFDFitStore( );
                
                if ( m_removeWaterTDFDFit == true )
                {
                    store.setWaterReferenceOffsets( m_allFittedWaterReferenceResonanceFrequencies );
                }
                
                m_popupjMRUIResultsMap = PopupjMRUIResultsMap.getInstance( store, 
                                                                           store.getAvailableMetabolites( ), 
                                                                           store.getFeatureNames( ), 
                                                                           m_removeWaterTDFDFit );
                
                if ( m_automaticStoreTDFDFitResultsCheckBoxMenuItem.isSelected( ) == true )
                {
                    store.writeTDFDFitResultsStore( );
                }
                BatchProcessing.resume( );
            }
        }
        
        if ( ae.getSource( ) instanceof DataLoadOptionFrame )
        { 
            DataLoadOptionFrame frame = (DataLoadOptionFrame)ae.getSource( );
            FileReaderWorker fileworker = null;
            
            // There are two response to be loaded and a difference to be computed
            int resp1, resp2;
            
            if ( ae.getID( ) == DataLoadOptionFrame.LOAD_DIFF_2_MINUS_1 )
            {
                resp1 = frame.getSecondOfTwoResponses( );
                resp2 = frame.getFirstOfTwoResponses( );
                fileworker = new FileReaderWorker( this, frame.getFileReferences( ), 
                                                   dicomManager, model, 
                                                   ae.getID( ),
                                                   resp1, resp2 ); 
            }
            if ( ae.getID( ) == DataLoadOptionFrame.LOAD_DIFF_1_MINUS_2 )
            {
                resp2 = frame.getFirstOfTwoResponses( );
                resp1 = frame.getSecondOfTwoResponses( );
                fileworker = new FileReaderWorker( this, frame.getFileReferences( ), 
                                                   dicomManager, model, 
                                                   ae.getID( ),
                                                   resp1, resp2 );
            }
           
            if ( ( ae.getID( ) == DataLoadOptionFrame.LOAD_ALL_AND_SUM ) ||
                 ( ae.getID( ) == DataLoadOptionFrame.LOAD_SINGLE_INSTANCE ) || 
                 ( ae.getID( ) == DataLoadOptionFrame.LOAD_SINGLE_INSTANCE_OF_MULTIPLE )   )   
            {
                fileworker = new FileReaderWorker( this, frame.getFileReferences( ), 
                                                   dicomManager, model, 
                                                   ae.getID( ),
                                                   frame.getSelectedInstanceNumber( ) );
            }
            
            fileworker.execute( );
        }
        
        if ( sender == this.dicomManager && ae.getActionCommand( ).matches( DicomFileSelectionControl.TREE_ENTRY_DBL_CLICKED_CMD ) )
        {
            
            final LinkedList<String> fileReferences = dicomseltab.getSelectedSeriesFileReferences( );
            DicomImageSeriesData dicomData = new DicomImageSeriesData( fileReferences );
            
            if ( ( dicomData.getFileInfo(0).isImageData( ) ) ||
                 ( !dicomData.getFileInfo(0).isImageData( ) && ( fileReferences.size( ) == 1 ) ) )
            {

                SwingWorker worker = new SwingWorker<Integer, Void>( ) 
                {
                    @Override
                    public Integer doInBackground( ) 
                    {
                        final LinkedList<String> fileReferences = dicomseltab.getSelectedSeriesFileReferences( );
                        if ( fileReferences != null ) 
                        {
                            DicomImageSeriesData dicomData = new DicomImageSeriesData( fileReferences );
                            dicomData.orderBySlicePosition( );

    //                        if (dicomseltab.isImageSeries() == true) {
    //                            try {
    //                                processImageFile(fileReferences);
    //                            } catch (IOException ex) {
    //                                Logger.getLogger(MainGUI.class.getName()).log(Level.SEVERE, null, ex);
    //                            }
    //                        } else {
    //                            processCSIFile(fileReferences.getFirst().toString());
    //                        }
                            processFile( fileReferences.getFirst( ) );                     
                        }
                        return 1;
                    }

                    @Override
                    public void done( ) 
                    {
                    }
                };
                worker.execute( );
            }
            else
            {
                if ( dicomData.getFileInfo( 0 ).isImageData( ) == false )
                {
                    DataLoadOptionFrame loadOptionFrame = new DataLoadOptionFrame( fileReferences,
                                                                                   dicomData.getDataSeriesDescription( ) );
                    loadOptionFrame.addActionListener( this );
                    loadOptionFrame.setVisible( true );
                }
            }
        }
    }   
    
    public void applyManuelZeroOrderPhasing( float phase0, float phase1, boolean update )
    {
        
        if ( model != null ) 
        {
            model.manualPhaseSelection( phase0, phase1, update );
        }
        
    }
    
    /**
     * Handling code to load all responses of the fileReferences list 
     * but processed is only their sum response. 
     * @param fileReferences 
     */
    private void handleLoadAndSumAllInstances( LinkedList<String> fileReferences )
    {
        
        SwingWorker worker = new SwingWorker<Integer, Void>( ) 
        {
            @Override
            public Integer doInBackground( ) 
            {
                        final LinkedList<String> fileReferences = dicomseltab.getSelectedSeriesFileReferences( );
                        if ( fileReferences != null ) 
                        {
                            DicomImageSeriesData dicomData = new DicomImageSeriesData( fileReferences );
                            dicomData.orderBySlicePosition( );

                            Iterator it = fileReferences.iterator( );
                            while ( it.hasNext( ) )
                            {
                                processFile( fileReferences.getFirst( ).toString( ) );
                            }
                        }
                        return 1;
                    }

                    @Override
                    public void done( ) 
                    {
                    }
                };
                worker.execute( );
        
    }

    @Override
    public void setCSIReference(GlobalModel modelref) {
        if (this.model != null) {
            model.setReferenceSpectra(modelref.getSpectra());
        }
    }

    @Override
    public void setLimits(float min, float max) {
        if (model != null) {
            model.setOverlayThresholdMax(max, false);
            model.setOverlayThresholdMin(min, true);
        }
    }

    @Override
    public void nextLabel() {
        if (labellingHandler != null) {
            labellingHandler.nextLabel();
        }
    }

    @Override
    public void setUnlabelledVoxels(TreeSet<String> lbls) {
        if (labellingHandler != null) {
            labellingHandler.setUnlabelledVoxels(lbls);
        }
    }

    @Override
    public void finish() {
        if (labellingHandler != null) {
            labellingHandler.finish();
        }
    }

    @Override
    public void saveFileLocation(File file) {
        this.currentLabellingFile = file;
    }

    @Override
    public void saveReferenceFileLocation(File file) {
        this.currentLabellingReferenceFile = file;
    }

    @Override
    public void setLabelMap(LinkedHashMap<String, Double> mapValues, String patientn, String studyd, String series) {
        if (this.model != null) {
            String patientnaux = model.getPatientName();
            patientnaux.replace("^", "");
            patientnaux.replace("ä", "a");
            patientnaux.replace("Ä", "A");
            patientnaux.replace("ö", "o");
            patientnaux.replace("Ö", "O");
            patientnaux.replace("ü", "u");
            patientnaux.replace("Ü", "U");
            patientn.replace("^", "");
            patientn.replace("ä", "a");
            patientn.replace("Ä", "A");
            patientn.replace("ö", "o");
            patientn.replace("Ö", "O");
            patientn.replace("ü", "u");
            patientn.replace("Ü", "U");

            if (patientnaux.matches(patientn)
                    && model.getStudyDate().matches(studyd)
                    && (model.getSeriesNumber() + "-" + model.getSeriesDescription()).matches(series)) {
                model.getColorMap().setColorMapValues(mapValues, false, "Labels");
                this.requestFocus();
            } else {
                JOptionPane.showMessageDialog(this, "The selected label session corresponds to a different patient/study/series.");
            }
        }
    }

    @Override
    public synchronized void processingFinished() {
        this.setWaitLayerActive(false);
        model.updateSpectraPanel();
        if (model != null) {
            model.printTxt("Processing Finished!");
        }
    }
    
    /**
     * This routine calls the HLSVDPro python code. The Java code opens a socket
     * to the python code and send the real and imaginary TD spectra, the python
     * code will execute in parallel and send a JSON as an answer with the needed 
     * information.
     * 
     * @param lowerLimit
     * @param upperLimit
     * @param peaks 
     */
    @Override
    public void removeWaterHLSVDPro( double lowerLimit, double upperLimit, int peaks ) 
    {
        /*TDFDFittingDefaults defaults = TDFDFittingDefaults.getInstance( );
        defaults.load( );
        String python_command = defaults.getProperty( TDFDFittingDefaults.PYTHON_EXECUTABLE_FILENAME );
        if( python_command == null || python_command.equals("")){
            PythonSettings Pysetting = new PythonSettings();
            System.out.println("I did enter the first if");
            boolean test = false;
            while( test == false ){
                test = Pysetting.GetStatusAccept();
                //return;
            }
            defaults.load();
            python_command = defaults.getProperty( TDFDFittingDefaults.PYTHON_EXECUTABLE_FILENAME );
            System.out.println("After the save: " + python_command);
        }*/
        applyHLSVDProFilterInSwingWorkerThread( );
    }

    /**
     * This routine calls the HLSVD64 code. In a previous version of the 
     * application the jMRUI-kernel was called. This had to be replaced by
     * by a call to local HLSVD-64 code. 
     * 
     * @param lowerLimit
     * @param upperLimit
     * @param peaks 
     */
    @Override
    public void removeWaterHLSVD64( double lowerLimit, double upperLimit, int peaks ) 
    {
        // this.mruiViewerInterface.removeWater( lowerLimit, upperLimit, peaks );
        // No parameters yet!
        applyHLSVD64FilterInSwingWorkerThread( );
    }

    
    
    
    
    
    /**
     * Performs the quantification of spectra using QUEST.
     */
    @Override
    public void quantifySpectra( ) 
    {
        if ( model != null && !model.isSpectraNull( ) ) 
        {
            ProcessingAction procAction = this.processingActions.get( this.jComboBoxProcessingAction.getSelectedIndex( ) );
            QuantificationAction quantAction = procAction.getQuantificationAction( );
            if ( quantAction != null ) 
            {
                model.printTxt( "Running Quantification Action \"" + quantAction.getName( ) + "\"" );
                switch ( quantAction.getMlFileSelectionMode( ) ) 
                {
                    case QuantificationAction.MANUAL:
                        String mdl = getFile( "ml", currentFile.toString( ) );
                        String op = null;
                        if ( mdl != null ) 
                        {
                            model.printTxt( "Selected custom Metabolite Model file: " + mdl );
                            currentFile = new File( mdl );
                            op = getFile( "op", mdl );
                            if ( op != null ) 
                            {
                                model.printTxt( "Selected custom QUEST options file: " + op );
                            }
                            this.mruiViewerInterface.quantifySpectra( mdl, op, this );
                        } 
                        else 
                        {
                            model.printTxt("Quantification cancelled.");
                        }
                        break;
                    case QuantificationAction.ML:
                        this.mruiViewerInterface.quantifySpectra( quantAction.getMlFile( ), 
                                                                  quantAction.getOpFile( ), 
                                                                  this );
                        break;
                    case QuantificationAction.MRUI:
                        ArrayList<String> files     = new ArrayList<>( );
                        ArrayList<String> names     = new ArrayList<>( );
                        ArrayList<Integer> spins    = new ArrayList<>( );

                        for ( MruiFile mruiFile : quantAction.getMruiFiles( ) ) 
                        {
                            if ( mruiFile.isActive( ) ) 
                            {
                                names.add( mruiFile.getName( ) );
                                spins.add( mruiFile.getSpins( ) );
                                files.add( mruiFile.getMruiFile( ) );
                            }
                        }
                        if ( files.size( ) > 0 ) 
                        {
                            String mlFile = mruiViewerInterface.createMlFile( files, spins, names ).toString( );
                            if ( mlFile != null ) 
                            {
                                mruiViewerInterface.quantifySpectra( mlFile, quantAction.getOpFile( ), this );
                            } 
                            else 
                            {
                                model.printTxt( "Could not create .ml file from .mrui files." );
                            }
                        } 
                        else 
                        {
                            model.printTxt( "No active metabolites." );
                        }
                }
            }
            BatchProcessing.resume( );
        }
    }
      
    @Override
    public void quantifyWithTDFDFitInAction( String tdfdfitModelPathAndFileNameToUse )
    {
          // The following string should come from the current ProcessingAction;
        // now it is hard coded.
        // String modelReference = "C:\\Users\\slotboom\\fitting_tdfdfit_models\\FINAL-TEST\\FINAL-TEST.tfm";
        

//        TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
//        String defaultModelName = def.getProperty( TDFDFittingDefaults.DEFAULT_TDFDFIT_FIT_MODEL_NAME );
//        String defaultModelPath = def.getProperty( TDFDFittingDefaults.DEFAULT_USED_TDFDFIT_MODEL_PATH );
        
        if ( tdfdfitModelPathAndFileNameToUse.endsWith( ".tfm" ) == false )
        {
            tdfdfitModelPathAndFileNameToUse = tdfdfitModelPathAndFileNameToUse + ".tfm";
        }
        
        // String modelReference = defaultModelPath + System.getProperty( "file.separator" ) + tdfdfitModelToUse;
        File defaultModelFile = new File( tdfdfitModelPathAndFileNameToUse );
        
        if ( defaultModelFile.exists( ) == true )
        {
            NonInteractiveTDFDFitExecuter tdfdfitExecutor = new NonInteractiveTDFDFitExecuter( this, tdfdfitModelPathAndFileNameToUse, model, false );
            tdfdfitExecutor.loadTDFDFitPrototypeModelSpectrumFile( );
                        
            if ( tdfdfitExecutor.getSingleVoxelMeasuredSpectralData( ).getAbsorptionChannelFD( ).length == model.getVectorSize( ) )
            {

                tdfdfitExecutor.addActionListener( this );
                tdfdfitExecutor.executeTDFDFitting( true );
            }
            else
            {
                 JOptionPane.showMessageDialog( this, "TDFDFitting cannot be performed: \n Number of points of selected model does not match the number of points in the data!." );
            }
            
//            tdfdfitExecutor.addActionListener( this );
//            tdfdfitExecutor.executeTDFDFitting( true );
        }
    }
            

    private String getFile(String fileType, String... dir) 
    {
        JFileChooser fileChooser = new JFileChooser( );
        if ( dir.length > 0 ) 
        {
            fileChooser.setCurrentDirectory( new File( dir[0] ) );
        }
        FileNameExtensionFilter filter = new FileNameExtensionFilter( fileType.toUpperCase( ), fileType );
        fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
        fileChooser.setFileFilter(filter);
        fileChooser.setDialogTitle("Please select an " + fileType + " file.");
        int result = fileChooser.showOpenDialog(this);

        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                return fileChooser.getSelectedFile().toString();
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                return null;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                return null;
        }
        return null;
    }

    @Override
    public void assessQuality(String RFile) {
        if (model != null) {
            model.classifySpectralQuality(RFile, false);
        }
    }

    @Override
    public int qualitySelection(double threshold) {
        if (model != null) {
            model.selectGoodQualityVoxels(threshold, false);
            return model.getSelectedVoxels().size();
        }
        return 0;
    }

    @Override
    public void baselineCorrection(int nr) {
        this.mruiViewerInterface.baselineCorrection(nr);
    }

    @Override
    public void clearResultsData() {
        this.mruiViewerInterface.clearData();
    }

    @Override
    public GlobalModel getModel() {
        return this.model;
    }

    @Override
    public void resetShiftsSelection() {
        if (model != null) {
            model.resetShifts(true);
        }
    }

    @Override
    public void resetShiftsAll() {
        if (model != null) {
            model.resetShiftsSelection(true);
        }
    }

    @Override
    public void openFile(String file) {
        processFile(file);
    }

    @Override
    public void openReferenceImages(String file1, String file2, String file3) {
        if (model != null) {
            try {
                model.removeLocalizers();
                clearLocalizerPanels();
                Raster imageRaster1 = DicomHandler.readImageRaster(file1);
                DicomObject object1 = DicomHandler.getDicomObject(file1);
                DicomHeader header1 = DicomHandler.getHeader(object1);
                LocalizerPanel loc1 = new LocalizerPanel();
                loc1.setImageInfo(new ImageSlice(imageRaster1, header1, file1.toString()));
                model.addLocalizerPanel(loc1); //Link Localizer with ImageViewerPanel
                Raster imageRaster2 = DicomHandler.readImageRaster(file2);
                DicomObject object2 = DicomHandler.getDicomObject(file2);
                DicomHeader header2 = DicomHandler.getHeader(object2);
                LocalizerPanel loc2 = new LocalizerPanel();
                loc2.setImageInfo(new ImageSlice(imageRaster2, header2, file2.toString()));
                model.addLocalizerPanel(loc2); //Link Localizer with ImageViewerPanel
                Raster imageRaster3 = DicomHandler.readImageRaster(file3);
                DicomObject object3 = DicomHandler.getDicomObject(file3);
                DicomHeader header3 = DicomHandler.getHeader(object3);
                LocalizerPanel loc3 = new LocalizerPanel();
                loc3.setImageInfo(new ImageSlice(imageRaster3, header3, file3.toString()));
                model.addLocalizerPanel(loc3); //Link Localizer with ImageViewerPanel
                setLocalizer(loc1);
                setLocalizer(loc2);
                setLocalizer(loc3);

            } catch (IOException ex) {
                Logger.getLogger(ClinicalViewer.class
                        .getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    @Override
    public void createReport( String outputFile, int outputFileType, String customReportFile ) 
    {
        model.showMiddleSliceWithIntersection( );
        StdReportFrame reportFrame;
        if ( model.getTDFDFitStore( ) == null )
        {
            reportFrame = new StdReportFrame( StdReportFrame.STDMETAB, 
                                              this.model, 
                                              (jMRUIResultsMapListener) mruiViewerInterface );
        }
        else
        {
            reportFrame = new StdReportFrame( StdReportFrame.STDMETAB, 
                                              this.model, 
                                              (jMRUIResultsMapListener) model.getTDFDFitStore( ) );
        }
        
        reportFrame.setLocationRelativeTo( this );
        
        JPanel reportContainer = reportFrame.getContainerPanel( );
        BufferedImage bi = new BufferedImage( reportContainer.getWidth( ), reportContainer.getHeight( ), BufferedImage.TYPE_INT_RGB );
        Graphics g = bi.createGraphics( );
        reportContainer.print( g );
        g.dispose( );
        try 
        {
            ImageIO.write( bi, "PNG", new File( outputFile ) );

        } 
        catch ( IOException ex ) 
        {
            Logger.getLogger( ClinicalViewer.class
                    .getName( ) ).log( Level.SEVERE, null, ex );
        }
    }

    @Override
    public void apodizeExponentialSelection(double fact, boolean update) {
        if (model != null) {
            model.apodizeExponentialSelection(fact, update);
        }
    }

    @Override
    public void apodizeGaussianSelection(double fact, boolean update) {
        if (model != null) {
            model.apodizeGaussianSelection(fact, update);
        }
    }

    @Override
    public void calcPPMshiftSelection(double[] minvals, double[] maxvals, double[] targets, int[] multiplicities, double SNRLimit, double minPPM, double maxPPM, double maxLocalShift, boolean update) {
        if (model != null) {
            model.calcPPMshiftSelection(minvals, maxvals, targets, multiplicities, SNRLimit, minPPM, maxPPM, maxLocalShift, update);
        }
    }

    @Override
    public void autoPhaseSelection(float minppm, float maxppm, boolean update) {
        if (model != null) {
            model.autoPhaseSelection(minppm, maxppm, update);
        }
    }

    @Override
    public void selectExcitedVoxels() {
        if (model != null) {
            if (model.getGridSize() > 0) {
                model.selectExcitedVoxels();
            }
        }
    }

    @Override
    public void selectAllVoxels() {
        if (model != null) {
            if (model.getGridSize() > 0) {
                model.selectAllVoxels();
            }
        }
    }

    @Override
    public TreeMap<String, HashMap<String, ArrayList<Double>>> getQuantificationResults() {
        return mruiViewerInterface.getQuantificationResults();
    }

    @Override
    public void updateProcessingActions() {
        this.jComboBoxProcessingAction.removeAllItems();
        processingActions.clear();
        if (!model.isSpectraNull()) {
            for (ProcessingAction action : ProcessingSettings.getInstance().getProcessingActions(model)) {
                this.jComboBoxProcessingAction.addItem(action.getName());
                if (action.getQuantificationAction() != null) {
                    action.setQuantificationAction(action.getQuantificationAction().clone());
                }
                this.processingActions.add(action);
            }
            this.jComboBoxProcessingAction.addItem("*Default*");
            ProcessingAction defaultAction = new ProcessingAction( );
            defaultAction.setPreprocessingAction( new PreprocessingAction( model ) );
            defaultAction.setQuantificationAction( new QuantificationAction( QuantificationTypeSelectionFrame.TDFDFIT_SELECTED ) );
            defaultAction.setName("*Default*");
            defaultAction.getPreprocessingAction( ).setName("*Default*");
            defaultAction.getQuantificationAction( ).setName("*Default*");
            this.processingActions.add( defaultAction );
            this.jComboBoxProcessingAction.setSelectedIndex( 0 );

            ProcessingAction procAction = processingActions.get( 0 );
            this.jButtonSelectMetabolites.setEnabled( procAction.getQuantificationAction() != null && 
                                                      procAction.getQuantificationAction().getMlFileSelectionMode() == QuantificationAction.MRUI );
            this.jButtonJustPreprocess.setEnabled( procAction.getPreprocessingAction() != null );
            this.jButtonJustQuantify.setEnabled( procAction.getQuantificationAction() != null );
            this.jButtonProcessData.setEnabled( procAction.getPreprocessingAction() != null && procAction.getQuantificationAction() != null);
            this.jButtonJustHandleResults.setEnabled(procAction.getResultsAction() != null);
            this.jComboBoxProcessingAction.setEnabled(true);
        } else {
            this.jButtonJustPreprocess.setEnabled(false);
            this.jButtonJustQuantify.setEnabled(false);
            this.jButtonProcessData.setEnabled(false);
            this.jButtonSelectMetabolites.setEnabled(false);
            this.jButtonJustHandleResults.setEnabled(false);
            this.jComboBoxProcessingAction.setEnabled(false);
        }
    }

    /**
     * Pre processes the spectra based on the pre set preferences of the user.
     * Changed JS 11.2018
     */
    private void preprocessSpectra( ) 
    {
        if ( model != null && !model.isSpectraNull( ) ) 
        {
            ProcessingAction procAction = this.processingActions.get( this.jComboBoxProcessingAction.getSelectedIndex( ) );
            PreprocessingAction preproAction = procAction.getPreprocessingAction( );

            BatchProcessing.cancel( );
            this.setWaitLayerActive( true );
            model.clearColorMap( );

            if ( preproAction != null ) 
            {
                model.printTxt( "Running Pre-Processing Action \"" + preproAction.getName( ) + "\"" );
                int[] order = preproAction.getPanelOrder( );

                // Add the different preprocessing steps depending on the choice
                for ( int i = 0; i < order.length; i++ ) 
                {
                    for ( int j = 0; j < order.length; j++ ) 
                    {
                        if ( i == order[j] ) 
                        {
                            switch ( j ) 
                            {
                                case ( PreprocessingActionUI.APODIZATION ): 
                                            {
                                                if ( preproAction.isApodisationUse( ) ) 
                                                {
                                                    BatchProcessing.addApodization(preproAction.getApodisationType(), preproAction.getApodisationLineBroadning());
                                                }
                                                break;
                                            }
                                case ( PreprocessingActionUI.QUALITY_FILTERING ): 
                                            {
                                                if ( preproAction.isQualityUse( ) ) 
                                                {
                                                    String tasks = getMissingTasksQuality( preproAction.getQualityRFile( ) );
                                                    if ( tasks.matches( "" ) ) 
                                                    {
                                                        BatchProcessing.addQualityFiltering( preproAction.getQualityRFile( ), 
                                                                                             preproAction.getQualityThreshold( ) );
                                                    } 
                                                    else 
                                                    {
                                                        JOptionPane.showMessageDialog( this, "<html>Automatic Quality Control can not be performed:" + tasks + "<br><br>For help setting up Automatic Quality Control, contact nuno.barros@insel.ch</html>" );
                                                    }
                                                }
                                                break;
                                            }
                                case ( PreprocessingActionUI.BASELINE_REMOVAL ): 
                                            {
                                                if ( preproAction.isBaselineUse( ) ) 
                                                {
                                                    BatchProcessing.addBaselineCorrection( preproAction.getBaselineNR( ) );
                                                }
                                                break;
                                            }
                                case ( PreprocessingActionUI.WATER_REMOVAL_HLSVD64 ): 
                                            {
                                                if ( preproAction.isHLSVD64WaterRemovalUse( ) ) 
                                                {
                                                    BatchProcessing.addWaterPeakRemovalHLSVD64( preproAction.getHLSVD64WaterRemovalMin( ), 
                                                                                                preproAction.getHLSVD64WaterRemovalMax( ), 
                                                                                                preproAction.getHLSVD64WaterRemovalNumberOfPeaks( ) );
                                                } 
                                                break;
                                            }
                                case ( PreprocessingActionUI.WATER_REMOVAL_HLSVDPRO ): 
                                            {
                                                if ( preproAction.isHLSVDProWaterRemovalUse( ) ) 
                                                {
                                                    BatchProcessing.addWaterPeakRemovalHLSVDPro( preproAction.getHLSVDProWaterRemovalMin( ), 
                                                                                                 preproAction.getHLSVDProWaterRemovalMax( ), 
                                                                                                 preproAction.getHLSVDProWaterRemovalNumberOfPeaks( ) );
                                                } 
                                                break;
                                            }            
                                            
                                case ( PreprocessingActionUI.WATER_REMOVAL_TDFDFIT ):   
                                            {
                                                if ( preproAction.isTDFDFitWaterRemovalUse( ) ) 
                                                {
                                                    BatchProcessing.addWaterPeakRemovalTDFDFit( preproAction.getTDFDFitWaterModelName( ) ); 
                                                }
                                                break;
                                             }
                                case ( PreprocessingActionUI.AUTO_PHASING ):
                                            {
                                                if ( preproAction.isAutoPhasingUse( ) ) 
                                                {
                                                    BatchProcessing.addAutoPhasing( (float) preproAction.getAutoPhasingMinPPM( ), 
                                                                                    (float) preproAction.getAutoPhasingMaxPPM( ) );
                                                }
                                                break;
                                            }
                                            
                                case ( PreprocessingActionUI.OFFSET_CORRECTION_FD ):   
                                            {
                                                if ( preproAction.isUseRemoveAmplitudeOffsetFD( ) ) 
                                                {
                                                    BatchProcessing.addAmplitudeOffsetRemovalFD( (float)preproAction.getMinFDOffsetRange( ), 
                                                                                                 (float)preproAction.getMaxFDOffsetRange( ) ); 
                                                }
                                                break;
                                            }
                                                    
                                case ( PreprocessingActionUI.OFFSET_CORRECTION_TD ):   
                                            {
                                                if ( preproAction.isUseRemoveAmplitudeOffsetTD( ) ) 
                                                {
                                                    BatchProcessing.addAmplitudeOffsetRemovalTD( (float)preproAction.getMinTDOffsetRange( ), 
                                                                                                 (float)preproAction.getMaxTDOffsetRange( ) ); 
                                                }
                                                break;
                                            }     
           
                                case ( PreprocessingActionUI.FREQUENCY_SHIFT ): 
                                            {
                                                if ( preproAction.isFreqShiftUse( ) ) 
                                                {
                                                    double[] minvals = new double[ preproAction.getFreqShiftPeaks( ).size( ) ];
                                                    double[] maxvals = new double[ preproAction.getFreqShiftPeaks( ).size( ) ];
                                                    double[] targets = new double[ preproAction.getFreqShiftPeaks( ).size( ) ];
                                                    int[] multiplicities = new int[ preproAction.getFreqShiftPeaks( ).size( ) ];
                                                    int k = 0;
                                                    for ( ReferencePeak peak : preproAction.getFreqShiftPeaks( ) ) 
                                                    {
                                                        minvals[k] = peak.getMinppm( );
                                                        maxvals[k] = peak.getMaxppm( );
                                                        targets[k] = peak.getTargetppm( );
                                                        multiplicities[k++] = peak.getMultiplicity( );
                                                    }
                                                    if ( this.checkValuesFrequencyShiftCorrection( minvals, maxvals, targets, 
                                                                                                   preproAction.getFreqShiftMinPPM( ), 
                                                                                                   preproAction.getFreqShiftMaxPPM( ) ) ) 
                                                    {
                                                        BatchProcessing.addFrequencyShiftCorrection( minvals, maxvals, targets, 
                                                                                                     multiplicities, preproAction.getFreqShiftSNR( ), 
                                                                                                     preproAction.getFreqShiftMinPPM( ), 
                                                                                                     preproAction.getFreqShiftMaxPPM( ), 
                                                                                                     preproAction.getFreqShiftMaxLocalShift( ) );
                                                    } 
                                                    else 
                                                    {
                                                        JOptionPane.showMessageDialog( this, "<html>Freq. Shift Correction can not be performed: some values fall outside the current data PPM limits.<br> Please revise Freq. Shift Correction Settings for the current Processing Action.</html>" );
                                                    }
                                                }
                                                break;
                                            }
                                        }
                        break;
                        }
                    }
                }
            }

            // Start the batch processing.
            BatchProcessing.run( );
        }
    }
    
    
    /**
     * Updated routine to process the spectra. Added to this routine is
     * TDFDFit-based water removal.
     */
    private void processSpectra( ) 
    {
        if ( model != null && !model.isSpectraNull( ) ) 
        {
            ProcessingAction procAction = this.processingActions.get( this.jComboBoxProcessingAction.getSelectedIndex( ) );
            PreprocessingAction preproAction = procAction.getPreprocessingAction( );

            BatchProcessing.cancel( );
            model.printTxt( "Running Processing Action \"" + procAction.getName( ) + "\"" );
            this.setWaitLayerActive( true );
            model.clearColorMap( );

            if ( preproAction != null ) 
            {
                int[] order = preproAction.getPanelOrder( );

                // Add the different preprocessing steps depending on the choice
                for ( int i = 0; i < order.length; i++ ) 
                {
                    for ( int j = 0; j < order.length; j++ ) 
                    {
                        if ( i == order[j] ) 
                        {
                            switch ( j ) 
                            {
                                case ( PreprocessingActionUI.APODIZATION ): 
                                {
                                    if ( preproAction.isApodisationUse( ) ) 
                                    {
                                        BatchProcessing.addApodization( preproAction.getApodisationType( ), 
                                                                        preproAction.getApodisationLineBroadning( ) );
                                    }
                                    break;
                                }
                                case ( PreprocessingActionUI.QUALITY_FILTERING ): 
                                {
                                    if ( preproAction.isQualityUse( ) ) 
                                    {
                                        String tasks = getMissingTasksQuality( preproAction.getQualityRFile( ) );
                                        if ( tasks.matches( "" ) ) 
                                        {                                
                                            BatchProcessing.addQualityFiltering( preproAction.getQualityRFile( ), 
                                                                                 preproAction.getQualityThreshold( ) );
                                        } 
                                        else 
                                        {
                                            JOptionPane.showMessageDialog( this, "<html>Automatic Quality Control can not be performed:" + 
                                                                           tasks + "<br><br>For help setting up Automatic Quality Control, contact nuno.barros@insel.ch</html>" );
                                        }
                                    }
                                    break;
                                }
                                case ( PreprocessingActionUI.BASELINE_REMOVAL ): 
                                {
                                    if ( preproAction.isBaselineUse( ) ) 
                                    {
                                        BatchProcessing.addBaselineCorrection(preproAction.getBaselineNR( ) );
                                    }
                                    break;
                                }
                                case ( PreprocessingActionUI.WATER_REMOVAL_HLSVD64 ): 
                                {
                                    if ( preproAction.isHLSVD64WaterRemovalUse( ) ) 
                                    {
                                        BatchProcessing.addWaterPeakRemovalHLSVD64( preproAction.getHLSVD64WaterRemovalMin( ), 
                                                                                    preproAction.getHLSVD64WaterRemovalMax( ), 
                                                                                    preproAction.getHLSVD64WaterRemovalNumberOfPeaks( ) );
                                    }
                                    break;
                                }
                                case ( PreprocessingActionUI.WATER_REMOVAL_HLSVDPRO ): 
                                {
                                    if ( preproAction.isHLSVDProWaterRemovalUse( ) ) 
                                    {
                                        BatchProcessing.addWaterPeakRemovalHLSVDPro( preproAction.getHLSVDProWaterRemovalMin( ), 
                                                                                     preproAction.getHLSVDProWaterRemovalMax( ), 
                                                                                     preproAction.getHLSVDProWaterRemovalNumberOfPeaks( ) );
                                    }
                                    break;
                                }
                                
                                case ( PreprocessingActionUI.WATER_REMOVAL_TDFDFIT ):   
                                    {
                                        if ( preproAction.isTDFDFitWaterRemovalUse( ) ) 
                                        {
                                            BatchProcessing.addWaterPeakRemovalTDFDFit( preproAction.getTDFDFitWaterModelName( ) ); 
                                        }
                                        break;
                                    }
                                case ( PreprocessingActionUI.AUTO_PHASING ): 
                                {
                                    if ( preproAction.isAutoPhasingUse( ) ) 
                                    {
                                        BatchProcessing.addAutoPhasing( (float) preproAction.getAutoPhasingMinPPM( ), 
                                                                        (float) preproAction.getAutoPhasingMaxPPM( ) );
                                    }
                                    break;
                                }
                                
                                case ( PreprocessingActionUI.OFFSET_CORRECTION_FD ):   
                                {
                                    if ( preproAction.isUseRemoveAmplitudeOffsetFD( ) ) 
                                    {
                                        BatchProcessing.addAmplitudeOffsetRemovalFD( (float)preproAction.getMinFDOffsetRange( ), 
                                                                                     (float)preproAction.getMaxFDOffsetRange( ) ); 
                                    }
                                    break;
                                }
                                                    
                                case ( PreprocessingActionUI.OFFSET_CORRECTION_TD ):   
                                {
                                    if ( preproAction.isUseRemoveAmplitudeOffsetTD( ) ) 
                                    {
                                        BatchProcessing.addAmplitudeOffsetRemovalTD( (float)preproAction.getMinTDOffsetRange( ), 
                                                                                     (float)preproAction.getMaxTDOffsetRange( ) ); 
                                    }
                                    break;
                                }     
                                
                                
                                case ( PreprocessingActionUI.FREQUENCY_SHIFT ): 
                                {
                                    if ( preproAction.isFreqShiftUse( ) ) 
                                    {
                                        double[] minvals = new double[preproAction.getFreqShiftPeaks( ).size( )];
                                        double[] maxvals = new double[preproAction.getFreqShiftPeaks( ).size( )];
                                        double[] targets = new double[preproAction.getFreqShiftPeaks( ).size( )];
                                        int[] multiplicities = new int[preproAction.getFreqShiftPeaks( ).size( )];
                                        int k = 0;
                                        for ( ReferencePeak peak : preproAction.getFreqShiftPeaks( ) ) 
                                        {
                                            minvals[k] = peak.getMinppm( );
                                            maxvals[k] = peak.getMaxppm( );
                                            targets[k] = peak.getTargetppm( );
                                            multiplicities[k++] = peak.getMultiplicity( );
                                        }
                                        if ( this.checkValuesFrequencyShiftCorrection( minvals, maxvals, targets, 
                                                                                       preproAction.getFreqShiftMinPPM( ), 
                                                                                       preproAction.getFreqShiftMaxPPM( ) ) ) 
                                        {
                                            BatchProcessing.addFrequencyShiftCorrection( minvals, maxvals, targets, 
                                                                                         multiplicities, preproAction.getFreqShiftSNR( ), 
                                                                                         preproAction.getFreqShiftMinPPM( ), 
                                                                                         preproAction.getFreqShiftMaxPPM( ), 
                                                                                         preproAction.getFreqShiftMaxLocalShift( ) );
                                        } 
                                        else 
                                        {
                                            JOptionPane.showMessageDialog( this, "<html>Freq. Shift Correction can not be performed: some values fall outside the current data PPM limits.<br> Please revise Freq. Shift Correction Settings for the current Processing Action.</html>");
                                        }
                                    }
                                    break;
                                }
                            }
                            break;
                        }
                    }
                }
            }
            
            QuantificationAction quantAction =  procAction.getQuantificationAction( );        
            // add quantification
            BatchProcessing.addQuantification( quantAction );

            // add results action
            ResultsAction resAction = procAction.getResultsAction( );
            if (resAction != null) 
            {
                switch ( resAction.getType( ) ) 
                {
                    case ResultsAction.SAVE_RESULTS:
                        BatchProcessing.addSaveResultsCommand( resAction.getResultsFolder( ) );
                        break;
                    case ResultsAction.SAVE_METAB_MAT:
                        BatchProcessing.addSaveMetaboliteMapsCommand( resAction.getResultsFolder( ), true );
                }
            }

            // execute worker
            BatchProcessing.run( );
        }
    }

    private String getMissingTasksQuality(String classifierFile) {
        String tasks = "";
        if (GlobalSettings.getInstance().getRExecutable() == null
                || GlobalSettings.getInstance().getRExecutable().matches("")
                || !GlobalSettings.getInstance().getRExecutable().endsWith("Rscript.exe")) {
            tasks += "<br>- please provide Rscript.exe file in Settings>Other";
        }
        if (!checkSignalFreeRegionFD()) {
            tasks += "<br>- please revise FD Signal Free Region in Settings>Other";
        }
        if (classifierFile == null || classifierFile.matches("")) {
            tasks += "<br>- please provide a valid Quality Control Classifier file";
        }
        if(!checkRPackagesInstalled()) {
            tasks += "<br>- please ensure that randomForest and Runiversal packages are installed in ($home)/Documents/R";
        }    
        return tasks;
    }

    private boolean checkSignalFreeRegionFD() {
        boolean ans = true;
        if (model != null && !model.isSpectraNull()) {
            double minppm = GlobalSettings.getInstance().getSignalFreeFDMin();
            double maxppm = GlobalSettings.getInstance().getSignalFreeFDMax();
            if (minppm >= maxppm || minppm != model.getSpectra().validatePPM(minppm) || maxppm != model.getSpectra().validatePPM(maxppm)) {
                ans = false;
            }
        }
        return ans;
    }
    
       private boolean checkRPackagesInstalled() {
        boolean ans = true;
        String librariesR = System.getProperty("user.home")+ File.separator+ "Documents"+ File.separator+ "R";
        if (!(new File(librariesR)).exists()){
         ans = false;
        }
        return ans;
    }

    private boolean checkValuesFrequencyShiftCorrection(double[] minvals, double maxvals[], double targets[], double minPPM, double maxPPM) {
        boolean ans = true;
        if (model != null && !model.isSpectraNull()) {
            for (int i = 0; i < minvals.length; i++) {
                if (minvals[i] != model.getSpectra().validatePPM(minvals[i])
                        || maxvals[i] != model.getSpectra().validatePPM(maxvals[i])
                        || targets[i] != model.getSpectra().validatePPM(targets[i])) {
                    ans = false;
                }
            }
            if (minPPM != model.getSpectra().validatePPM(minPPM)
                    || maxPPM != model.getSpectra().validatePPM(maxPPM)) {
                ans = false;
            }
        }
        return ans;
    }

    @Override
    public void saveResults(String file) {
        //TODO
    }

    @Override
    public void saveMetaboliteMapsMAT(String folder, boolean profileCorrection) {
        String[] metabs = mruiViewerInterface.getMetabolitesNames();
        if (!folder.endsWith("//")) {
            folder += "//";
        }
        //Save Spectra :: TEMP this should be in another function
        String filenameStart = folder + model.getPatientName() + "_" + model.getStudyDate() + "_" + model.getSeriesNumber() + "_" + model.getTE() + "-";
        model.saveSelectedSpectraToMAT(filenameStart + "Spectra.mat");

        //Save Fit Quality Number
        mruiViewerInterface.setColorMapfromjMRUIResults(0, 5, false, "");
        model.getColorMap().saveMapToMAT(new File(filenameStart + "FitQuality.mat"), false);

        //Save Damping (Common excluding lipids)
        mruiViewerInterface.setColorMapfromjMRUIResults(0, 2, false, "");
        model.getColorMap().saveMapToMAT(new File(filenameStart + "Damping.mat"), false);

        //Save Quality Map
        int indexQMap = 0;
        for (int i = 0; i < model.getColorMap().getFunctionsNames().size(); i++) {
            if (model.getColorMap().getFunctionsNames().get(i).matches("Quality Map")) {
                indexQMap = i;
                break;
            }
        }
        model.getColorMap().createMap(indexQMap);
        model.getColorMap().saveMapToMAT(new File(filenameStart + "QControlScore.mat"), false);
        for (int i = 0; i < metabs.length; i++) {
            //Save FreqShift for each metab
            mruiViewerInterface.setColorMapfromjMRUIResults(i, 1, false, "");
            model.getColorMap().saveMapToMAT(new File(filenameStart + metabs[i] + "_FreqShift.mat"), false);

            //Save Amplitudes not corrected
            mruiViewerInterface.setColorMapfromjMRUIResults(i, 0, false, "");
            model.getColorMap().saveMapToMAT(new File(filenameStart + metabs[i] + "_Amp.mat"), false);
            if (profileCorrection) {
                System.out.println(metabs[i]);
                try {
                    SelectionProfileCorrection selProfCorrection = new SelectionProfileCorrection(model.getTE(), model.getCSIGrid().getDimsExcitedVolume());
                    if (selProfCorrection.checkMetaboliteName(metabs[i])) {
                        model.getColorMap().correctSelectionProfile(selProfCorrection, metabs[i]);
                        model.getColorMap().saveMapToMAT(new File(filenameStart + metabs[i] + "_Ampcorrected.mat"), false);
                    } else {
                        model.printTxt("Selection profile correction not performed. Metabolite name (" + metabs[i] + ") not recognized.");
                    }
                } catch (NoSuchFieldException ex) {
                    model.printTxt("Selection profile correction not available for TE=" + model.getTE()
                            + " and Excited Volume with dimensions " + model.getCSIGrid().getDimsExcitedVolume()[0] + "x" + model.getCSIGrid().getDimsExcitedVolume()[1]);
                }
            }
        }
    }

    @Override
    public void selectInnerExcitedVoxels() {
        if (model != null) {
            if (model.getGridSize() > 0) {
                model.selectInnerExcitedVoxels();
            }
        }
    }

    @Override
    public void printTxt(String txt) {
        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss.SSS");
        Date now = new Date();
        String strDate = sdf.format(now);

        if (this.jTextAreaOutput != null) {
            jTextAreaOutput.setCaretPosition(jTextAreaOutput.getDocument().getLength());
            jTextAreaOutput.append("#" + strDate + ">> " + txt + "\n");
        }
    }

    public void eraseLastLineTextArea( ) 
    {
        try 
        {
            String content = jTextAreaOutput.getDocument( ).getText( 0, jTextAreaOutput.getDocument( ).getLength( ) );
            content.trim( );
            if( content.endsWith( "\n" ) )
            {
                content = content.substring( 0,content.length( ) - 1 );
            }
            int lastLineBreak = content.lastIndexOf( '\n' );
            jTextAreaOutput.getDocument().remove( lastLineBreak, jTextAreaOutput.getDocument( ).getLength( ) - lastLineBreak );
            jTextAreaOutput.append( "\n" );
        } catch ( BadLocationException ex ) 
        {
        }
    }

    /**
     * This method performs the water removal using a TDFDFit based 
     * model using Prony's method.
     * @param waterModel 
     */
    @Override
    public void removeWaterTDFDFit( String waterModel ) 
    {
        TDFDFittingDefaults def = TDFDFittingDefaults.getInstance( );
        def.load( );
        
        // String defaultWaterModelName = def.getProperty( TDFDFittingDefaults.TDFDFIT_WATER_MODEL_NAME );
        String defaultWaterModelName = waterModel;
        String defaultWaterModelPath = def.getProperty( TDFDFittingDefaults.TDFDFIT_WATER_MODEL_PATH );
        
        m_removeWaterTDFDFit = true;
        
        if ( defaultWaterModelName.endsWith( ".tfm" ) == false )
        {
            defaultWaterModelName = defaultWaterModelName + ".tfm";
        }
        
        String modelReference = defaultWaterModelPath + System.getProperty( "file.separator" ) + defaultWaterModelName;
        File defaultModelFile = new File( modelReference );
        
        if ( defaultModelFile.exists( ) == true )
        {
            NonInteractiveTDFDFitExecuter tdfdfitExecutor = new NonInteractiveTDFDFitExecuter( this, modelReference, model, true );
            tdfdfitExecutor.loadTDFDFitPrototypeModelSpectrumFile( );
                        
            if ( tdfdfitExecutor.getSingleVoxelMeasuredSpectralData( ).getAbsorptionChannelFD( ).length == model.getVectorSize( ) )
            {

                tdfdfitExecutor.addActionListener( this );
                tdfdfitExecutor.executeTDFDFitting( true );
            }
            else
            {
                 JOptionPane.showMessageDialog( this, "TDFDFitting cannot be performed: \n Number of points of selected model does not match the number of points in the data!." );
            }
            
//            tdfdfitExecutor.addActionListener( this );
//            tdfdfitExecutor.executeTDFDFitting( true );
        }
    }
    
    /**
     * This class implements the BatchProcessingTaskExecutor interface. 
     * Method executes the amplitude offset removal in time domain.
     * @param lowerLimitTD
     * @param upperLimitTD 
     */
    @Override
    public void removeAmplitudeOffsetTD( double lowerLimitTD, double upperLimitTD ) 
    {
        int numberOfProgressSteps = model.getSelectedVoxels( ).size( );
        
        m_dualProgressBar = new DualProgressBar( this, numberOfProgressSteps, 0, new Dimension( 900, 150 ), false );
        m_dualProgressBar.setTitle( "Applying time domain offset correction .."  );
        m_dualProgressBar.setUpperProgressVisible( true );
        m_dualProgressBar.setUpperProgress( 0 );
        m_dualProgressBar.setUpperLabel( "<HTML><BR>     Correcting signal number : " + 0 + "</HTML>" );
        m_dualProgressBar.setLowerProgressVisible( false );
        
        // convert the time points into array index values
        int lowerIndex = (int)( lowerLimitTD * model.getBandwidth( ) );
        int upperIndex = (int)( upperLimitTD * model.getBandwidth( ) );
        launchPerformTimeDomainOffsetCorrectionOnDataset( lowerIndex, upperIndex );
    }

    /**
     * This class implements the BatchProcessingTaskExecutor interface. 
     * Method executes the amplitude offset removal in frequency domain.
     * @param lowerLimitFD
     * @param upperLimitFD 
     */
    @Override
    public void removeAmplitudeOffsetFD( double lowerLimitFD, double upperLimitFD ) 
    {
        int numberOfProgressSteps = model.getSelectedVoxels( ).size( );
        
        m_dualProgressBar = new DualProgressBar( this, numberOfProgressSteps, 0, new Dimension( 900, 150 ), false );
        m_dualProgressBar.setTitle( "Applying frequency domain offset correction .."  );
        m_dualProgressBar.setUpperProgressVisible( true );
        m_dualProgressBar.setUpperProgress( 0 );
        m_dualProgressBar.setUpperLabel( "<HTML><BR>     Correcting spectrum number : " + 0 + "</HTML>" );
        m_dualProgressBar.setLowerProgressVisible( false );
        
        // the range borders to be used to define offset correction from are in ppm
        double specRangeInPPM = ( model.getBandwidth( ) / model.getResonanceFrequency( ) ) * 1000000f;
        double minPPMVal = model.getMinimalPPMValueOfSpectrum( );
        double maxPPMVal = model.getMaximalPPMValueOfSpectrum( );
        
        int minArrayValInteger = (int)( ( ( maxPPMVal - upperLimitFD  ) / specRangeInPPM ) * model.getCSIData( ).m_numberOfTimeSamplePoints );
        int maxArrayValInteger = (int)( ( ( maxPPMVal - lowerLimitFD ) / specRangeInPPM ) * model.getCSIData( ).m_numberOfTimeSamplePoints );
        
        // launchPerformFrequencyDomainOffsetCorrectionOnDataset( (int)lowerLimitFD, (int)upperLimitFD );
        
        launchPerformFrequencyDomainOffsetCorrectionOnDataset( minArrayValInteger, maxArrayValInteger );
        
//        m_lowerLimitFD = lowerLimitFD;
//        m_upperLimitFD = upperLimitFD;        
//                
//        int numberOfProgressSteps = model.getSelectedVoxels( ).size( );
//        
//        m_dualProgressBar = new DualProgressBar( this, numberOfProgressSteps, 0, new Dimension( 900, 150 ), false );
//        m_dualProgressBar.setTitle( "Applying frequency domain offset correction .."  );
//        m_dualProgressBar.setUpperProgressVisible( true );
//        m_dualProgressBar.setUpperProgress( 0 );
//        m_dualProgressBar.setUpperLabel( "<HTML><BR>     Correcting spectrum number : " + 0 + "</HTML>" );
//        m_dualProgressBar.setLowerProgressVisible( false );
//       
//        final org.spectrim.lib.SwingWorker worker = new org.spectrim.lib.SwingWorker( )
//        {
//
//            @Override
//            public Object construct( )
//            {
//                performFrequencyDomainOffsetCorrectionOnDataset( );
//                return null;
//            }
//
//            // runs in the event dispatching thread
//            @Override
//            public void finished( )
//            {
//                // After calculation set enabled again
//                m_dualProgressBar.setVisible( false );
//                m_dualProgressBar.dispose( );
//            }
//        };
//
//        worker.start( );
    }

    @Override
    public void processTDDomainTruncation( int vectorsize ) 
    {
        if ( model != null ) 
        {
            currentVectorSize = vectorsize;
            model.truncateTDModel( vectorsize, true );
        }
    }
    
     /**
     * This method only stores the preprocessed data into a binary file.
     */
    public boolean writePreprocessingResultsToBinaryFile( ) 
    {
        String currentDCMFileRef = model.getCSIData( ).getFile( );
        String outputOverallResultFile;
        
        if ( currentDCMFileRef.length( ) > 0 )
        {
            int index = currentDCMFileRef.lastIndexOf( "." );
            if ( ( index > 0 ) && ( index <= currentDCMFileRef.length( ) ) )
            {
                outputOverallResultFile = currentDCMFileRef.substring( 0, index );
            }
            else
            {         
                outputOverallResultFile = currentDCMFileRef;
            }
            
            outputOverallResultFile = outputOverallResultFile + ".tpf";
            
            float[] allPreprocessedSignals = getAllMeasuredAndPreProcessedSignals( );
            
            for (int i=0;i<100;i++)
            {
                System.out.println( "allPreprocessedSignals[" + i + "] = " + allPreprocessedSignals[i] );
            }
            
            try ( DataOutputStream dos = new DataOutputStream( new FileOutputStream( outputOverallResultFile ) ) ) 
            {    
                byte[] buffer = new byte[4*allPreprocessedSignals.length];
                System.out.println( "Writing too : " + outputOverallResultFile );
                for ( int i = 0; i < allPreprocessedSignals.length; ++i )
                {
                    byte[] convertedFloatAsByteArray = floatToByteArray( allPreprocessedSignals[i] );
                    buffer[4 * i]     = convertedFloatAsByteArray[0];
                    buffer[4 * i + 1] = convertedFloatAsByteArray[1];
                    buffer[4 * i + 2] = convertedFloatAsByteArray[2];
                    buffer[4 * i + 3] = convertedFloatAsByteArray[3];
                }
                dos.write( buffer );
                dos.flush( );
                
                // finally close the data output stream
                dos.close( );    
            } 
            catch ( IOException ex ) 
            {
                Logger.getLogger( TDFDFitResultsStore.class.getName( ) ).log( Level.SEVERE, null, ex );
                return false;
            }
        }
        else
        {
            System.out.println( "Warning writePreprocessingResultsToBinaryFile() : Cannot make preprocessed spectral information persistent!" );
            return false;
        }
        return true;
    }
    
    private float[] getAllMeasuredAndPreProcessedSignals( )
    {
        
        int size = model.getCSIGrid( ).m_gridSizeDir1 *
                   model.getCSIGrid( ).m_gridSizeDir2 *
                   model.getCSIGrid( ).m_gridSizeDir3 *
                   2 * MRSignalProperties.getInstance( ).getNumberOfSamplePoints( );
        
        float[] allComplexDotBinSignals = new float[size];
        int cntr = 0;
        
        for ( int i = 0; i < model.getCSIGrid( ).m_gridSizeDir1 ; i++ )
        {
            for ( int j = 0; j < model.getCSIGrid( ).m_gridSizeDir2 ; j++ )
            {
                for ( int k = 0; k < model.getCSIGrid( ).m_gridSizeDir3 ; k++ )
                {
                    String key = "" + i + "_" + j + "_" + k;
                      
                    float[] abs = model.getSpectra( ).getSpectrumData( key, Spectra.Domain.TD, Spectra.Mode.ABS );
                    float[] disp = model.getSpectra( ).getSpectrumData( key, Spectra.Domain.TD, Spectra.Mode.DISP );
                    System.out.println( "abs[512] = " + abs[512] + "disp[512] = " + disp[512] );
                    // Copy the TD data into the global data array.
                    for ( int ii = 0; ii <1024; ii++ )
                    {
                        allComplexDotBinSignals[cntr] = abs[ii];
                        cntr++;
                        allComplexDotBinSignals[cntr] = disp[ii];
                        cntr++;
                    }
                }
            }
        }
        
        System.out.println( "abs[512] = " + allComplexDotBinSignals[512] + "disp[512] = " + allComplexDotBinSignals[513] );
         
        return allComplexDotBinSignals;
    }
    
    /**
     * Reads the preprocessed binary data from the files system.
     * @return 
     */
    public boolean readreprocessingResultsFromBinaryFile( )
    {
        String currentDCMFileRef = model.getCSIData( ).getFile( );
        String inputOverallResultFile = null;
        
        int numberOfSpectra = model.getCSIGrid( ).m_gridSizeDir1 *
                              model.getCSIGrid( ).m_gridSizeDir2 *
                              model.getCSIGrid( ).m_gridSizeDir3;
        
        
        int floatSize = numberOfSpectra *
                        2 * model.getSpectraVectorSize( );
        
        float[] allSignalFloats = new float[floatSize];
        float[] allPreprocessedSignalFloats = new float[floatSize];
        
        if ( currentDCMFileRef.length( ) > 0 )
        {
            int index = currentDCMFileRef.lastIndexOf( "." );
            if ( ( index > 0 ) && ( index <= currentDCMFileRef.length( ) ) )
            {
                inputOverallResultFile = currentDCMFileRef.substring( 0, index );
            }
            else
            {
                inputOverallResultFile = currentDCMFileRef;
            }
            inputOverallResultFile = inputOverallResultFile + ".tpf";
        }
        
        try ( DataInputStream dis = new DataInputStream( new FileInputStream( inputOverallResultFile ) ) ) 
        {
            
            byte[] buffer = new byte[4*floatSize];
            
            // Read the preprocessed data
            dis.read( buffer );
            
            for ( int i = 0; i < floatSize; i++ )
            {
                byte[] preprocessedfloatAsByteArray = new byte[4];
                
                preprocessedfloatAsByteArray[0] = buffer[4*i];
                preprocessedfloatAsByteArray[1] = buffer[4*i+1];
                preprocessedfloatAsByteArray[2] = buffer[4*i+2];
                preprocessedfloatAsByteArray[3] = buffer[4*i+3];
                
                allPreprocessedSignalFloats[i] = byteArrayToFloat( preprocessedfloatAsByteArray );
            }
            
            // we are already done, close the file input stream
            dis.close( );
            
            // Create the NumericTDFDFitResults objects and fill them with
            // the just read signal data.
            int cntr = 0;
            for ( int i = 0; i < model.getCSIGrid( ).m_gridSizeDir1; i++ )
            {
                for ( int j = 0; j < model.getCSIGrid( ).m_gridSizeDir2; j++ )
                {
                    for ( int k = 0; k < model.getCSIGrid( ).m_gridSizeDir3; k++ )
                    {
                        
                        String key = "" + i + "_" + j + "_" + k;
                                   
                        float[] absPrepro  = new float[ model.getSpectraVectorSize( ) ];
                        float[] dispPrepro = new float[ model.getSpectraVectorSize( ) ];
                        
                        for ( int kk = 0; kk < model.getSpectraVectorSize( ); kk++ )
                        {                          
                            absPrepro[kk] = allPreprocessedSignalFloats[ ( cntr * 2 * model.getSpectraVectorSize( ) ) + 2 * kk];
                            dispPrepro[kk] = allPreprocessedSignalFloats[ ( cntr * 2 * model.getSpectraVectorSize( ) ) + 2 * kk + 1];   
                        }
                        
                        // Set the preprocessing data into the spectrum
                        model.getSpectra( ).setSpectrum( absPrepro, dispPrepro, key );
                       
                        cntr++; 
                    }
                }
            }
        } 
        catch ( FileNotFoundException ex ) 
        {        
             JOptionPane.showMessageDialog( null, "readTDFDFitResultsStore( ): Cannot load associated preprocessed data!\n No .tpf file found!" );
             return false;
        } 
        catch ( IOException ex ) 
        {
            Logger.getLogger( TDFDFitResultsStore.class.getName( ) ).log( Level.SEVERE, null, ex );
            return false;
        }
        return true;
    }
    
    /**
     * Method called for baseline correction ...
     * @param xValues
     * @param yValues
     * @param xValue
     * @return 
     */
    public float getCorrespondingYValue( float[] xValues, float[] yValues, float xValue )
    {
              // float[] xaxis = m_specData.getMagnitudeCurveFDPPM( ).getXvalues( );
        int index = getIndexOfFirstMatchingValue( xValue, xValues );
        
        // do not return the value of the index itsef, but average of 3 points
        float average = yValues[index];
        
        if ( ( index > 1 ) && ( index < xValues.length - 2 ) )
        {
            average += yValues[index - 1];
            average += yValues[index + 1];
            average += yValues[index - 2];
            average += yValues[index + 2];
        }
        
        if ( index == 0 )
        {
            average += yValues[1];
            average += yValues[2];
            average += yValues[3];
            average += yValues[4];
        }            
        if ( index == xValues.length - 1 )
        {
            average += yValues[xValues.length - 2];
            average += yValues[xValues.length - 3];
            average += yValues[xValues.length - 4];
            average += yValues[xValues.length - 5];
        }
        
        if ( index == 1 )
        {
            average += yValues[0];
            average += yValues[2];
            average += yValues[3];
            average += yValues[4];
        }            
        if ( index == xValues.length - 2 )
        {
            average += yValues[xValues.length - 1];
            average += yValues[xValues.length - 3];
            average += yValues[xValues.length - 4];
            average += yValues[xValues.length - 5];
        }
        
        return ( average / 5 );
    }
    
     /**
     * Returns the array index of the coordinate containing the maximum value.
     * @param value
     * @param y
     * @return 
     */
    public int getIndexOfFirstMatchingValue( float value, float[] y ) 
    {
	int index = 0;
	
        float current_difference = Float.MAX_VALUE;
        
	for ( int k = 0; k < y.length; k++ ) 
        {
            
            // System.out.println( "Difference = " + Math.abs( y[k] - value ) );
            
            float difference = Math.abs( y[k] - value );
            
	    if ( difference < current_difference ) 
            {
		index = k;
                current_difference = difference;
	    }
	}
        
	return index;
    }
    
    public float[][] FD2TD( float[] abs, float[] disp ) 
    {
        float[][] vaux = new float[abs.length][2];

        for ( int m = 0; m < abs.length; m++ ) 
        {
            int d = (m + 1 + abs.length / 2) % abs.length;
            
            vaux[d][0] = abs[abs.length - 1 - m];
            vaux[d][1] = disp[disp.length - 1 - m];
        }
        
        FFT fft = new FFT( );
        vaux = fft.fft_1d( vaux );

        return vaux;
    }
    
}
